<?php
	require_once('_cfg_emp.php');

	function config_pad($chave){
		$cfg = config_pad_emp();

		$cfg['sistema_versao']      = '15.21.00';

		$cfg['sistema_data_versao'] = '25/11/2024';

		$cfg['nfe_versao'] = '4.00';
		$cfg['cte_versao'] = '4.00';
		$cfg['cce_versao'] = '1.00';
		$cfg['conf_versao'] = '1.00';
		$cfg['mdfe_versao'] = '3.00';
		$cfg['ct_cce_versao'] = '4.00';
		$cfg['cfe_versao'] = '0.08';//0.07  modificado em  12-04-2022 por orientacao de Mauricio

		$cfg['nfe_tpenvio'] = 'uma';//lote - uma

		$cfg['nfe_cancela'] = 'evento';

		$cfg['contas_aceite'] = 15;

		$cfg['tef_certif'] = '3655';    //Certificado TEF NTK
		$cfg['tef_certif_ver'] = '212'; //Verso do Roteiro TEF NTK
		$cfg['tef_versao'] = '5.0.0';   //Verso do TEF

		$cfg['paf_emp_cnpj'] = '83.188.342/0001-04';
		$cfg['paf_emp_ie'] = '252290720';
		$cfg['paf_emp_im'] = '33061';
		$cfg['paf_emp_razao'] = 'Freeline Informtica Ltda - ME';
		$cfg['paf_emp_end1'] = 'Rua Benjamin Constant, 4135 - Gloria';
		$cfg['paf_emp_end2'] = '89217-002 - Joinville - SC';
		$cfg['paf_emp_tel'] = '4734730001';
		$cfg['paf_emp_contato'] = 'Denise Alves Molon';
		$cfg['paf_emp_email'] = 'freeline@freeline.inf.br';


		$cfg['sistema_versao_pdv']  = '8.1.0';
		$cfg['sistema_nome_pdv']    = '$imples-PDV';
		$cfg['sistema_er_pdv']    = '01.00';

		$cfg['help'] = 'http://freeline.inf.br/help/SimplesWeb.html';

		if($chave == 'sistema_licenca'){
			//consulta empresa licenciada
			$con_licenca = 'SELECT Nome_Razao FROM pessoa '.
							' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
							' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'"';
			$res_licenca = consulta_sql($con_licenca);
			$reg_licenca = consulta_ler_objeto($res_licenca);
			consulta_limpa($res_licenca);

			if($reg_licenca->Nome_Razao != ''){
				$cfg['sistema_licenca']     = $reg_licenca->Nome_Razao;
			}
		}

		$cfg['pis_cst_01'] = ';0.65;1.65;';
		$cfg['cofins_cst_01'] = ';3.00;7.60;';

		$cfg['pis_cst_02_E'] = ';0.80;1.00;1.65;0.65;1,2375;';
		$cfg['cofins_cst_02_E'] = ';3.20;3.00;6.00;7.60;';

		$cfg['pis_cst_02_S'] = ';0.80;0.65;1.30;1.65;';
		$cfg['cofins_cst_02_S'] = ';3.20;4.60;7.60;3.00;5.70;';

		$cfg['pis_cst_04'] = ';5.08;4.21;10.20;5.00;5.08;4.21;2.00;6.15;1.00;1.50;3.75;2.10;2.20;2.30;1.65;2.00;3.50;';
		$cfg['cofins_cst_04'] = ';23.44;19.42;47.40;23.20;23.44;19.42;9.60;28.32;4.60;6.90;17.25;9.90;10.30;10.60;7.60;5.50;16.65';

		$cfg['ncm_escala'] = " ;".
							"03.001.00;".
							"03.002.00;".
							"03.002.00;".
							"03.003.00;".
							"03.004.00;".
							"03.005.00;".
							"03.006.00;".
							"03.006.00;".
							"03.007.00;".
							"03.008.00;".
							"03.010.00;".
							"03.011.00;".
							"03.012.00;".
							"03.013.00;".
							"03.014.00;".
							"03.015.00;".
							"03.016.00;".
							"03.022.00;".
							"17.110.00;".
							"17.111.00;".
							"17.112.00;".
							"17.113.00;".
							"17.114.00;".
							"17.115.00;".
							"03.024.00;".
							"03.025.00;".
							"17.047.00;".
							"17.048.00;".
							"17.048.02;".
							"17.049.00;".
							"17.049.01;".
							"17.049.02;".
							"17.049.03;".
							"17.049.04;".
							"17.049.05;".
							"17.012.00;".
							"17.014.00;".
							"17.016.00;".
							"17.016.01;".
							"17.017.00;".
							"17.017.01;".
							"17.018.00;".
							"17.018.01;".
							"17.019.00;".
							"17.019.01;".
							"17.019.02;".
							"17.020.00;".
							"17.020.01;".
							"17.021.00;".
							"17.021.01;".
							"17.022.00;".
							"17.023.00;".
							"17.023.01;".
							"17.024.00;".
							"17.024.01;".
							"17.024.02;".
							"17.024.03;".
							"17.024.04;".
							"17.025.00;".
							"17.025.01;".
							"17.025.02;".
							"17.029.00;".
							"17.076.00;".
							"17.077.00;".
							"17.078.00;".
							"17.079.00;".
							"17.079.01;".
							"17.079.02;".
							"17.079.03;".
							"17.079.04;".
							"17.079.05;".
							"17.079.06;".
							"17.080.00;".
							"17.080.01;".
							"17.081.00;".
							"17.082.00;".
							"17.083.00;".
							"17.084.00;".
							"17.085.00;".
							"17.086.00;".
							"17.087.00;".
							"17.087.00;".
							"17.087.01;".
							"17.087.02;".
							"17.013.00;".
							"17.015.00;".
							"17.030.00;".
							"17.031.00;".
							"17.042.00;".
							"17.043.00;".
							"17.048.01;".
							"17.001.00;".
							"17.002.00;".
							"17.003.00;".
							"17.004.00;".
							"17.005.00;".
							"17.005.01;".
							"17.006.00;".
							"17.006.01;".
							"17.006.02;".
							"17.007.00;".
							"17.008.00;".
							"17.009.00;".
							"17.046.00;".
							"17.046.01;".
							"17.046.02;".
							"17.046.03;".
							"17.046.04;".
							"17.046.05;".
							"17.046.06;".
							"17.046.07;".
							"17.046.08;".
							"17.046.09;".
							"17.046.10;".
							"17.046.11;".
							"17.046.12;".
							"17.046.13;".
							"17.046.14;".
							"17.046.03;".
							"17.046.04;".
							"17.046.05;".
							"17.046.06;".
							"17.046.07;".
							"17.046.08;".
							"17.046.09;".
							"17.046.10;".
							"17.046.11;".
							"17.046.12;".
							"17.046.13;".
							"17.046.14;".
							"17.050.00;".
							"17.051.00;".
							"17.052.00;".
							"17.053.00;".
							"17.053.01;".
							"17.053.02;".
							"17.054.00;".
							"17.054.01;".
							"17.054.02;".
							"17.056.00;".
							"17.056.01;".
							"17.056.02;".
							"17.057.00;".
							"17.058.00;".
							"17.059.00;".
							"17.060.00;".
							"17.062.00;".
							"17.062.00;".
							"17.062.01;".
							"17.062.02;".
							"17.062.03;".
							"17.063.00;".
							"17.064.00;".
							"17.034.00;".
							"17.035.00;".
							"17.036.00;".
							"17.038.00;".
							"17.039.00;".
							"17.041.00;".
							"17.010.00;".
							"17.011.00;".
							"17.026.00;".
							"17.027.00;".
							"17.027.01;".
							"17.027.02;".
							"17.032.00;".
							"17.033.00;".
							"17.033.01;".
							"17.037.00;".
							"17.040.00;".
							"17.088.00;".
							"17.088.01;".
							"17.089.00;".
							"17.089.01;".
							"17.090.00;".
							"17.090.01;".
							"17.091.00;".
							"17.091.01;".
							"17.092.00;".
							"17.092.01;".
							"17.093.00;".
							"17.093.01;".
							"17.094.00;".
							"17.094.01;".
							"17.095.00;".
							"17.095.01;".
							"17.097.00;".
							"17.106.00;".
							"10.025.00;".
							"10.026.00;".
							"10.027.00;".
							"10.028.00;".
							"10.029.00;".
							"10.030.00;".
							"10.030.01;".
							"10.030.01;".
							"10.031.00;".
							"11.004.00;".
							"11.005.00;".
							"11.006.00;";

		return $cfg[$chave];
	}
?>
