<?
	require_once(dirname(__FILE__).'/nfe_funcoes.php');

	function nfe_retorna_nfe($nr_nota){
	}

	function nota_fiscal_gera_ped_sit($filt_serie,$modalidade){

		$con_nota_serie = 'select NFe_Ambiente from nota_fiscal_serie '.
							' where Dominio = "'.$_SESSION['Dominio'].'"'.
							' and Empresa="'.$_SESSION["Empresa_Codigo"].'"'.
							' and Modelo = "'.base64_decode_si($filt_serie).'"';
		$res_nota_serie = consulta_sql($con_nota_serie);
		$reg_nota_serie = consulta_ler_linha($res_nota_serie);
		consulta_limpa($res_nota_serie);

		$con_uf = 'select UF from pessoa_endereco '.
					' where Dominio = "'.$_SESSION['Dominio'].'"'.
					' and Pessoa = "'.$_SESSION["Empresa_Codigo"].'"'.
					' and Situacao <> "E" order by Seq_Endereco ';
		$res_uf = consulta_sql($con_uf);
		$reg_uf = consulta_ler_linha($res_uf);
		consulta_limpa($res_uf);

		$consulta = 'select Codigo_UF from uf '.
					' where Dominio="'.$_SESSION["Dominio"].'"'.
					' and UF = "'.$reg_uf[0].'"';
		$resultado = consulta_sql($consulta);
		$rowarr = consulta_ler_linha($resultado);
		consulta_limpa($resultado);

		$ano_mes = nfe_ano_mes();
		$versao_c = config_pad('nfe_versao');
		$xml = new XML();
		$root = &$xml->createRoot("consStatServ");
		$root->addAttribute('versao', $versao_c, true);
		$root->addAttribute('xmlns', 'http://www.portalfiscal.inf.br/nfe', true);

		$root->addAttribute('tpAmb', $reg_nota_serie[0], false);
		//$root->addAttribute('tpAmb', '1', false);
		$root->addAttribute('cUF',  $rowarr[0], false);
		$root->addAttribute('tpEmis',  $modalidade, false);
		$root->addAttribute('xServ',  'STATUS', false);

		$ano_mes = data_atual('date');
		$hora = nr2hora(hora_atual());

		$ano_mes_hora  = str_replace('-','',$ano_mes).'T'.str_replace(':','',$hora);
		//$ano_mes_hora = 'Outro';
		$xml->toFile(nfe_pasta_raiz().'tmp/', $ano_mes_hora.'-ped-sta.xml');
		$salvou = nfe_copia_arquivo('tmp','envio',$ano_mes_hora.'-ped-sta.xml','',false);

		//se consegui salvar
		if ($salvou){
			$ok = false;
			while (!($ok)){
				set_time_limit(60);
				if ((file_exists(nfe_pasta_raiz().'retorno/'.$ano_mes_hora.'-sta.xml'))||
					(file_exists(nfe_pasta_raiz().'retorno/'.$ano_mes_hora.'-ped-sta.err'))){
					$ok = true;
					sleep(10);
					if (file_exists(nfe_pasta_raiz().'retorno/'.$ano_mes_hora.'-sta.xml')){
						$status = '';
						$motivo = '';
						$xml = new XML();
						$xml->fromFile(nfe_pasta_raiz().'retorno/',$ano_mes_hora.'-sta.xml', true);
						if ($xml->root->name == 'retConsStatServ'){
							foreach($xml->root->atts as $key2 => $value){
								if ($xml->root->atts[$key2]->name== 'cStat'){
									$status = &$xml->root->atts[$key2]->value;
								}
								if ($xml->root->atts[$key2]->name== 'xMotivo'){
									$motivo = &$xml->root->atts[$key2]->value;
								}
							}
							if($status=='107'){
								unlink(nfe_pasta_raiz().'retorno/'.$ano_mes_hora.'-sta.xml');
								return true;
							}else {
								//salva arquivo na pasta de erros
								nfe_copia_arquivo('retorno','erros/'.$ano_mes,$ano_mes_hora.'-sta.xml','',true);
								//exibe motivo da Denegao da Autorizao
								nfe_exibe_erro('FRE-901','A SEFAZ no autorizou a entrada em Contingncia SCAN!'.
								'"'.$status.'" - '.$motivo,'');
								return false;
							}
						}else{
							unlink(nfe_pasta_raiz().'retorno/'.$ano_mes_hora.'-sta.xml');
							nfe_exibe_erro('FRE-906','Falha na estrutura do arquivo XML de retorno!','');
							return false;
						}
					}else if (file_exists(nfe_pasta_raiz().'retorno/'.$ano_mes_hora.'-ped-sta.err')){
						//exibe mensagem do arquivo de erro
						$conteudo_arquivo = nfe_abre_arquivo_err($ano_mes_hora.'-ped-sta.err');
						nfe_exibe_erro('FRE-902','Falha no Processamento do Arquivo "'.$ano_mes_hora.'-ped-sta.err"!'.
						$conteudo_arquivo,'');
						nfe_copia_arquivo('retorno','erros/'.$ano_mes,$ano_mes_hora.'-ped-sta.err','',true);
						return false;
					}else{
						nfe_exibe_erro('FRE-903','Falha no Processamento do Arquivo "'.$ano_mes_hora.'-ped-sta.xml"!','');
						return false;
					}
				}
			}//while
		}else{
			return false;
		}
		return false;
	}

	function arquivo_alt_con_uninfe_cfg($tipoAmb){
		$xml = new XML();
		$root = &$xml->createRoot("altConfUniNFe");
		$root->addAttribute('tpEmis', $tipoAmb, false);
		$ano_mes_hora  = 'uninfe-alt-con.xml';
		$xml->toFile(nfe_pasta_raiz().'tmp/', $ano_mes_hora);
		$salvou = nfe_copia_arquivo('tmp','envio',$ano_mes_hora,'',false);
		$ano_mes = nfe_ano_mes();
		//se consegui salvar
		if($salvou){
			$ok = false;
			while (!($ok)){
				set_time_limit(60);
				if ((file_exists(nfe_pasta_raiz().'retorno/uninfe-ret-alt-con.xml'))||
					(file_exists(nfe_pasta_raiz().'retorno/uninfe-alt-con.err'))){
					$ok = true;
					sleep(10);
					if (file_exists(nfe_pasta_raiz().'retorno/uninfe-ret-alt-con.xml')){
						unlink(nfe_pasta_raiz().'retorno/uninfe-ret-alt-con.xml');
						return true;
					}else if (file_exists(nfe_pasta_raiz().'retorno/uninfe-alt-con.err')){
						//exibe mensagem do arquivo de erro
						$conteudo_arquivo = nfe_abre_arquivo_err('uninfe-alt-con.err');
						nfe_exibe_erro('FRE-904','Falha no Processamento do Arquivo "uninfe-alt-con.err"!'.
						$conteudo_arquivo,'');
						nfe_copia_arquivo('retorno','erros/'.$ano_mes,'uninfe-alt-con.err','',true);
						return false;
					}else{
						nfe_exibe_erro('FRE-905','Falha no Processamento do Arquivo "uninfe-ret-alt-con.xml"','');
						return false;
					}
				}
			}
		}else{
			return false;
		}
	}
	
?>