<?php
	class session {
		public static function close(){
			if(isset($_SESSION["ID_ACESSO"])){
				session::sessao_ativa_sair($_SESSION['Dominio'],base64_decode_si($_SESSION['USER_ID']),$_SESSION['ID_ACESSO']);
			}
			$_SESSION = array();
			session_destroy();
		}

		public static function loga_usr($user_id) {
			$_SESSION["USER_ID"] = $user_id;
		}

		public static function permissoes($user_id, $dominio = '', $estacao = ''){
			//echo '1a';
			if($dominio==''){
				$_SESSION["Dominio"] = $_COOKIE['ID_DOMINIO'];
			}else{
				$_SESSION["Dominio"] = $dominio;
			}
			if($estacao == ''){
				$_SESSION["Estacao_Codigo"] = $_COOKIE['ID_ESTACAO'];
			}else{
				$_SESSION["Estacao_Codigo"] = $estacao;
			}
			$lista = consulta_sql('SELECT perm.Atividade, perm.Edita, perm.Insere, perm.Deleta FROM permissao perm'.
								' INNER JOIN atividade ativ '.
								' ON perm.Dominio = ativ.Dominio '.
								' AND perm.Atividade = ativ.Codigo '.
								' AND ativ.Modulo IN ('.verifica_modulos().')'.
								' WHERE perm.Dominio = "'.$_SESSION["Dominio"].'"'.
								' and perm.Usuario = "'.base64_decode_si($user_id).'" ');
			$nrows = consulta_num_registros($lista);
			for($k=0;$k<$nrows;$k++){
				$rowarr = consulta_ler_linha($lista);
				$_SESSION[$rowarr[0]."_Edita"] = $rowarr[1];
				$_SESSION[$rowarr[0]."_Insere"] = $rowarr[2];
				$_SESSION[$rowarr[0]."_Deleta"] = $rowarr[3];
				//echo $rowarr[0].'-'.$rowarr[1].$rowarr[2].$rowarr[3].'<BR>';
			}
			consulta_limpa($lista);
			//echo '2a';
			$con_usuario = 'SELECT Sexo,Perfil_Atual, Limite_Credito FROM usuario '.
							' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
							' and Usuario = "'.base64_decode_si($user_id).'" ';
			$lista = consulta_sql($con_usuario);
			$rowarr = consulta_ler_linha($lista);
			$_SESSION["USER_SEXO"] = $rowarr[0];
			$_SESSION["USER_PERFIL"] = $rowarr[1];
			$_SESSION["USER_LIMITE"] = $rowarr[2];
			consulta_limpa($lista);
			//echo '3a';
			$lista = consulta_sql('SELECT Empresa FROM estacao '.
								' WHERE Dominio = "'.$_SESSION["Dominio"].'" '.
								' AND Codigo_Estacao = "'.$_SESSION["Estacao_Codigo"].'"');
			$rowarr = consulta_ler_linha($lista);
			consulta_limpa($lista);
			$_SESSION["Empresa_Codigo"] = $rowarr[0];
			$lista = consulta_sql('SELECT Nome_Listas FROM pessoa '.
								' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
								' AND Pessoa = "'.$rowarr[0].'"');
			$rowarr = consulta_ler_linha($lista);
			$_SESSION["Empresa_Nome"] = $rowarr[0];
			consulta_limpa($lista);
			//echo '4a';
			return session::sessao_ativa_logar($_SESSION["Dominio"],
											base64_decode_si($user_id),
											$_SESSION["Empresa_Codigo"],
											$_SESSION["Estacao_Codigo"]);
		}

		public static function sessao_ativa_logar($dominio,$usuario,$empresa,$estacao){
			$retorno = array();
			$retorno['codigo'] = '';
			$retorno['descricao'] = '';
			$retorno['id_sessao'] = '';
			$retorno['prazo_val'] = '';
			//$retorno['qtd_max'] = 0;
			$endl = '|';
			//conuslta o dominio pra saber quantas licenar pode ser
			$con_dominio = 'SELECT * FROM dominio '.
							' WHERE Dominio = "'.$dominio.'"';
			$res_dominio = consulta_sql($con_dominio);
			$reg_dominio = consulta_ler_objeto($res_dominio);
			consulta_limpa($res_dominio);
			//valida MD5 do dominio
			$md5 = md5('$imples'.
								$reg_dominio->Dominio.'$'.
								$reg_dominio->CNPJ.'$'.
								$reg_dominio->Situacao.'$'.
								$reg_dominio->DataValidade.'$'.
								$reg_dominio->Acessos.'$Web');
			$pdv_login = "N";
			if($_SESSION['MOD'] == "PDV"){
				$pdv_login = "S";
			}
			if($md5!= $reg_dominio->Cript){
				$retorno['codigo'] = '201';
				$retorno['descricao'] = 'MD5 do Domnio no Confere!';
				return $retorno;
			}else{
				if(data2nr(dataf($reg_dominio->DataValidade)) < data_atual('nr')){
					$retorno['codigo'] = '203';
					$retorno['descricao'] = '*** Sistema com Prazo de Validade expirado ***|'.
											'*** Para renovar o prazo, contate a Freeline pelo fone 47 3473-0001 ***';
					return $retorno;
				}else{
					$retorno['prazo_val'] = $reg_dominio->DataValidade;
					//verifica se o usurio j est conectado
					//e faz log out dessa sesso se tiver uma autra ativa
					$con_usuario = 'SELECT DH_Login, DH_Logout FROM sessao_ativa '.
									' WHERE Dominio = "'.$dominio.'"'.
									' AND Usuario = "'.$usuario.'"'.
									' AND PDV="'.$pdv_login.'"';
					$res_usuario = consulta_sql($con_usuario);
					$nrw_usuario = consulta_num_registros($res_usuario);
					if($nrw_usuario == 1){
						$reg_usuario = consulta_ler_objeto($res_usuario);
						if($reg_usuario->DH_Logout == '0000-00-00 00:00:00'){
							session::sessao_ativa_sair($dominio, $usuario, $reg_usuario->DH_Login);
						}
					}
					consulta_limpa($res_usuario);
					$con_usuario = 'SELECT Usuario, DH_Login FROM sessao_ativa '.
									' WHERE Dominio = "'.$dominio.'"'.
									' AND DH_Logout = "0000-00-00 00:00:00"'.
									' AND Usuario <> "Freeline"'.
									' AND PDV = "N"'.
									' ORDER BY DH_Autentica';
					$res_usuario = consulta_sql($con_usuario);
					$nrw_usuario = consulta_num_registros($res_usuario);
					consulta_limpa($res_usuario);
					//descobre quantos precisa retirar
					$qtd_tirar = ($nrw_usuario - $reg_dominio->Acessos) + 1;
					$data = data_atual('date');
					$insere_acessos = 'INSERT IGNORE INTO sessao_acessos '.
										'(Dominio, Data, Qtd_Acessos, Qtd_Negados) '.
										' VALUES ("'.$dominio.'", "'.$data.'", "0", "0")';
					consulta_sql($insere_acessos, false);
					if(($_SESSION['MOD'] == 'PDV') || (strtolower($usuario) == 'freeline')){
						$qtd_tirar = 0;
					}else if($qtd_tirar > 0){
						$con_usuarioe = 'SELECT Usuario, DH_Login FROM sessao_ativa '.
										' WHERE Dominio = "'.$dominio.'"'.
										' AND DH_Logout = "0000-00-00 00:00:00"'.
										' AND Usuario <> "Freeline"'.
										' AND DH_Expira < now() '.
										' AND PDV = "N"'.
										' ORDER BY DH_Autentica';
						$res_usuarioe = consulta_sql($con_usuarioe);
						$nrw_usuarioe = consulta_num_registros($res_usuarioe);
						if($nrw_usuarioe >= $qtd_tirar){
							for($t=0;$t<$qtd_tirar;$t++){
								$reg_usuarioe = consulta_ler_objeto($res_usuarioe);
								session::sessao_ativa_sair($dominio, $reg_usuarioe->Usuario, $reg_usuarioe->DH_Login);
							}
						}
						consulta_limpa($res_usuarioe);
						//testa mais uma vez
						$con_usuario = 'SELECT Usuario, DH_Login FROM sessao_ativa '.
										' WHERE Dominio = "'.$dominio.'"'.
										' AND DH_Logout = "0000-00-00 00:00:00"'.
										' AND Usuario <> "Freeline"'.
										' AND PDV = "N"'.
										' ORDER BY DH_Autentica';
						$res_usuario = consulta_sql($con_usuario);
						$nrw_usuario = consulta_num_registros($res_usuario);
						consulta_limpa($res_usuario);
						$qtd_tirar = ($nrw_usuario - $reg_dominio->Acessos) + 1;
					}
					if($qtd_tirar > 0){ //no conseguiu
						$update_acessos = 'UPDATE sessao_acessos SET '.
											' Qtd_Negados = Qtd_Negados + 1 './/Qtd_Acessos
											' WHERE Dominio = "'.$dominio.'" '.
											' AND Data = "'.$data.'"';
						consulta_sql($update_acessos);
						$retorno['codigo'] = '202';
						$retorno['descricao'] = 'Quantidade de Acessos excede o Limite do Domnio: '.$endl.
												'Limite de Acessos Simultneos: '.$reg_dominio->Acessos.$endl.
												'Acessos Ativos: '.$nrw_usuario.$endl.$endl.
												'- Faa o Log-Off de outros usurios, e/ou;'.$endl.
												'- Tente acessar com outro usurio para desconect-lo da sesso anterior '.
												' (ATENO: este procedimento ir desabilitar a sesso deste outro usurio em outra estao de trabalho!), e/ou;'.$endl.
												'- Aguarde alguns momentos at que a senha de usurios inativos expire, e/ou;'.$endl.
												'- Acesse o Painel Administrativo do seu domnio para forar o Log-off de usurios '.
												' (para configurar a senha de acesso a esse painel, acesse as configuraes do sistema).'.$endl.$endl.
												'Contate a Freeline caso queria obter '.
												'um limite maior de acessos ao seu Domnio"';
						return $retorno;
					}else{
						$con_usuarioe = 'SELECT Usuario, DH_Login FROM sessao_ativa '.
										' WHERE Dominio = "'.$dominio.'"'.
										' AND DH_Logout = "0000-00-00 00:00:00"'.
										' AND Usuario <> "Freeline"'.
										' AND DH_Expira < now() '.
										' AND PDV = "N"'.
										' ORDER BY DH_Autentica';
						$res_usuarioe = consulta_sql($con_usuarioe);
						$nrw_usuarioe = consulta_num_registros($res_usuarioe);
						consulta_limpa($res_usuarioe);
						
						$qtd_acessos = ($nrw_usuario + 1) - $nrw_usuarioe;
						//cria peimrio acesso do usurio
						$update_acessos = 'UPDATE sessao_acessos SET '.
										' Qtd_Acessos = "'.$qtd_acessos.'" '.
										' WHERE Dominio = "'.$dominio.'" '.
										' AND Data = "'.$data.'"'.
										' AND Qtd_Acessos < "'.$qtd_acessos.'"';
						consulta_sql($update_acessos, false);
						$data_acesso = data_atual('date').' '.nr2hora(hora_atual());
						$tempo_usuario = '00:10:00';
						$ip = $_SERVER["REMOTE_ADDR"];
						
						
						
						
						//insert
						$ins_acesso = 'INSERT IGNORE INTO sessao_ativa '.
										'(Dominio, Usuario, PDV, Primiero_DH, Primeiro_IP) '.
										' VALUES '.
										' ("'.$dominio.'", "'.$usuario.'", "'.$pdv_login.'", "'.$data_acesso.'", "'.$ip.'")';
						consulta_sql($ins_acesso,false,1);
						//conulta ultimo acesso
						$con_usuario = 'SELECT DH_Login, DH_Logout, Ender_IP FROM sessao_ativa '.
										' WHERE Dominio = "'.$dominio.'"'.
										' AND Usuario = "'.$usuario.'"'.
										' AND PDV = "'.$pdv_login.'"';
						$res_usuario = consulta_sql($con_usuario);
						$reg_usuario = consulta_ler_objeto($res_usuario);
						consulta_limpa($res_usuario);
						
						//grava dados acesso novo
						$upt_acesso = 'UPDATE sessao_ativa SET '.
										' DH_Login = "'.$data_acesso.'", '.
										' DH_Autentica = "'.$data_acesso.'", '.
										' DH_Expira = ("'.$data_acesso.'" + INTERVAL '.hora2nr($tempo_usuario).' SECOND), '.
										' DH_Logout = "",'.
										' Ender_IP = "'.$ip.'", '.
										' Estacao = "'.$estacao.'", '.
										' Empresa = "'.$empresa.'", '.
										' Tempo_Expira = "'.$tempo_usuario.'",'.
										' Ultimo_DH_Login = "'.$reg_usuario->DH_Login.'",'.
										' Ultimo_DH_Logout = "'.$reg_usuario->DH_Logout.'",'.
										' Ultimo_IP = "'.$reg_usuario->Ender_IP.'" '.
										//' PDV = "'.$pdv_login.'"'.
										' WHERE Dominio = "'.$dominio.'"'.
										' AND Usuario = "'.$usuario.'"'.
										' AND PDV = "'.$pdv_login.'"';
						consulta_sql($upt_acesso, false);
						$retorno['codigo'] = '100';
						$retorno['descricao'] = 'Acesso concedido!';
						$retorno['id_sessao'] = $data_acesso;
						$_SESSION["ID_ACESSO"] = $data_acesso;
						session::salvarLogAcessos($dominio, $usuario, 'login');
						return $retorno;
					}
				}
			}
		}

		public static function sessao_ativa_sair($dominio,$usuario,$sessao){
			//verifica se o usurio j est conectado
			$pdv_login = "N";
			if($_SESSION['MOD'] == "PDV"){
				$pdv_login = "S";
			}
			$con_usuario = 'UPDATE sessao_ativa SET '.
							' DH_Logout = now() '.
							' WHERE Dominio = "'.$dominio.'"'.
							' AND Usuario = "'.$usuario.'"'.
							' AND PDV = "'.$pdv_login.'"'.
							' AND DH_Login = "'.$sessao.'"';
			consulta_sql($con_usuario, false);
			session::salvarLogAcessos($dominio, $usuario, 'logout');
		}

		public static function sessao_ativa_atualiza($dominio, $usuario, $sessao){
			//verifica se o usurio j est conectado
			//$_REQUEST['USER_ID'] = base64_encode($usuario);
			$pdv_login = "N";
			if($_SESSION['MOD'] == "PDV"){
				$pdv_login = "S";
			}
			
			$con_usuario = 'SELECT DH_Login, DH_Logout, DH_Expira FROM sessao_ativa '.
							' WHERE Dominio = "'.$dominio.'"'.
							' AND Usuario = "'.$usuario.'"'.
							' AND PDV = "'.$pdv_login.'"';
			$res_usuario = consulta_sql($con_usuario);
			$reg_usuario = consulta_ler_objeto($res_usuario);
			consulta_limpa($res_usuario);
			$dt_nr_expira = data2nr(dataf($reg_usuario->DH_Expira));
			$hr_nr_expira = hora2nr(substr($reg_usuario->DH_Expira, 11, 8));
			$hr_nr_expira+= $dt_nr_expira * (24 *60 * 60);//segundos do dia
			$dt_nr_min = data_atual('num');
			$hr_nr_min = hora_atual() + ($dt_nr_min* (24 * 60 * 60));
			$hr_nr_min-= ( 2 * (24 *60 * 60)); //2 dias
			if($hr_nr_expira < $hr_nr_min){
				$res_atualiza = 0; //dois dias expirou
			}else if(($reg_usuario->DH_Login == $sessao) &&
					($reg_usuario->DH_Logout == '0000-00-00 00:00:00')){
				$data_acesso = data_atual('date').' '.nr2hora(hora_atual());
				$con_usuario = 'UPDATE sessao_ativa SET '.
								' DH_Autentica = "'.$data_acesso.'", '.
								' DH_Expira = ("'.$data_acesso.'" + INTERVAL TIME_TO_SEC(Tempo_Expira) SECOND) '.
								' WHERE Dominio = "'.$dominio.'"'.
								' AND Usuario = "'.$usuario.'"'.
								' AND PDV = "'.$pdv_login.'"'.
								' AND DH_Login = "'.$sessao.'"'.
								' AND DH_Logout = "0000-00-00 00:00:00"';
				consulta_sql($con_usuario, false, 1);
				$res_atualiza = 1;
			}else{
				$res_atualiza = 0;
			}
			return ($res_atualiza == 1);
		}

		public static function start($modulo = ''){
			set_time_limit(0);
			session_name('Freeline');
			session_cache_expire (648000);
			session_start();
			if($modulo != ''){
				$_SESSION['MOD'] = $modulo;
			}
		}

		public static function start_imp($dominio = ''){
			set_time_limit(0);
			session_name('FreelineImp');
			session_cache_expire (648000);
			session_start();
			//echo 'Dominio='.$dominio;
			if($dominio == ''){
				$dominio = config_pad('sistema_dominio');
			}
			if($dominio != '-1'){ //no troca depois que j fez o login
				$_SESSION["Dominio"] = $dominio;
				$_SESSION["Empresa_Codigo"] = '1';
				$_SESSION["Estacao_Codigo"] = 0;
				$_SESSION['MOD'] = 'ADM';
			}
		}

		public static function usr_logado() {
			return $_SESSION["USER_ID"];
		}

		public static function tempermissao($atividade){
			$permis = '   ';
			if(!isset($_SESSION[$atividade."_Edita"])){
				$permis[0] = ' ';
			}else{
				$permis[0] = $_SESSION[$atividade."_Edita"];
			}
			if(!isset($_SESSION[$atividade."_Insere"])){
				$permis[1] = ' ';
			}else{
				$permis[1] = $_SESSION[$atividade."_Insere"];
			}
			if(!isset($_SESSION[$atividade."_Deleta"])){
				$permis[2] = ' ';
			}else{
				$permis[2] = $_SESSION[$atividade."_Deleta"];
			}
			return $permis;
		}

		public static function loja_user(){
			return $_SESSION["Empresa"];
		}

		public static function usr_conectado($user){
			if(isset($_SESSION["CRM_REL"]) && $_SESSION["CRM_REL"]){
				return true;
			}
			//session_cache_expire (648000);
			session::start();
			$ori = '';
			if(!(file_exists('login.php'))){
				$ori = '../../';
			}
			if(!(file_exists($ori.'login.php'))){
				$ori = '../';
			}
			if(!isset($_SESSION['USER_ID'])){
				header('location: '.$ori.'login.php?error=2');
				return false;
			}else if($_SESSION['USER_ID'] != $user){
				header('location: '.$ori.'login.php?error=3&msn='.base64_decode_si($_SESSION['USER_ID']));
				return false;
			}else{
				//valida sesso logada
				if(session::sessao_ativa_atualiza($_SESSION['Dominio'], base64_decode_si($_SESSION['USER_ID']), $_SESSION['ID_ACESSO'])){
					$c1 = BuscaParam('COR_GRADE');
					$c2 = BuscaParam('COR_GRADE_ATIVO');
					if($c1!='')
						$GLOBALS['color1'] = $c1;
					if($c2!='')
						$GLOBALS['color2'] = $c2;
					return true;
				}else{
					header('location: '.$ori.'login.php?error=6&msn=Esta sesso foi desconectada!');
					return false;
				}
			}
		}

		public static function usr_conectado_imp($user){
			session::start_imp('-1');//-1 para no trocar o dominio
			$ori = '';
				if(!(file_exists('login.php'))){
				$ori = '../../';
			}
			if(!(file_exists($ori.'login.php'))){
				$ori = '../';
			}
			if(!isset($_SESSION['USER_ID'])){
				header('location: '.$ori.'login.php?error=2');
				return false;
			}else if($_SESSION['USER_ID'] != $user){
				header('location: '.$ori.'login.php?error=3&msn='.base64_decode_si($_SESSION['USER_ID']));
				return false;
			}else{
				//valida sesso logada
				return true;
			}
			return true;
		}

		public static function salvarLogAcessos($dominio, $usuario, $tipo = ''){
			if(UpperDados($usuario) != 'FREELINE'){
				$dataAtual = data_atual('data');
				$horaAtual = hora_atual('hora');
				$insert = 'INSERT INTO sessao_historico_usuario ( '.
							' Dominio, '.
							' Usuario, '.
							' Data_Hora, '.
							' Tipo '.
							' ) VALUES ( '.
							' "'.$dominio.'", '.
							' "'.$usuario.'", '.
							' "'.datad($dataAtual).' '.$horaAtual.'", '.
							' "'.$tipo.'" '.
							' )';
				consulta_sql($insert);
				if($dominio == '10'){
					$ano = substr($dataAtual, 6, 4);
					$mes = substr($dataAtual, 3, 2);
					$dir = DIR_ARQUIVOS_CLIENTES.'/'.$dominio.'/log_acessos';
					$arquivo = 'log_'.$usuario.'_'.$ano.$mes.'.csv';
					rmkdir($dir);
					$dirArquivo = $dir.'/'.$arquivo;
					$txt = '';
					if(!file_exists($dirArquivo)){
						$txt = 'Data;Hora;Usurio;Tipo'.PHP_EOL;
					}
					$txt.= $dataAtual.';'.hora_atual('hora').";".$usuario.';'.$tipo.PHP_EOL;
					file_put_contents($dirArquivo, $txt, FILE_APPEND | LOCK_EX);
				}
			}
		}
	}
	
?>