<?php

class OFXparaXML {    
	private $txtFile;
	private $empresa;
	private $xmlFile;
	private $anoMes; 
	private $data;
	private $datah;
	private $arquivoXML;
	public function __construct() {

		$this->anoMes= date('Ym');	
		$this->data = date('Ymd');
		$this->datah = date('Ymd_Hi');
		$this->empresa = $_SESSION["Empresa_Codigo"];
		$caminhoOriginal =  "../../../arquivos_clientes/".$_SESSION['Dominio']."/integracao/banco/ofx/".$this->empresa."/".$this->anoMes."/";
		$this->arquivoXML = "../../../arquivos_clientes/".$_SESSION['Dominio']."/integracao/banco/ofx/".$this->empresa."/".$this->anoMes."/".$this->datah."_arquivo.xml";

		

	
		// Meu arquivo
		$arquivo = $this->datah.'_original.txt';

		// Cria o recurso (abrir o arquivo);
		// $handle = file_get_contents( $caminhoOriginal.$arquivo );
		// $this->txtFile = $handle;


		$linhas = file($caminhoOriginal.$arquivo);
		$this->txtFile = $linhas;

		// echo '<bR>linha 26 ( recebeOFXdevolveXML):<pre>';	
		// var_dump( $this->txtFile );
		// echo '</pre>';
	} 
    
    

    /**Formar arquivo XML */
    public function  formarArquivoXML(){ 

		$devolve = array();		
        $msg ='';
		$data = date('Ym');	
		$data2 = date('Ymd');
		$empresa = $_SESSION["Empresa_Codigo"];
		$caminhoSaida =  "../../../arquivos_clientes/".$_SESSION['Dominio']."/integracao/banco/ofx/".$this->empresa."/".$this->anoMes."/";
		if (realpath($caminhoSaida) !== false && is_dir($caminhoSaida)) {
			$msg .= '<br>O caminho completo existe.<br>'. $caminhoSaida;
		} else {
			$msg .= '<br>O caminho completo no existe.<br>';
			if (  mkdir( $caminhoSaida, 0777, true )){
				print_r(error_get_last());
			}
			// 0755; 0777;  0700
		}
        $data2 = date("Ymd");
        
        $dom = new DOMDocument('1.0' , 'UTF-8');
        $dom->formatOutput = true;
        //formatar a saida do documento 


		$infoNode = $dom->createElement('informacoes');
        $bancoNode = $dom->createElement('banco');
        $rootNode = $dom->createElement('root');

		$dom->appendChild($rootNode) ;

		$cada_linha = array();
		foreach ( $this->txtFile  as $linha) {
			//$conteudo = explode("\n", $linha);
			$conteudo = preg_split('/\r\n|\r|\n/',  $linha );
			$cada_linha[] = $conteudo[0];
		}



	

			// $cada_linha= preg_split('/\r\n|\r|\n/',  $this->ofxFile );
			// echo '<bR>linha 91 ( recebeOFXdevolveXML):<pre>';
			// print_r($cada_linha);
			// echo '</pre>';



			for(  $ln = 0 ;  $ln <count($cada_linha); $ln++  ){
				//echo' <br> linha 97 (recebe e devolve )::: '. $cada_linha[$ln] ;

				//pegando as primeiras linhas do arquivo
				$comparar = ':';               
                if( ( strpos( $cada_linha[$ln]  , $comparar ) !== false) && $ln <9 ){
                    
                    $titulos[$ln] = explode( ":", $cada_linha[$ln]);
                    
					$tituloNodeValue[$ln] = $dom->createTextNode($titulos[$ln][1]);
                    $tituloNode[$ln] = $dom->createElement($titulos[$ln][0]);
                    $tituloNode[$ln]->appendChild($tituloNodeValue[$ln]);
                    $infoNode->appendChild( $tituloNode[$ln]  );
                    $rootNode->appendChild($infoNode );
				}else{
                    //iremos tratar as outras linhas do OFX 
                    $comparar = '<';
                    $tagpai='';
                    $tagfilho='';
                    $tagfim ='';


					if(substr( trim( $cada_linha[$ln] ), 0, 1) === "<"){

                       // $cada_linha[$ln] = str_replace('<', '[',trim( $cada_linha[$ln]) );
                        //$cada_linha[$ln] = str_replace('>', ']', trim($cada_linha[$ln]) );
                        $itag = strpos( $cada_linha[$ln] , '<');
                        $ftag = strpos( $cada_linha[$ln] , '>');
                        $tagFinaliza = strpos( $cada_linha[$ln] , "</");
					// 	if(  $tagFinaliza == ''){
					// 		$tagFinaliza = strpos( $cada_linha[$ln] , ">");

					// 	}
                    //    echo ' quem??? '.
					    $tagpai = substr( $cada_linha[$ln]  , ($itag +1),  ($ftag - $itag -1) );
                        //$tagfilho = substr( $cada_linha[$ln]  ,  ($ftag +1),  ($tagFinaliza  -  ($ftag+1)   ) );

						//echo ' <br> linha 127 tagpai:::: '. $tagpai;


						if( $tagFinaliza == false ||   $tagFinaliza == 0  ){
							$tagfilho = substr( $cada_linha[$ln]  ,  ($ftag +1)  );
					    }else{
							$tagfilho = substr( $cada_linha[$ln]  ,  ($ftag +1)  , (($tagFinaliza-0) - ($ftag +1))  );
					    }
					  

                        //criar o n pai
                        //ofx
                        if( $tagpai == 'OFX'){
                            $ofxNode = $dom->createElement( $tagpai);
                            $bancoNode->appendChild(  $ofxNode) ;

                            
                            
                        }


						//aqui eu comeco os filhos de ofx 
						if(  $ofxNode ){
                            if( $tagpai == 'SIGNONMSGSRSV1'){
                                $sigNode = $dom->createElement( $tagpai);
                                $ofxNode->appendChild(  $sigNode );
                            }//FEHCA PAI  SIGNO
                           
                            if( $sigNode ){
                                if( $tagpai == 'SONRS'){
                                    $SONRS = $dom->createElement( $tagpai);
                                    $sigNode->appendChild( $SONRS   );                                   
                                }
                                if( $SONRS ){

									if( $tagpai == 'STATUS'){
                                        $STATUS = $dom->createElement( $tagpai);
                                        $SONRS->appendChild( $STATUS  );
                                    }

                                    if(  $STATUS ){
                                        if( $tagpai == 'CODE'  ||  $tagpai == 'SEVERITY' ){
                                            $tpaiSTATUS = $dom->createElement( $tagpai);
                                            $STATUS->appendChild(  $tpaiSTATUS  );                
                                            $filhoSTATUS = $dom->createTextNode($tagfilho);                
                                            $tpaiSTATUS->appendChild($filhoSTATUS );
                                        }    
                                    }//SE STATUS EXISTE 

									//verifica se a tag pai  DTSERVER
                                    if( $tagpai == 'DTSERVER'   ){
                                        $DTSERVER = $dom->createElement( $tagpai);
                                        $SONRS->appendChild( $DTSERVER  );

                                        $filhoDTSERVER = $dom->createTextNode($tagfilho);
                                        $DTSERVER->appendChild(  $filhoDTSERVER );

                                    }
									//verifica se a tag pai  LANGUAGE
                                    if( $tagpai == 'LANGUAGE'){
                                        $LANGUAGE = $dom->createElement( $tagpai);
                                        $SONRS->appendChild( $DTSERVER  );

                                        $filhoLANGUAGE = $dom->createTextNode($tagfilho);
                                        $LANGUAGE->appendChild(  $filhoLANGUAGE );

                                    }

                                    

									
									
                                    //verifica se a tag pai  FI
                                    if( $tagpai == 'FI'){
                                        $FI = $dom->createElement( $tagpai);
                                        $SONRS->appendChild( $FI  );

                                    }
                                    if( $FI ){
                                        if( $tagpai == 'ORG' || $tagpai == 'FID' ){
                                            $tagFilhoFI = $dom->createElement( $tagpai);
                                            $FI->appendChild( $tagFilhoFI  );
    
                                            $filhoFI = $dom->createTextNode($tagfilho);
                                            $tagFilhoFI->appendChild(  $filhoFI  );        
                                        }
                                    }
								}//FECHA SE SONS EXISTE 
                            }//FECHA SE SIGNO EXISTE  
                            
							//comecando as tag de  BANKMSGSRSV1
                            if($tagpai == 'BANKMSGSRSV1' ){
                                $BANKMSGSRSV1 = $dom->createElement( $tagpai);
                                $ofxNode->appendChild(   $BANKMSGSRSV1  );
                            }

							//comecando a add os filhos dele 
                            if( $BANKMSGSRSV1 ){
                              
                                if( $tagpai == 'STMTTRNRS'){
                                    $STMTTRNRS = $dom->createElement( $tagpai);
                                    $BANKMSGSRSV1->appendChild( $STMTTRNRS   );                                   
                                }

								if(  $STMTTRNRS ){
                                    if( $tagpai == 'TRNUID'){
                                        $TRNUID = $dom->createElement( $tagpai);
                                        $STMTTRNRS->appendChild( $TRNUID  ); 
                                        
                                        $filhoTRNUID = $dom->createTextNode($tagfilho);                
                                        $TRNUID->appendChild( $filhoTRNUID );
                                    }

                                    if( $tagpai == 'STATUS'){
                                        $STATUS_STMTTRNRS = $dom->createElement( $tagpai);
                                        $STMTTRNRS->appendChild( $STATUS_STMTTRNRS  );
                                    }

                                    if(  $STATUS_STMTTRNRS ){
                                        if( $tagpai == 'CODE'  ||  $tagpai == 'SEVERITY' ){
                                            $tpaiSTATUS = $dom->createElement( $tagpai);
                                            $STATUS_STMTTRNRS->appendChild(  $tpaiSTATUS  );
                
                                            $filhoSTATUS = $dom->createTextNode($tagfilho);                
                                            $tpaiSTATUS->appendChild($filhoSTATUS );
                                        }    
                                    }//SE STATUS EXISTE
									
									
									// informacoes do banco 
                                    if( $tagpai == 'STMTRS'){
                                        $STMTRS = $dom->createElement( $tagpai);
                                        $STMTTRNRS->appendChild( $STMTRS  );
                                    }
                                    if( $STMTRS ){
                                        if( $tagpai == 'CURDEF'   ){
                                            $CURDEF = $dom->createElement( $tagpai);
                                            $STMTRS->appendChild(  $CURDEF  );

                                            $filho = $dom->createTextNode($tagfilho);                
                                            $CURDEF->appendChild($filho );
                                        } 
                                        
                                        if( $tagpai == 'BANKACCTFROM'   ){
                                            $BANKACCTFROM = $dom->createElement( $tagpai);
                                            $STMTRS->appendChild(  $BANKACCTFROM );
                                        }

                                        if( $BANKACCTFROM){
                                            if( $tagpai == 'BANKID'  ||  $tagpai == 'BRANCHID' ||  $tagpai == 'ACCTID' ||  $tagpai == 'ACCTTYPE' ){
                                                $tpaiBANKACCTFROM = $dom->createElement( $tagpai);
                                                $BANKACCTFROM->appendChild(  $tpaiBANKACCTFROM  );                                             
                                                
                                                $filhoBANKACCTFROM = $dom->createTextNode($tagfilho);                
                                                $tpaiBANKACCTFROM->appendChild( $filhoBANKACCTFROM );
                                            }
                                        }

										//informacoes desta lista bancaria 
                                        if( $tagpai == 'BANKTRANLIST'   ){
                                            $BANKTRANLIST = $dom->createElement( $tagpai);
                                            $STMTRS->appendChild(  $BANKTRANLIST );
                                        }

										if( $BANKTRANLIST ){

                                            if( $tagpai == 'DTSTART'  ||  $tagpai == 'DTEND'  ){
                                                $tpaiBANKTRANLIST = $dom->createElement( $tagpai);
                                                $BANKTRANLIST->appendChild(  $tpaiBANKTRANLIST  );                                             
                                                
                                                $filhoBANKTRANLIST = $dom->createTextNode($tagfilho);                
                                                $tpaiBANKTRANLIST->appendChild( $filhoBANKTRANLIST );
                                            }
                                            //as movimentacao do periodo 
                                            if( $tagpai == 'STMTTRN'   ){
                                                $STMTTRN = $dom->createElement( $tagpai);
                                                $BANKTRANLIST->appendChild(  $STMTTRN );
                                            }

                                            if( $STMTTRN ){
                                                if( $tagpai == 'TRNTYPE'  ||  $tagpai == 'DTPOSTED' ||  $tagpai == 'TRNAMT'  ||  $tagpai == 'FITID'   ||  $tagpai == 'MEMO'  ||  $tagpai == 'CHECKNUM'  ||  $tagpai == 'REFNUM' ){
                                                    $tpaiSTMTTRN = $dom->createElement( $tagpai);
                                                    $STMTTRN->appendChild(  $tpaiSTMTTRN  );                                             
                                                    
                                                    $filhoSTMTTRN = $dom->createTextNode($tagfilho);                
                                                    $tpaiSTMTTRN->appendChild( $filhoSTMTTRN );
                                                }
                                            }
                                        }

										//balanco final da operacao
                                        if( $tagpai == 'LEDGERBAL'   ){
                                            $LEDGERBAL = $dom->createElement( $tagpai);
                                            $STMTRS->appendChild(  $LEDGERBAL );
                                        }
                                        if( $LEDGERBAL ){
                                            if( $tagpai == 'BALAMT'  ||  $tagpai == 'DTASOF'){
                                                $tpaiLEDGERBAL = $dom->createElement( $tagpai);
                                                $LEDGERBAL->appendChild(  $tpaiLEDGERBAL  );                                             
                                                
                                                $filhoLEDGERBAL = $dom->createTextNode($tagfilho);                
                                                $tpaiLEDGERBAL->appendChild( $filhoLEDGERBAL );
                                            }
                                        }

										//Rendimentos 
                                        if( $tagpai == 'BALLIST'   ){
                                            $BALLIST = $dom->createElement( $tagpai);
                                            $STMTRS->appendChild(  $BALLIST );
                                        }
                                        if( $BALLIST ){

                                            if( $tagpai == 'BAL'   ){
                                                $BAL = $dom->createElement( $tagpai);
                                                $BALLIST->appendChild(  $BAL );
                                            }
                                            if($BAL){                                            
                                                if( $tagpai == 'NAME'  ||  $tagpai == 'DESC'  ||  $tagpai =='BALTYPE'   ||  $tagpai == 'VALUE'){
                                                    $tpaiBAL = $dom->createElement( $tagpai);
                                                    $BAL->appendChild(  $tpaiBAL  );                                             
                                                    
                                                    $filhoBAL = $dom->createTextNode($tagfilho);                
                                                    $tpaiBAL->appendChild( $filhoBAL );
                                                }
                                            }
                                        }
									}//fehcamento temporario de  $STMTRS
								}//FECHAMENTO TEMPORARIO DA $STMTTRNRS
							}//FECHAMENTO TEMPORAIRO DA  $BANKMSGSRSV1
						}//FECHAMETNO TEMPORARIO 
					}//fECHAMENTO TEMPORARIO
				}//fim da leitura das tags
			}//fim para cada linha 
		//}//fim da leitura de toda a string



		$rootNode->appendChild($infoNode );
		$rootNode->appendChild($bancoNode);


        $xml =  $dom->saveXML(); 


		// echo '<bR>linha 143( recebeOFXdevolveXML):<pre>';		
		// echo $xml ; 
		// echo '</pre>';



        // //salvando com o DOM
        //$dom->save(  $caminhoSaida . 'arquivo.xml' );
/*

Comentado em  14-04-2023 apenas para nao ficar copiando em cima do arquivo ja existente */
        $arqSaida =   $caminhoSaida . $this->datah.'_arquivo.xml' ;
        $fp = fopen(  $arqSaida , 'a');
        fwrite($fp,  $xml  );
        fclose($fp);
/**/

		if( file_exists(  $arqSaida ) ){
			$retorno['status'] = 'Arquivo Gerado com Sucesso';

		}else{
			$retorno['status'] = 'Erro';
			$retorno['msg'] = 'Erro ao gerar o arquivo XML';
		}
		return $retorno ;

    }

    public function resultado(){ 
        return $resultado['msg'] = 'VAZIO';
    }

	/**Funo para pegar as informaes principais do arquivo (codificacao)	*/
	public function getInfoArq(){

		$xml = new SimpleXMLElement($this->arquivoXML  , null, true   ); 
		$ENCODING = $xml->informacoes->ENCODING;
		$CHARSET = $xml->informacoes->CHARSET;

		return Array( 'encoding' => $ENCODING, 'charset' => $CHARSET); 

	}


	/*     * Retorna o Saldo da conta na data de exportao do extrato     */ 
	public function getBalance() { 
	
		$xml = new SimpleXMLElement($this->arquivoXML  , null, true   ); 
		
		$balance = $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->LEDGERBAL->BALAMT;        
		$dateOfBalance = $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->LEDGERBAL->DTASOF; 
		$date = strtotime(substr($dateOfBalance, 0, 8));  
		$dateToReturn = date('Y-m-d', $date);   
		return Array('date' => $dateToReturn, 'balance' => $balance);    
	} 



	
	/****Retorna uma array de objetos com as informaes do balano do perodo
	 * Informaes encontradas no banco  NU PAGAMENTOS S.A. ( 260 )
	 * 
	 */
	public function getRendimentos() {        
		$xml = new SimpleXMLElement( $this->arquivoXML  , null, true ); 
		$info_rend =   $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->BALLIST->BAL;        
		return $info_rend ;
	} 


	/*     * Retora um array de objetos com as transaes      *
	       * DTPOSTED => Data da Transao    
	       * TRNAMT   => Valor da Transao      
	       * TRNTYPE  => Tipo da Transao  (Dbito ou Crdito)     
	       * MEMO     => Descrio da Transao     */    
	public function getTransactions() {        
		$xml = new SimpleXMLElement($this->arquivoXML  , null, true);       
		$transactions = $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->BANKTRANLIST->STMTTRN;        
		return $transactions;    
	}

	/**Retorna as informaes do banco 
	 * BANKID   => Numero do Banco ( Teste == 748 );
	 * ACCTID   => Agencia[4 primeiros digitos ] e Numero [sequencia ] (26020000000290068)
	 * ACCTTYPE => Tipo de informao vinda do Banco ??? (CHECKING) 
	 */
	public function getBanco(){
		$xml = new SimpleXMLElement( $this->arquivoXML  , null, true);       
		$info_banco = $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->BANKACCTFROM;        
		return $info_banco; 

	}

	/**Retorna uma array com as Data Inicial e Final do arquivo OFX 
	 * DTSTART => Data inicial do evento ( 20200501000000[-3:GMT] )
	 * DTEND   => Data final do evento  ( 20200531000000[-3:GMT])
	*/
	public function getDatas(){

		$xml = new SimpleXMLElement($this->arquivoXML  , null, true );
		$data_inicio='0000-00-00';
		$data_fim='0000-00-00';
		$dataI =  $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->BANKTRANLIST->DTSTART; 
		$dateI = strtotime(substr($dataI, 0, 8));
		$data_inicio= date('Y-m-d', $dateI); 
		$dataF =  $xml->banco->OFX->BANKMSGSRSV1->STMTTRNRS->STMTRS->BANKTRANLIST->DTEND;
		$dateF = strtotime(substr($dataF, 0, 8)); 
		$data_fim= date('Y-m-d', $dateF);
		
		return Array('inicio' => $data_inicio, 'fim' => $data_fim);   

	}






	/*     * Converte o arquivo OFX para XML     */    
	public function getOfxAsXML() {        
		$content = file_get_contents($this->ofxFile);        
		$line = strpos($content, "<OFX>");        
		$ofx = substr($content, $line - 1);        
		$buffer = $ofx;        $count = 0;       
		while ($pos = strpos($buffer, '<')) {           
		 	$count++;            
		 	$pos2 = strpos($buffer, '>');            
		 	$element = substr($buffer, $pos + 1, $pos2 - $pos - 1);            
		 	if (substr($element, 0, 1) == '/')               
		 		 $sla[] = substr($element, 1);            
		 	else                
		 		$als[] = $element;            
		 	$buffer = substr($buffer, $pos2 + 1);        
		 
		}
    }
}

?>