<?php

	require_once(dirname(__FILE__).'/_cfg.php');
	require_once(dirname(__FILE__).'/conn_default.php');
	require_once(dirname(__FILE__).'/combos_fixas.php');
	require_once(dirname(__FILE__).'/funcoes/data_hora.php');
	require_once(dirname(__FILE__).'/funcoes/consulta_sql.php');
	require_once(dirname(__FILE__).'/funcoes/sessao.php');
	require_once(dirname(__FILE__).'/funcoes/formatacao_valor.php');
	require_once(dirname(__FILE__).'/funcoes/parametro.php');
	require_once(dirname(__FILE__).'/funcoes/log.php');
	require_once(dirname(__FILE__).'/funcoes/sistema.php');
	require_once(dirname(__FILE__).'/funcoes/email.php');
	require_once(dirname(__FILE__).'/funcoes/arquivo.php');
	require_once(dirname(__FILE__).'/funcoes/requisicao.php');
	require_once(dirname(__FILE__).'/funcoes/embalagem.php');
	require_once(dirname(__FILE__).'/funcoes/comanda.php');
	require_once(dirname(__FILE__).'/funcoes/doc_aux.php');
	require_once(dirname(__FILE__).'/funcoes/barcodeValidator.php');
	require_once(dirname(__FILE__).'/funcoes/engenharia.php');
	require_once(dirname(__FILE__).'/funcoes/assert_options.php');
	// Classes
	require_once(dirname(__FILE__).'/classes/Sistema.php');
	require_once(dirname(__FILE__).'/classes/Dominio.php');

	function busca_menus($menu){
		$menu = substr($menu,1);//tira o primiro ";"
		$resultado = array();
		$k = 0;
		while(strpos(' '.$menu,';',0)>0){
			$n = strpos(' '.$menu,';',0);
			$resultado[$k] = substr($menu,0,($n-1));
			$menu = substr($menu,$n);
			$k++;
		}
		return $resultado;
	}

	function monta_cb_busca($chave, $valor, $valor_pad){
		if($chave == $valor_pad){
			return "<option value='".$chave."' selected>".$valor."</option>";
		}else{
			return "<option value='".$chave."'>".$valor."</option>";
		}
	}

	function cria_cb_busca($nome,$valor_pad){
		$resultado = '';
		$lista = monta_lista_cb_fixo($nome);
		for($i=0;$i<$lista['lista'];$i++){
			$resultado.= monta_cb_busca($lista['vlista'][$i], $lista['slista'][$i], $valor_pad);
		}
		return $resultado;
	}

	function busca_dados_combo($nome, $valor_pad){
		$resultado = '';
		$lista = monta_lista_cb_fixo($nome);
		for($i=0;$i<$lista['lista'];$i++){
			if($lista['vlista'][$i] == $valor_pad){
				$resultado = $lista['slista'][$i];
			}
		}
		return $resultado;
	}

	function base64_decode_si($valor){
		$valor = str_replace(' ','+',$valor);
		$valor = base64_decode($valor);
		return $valor;
	}

	function is_base64($data){
		return (base64_encode(base64_decode($data)) === $data);
	}
	function coloca_prefixo_tabela($nm_tabela,$prefixo,$sql){
		require_once(dirname(__FILE__).'/inc_busca/'.$nm_tabela.'.php');
		$campos = $tabela['campo'];
		$n = $tabela['ncampos'];
		$repl = 'Dominio'; $sql = str_replace($repl,$prefixo.'.'.$repl,$sql);
		$repl = 'Status';  $sql = str_replace($repl,$prefixo.'.'.$repl,$sql);
		$repl = 'Situacao';$sql = str_replace($repl,$prefixo.'.'.$repl,$sql);
		
		for($i=0;$i<$n;$i++){
			if (($i==0)&&($nm_tabela=='contas_receber')){
				$repl = 'Nr_Doc';$sql = str_replace($repl,$prefixo.'.'.$repl,$sql);
				$repl = 'Serie'; $sql = str_replace($repl,$prefixo.'.'.$repl,$sql);
				$repl = 'MOdelo';$sql = str_replace($repl,$prefixo.'.'.$repl,$sql); 
			}else{
				$repl = $campos[$i]['nome'];
				$sql = str_replace($repl,$prefixo.'.'.$repl,$sql);
			}
		}
		
		$repl = $prefixo.'.'.$prefixo.'.';$sql = str_replace($repl,$prefixo.'.',$sql);
		$repl = $prefixo.'.'.$prefixo.'.';$sql = str_replace($repl,$prefixo.'.',$sql);
		return $sql;
	}
?>