<?
    require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
    session::usr_conectado($_REQUEST['USER_ID']);
    require_once('../../includes/write_excel/Worksheet.php');
    require_once('../../includes/write_excel/Workbook.php');

    function HeaderingExcel($filename) {
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=$filename" );
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
        header("Pragma: public");
    }

    $dominios = array();
    $dominios['2'] = '2';
    $dominios['71'] = '71';

    $hora = nr2hora(hora_atual());
    $hoje = data_atual('data');
    $label = label_vendedor_ou_rep_comercial('S');
    // HTTP headers
    HeaderingExcel('CONTAS_RECEBER.xls');

    // Creating a workbook
    $workbook = new Workbook("-");
    // Creating the first worksheet
    $titulo_sheet = 'CONTAS A RECEBER';
    $worksheet1 =& $workbook->add_worksheet($titulo_sheet);

    // Format for the headings
    $formatot =& $workbook->add_format();
    $formatot->set_size(18);

    $formatost =& $workbook->add_format();
    $formatost->set_size(14);

    $formatotit =& $workbook->add_format();
    $formatotit->set_size(12);

    $worksheet1->write_string(0,0,'RELATRIO DE CONTAS A RECEBER',$formatot);
    $worksheet1->write(3,0,config_pad('sistema_licenca'));
    $worksheet1->write(4,0,"Data: ".$hoje." - Hora: ".$hora);
    $worksheet1->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

    $filtro = '';

    $empresa = $_REQUEST['empresa'];
    $cliente = $_REQUEST['pessoa'];
    $familia = $_REQUEST['familia'];
    $fam_grupo = $_REQUEST['fam_grupo'];
    $vendedor = $_REQUEST['vendedor'];
    $tipo_data = $_REQUEST['tipo_data'];
    $tipo_data_ini = $_REQUEST['tipo_data_ini'];
    $tipo_data_fim = $_REQUEST['tipo_data_fim'];
    $valor_ini = $_REQUEST['valor_ini'];
    $valor_fim = $_REQUEST['valor_fim'];
    $nome_parcial = $_REQUEST['nome_parcial'];
    $situacao = $_REQUEST['situacao'];
    $modelo = $_REQUEST['modelo'];
    $serie = $_REQUEST['serie'];
    $nr_fatura = $_REQUEST['nr_fatura'];
    $tipo_emissao = $_REQUEST['tipo_emissao'];
    $adianta = $_REQUEST['adianta'];
    $cheques = $_REQUEST['cheques'];
    $agrupado = $_REQUEST['agrupado'];
    $grupo = $_REQUEST['grupo'];
    $contrato = $_REQUEST['contrato'];
    $antecipacao = $_REQUEST['antecipacao'];
    $aceite = $_REQUEST['aceite'];
    $banco_envio = $_REQUEST['banco_envio'];
    $AceiteConfere = $_REQUEST['AceiteConfere'];
	$procuracao = $_REQUEST['procuracao'];

    if($grupo == ''){
		$grupo = 'C';
    }

    if (isset($_REQUEST['observ'])){
		$observ = $_REQUEST['observ'];
    }else{
		$observ = 'S';
    }

    if(isset($_REQUEST['tp_cobranca'])){
		$tp_cobranca = $_REQUEST['tp_cobranca'];
    }else{
		$tp_cobranca = '';
    }

    $uf = $_REQUEST['uf'];
    $cidade = $_REQUEST['cidade'];
    $itens = $_REQUEST['itens'];

    $correcao_data = $_REQUEST['correcao_data'];
    $correcao_juros = str2nr(formata_valor($_REQUEST['correcao_juros']));
//    echo 'Juros: '.$_REQUEST['correcao_juros'];
    $p_desconto_cli = str2nr(formata_valor($_REQUEST['correcao_desc']));

    $vendedor_origem = $_REQUEST['vend_origem'];

    if($agrupado=='S'){
		$cons_pessoa = 'select CPF_CNPJ from pessoa '.
				  ' where Dominio = "'.$_SESSION['Dominio'].'" '.
				  ' and Pessoa = "'.$cliente.'" ';
		$res_pessoa = consulta_sql($cons_pessoa);
		$reg_pessoa = consulta_ler_linha($res_pessoa);

		if((strlen($reg_pessoa[0])==18)&&($reg_pessoa[0]!='00.000.000/0000-00')){

		}else{
			$agrupado = 'N';
		}

    }
    $carencia = BuscaParam('FAT_CARENCIA');

    if($vendedor!=''){
        if($vendedor_origem=='C'){
			$inner_vendedor = 'inner join pessoa_cliente pes_cli on '.
							'pes.Dominio = pes_cli.Dominio '.
							'and pes.Pessoa = pes_cli.Pessoa';
        }else{
			$inner_vendedor = '';
        }
    }else{
        $inner_vendedor = '';
    }
	if ($banco_envio!=''){
		$inner_vendedor.=' left outer join banco_envio_det det '.
						' on det.Contas_Empresa=cp.Empresa'.
						' and det.Contas_Nr_Contas=cp.Nr_Contas'.
						' and det.Contas_Seq=cp.Seq';
	}

    $meio_pagto = $_REQUEST['meio_pagto'];
    $forma_pagto_contas = $_REQUEST['forma_pagto_contas'];

    $consulta = 'select cp.Nr_Doc, cp.Modelo, cp.Serie, cp.Pessoa, cp.Parcela, cp.DT_Vencto, cp.DH_Baixa, '.
                ' cp.Valor, cp.Valor_Desconto, cp.Valor_Acrescimo, cp.Valor_Liquido, cp.Valor_Total_Ja_Pago, '.
                ' cp.Empresa, cp.Vendedor, cp.Tipo_Docto, pes.Nome_Razao, cp.Observacao, cp.Contrato, cp.DH_Criacao, '.
                ' cp.Nr_Contas, cp.Seq, cp.PRC, cp.PRC_DT,cp.Acrescimo_Pre_Aprovado,cp.Desconto_Pre_Aprovado, '.
                ' cp.Juros_Data, cp.Adiantado, pes.CPF_CNPJ, cp.Nr_Nota, cp.UsuarioCriacao,'.
				' cp.Boleto_Barra, cp.Boleto_Envio from contas_pr cp '.
                ' inner join pessoa pes '.
                ' on cp.Dominio = pes.Dominio '.
                ' and cp.Pessoa = pes.Pessoa '.
                ' '.$inner_vendedor.' '.
                ' where cp.Dominio = "'.$_SESSION['Dominio'].'" '.
                ' and cp.TipoPR = "R" ';

    if($situacao=='A'){
		$tipo_rel = 'A Receber';
		$consulta.= ' and cp.Situacao = "A" and (cp.PRC <> "S")';
		if (oculta_em_cobranca($_SESSION['Dominio'])){
			$consulta.= ' and (cp.PRC <> "J") and (cp.PRC <> "S")'; // Retira os Em Cobrana
		}
    }else if($situacao=='RJ'){
		$tipo_rel = 'A Receber, exceto \'Em Cobrana\'';
		$consulta.= ' and cp.Situacao = "A" and (cp.PRC <> "S")';
		$consulta.= ' and (cp.PRC <> "J") and (cp.PRC <> "S")'; // Retira os Em Cobrana
    }else if($situacao=='V'){
		$tipo_rel = 'Vencido';
		$consulta.= ' and (cp.Situacao="A") and (cp.DT_Vencto<"'.data_atual('date').'") and (cp.PRC <> "S")';
		//' and cp.DT_Vencto<"'.data_atual('date').'"';
		if (oculta_em_cobranca($_SESSION['Dominio'])){
			$consulta.= ' and (cp.PRC <> "J") and (cp.PRC <> "S")'; // Retira os Em Cobrana
		}
    }else if($situacao=='I'){
		$tipo_rel = 'Vincendo';
		$consulta.= ' and (cp.Situacao="A") and (cp.DT_Vencto>="'.data_atual('date').'") and (cp.PRC <> "S")';
		//' and cp.DT_Vencto>"'.data_atual('date').'"';
		if (oculta_em_cobranca($_SESSION['Dominio'])){
			$consulta.= ' and (cp.PRC <> "J") and (cp.PRC <> "S")'; // Retira os Em Cobrana
		}
    }else if($situacao=='S'){
		$tipo_rel = 'Incobrvel';
		$consulta.= ' and (cp.PRC = "S") and (cp.Situacao="A")';
    }else if($situacao=='F'){
		$tipo_rel = 'Pago';
		$consulta.= ' and (cp.Situacao="F")';
    }else if ($situacao=='J'){
		$tipo_rel = 'Em Cobrana';
		$consulta.= ' and (cp.PRC = "J") and (cp.Situacao="A")'; // Em Cobrana
    }

    if($tp_cobranca!=''){
		$consulta.= ' and (cp.Cobranca_Tipo = "'.$tp_cobranca.'")';
    }

    if($empresa!=''){
		$consulta.= ' and cp.Empresa = "'.$empresa.'" ';

		$cons_empresa = 'select Nome_Listas from pessoa '.
				   ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				   ' and Pessoa = "'.$_REQUEST['empresa'].'"';
		$res_empresa = consulta_sql($cons_empresa);
		$reg_empresa = consulta_ler_linha($res_empresa);
		consulta_limpa($res_empresa);
		$filtro.= ' Empresa: "'.$reg_empresa[0].'"';
		if($grupo == 'E'){
			$grupo = 'V';  //tira o agrupamento de empresa que no vai precisar por j faz parte do filtro
		}
    }

    if($vendedor!=''){
		if($vendedor_origem=='C'){
			$consulta.= ' and pes_cli.Vendedor = "'.$vendedor.'" ';
		}else{
			$consulta.= ' and cp.Vendedor = "'.$vendedor.'" ';
		}

		$cons_fornec = 'select Nome_Listas from pessoa '.
				  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				  ' and Pessoa = "'.$vendedor.'"';
		$res_fornec = consulta_sql($cons_fornec);
		$reg_fornec = consulta_ler_linha($res_fornec);
		consulta_limpa($res_fornec);


		$label_emp = empresa_representante($vendedor,'S');

		$filtro.= ' '.$label.': '.$label_emp.'';
		if($grupo =='V'){
			$grupo = 'E';  //tira o agrupamento de vendedor que no vai precisar por j faz parte do filtro
		}
    }

    if($grupo =='C'){
		$grupo = 'E';  //tira o agrupamento de vendedor que no vai precisar por j faz parte do filtro
    }

    if($tipo_data=="V"){
		if(($tipo_data_ini!='')||($tipo_data_fim!='')){
			$filtro.= ' Data de: "Vencimento":';
			if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
				$consulta.= ' and (cp.DT_Vencto >= "'.datad($tipo_data_ini).'" '.
						 ' and cp.DT_Vencto <= "'.datad($tipo_data_fim).'") ';
				$filtro.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'"';
			}else if($tipo_data_ini!=''){
				$consulta.= ' and (cp.DT_Vencto >= "'.datad($tipo_data_ini).'") ';
				$filtro.= ' De "'.$tipo_data_ini.'"';
			}else if($tipo_data_fim!=''){
				$consulta.= ' and (cp.DT_Vencto <= "'.datad($tipo_data_fim).'") ';
				$filtro.= ' At "'.$tipo_data_fim.'"';
			}
		}
    }else if($tipo_data=="P"){
		if(($tipo_data_ini!='')||($tipo_data_fim!='')){
			$filtro.= ' Data de: "Pagamento":';
			if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
				$consulta.= ' and (cp.DT_Pagto >= "'.datad($tipo_data_ini).'" '.
						 ' and cp.DT_Pagto <= "'.datad($tipo_data_fim).'") ';
				$filtro.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'" ';
			}else if($tipo_data_ini!=''){
				$consulta.= ' and (cp.DT_Pagto >= "'.datad($tipo_data_ini).'") ';
				$filtro.= ' De "'.$tipo_data_ini.'"';
			}else if($tipo_data_fim!=''){
				$consulta.= ' and (cp.DT_Pagto <= "'.datad($tipo_data_fim).'") ';
				$filtro.= ' At "'.$tipo_data_fim.'"';
			}
		}
    }else{
		if(($tipo_data_ini!='')||($tipo_data_fim!='')){
			$filtro.= ' Data de: "Emisso":';
			if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
				$consulta.= ' and (cp.DH_Criacao >= "'.datad($tipo_data_ini).'" '.
						 ' and cp.DH_Criacao <= "'.datad($tipo_data_fim).' 23:59:59") ';
				$filtro.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'"';
			}else if($tipo_data_ini!=''){
				$consulta.= ' and (cp.DH_Criacao >= "'.datad($tipo_data_ini).'") ';
				$filtro.= ' De "'.$tipo_data_ini.'"';
			}else if($tipo_data_fim!=''){
				$consulta.= ' and (cp.DH_Criacao <= "'.datad($tipo_data_fim).' 23:59:59") ';
				$filtro.= ' At "'.$tipo_data_fim.'"';
			}
		}
    }

    if(($valor_ini!='') || ($valor_fim!='')){
		$filtro.= ' Valor:';
		if($valor_ini!=''){
			$consulta.= ' and cp.Valor >= "'.str2nr(formata_valor($valor_ini)).'" ';
			$filtro.= ' De "'.$valor_ini.'"';
		}
		if($valor_fim!=''){
			$consulta.= ' and cp.Valor <= "'.str2nr(formata_valor($valor_fim)).'" ';
			$filtro.= ' At "'.$valor_fim.'"';
		}
    }

    if($tipo_emissao!=''){
		if($tipo_emissao=='P'){
			$filtro.= ' Cereais: "Somente Cereais"';
			$consulta.= ' and (cp.Nr_Boletim_Pesagem <> 0)';
		}else{
			$filtro.= ' Cereais: "Somente No Cereais"';
			$consulta.= ' and (cp.Nr_Boletim_Pesagem = 0)';
		}
    }

    if($nome_parcial!=''){
		$consulta.= ' and pes.Nome_Razao like "%'.$nome_parcial.'%" ';
		$filtro.= ' Parcial Nome: "'.$nome_parcial.'"';
    }

    if($familia!=''){
		$consulta.= ' and pes.Familia = "'.$familia.'"';
		$cons_familia = 'select Descricao from pessoa_familia '.
					   ' where Dominio = "'.$_SESSION['Dominio'].'"'.
					   ' and Cod_Familia = "'.$familia.'"';
		$res_familia = consulta_sql($cons_familia);
		$reg_familia = consulta_ler_linha($res_familia);
		consulta_limpa($res_familia);

		$filtro.= ' Famlia: "'.$reg_familia[0].'"';
    }

    if($fam_grupo!=''){
		$consulta.= ' and pes.Grupo = "'.$fam_grupo.'"';

		$cons_grupo = 'select Descricao from pessoa_grupo '.
				 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
				 ' and Cod_Grupo = "'.$fam_grupo.'"';
		$res_grupo = consulta_sql($cons_grupo);
		$reg_grupo = consulta_ler_linha($res_grupo);
		consulta_limpa($res_grupo);

		$filtro.= ' Grupo: "'.$reg_grupo[0].'"';
    }

    if($modelo!=''){
		$consulta.= ' and cp.Modelo = "'.$modelo.'" ';
		$filtro.= ' Modelo: "'.$modelo.'"';
    }

    if($serie!=''){
		$consulta.= ' and cp.Serie = "'.$serie.'" ';
		$filtro.= ' Srie: "'.$serie.'"';
    }

    if($nr_fatura!=''){
		$consulta.= ' and cp.Nr_Doc = "'.$nr_fatura.'" ';
		$filtro.= ' NrFatura: "'.$nr_fatura.'"';
    }

    if(($correcao_juros>0)||($p_desconto_cli>0)){
		$filtro.= ' Correo Data: "'.$correcao_data.'"';
        if($correcao_juros>0){
			$filtro.= ' Juros: "'.str2nr(formata_qtd($correcao_juros)).' % a.m."';
        }
        if($p_desconto_cli>0){
			$filtro.= ' Desconto: "'.str2nr(formata_qtd($p_desconto_cli)).' % a.m."';
        }
    }

    if($agrupado=='N'){
		$consulta.= ' and (cp.Pessoa = "'.$cliente.'") ';
    }else{
		$consulta.= ' and (pes.CPF_CNPJ like "'.substr($reg_pessoa[0],0,9).'%") ';
		$filtro.= ' "Agrupado"';
	}

	if($meio_pagto!=''){
		$consulta.= ' and cp.Tipo_Docto = "'.$meio_pagto.'" ';
		$filtro.= ' Tipo Docto: "'.busca_dados_combo('tipo_fatura',$meio_pagto).'"';
	}

	if($forma_pagto_contas!=''){
		if($contas_finaliza=='SIMP'){
			$consulta.= ' and cp.Forma_Pagto_Contas = "'.$forma_pagto_contas.'" ';
		}else{
			$consulta.= ' and cp.Finalizadora = "'.$forma_pagto_contas.'" ';
		}

		$sql_forma ='select Descricao from forma_pagto_contas '.
					' where Dominio = "'.$_SESSION['Dominio'].'"'.
					' and Codigo_Pagto = "'.$forma_pagto_contas.'"';
		$res_forma = consulta_sql($sql_forma);
		$reg_forma = consulta_ler_linha($res_forma);
		consulta_limpa($res_forma);

		$filtro.= ' Forma Pagto: "'.$reg_forma[0].'"';
	}

	if($contrato!=''){
		$consulta.= ' and cp.Contrato = "'.$contrato.'" ';
		if($contrato=='S'){
			$filtro.= ' "Com Contratos"';
		}else{
			$filtro.= ' "Sem Contratos"';
		}
	}

	if($antecipacao!=''){
		$consulta.= ' and cp.Adiantado = "'.$antecipacao.'" ';
		if($antecipacao=='S'){
			$filtro.= ' "Somente Antecipao"';
		}else{
			$filtro.= ' "Sem Antecipao"';
		}
    }

    if($uf!=''){
		$filtro.= ' Estado: "'.$uf.'"';
    }

    if($cidade!=''){
		$con_cid = 'select Nome from cidade '.
				  ' where Dominio="'.$_SESSION['Dominio'].'"'.
				  ' and Codigo_Cidade = "'.$cidade.'"';
		$res_cid = consulta_sql($con_cid);
		$reg_cid = consulta_ler_linha($res_cid);
		consulta_limpa($res_cid);
		$filtro.= ' Cidade: "'.$reg_cid[0].'"';
    }
	if($banco_envio != ''){
		$filtro.= ' Boleto:';
		if($banco_envio == 'S'){
			$filtro.= ' Somente Enviados ao Banco';
			$consulta.= ' and det.Contas_Empresa>0';
		}else if($banco_envio == 'N'){
			$filtro.= ' Somente No Enviados ao Banco';
			$consulta.= ' and det.Contas_Empresa is null';
		}
	}
	if($aceite != ''){
		$filtro.= ' Aceite:';
		if($aceite == 'S'){
			$filtro.= ' Com Aceite';
		}else if($aceite == 'N'){
			$filtro.= ' Sem Aceite';
		}else if($aceite == 'T'){
			$filtro.= ' Terceiros';
		}
		$consulta.= ' AND (cp.Aceite2 = "'.$aceite.'")';
	}
	/**Procurao para Dominio 2 em  30/01/2023 por @isabel */
	if( isset($_REQUEST['procuracao'])){
		$pessoas_procuracao = busca_pessoas_com_procuracao();    
		if( $procuracao=='S'){
			$filtro.= ' "Com Procurao" ';            
			$consulta.= ' AND  cp.Pessoa IN ( '.$pessoas_procuracao.')';
		}else{ 
			$filtro.= ' "Sem Procurao" ';           
			$consulta.= ' AND  cp.Pessoa NOT IN ( '.$pessoas_procuracao.')';
		}
	}

	if($AceiteConfere != ''){
		$filtro.= ' Aceite Confere:';
		if($AceiteConfere == 'A'){
			$filtro.= ' Somente Aprovados';
			$consulta.= ' AND (cp.AceiteConfere = "'.$AceiteConfere.'")';
		}else if($AceiteConfere == 'R'){
			$filtro.= ' Somente Rejeitados';
			$consulta.= ' AND (cp.AceiteConfere = "'.$AceiteConfere.'")';
		}else if($AceiteConfere == 'N'){
			$filtro.= ' No Informado';
			$consulta.= ' AND (cp.AceiteConfere = "")';
		}
	}
	if ($banco_envio!=''){
		$consulta.= ' group by cp.Empresa, cp.Nr_Contas, cp.Seq';
	}
    $filtro.= ' Agrupado Por: ';
    if($grupo=='V'){
        $consulta.= ' order by cp.Vendedor, pes.Nome_Razao, cp.Pessoa, cp.DT_Vencto, cp.Empresa, cp.Nr_Doc, cp.Serie, cp.Modelo, cp.Parcela, cp.Seq';
        $filtro.= '"'.$label.'"';
    }else{
        $filtro.= '"Empresa"';
        $consulta.= ' order by cp.Empresa, pes.Nome_Razao, cp.Pessoa, cp.DT_Vencto, cp.Nr_Doc, cp.Serie, cp.Modelo, cp.Parcela, cp.Seq';
    }
	//echo 'SQL: '.$consulta;

    $worksheet1->write(7,0,"Filtro: ".$filtro);
    //$worksheet1->insert_bitmap(9,0,"../../imgs/logo_menu.bmp",0,0);

    $cons_cli = 'select Pessoa, Nome_Listas from pessoa '.
                ' where Dominio = "'.$_SESSION["Dominio"].'"'.
                ' and Pessoa = "'.$cliente.'"';
    $res_cli = consulta_sql($cons_cli);
    $reg_cli = consulta_ler_linha($res_cli);
    consulta_limpa($res_cli);

    $worksheet1->write(9,0,"Cliente: ".$reg_cli[0].'-'.$reg_cli[1],$formatotit);

    // Format for the headings
    $formatott =& $workbook->add_format();
    $formatott->set_align('center');
    $formatott->set_pattern();
    $formatott->set_fg_color(40);
    $formatott->set_bold(1);
    $formatott->set_border(1);

    // Formato texto
    $formatotl =& $workbook->add_format();
    $formatotl->set_border(1);
    $formatotl->set_align('left');

    $formatotli =& $workbook->add_format();
    $formatotli->set_border(1);
    $formatotli->set_align('left');
    $formatotli->set_italic(1);

    $formatotr =& $workbook->add_format();
    $formatotr->set_border(1);
    $formatotr->set_align('right');

    $formatotri =& $workbook->add_format();
    $formatotri->set_border(1);
    $formatotri->set_align('right');
    $formatotri->set_italic(1);

    $formatotc =& $workbook->add_format();
    $formatotc->set_border(1);
    $formatotc->set_align('center');

    $formatotlb =& $workbook->add_format();
    $formatotlb->set_border(1);
    $formatotlb->set_size(10);
    $formatotlb->set_align('left');
    $formatotlb->set_bold(1);


    // Formato qtd
    $formatotqtdb =& $workbook->add_format();
    $formatotqtdb->set_border(1);
    $formatotqtdb->set_align('right');
    $formatotqtdb->set_size(10);
    $formatotqtdb->set_bold(1);
//    $formatotqtdb->set_num_format('#,##0_);-#,##0_)');
    $formatotqtdb->set_num_format('#,##0.000_);-#,##0.000_)');

    $formatotqtdi =& $workbook->add_format();
    $formatotqtdi->set_border(1);
    $formatotqtdi->set_italic(1);
    $formatotqtdi->set_align('right');
//    $formatotqtdi->set_num_format('#,##0_);-#,##0_)');
    $formatotqtdi->set_num_format('#,##0.000_);-#,##0.000_)');

    $formatotqtd =& $workbook->add_format();
    $formatotqtd->set_border(1);
    $formatotqtd->set_align('right');
//    $formatotqtd->set_num_format('#,##0_);-#,##0_)');
    $formatotqtd->set_num_format('#,##0.000_);-#,##0.000_)');

    // Formato precos
    $formatotpreco =& $workbook->add_format();
    $formatotpreco->set_border(1);
    $formatotpreco->set_align('right');
    $formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

    $formatotbpreco =& $workbook->add_format();
    $formatotbpreco->set_border(1);
    $formatotbpreco->set_align('right');
    $formatotbpreco->set_bold(1);
    $formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

    $formatotipreco =& $workbook->add_format();
    $formatotipreco->set_border(1);
    $formatotipreco->set_align('right');
    $formatotipreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');


    $resultado = consulta_sql($consulta);
    $nrows = consulta_num_registros($resultado);

    $worksheet1->write_string(1,0,'Por Cliente - '.$tipo_rel,$formatost);

    $linha_ini = 11;

    if ($nrows>0){
        $coluna=0;

        $worksheet1->set_column($coluna,$coluna,3);
        $worksheet1->write_string($linha_ini,$coluna,'',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'NrFatura',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,5);
        $worksheet1->write_string($linha_ini,$coluna,'Par',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,3);
        $worksheet1->write_string($linha_ini,$coluna,'C',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'Dt Digit',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'Dt Venc',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,16);
        $worksheet1->write_string($linha_ini,$coluna,'Empresa',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,40);
        $worksheet1->write_string($linha_ini,$coluna,$label,$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,14);
        $worksheet1->write_string($linha_ini,$coluna,'Correo',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,14);
        $worksheet1->write_string($linha_ini,$coluna,'Atraso',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
        $worksheet1->write_string($linha_ini,$coluna,'Valor',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,16);
        $worksheet1->write_string($linha_ini,$coluna,'Valor j Pago',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,36);
        $worksheet1->write_string($linha_ini,$coluna,'Observao',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
        $worksheet1->write_string($linha_ini,$coluna,'CPF/CNPJ',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
        $worksheet1->write_string($linha_ini,$coluna,'Usuario Criao',$formatott);
        $coluna++;

		$worksheet1->set_column($coluna,$coluna,52);
        $worksheet1->write_string($linha_ini,$coluna,'Linha Digitvel Boleto',$formatott);
        $coluna++;

		if ($banco_envio=='S'){
			$worksheet1->set_column($coluna,$coluna,40);
			$worksheet1->write_string($linha_ini,$coluna,'Lote Envio',$formatott);
			$coluna++;
		}

        $linha_ini++;

        $vl_desconto = 0;
        $vl_acrescimo = 0;
        $vl_valor = 0;
        $vl_pago = 0;

        $vl_com_contratos = 0;
        $vl_sem_contratos = 0;
        
        $vl_vencidas = 0;
        $vl_vencer = 0;

        $vl_desconto_geral = 0;
        $vl_acrescimo_geral = 0;
        $vl_valor_geral = 0;
        $vl_pago_geral = 0;

        $vl_com_contratos_geral = 0;
        $vl_sem_contratos_geral = 0;
        
        $vl_vencidas_geral = 0;
        $vl_vencer_geral = 0;

        $vl_desconto_grupo = 0;
        $vl_acrescimo_grupo = 0;
        $vl_valor_grupo = 0;
        $vl_pago_grupo = 0;

        $vl_com_contratos_grupo = 0;
        $vl_sem_contratos_grupo = 0;
        
        $vl_vencidas_grupo = 0;
        $vl_vencer_grupo = 0;

        $id_data = '';
        $id_fornec = '';
        $id_vendedor = '';
        $id_empresa = '';

        $lista_empresas = lista_empresas();

        $total_vencido = 0;
        $total_vencer = 0;

        for($i=0;$i<$nrows;$i++){
            $registro = consulta_ler_objeto($resultado);
            set_time_limit(30);

            $ok_linha1 = true;
            if(($uf!='')||($cidade!='')){
				$array_uf = array();
				$array_cid = array();
				$con_cidade = 'select UF, Codigo_Cidade from pessoa_endereco '.
							 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
							 ' and Pessoa = "'.$registro->Pessoa.'" '.
							 ' and Situacao <> "E"';
				$res_cidade = consulta_sql($con_cidade);
				$nro_cidade = consulta_num_registros($res_cidade);
				for($u=0;$u<$nro_cidade;$u++){
					$reg_cidade = consulta_ler_linha($res_cidade);
					if(!isset($array_uf[$reg_cidade[0]])){
						$array_uf[$reg_cidade[0]] = $reg_cidade[0];
					}
					if(!isset($array_uf[$reg_cidade[1]])){
						$array_cid[$reg_cidade[1]] = $reg_cidade[1];
					}
				}
				consulta_limpa($res_cidade);

				if($ok_linha1){
					if(($uf!='')&&($cidade!='')){
						//$ok_linha1 = ($uf==$reg_cidade[0]);
						$ok_linha1 = ((isset($array_uf[$uf])) && (isset($array_cid[$cidade])));
					}else{
						if($ok_linha1){
							if($uf!=''){
								//$ok_linha1 = ($cidade==$reg_cidade[1]);
								$ok_linha1 = (isset($array_uf[$uf]));
							}
						}

						if($ok_linha1){
							if($cidade!=''){
								//$ok_linha1 = ($cidade==$reg_cidade[1]);
								$ok_linha1 = (isset($array_cid[$cidade]));
							}
						}
					}
				}
            }

            if($ok_linha1){
				$cpf_cnpj = $registro->CPF_CNPJ;

				if($grupo=='V'){
					if(($id_vendedor!=$registro->Vendedor)&&
						($id_vendedor!='')){
						$id_fornec = -1;
					}
				}else if($grupo=='E'){
					if(($id_empresa!=$registro->Empresa)&&
						($id_empresa!='')){
						$id_fornec = -1;
					}
				}

				if($id_fornec!=$registro->Pessoa){
					if($id_fornec!=''){
						$coluna=0;
						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'TOTAL CLIENTE',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						if($_SESSION['Dominio'] == $dominios['2']){
							$coluna++;

							$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.to_money($vl_com_contratos, false),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.to_money($vl_sem_contratos, false),$formatotlb);
						}else{
							$coluna++;

							$worksheet1->write_string($linha_ini,$coluna,'Vencidas: '.to_money($vl_vencidas, false),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,' Vencer: '.to_money($vl_vencer, false),$formatotlb);
						}

						if(($correcao_juros>0)||($p_desconto_cli>0)){
							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_desconto,$formatotbpreco);
						}else{
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);
						}

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_number($linha_ini,$coluna,$vl_valor,$formatotbpreco);

						$coluna++;
						$worksheet1->write_number($linha_ini,$coluna,$vl_pago,$formatotbpreco);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$linha_ini++;

						$vl_desconto = 0;
						$vl_acrescimo = 0;
						$vl_valor = 0;
						$vl_pago = 0;

						$vl_com_contratos = 0;
						$vl_sem_contratos = 0;
						 
						$vl_vencidas = 0;
						$vl_vencer = 0;
					}


					if((($id_vendedor!='')&&($grupo=='V')&&($id_vendedor!=$registro->Vendedor))||
						(($id_empresa!='')&&($grupo=='E')&&($id_empresa!=$registro->Empresa))){
						$coluna=0;

						if($grupo=='V'){
							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'TOTAL '.UpperDados($label),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						}else{
							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'TOTAL EMPRESA',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						}

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						if($_SESSION['Dominio'] == $dominios['2']){
							$coluna++;

							$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.to_money($vl_com_contratos_grupo, false),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.to_money($vl_sem_contratos_grupo, false),$formatotlb);
						}else{
							$coluna++;

							$worksheet1->write_string($linha_ini,$coluna,'Vencidas: '.to_money($vl_vencidas_grupo, false),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,' Vencer: '.to_money($vl_vencer_grupo, false),$formatotlb);
						}

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						if(($correcao_juros>0)||($p_desconto_cli>0)){
							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,str_replace('"','',to_money($vl_desconto_grupo)),$formatotlb);
						}else{
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);
						}

						$coluna++;
						$worksheet1->write_number($linha_ini,$coluna,$vl_valor_grupo,$formatotbpreco);

						$coluna++;
						$worksheet1->write_number($linha_ini,$coluna,$vl_pago_grupo,$formatotbpreco);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);


						$linha_ini++;

						$vl_desconto_grupo = 0;
						$vl_acrescimo_grupo = 0;
						$vl_valor_grupo = 0;
						$vl_pago_grupo = 0;

						$vl_com_contratos_grupo = 0;
						$vl_sem_contratos_grupo = 0;

						$vl_vencidas_grupo = 0;
						$vl_vencer_grupo = 0;
					}

					if(($id_fornec!='') && ($_SESSION['Dominio'] == $dominios['71'])){
						$coluna=0;
						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCIDO',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_number($linha_ini,$coluna,$total_vencido,$formatotbpreco);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$linha_ini++;



						$coluna=0;
						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCER',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_number($linha_ini,$coluna,$total_vencer,$formatotbpreco);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$linha_ini++;

						$total_vencido = 0;
						$total_vencer = 0;
					}

					if($grupo=='V'){
						if($id_vendedor!=$registro->Vendedor){
							$id_fornec = -1;

							$con_ender = 'select Nome_Razao from pessoa '.
										 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
										 ' and Pessoa="'.$registro->Vendedor.'"';
							$res_ender = consulta_sql($con_ender);
							$reg_ender = consulta_ler_linha($res_ender);
							consulta_limpa($res_ender);

							//$linha_ini++;
							$coluna=0;

							$label_emp = empresa_representante($registro->Vendedor,'S');

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,$label.': '.$label_emp,$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+13);

							for($lne=0;$lne<=12;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$linha_ini++;

						}
					}else if($grupo=='E'){
						if($id_empresa!=$registro->Empresa){
							$id_fornec = -1;

							$con_ender = 'select Nome_Listas from pessoa '.
										 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
										 ' and Pessoa="'.$registro->Empresa.'"';
							$res_ender = consulta_sql($con_ender);
							$reg_ender = consulta_ler_linha($res_ender);
							consulta_limpa($res_ender);

							//$linha_ini++;
							$coluna=0;

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Empresa: '.$reg_ender[0],$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+13);

							for($lne=0;$lne<=12;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$linha_ini++;

						}
					}

					$id_fornec = $registro->Pessoa;
					$id_empresa = $registro->Empresa;
					$id_vendedor = $registro->Vendedor;


					$coluna=0;

					$coluna++;

					if($registro->Nome_Razao!=''){
						$desc_pess = $registro->Nome_Razao;
					}else{
						$cons_pess = 'select Nome_Razao from pessoa '.
								  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
								  ' and Pessoa = "'.$registro->Pessoa.'"';
						$res_pess = consulta_sql($cons_pess);
						$reg_pess = consulta_ler_linha($res_pess);
						consulta_limpa($res_pess);

						$desc_pess = $reg_desc[0];
					}
					$worksheet1->write_string($linha_ini,$coluna,$registro->Pessoa.' - '.$desc_pess,$formatotlb);
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+3);

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


					//consulta endereco padro do cliente
					$con_ender = 'select Logradouro, Numero, Nome_Cidade, UF from pessoa_endereco '.
						   ' where Dominio = "'.$_SESSION['Dominio'].'" '.
						   ' and Pessoa="'.$registro->Pessoa.'"'.
						   ' and Situacao <> "E"'.
						   ' order by Seq_Endereco limit 1';
					$res_ender = consulta_sql($con_ender);
					$reg_ender = consulta_ler_linha($res_ender);
					consulta_limpa($res_ender);
					$endereco_log = $reg_ender[0].', ';
					if($reg_ender[1]!=''){
						$endereco_log.=$reg_ender[1];
					}else{
						$endereco_log.='S/N';
					}
					$endereco_cidade = $reg_ender[2].'-'.$reg_ender[3];

					$coluna++;
					$worksheet1->write_string($linha_ini,$coluna,$endereco_log,$formatotlb);
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+2);
					$coluna++;
					$coluna+=2;


					//consulta telefone do cliente
					$con_ender = 'select Numero_Telefone from pessoa_telefone '.
						   ' where Dominio = "'.$_SESSION['Dominio'].'" '.
						   ' and Pessoa="'.$registro->Pessoa.'"'.
						   ' and Situacao <> "E"'.
						   ' order by Seq_Telefone limit 2';
					$res_ender = consulta_sql($con_ender);
					$reg_ender = consulta_ler_linha($res_ender);
					$reg_ender2 = consulta_ler_linha($res_ender);
					consulta_limpa($res_ender);
					$telefones = $reg_ender[0];
					if($reg_ender2[0]!=''){
						$telefones.=', '.$reg_ender2[0];
					}

					$worksheet1->write_string($linha_ini,$coluna,$telefones,$formatotlb);
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+2);
					$coluna++;
					$coluna++;

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

					$worksheet1->write_string($linha_ini,$coluna,$endereco_cidade,$formatotlb);
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+3);

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

					$coluna++;
					$worksheet1->write_blank($linha_ini,$coluna,$formatotc);


					$linha_ini++;

				}


				$coluna = 0;
				$contar_total = true;
				if(isset($listas_contados[$registro->Empresa.'-'.$registro->Nr_Contas])){
					$contar_total = false;
				}else{
					$listas_contados[$registro->Empresa.'-'.$registro->Nr_Contas] = $registro->Seq;
				}


				$worksheet1->write_string($linha_ini,$coluna,$registro->Tipo_Docto,$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,$registro->Nr_Doc.'/'.$registro->Serie.'-'.$registro->Modelo,$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,$registro->Parcela,$formatotc);
				$coluna++;


				if($registro->Contrato=='S'){
					$txt_cont = 'C';
					if($contar_total){
						$vl_com_contratos+=$registro->Valor;
						$vl_com_contratos_geral+=$registro->Valor;
						$vl_com_contratos_grupo+=$registro->Valor;
					}
				}else{
					$txt_cont = '';
					if($contar_total){
						$vl_sem_contratos+=$registro->Valor;
						$vl_sem_contratos_geral+=$registro->Valor;
						$vl_sem_contratos_grupo+=$registro->Valor;
					}	
				}
               
				if($contar_total){
					if(data2nr(dataf($registro->DT_Vencto)) < data_atual()){
						$vl_vencidas+= $registro->Valor;
						$vl_vencidas_geral+= $registro->Valor;
						$vl_vencidas_grupo+= $registro->Valor;
					}else{
						$vl_vencer+= $registro->Valor;
						$vl_vencer_grupo+= $registro->Valor;
						$vl_vencer_geral+= $registro->Valor;
					}
				}
               
				$worksheet1->write_string($linha_ini,$coluna,$txt_cont,$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,dataf($registro->DH_Criacao),$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,dataf($registro->DT_Vencto),$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,nome_empresa($lista_empresas,$registro->Empresa),$formatotl);
				$coluna++;


				if($registro->Vendedor>0){
					$con_ender = 'select Nome_Razao from pessoa '.
							   ' where Dominio = "'.$_SESSION['Dominio'].'" '.
							   ' and Pessoa="'.$registro->Vendedor.'"';
					$res_ender = consulta_sql($con_ender);
					$reg_ender = consulta_ler_linha($res_ender);
					consulta_limpa($res_ender);

					$label_emp = empresa_representante($registro->Vendedor,'S');

					$nm_vend = $label_emp;
				}else{
					$nm_vend = '';
				}
				$worksheet1->write_string($linha_ini,$coluna,$nm_vend,$formatotl);
				$coluna++;


				$valor_correcao = 0;

				$dif_datas = data2nr($correcao_data) - data2nr(dataf($registro->DT_Vencto));
				$dif_datas2 = $dif_datas;

				if(($registro->Juros_Data!='0000-00-00')&&($registro->Seq>1)){
					$dif_datas = data2nr($correcao_data) - data2nr(dataf($registro->Juros_Data));
				}

				if($registro->Acrescimo_Pre_Aprovado>0){
					$valor_correcao = $registro->Acrescimo_Pre_Aprovado;
				}else if( ($dif_datas>0) && ($dif_datas2>$carencia) ){
					if($correcao_juros>0){
						//calcula juros
						$dias = $dif_datas;
						$p_juros = $correcao_juros;
						$acrescimo = 0;
						$desconto = 0;
						$t_juros = 'C';

						$meses=0;
						while($dias>=30){
							$meses++;
							$dias-= 30;
						}
						$valor_pagar = round(((($registro->Valor-$registro->Desconto_Pre_Aprovado) + $acrescimo) - $desconto), 2);
						if(($t_juros=='C')&&($meses>0)){
							for($m=0;$m<$meses;$m++){
								$acrescimo+= $valor_pagar * ($p_juros/100);
								$valor_pagar = (($registro->Valor-$registro->Desconto_Pre_Aprovado) + $acrescimo) - $desconto;
							}
						}else if($meses>0){
							$acrescimo+= ($valor_pagar * ($p_juros/100) * $meses);
						}
						if($dias>0){
							$acrescimo+= (($valor_pagar * ($p_juros/100))/30)*$dias;
						}
						$acrescimo = round($acrescimo,2);
						$valor_correcao = $acrescimo;
					}
				}

				//if($registro->Desconto_Pre_Aprovado>0){
				$valor_correcao-= $registro->Desconto_Pre_Aprovado;
				//}else{
				if(($p_desconto_cli>0)&&($p_desconto_cli<100)){
					if(((data2nr(dataf($registro->DT_Vencto)))>data2nr($correcao_data))){
						$dias = data2nr(dataf($registro->DT_Vencto)) - data2nr($correcao_data);
						$meses =0;
						while($dias>=30){
							$meses++;
							$dias-= 30;
						}
						$valor_liquido = ($registro->Valor + $valor_correcao);

						$valor_receber2 =  $valor_liquido;

						$desconto_item = 0;

						if($meses>0){
							for($m=0;$m<$meses;$m++){
								$desconto_item+= $valor_receber2 * ($p_desconto_cli/100);
								$valor_receber2 = ($valor_liquido) - $desconto_item;
							}
						}else{
							$desconto_item = 0;
						}

						if($dias>0){
							$desconto_item+= (($valor_receber2 * ($p_desconto_cli/100))/30)*$dias;
						}
						$desconto_item = round($desconto_item,2);

						$valor_correcao-= $desconto_item;

					}
				}
				//}

				if(($valor_correcao==0)&&($correcao_juros==0)){
					$txt_correcao = ''; $dif_datas = '';
				}else{
					$txt_correcao = ($registro->Valor + $valor_correcao);
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_correcao,$formatotpreco);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,$dif_datas,$formatotc);
				$coluna++;


				if(($registro->Valor=='')||($registro->Valor==0)){
					$txt_valor = '';
				}else{
					$txt_valor = $registro->Valor;
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_valor,$formatotpreco);
				$coluna++;

				if(($registro->DT_Pagto == '') || ($registro->DT_Pagto == '0000-00-00')){
					if(data2nr(dataf($registro->DT_Vencto)) < data_atual()){
						$total_vencido+= $registro->Valor;
					}else{
						$total_vencer+= $registro->Valor;
					}
				}

				if(($registro->Valor_Total_Ja_Pago=='')||($registro->Valor_Total_Ja_Pago==0)){
					$txt_valor_pago = '';
				}else{
					$txt_valor_pago = $registro->Valor_Total_Ja_Pago;
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_valor_pago,$formatotpreco);
				$coluna++;


				$desc_obs = '';
				if($registro->Adiantado=='S'){
					$desc_obs.= 'Antecipado';

					$cons_ant_con = 'select Empresa, Nr_Antecipa from contas_antecipa_contas '.
								  ' where Dominio = "'.$_SESSION['Dominio'].'"'.
								  ' and Contas_Empresa = "'.$registro->Empresa.'"'.
								  ' and Contas_Nr_Contas = "'.$registro->Nr_Contas.'"'.
								  ' and Contas_Seq = "'.$registro->Seq.'"';
					$res_ant_con = consulta_sql($cons_ant_con);
					$nrow_ant_cont = consulta_num_registros($res_ant_con);
					if($nrow_ant_cont>0){
						$reg_ant_con = consulta_ler_linha($res_ant_con);

						$cons_ant = 'select Data from contas_antecipa '.
								 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
								 ' and Empresa = "'.$reg_ant_con[0].'"'.
								 ' and Nr_Antecipa = "'.$reg_ant_con[1].'"'.
								 ' and Situacao = "A" and Tipo_Mov = "A"';
						$res_ant = consulta_sql($cons_ant);
						$reg_ant = consulta_ler_linha($res_ant);
						consulta_limpa($res_ant);

						if($reg_ant[0]!='0000-00-00'){
							$desc_obs.= ' Dia '.dataf($reg_ant[0]);
						}
					}
					consulta_limpa($res_ant_con);
                  
					$con_contas = 'SELECT Nr_Doc, Modelo, Serie FROM contas_pr '.
								' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
								' AND Empresa = "'.$registro->Empresa.'" '.
								' AND Nr_Contas = "'.$registro->Nr_Contas.'" '.
								' AND Seq = "'.$registro->Seq.'" ';
					$res_contas = consulta_sql($con_contas);
					$reg_contas = consulta_ler_objeto($res_contas);
					consulta_limpa($res_contas);

					$desc_obs.= ' Referente  fatura '.$reg_contas->Nr_Doc.'/'.$reg_contas->Serie.'-'.$reg_contas->Modelo;
				}
				if($desc_obs!=''){
					$desc_obs.= ' ';
				}
				$desc_obs.= $registro->Observacao;
				$worksheet1->write_string($linha_ini,$coluna,$desc_obs,$formatotl);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$cpf_cnpj,$formatotc);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$registro->UsuarioCriacao,$formatotc);
				$coluna++;

				$barra_boleto = $registro->Boleto_Barra;
				if (strlen($barra_boleto)==44){
					$barra_boleto = financeiro_boleto_monta_linha_digitavel($barra_boleto);
				}
				$worksheet1->write_string($linha_ini,$coluna,$barra_boleto,$formatotl);
				$coluna++;

				if ($banco_envio=='S'){
					$con_envio = 'select env.Nr_Envio, env.Usuario_Processo, env.Data_Processo, env.Nr_Lote '.
									' from banco_envio env '.
									' inner join banco_envio_det det'.
									' on env. Dominio=det.Dominio '.
									' and env.Empresa=det.Empresa '.
									' and env.Nr_Envio=det.Nr_Envio '.
								' where env.Dominio="'.$_SESSION['Dominio'].'"'.
								' and det.Contas_Empresa="'.$registro->Empresa.'"'.
								' and det.Contas_Nr_Contas="'.$registro->Nr_Contas.'"'.
								' and det.Contas_Seq="'.$registro->Seq.'"'.
								' and env.Situacao<>"E"'.
								' order by env.Data_Processo desc, env.Nr_Envio desc limit 1';
					$res_envio = consulta_sql($con_envio);
					$reg_envio = consulta_ler_linha($res_envio);
					consulta_limpa($res_envio);
					$dados_envio = '';
					if ($reg_envio[0]>0){
						$dados_envio = 'Envio: '.$reg_envio[0].' ('.dataf($reg_envio[2]).') '.
										$reg_envio[1].' Lote:'.$reg_envio[3];
					}
					$worksheet1->write_string($linha_ini,$coluna,$dados_envio,$formatotl);
					$coluna++;
				}

				$linha_ini++;


				if(($itens=='S') && ($registro->Nr_Nota>0) &&
					(($registro->Modelo=='01')||($registro->Modelo=='02')||
					($registro->Modelo=='55')||($registro->Modelo=='65')||
					($registro->Modelo=='97')||($registro->Modelo=='98'))
				){
					$cons_item = 'select Id_Produto, Quantidade_Estoque, Valor_Unitario, Valor_Total '.
                               ' from nota_fiscal_item '.
                               ' where Dominio="'.$_SESSION['Dominio'].'"'.
                               ' and Empresa="'.$registro->Empresa.'"'.
                               ' and Nr_Nota="'.$registro->Nr_Nota.'"'.
                               ' order by Seq_Item';
					$res_item = consulta_sql($cons_item);
					$nrw_item = consulta_num_registros($res_item);
					if($nrw_item>0){
						$coluna=0;

						$worksheet1->write_string($linha_ini,$coluna,'',$formatotc);
						$coluna++;

						$worksheet1->write_string($linha_ini,$coluna,'Produto',$formatotli);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+5);
						for($lne=0;$lne<=5;$lne++){
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
						}

						$worksheet1->write_string($linha_ini,$coluna,'Quantidade',$formatotri);
						$coluna++;

						$worksheet1->write_string($linha_ini,$coluna,'Valor Unitrio',$formatotri);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						for($lne=0;$lne<=1;$lne++){
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
						}

						$worksheet1->write_string($linha_ini,$coluna,'Valor Total',$formatotri);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+3);
						for($lne=0;$lne<=3;$lne++){
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
						}

						$linha_ini++;

						for($it=0;$it<$nrw_item;$it++){
							$reg_item = consulta_ler_linha($res_item);
							$coluna=0;

							$worksheet1->write_string($linha_ini,$coluna,'',$formatotc);
							$coluna++;

							$desc_prod = '';
							if($reg_item[0]>0){
								$cons_prod = 'select Codigo_Produto, Descricao_Completa from produto '.
											' where Dominio = "'.$_SESSION['Dominio'].'" '.
											' and Id_Produto = "'.$reg_item[0].'" ';
								$res_prod = consulta_sql($cons_prod);
								$reg_prod = consulta_ler_linha($res_prod);
								consulta_limpa($res_prod);

								$desc_prod = $reg_prod[0].'-'.$reg_prod[1];
							}
							$worksheet1->write_string($linha_ini,$coluna,$desc_prod,$formatotli);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+5);
							for($lne=0;$lne<=5;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$worksheet1->write_number($linha_ini,$coluna,$reg_item[1],$formatotqtdi);
							$coluna++;

							$worksheet1->write_number($linha_ini,$coluna,$reg_item[2],$formatotipreco);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							for($lne=0;$lne<=1;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$worksheet1->write_number($linha_ini,$coluna,$reg_item[3],$formatotipreco);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+3);
							for($lne=0;$lne<=3;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$linha_ini++;
						}
					}
					consulta_limpa($res_item);
				}


				$vl_desconto+= $registro->Valor + $valor_correcao;

				if($contar_total){
					$vl_valor+= $registro->Valor;
					$vl_valor_geral+= $registro->Valor;
					$vl_valor_grupo+= $registro->Valor;
				}
				$vl_pago+= $registro->Valor_Total_Ja_Pago;

				$vl_desconto_geral+= $registro->Valor + $valor_correcao;
				$vl_pago_geral+= $registro->Valor_Total_Ja_Pago;

				$vl_desconto_grupo+= $registro->Valor + $valor_correcao;
				$vl_pago_grupo+= $registro->Valor_Total_Ja_Pago;
			}

        }

        if($id_fornec!=''){
			$coluna=0;

			$coluna++;
			$worksheet1->write_string($linha_ini,$coluna,'TOTAL CLIENTE',$formatotlb);
			$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

			if($_SESSION['Dominio'] == $dominios['2']){
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.to_money($vl_com_contratos, false),$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.to_money($vl_sem_contratos, false),$formatotlb);
			}else{
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,'Vencidas: '.to_money($vl_vencidas, false),$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,' Vencer: '.to_money($vl_vencer, false),$formatotlb);
			}

			if(($correcao_juros>0)||($p_desconto_cli>0)){
				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$vl_desconto,$formatotbpreco);
			}else{
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);
			}

			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

			$coluna++;
			$worksheet1->write_number($linha_ini,$coluna,$vl_valor,$formatotbpreco);

			$coluna++;
			$worksheet1->write_number($linha_ini,$coluna,$vl_pago,$formatotbpreco);

			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);


			$linha_ini++;

			$vl_desconto = 0;
			$vl_acrescimo = 0;
			$vl_valor = 0;
			$vl_pago = 0;

			$vl_com_contratos = 0;
			$vl_sem_contratos = 0;

			$vl_vencidas = 0;
			$vl_vencer = 0;
        }

        if((($id_vendedor!='')&&($grupo=='V'))||
			(($id_empresa!='')&&($grupo=='E'))){

            $coluna=0;
            if($grupo=='V'){
                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'TOTAL '.UpperDados($label),$formatotlb);
            }else{
                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'TOTAL EMPRESA',$formatotlb);
            }
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            if($_SESSION['Dominio'] == $dominios['2']){
                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.to_money($vl_com_contratos_grupo, false),$formatotlb);
                $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.to_money($vl_sem_contratos_grupo, false),$formatotlb);
            }else{
                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'Vencidas: '.to_money($vl_vencidas_grupo, false),$formatotlb);
                $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,' Vencer: '.to_money($vl_vencer_grupo, false),$formatotlb);
            }

            if(($correcao_juros>0)||($p_desconto_cli>0)){
                $coluna++;
                $worksheet1->write_number($linha_ini,$coluna,$vl_desconto_grupo,$formatotbpreco);
            }else{
                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);
            }

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_number($linha_ini,$coluna,$vl_valor_grupo,$formatotbpreco);

            $coluna++;
            $worksheet1->write_number($linha_ini,$coluna,$vl_pago_grupo,$formatotbpreco);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $linha_ini++;

            $vl_desconto_grupo = 0;
            $vl_acrescimo_grupo = 0;
            $vl_valor_grupo = 0;
            $vl_pago_grupo = 0;

            $vl_com_contratos_grupo = 0;
            $vl_sem_contratos_grupo = 0;
            
            $vl_vencidas_grupo = 0;
            $vl_vencer_grupo = 0;
		}

        if(($id_fornec!='') && ($_SESSION['Dominio'] == $dominios['71'])){
            $coluna=0;
            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCIDO',$formatotlb);
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_number($linha_ini,$coluna,$total_vencido,$formatotbpreco);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $linha_ini++;



            $coluna=0;
            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCER',$formatotlb);
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
            $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_number($linha_ini,$coluna,$total_vencer,$formatotbpreco);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $coluna++;
            $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

            $linha_ini++;

            $total_vencido = 0;
            $total_vencer = 0;
		}

        $linha_ini++;
        $coluna=0;

        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,'TOTAL GERAL',$formatotlb);
        $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        if($_SESSION['Dominio'] == $dominios['2']){
			$coluna++;
			$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.to_money($vl_com_contratos_geral, false),$formatotlb);
			$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

			$coluna++;
			$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.to_money($vl_sem_contratos_geral, false),$formatotlb);
        }else{
			$coluna++;
			$worksheet1->write_string($linha_ini,$coluna,'Vencidas: '.to_money($vl_vencidas_geral, false),$formatotlb);
			$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

			$coluna++;
			$worksheet1->write_string($linha_ini,$coluna,' Vencer: '.to_money($vl_vencer_geral, false),$formatotlb);
        }

        if(($correcao_juros>0)||($p_desconto_cli>0)){
			$coluna++;
			$worksheet1->write_number($linha_ini,$coluna,$vl_desconto_geral,$formatotbpreco);
        }else{
			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc);
        }

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,$vl_valor_geral,$formatotbpreco);

        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,$vl_pago_geral,$formatotbpreco);

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $linha_ini++;

    }else{
        $worksheet1->write(10,0,"No existem registros para este filtro!");
    }
    consulta_limpa($resultado);


    //incluir cheques
    if($cheques=='S'){
		$titulo_sheet2 = 'CHEQUES';
		$worksheet2 =& $workbook->add_worksheet($titulo_sheet2);

		$worksheet2->write_string(0,0,'RELATRIO DE CHEQUES',$formatot);
		//$worksheet2->write(3,0,"SIASA - Sul Agrcola");
		$worksheet2->write(3,0,config_pad('sistema_sigla')." - ".config_pad('sistema_licenca'));
		$worksheet2->write(4,0,"Data: ".$hoje." - Hora: ".$hora);
		$worksheet2->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

		$filtro2 = '';

		$cons_cheque = 'select Banco, Agencia, Conta, Nr_Cheque, DT_Vencto, DT_Emissao, Valor, Pessoa, Situacao '.
				  ' from cheque_pre '.
				  ' where Dominio = "'.$_SESSION['Dominio'].'" ';

		if($empresa!=''){
			$cons_cheque.= ' and Empresa_Atual = "'.$empresa.'"';

			$con_pessoa = 'select Nome_Listas from pessoa '.
						' where Dominio = "'.$_SESSION['Dominio'].'"'.
						' and Pessoa = "'.$empresa.'" ';
			$res_pessoa = consulta_sql($con_pessoa);
			$reg_pessoa = consulta_ler_linha($res_pessoa);
			consulta_limpa($res_pessoa);

			$filtro2.=' Empresa: "'.$reg_pessoa[0].'"';
		}

		if($cliente!=''){
			$cons_cheque.= ' and Pessoa = "'.$cliente.'" ';
			$filtro2.= ' Pessoa: "'.$cliente.'" ';
		}

		if($vendedor!=''){
			$filtro2.= ' Vendedor: "'.$vendedor.'" ';
			$con_vend = 'select cp.Pessoa '.
					  ' from cheque_pre cp '.
					  ' INNER JOIN pessoa_cliente pc '.
					  ' ON cp.Dominio = pc.Dominio '.
					  ' AND cp.Pessoa = pc.Pessoa '.
					  ' where cp.Dominio = "'.$_SESSION['Dominio'].'" '.
					  ' AND pc.Vendedor = "'.$vendedor.'" '.
					  ' group by cp.Pessoa ';
			$res_vend = consulta_sql($con_vend);
			$nrows_vend = consulta_num_registros($res_vend);
			$con_filtro = '';
			$lista_pessoa = '';

			for($v=0;$v<=$nrows_vend;$v++){
				$reg_vend = consulta_ler_linha($res_vend);

				$lista_pessoa = explode(';',$reg_vend[0]);
				foreach($lista_pessoa as $key => $valor){
					if ($valor!=''){
						if($con_filtro != ''){
							$con_filtro.= 'or';
						}
						$con_filtro.= ' (Pessoa = "'.$valor.'") ';

						$con_pessoa = 'select Nome_Listas, Pessoa from pessoa '.
									 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
									 ' and Pessoa = "'.$valor.'" ';
						$res_pessoa = consulta_sql($con_pessoa);
						$reg_pessoa = consulta_ler_linha($res_pessoa);
						consulta_limpa($res_pessoa);
					}
				}
			}
			if($con_filtro != ''){
				$cons_cheque.= ' and ('.$con_filtro.')';
			}
			consulta_limpa($res_vend);
		}

		if(($valor_ini!='') || ($valor_fim!='')){
			$filtro2.= 'Valor:';
			if($valor_ini!=''){
				$cons_cheque.= ' and Valor >= "'.str2nr(formata_valor($valor_ini)).'" ';
				$filtro2.= ' De: "'.$valor_ini.'"';
			}
			if($valor_fim!=''){
				$cons_cheque.= ' and Valor <= "'.str2nr(formata_valor($valor_fim)).'" ';
				$filtro2.= ' At: "'.$valor_fim.'"';
			}
		}

		if($tipo_data=="V"){
			if(($tipo_data_ini!='')||($tipo_data_fim!='')){
				$filtro2.= ' "Vencimento":';
				if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
					$cons_cheque.= ' and (DT_Vencto >= "'.datad($tipo_data_ini).'" '.
							' and DT_Vencto <= "'.datad($tipo_data_fim).'") ';
					$filtro2.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'"';
				}else if($tipo_data_ini!=''){
					$cons_cheque.= ' and (DT_Vencto >= "'.datad($tipo_data_ini).'") ';
					$filtro2.= ' De "'.$tipo_data_ini.'"';
				}else if($tipo_data_fim!=''){
					$cons_cheque.= ' and (DT_Vencto <= "'.datad($tipo_data_fim).'") ';
					$filtro2.= ' At "'.$tipo_data_fim.'"';
				}
			}
		}

		if($tipo_data=="E"){
			if(($tipo_data_ini!='')||($tipo_data_fim!='')){
				$filtro2.= ' "Emisso":';
				if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
					$cons_cheque.= ' and (DT_Emissao >= "'.datad($tipo_data_ini).'" '.
							' and DT_Emissao <= "'.datad($tipo_data_fim).'") ';
					$filtro2.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'"';
				}else if($tipo_data_ini!=''){
					$cons_cheque.= ' and (DT_Emissao >= "'.datad($tipo_data_ini).'") ';
					$filtro2.= ' De "'.$tipo_data_ini.'"';
				}else if($tipo_data_fim!=''){
					$cons_cheque.= ' and (DT_Emissao <= "'.datad($tipo_data_fim).'") ';
					$filtro2.= ' At "'.$tipo_data_fim.'"';
				}
			}
		}

		$_REQUEST['situacao']='A';
		if($situacao=='S'){
			$_REQUEST['situacao']='I';
		}
		if($_REQUEST['situacao']!=''){
			$filtro2.= ' Situao: ';
			if($_REQUEST['situacao']=='S'){
				$_REQUEST['situacao']='I';
			}
			if($_REQUEST['situacao']=='A'){
				$filtro2.= '"A Receber"';
				$cons_cheque.= ' and ((Situacao = "C") or (Situacao = "M") or (Situacao = "D") or (Situacao = "2") or (Situacao = "J"))';
			}else if($_REQUEST['situacao']=='F'){
				$filtro2.= '"Recebido"';
				$cons_cheque.= ' and ((Situacao = "B") or (Situacao = "P") or (Situacao = "R"))';
			}else if($_REQUEST['situacao']=='CD'){
				$filtro2.= '"Bons"';
				$cons_cheque.= ' and ((Situacao = "C") or (Situacao = "D"))';
			}else if($_REQUEST['situacao']=='2J'){
				$filtro2.= '"Ruins"';
				$cons_cheque.= ' and ((Situacao = "2") or (Situacao = "J"))';
			}else if($_REQUEST['situacao']=='I'){
				$filtro2.= '"Incobrveis"';
				$cons_cheque.= ' and (Situacao = "I")';
			}else{
				$cons_cheque.= ' and Situacao = "'.$_REQUEST['status'].'" ';
				if($_REQUEST['situacao']=='C'){
					$filtro2.= '"Custdia"';
				}else if($_REQUEST['situacao']=='B'){
					$filtro2.= '"1 Depsito"';
				}else if($_REQUEST['situacao']=='D'){
					$filtro2.= '"1 Devoluo"';
				}else if($_REQUEST['situacao']=='P'){
					$filtro2.= '"2 Depsito"';
				}else if($_REQUEST['situacao']=='2'){
					$filtro2.= '"2 Devoluo"';
				}else if($_REQUEST['situacao']=='R'){
					$filtro2.= '"Resgate"';
				}else if($_REQUEST['situacao']=='J'){
					$filtro2.= '"Em Cobrana"';
				}
			}
		}else{
			$filtro2.= ' Situao: "Todos"';
		}

		$_REQUEST['ordenacao'] = 'N';
		if($_REQUEST['ordenacao']!=''){
			$filtro2.= ' Ordenao: ';
			if($_REQUEST['ordenacao']=='R'){
				$cons_cheque.= ' order by Valor ';
				$filtro2.= '"Por Valor"';
			}else{
				$cons_cheque.= ' order by DT_Vencto ';
				$filtro2.= '"Por Vencimento"';
			}
		}


		$worksheet2->write(7,0,"Filtro: ".$filtro);

		$cons_cli = 'select Pessoa, Nome_Listas from pessoa '.
				   ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				   ' and Pessoa = "'.$cliente.'"';
		$res_cli = consulta_sql($cons_cli);
		$reg_cli = consulta_ler_linha($res_cli);
		consulta_limpa($res_cli);

		$worksheet2->write(9,0,"Cliente: ".$reg_cli[0].'-'.$reg_cli[1].' ('.$cpf_cnpj.')',$formatotit);


		$res_cheque = consulta_sql($cons_cheque);
		$nrows_cheque = consulta_num_registros($res_cheque);

		$linha_cheque = 11;

		if($nrows_cheque>0){
			$col_cheque=0;

			$worksheet2->set_column($col_cheque,$col_cheque,50);
			$worksheet2->write_string($linha_cheque,$col_cheque,'Cheque',$formatott);
			$col_cheque++;

			$worksheet2->set_column($col_cheque,$col_cheque,35);
			$worksheet2->write_string($linha_cheque,$col_cheque,'Cliente',$formatott);
			$col_cheque++;

			$worksheet2->set_column($col_cheque,$col_cheque,14);
			$worksheet2->write_string($linha_cheque,$col_cheque,'Dt Emisso',$formatott);
			$col_cheque++;

			$worksheet2->set_column($col_cheque,$col_cheque,14);
			$worksheet2->write_string($linha_cheque,$col_cheque,'Dt Vencto',$formatott);
			$col_cheque++;

			$worksheet2->set_column($col_cheque,$col_cheque,18);
			$worksheet2->write_string($linha_cheque,$col_cheque,'Valor',$formatott);
			$col_cheque++;

			$worksheet2->set_column($col_cheque,$col_cheque,18);
			$worksheet2->write_string($linha_cheque,$col_cheque,'Valor c/ Juros',$formatott);
			$col_cheque++;

			$linha_cheque++;

			$vl_total_cheques = 0;
			$chq_total_correcao = 0;

			for($c=0;$c<$nrows_cheque;$c++){
				$reg_cheque = consulta_ler_objeto($res_cheque);
				set_time_limit(30);


				$col_cheque = 0;

				$desc_cheque = 'Banco: '.$reg_cheque->Banco.
							' - Agncia: '.$reg_cheque->Agencia.' - '.
							'Conta: '.$reg_cheque->Conta.
							' - Cheque: '.$reg_cheque->Nr_Cheque;
				$worksheet2->write_string($linha_cheque,$col_cheque,$desc_cheque,$formatotl);
				$col_cheque++;


				if(($reg_cheque->Pessoa!='')&&($reg_cheque->Pessoa!='0')){
					$con_pessoa = 'select Nome_Listas from pessoa '.
							   ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
							   ' and Pessoa = "'.$reg_cheque->Pessoa.'"';
					$res_pessoa = consulta_sql($con_pessoa);
					$reg_pessoa = consulta_ler_linha($res_pessoa);
					consulta_limpa($res_pessoa);
					$desc_pessoa  =  $reg_cheque->Pessoa.'-'.$reg_pessoa[0].' ('.$cpf_cnpj.')';
				}else{
					$desc_pessoa  = '';
				}
				$worksheet2->write_string($linha_cheque,$col_cheque,$desc_pessoa,$formatotl);
				$col_cheque++;


				$worksheet2->write_string($linha_cheque,$col_cheque,dataf($reg_cheque->DT_Emissao),$formatotc);
				$col_cheque++;


				$worksheet2->write_string($linha_cheque,$col_cheque,dataf($reg_cheque->DT_Vencto),$formatotc);
				$col_cheque++;


				if(($reg_cheque->Valor=='')||($reg_cheque->Valor==0)){
					$txt_valor = '';
				}else{
					$txt_valor = $reg_cheque->Valor;
				}
				$worksheet2->write_number($linha_cheque,$col_cheque,$txt_valor,$formatotpreco);
				$col_cheque++;


				if($_REQUEST['situacao']!='A'){
					if($reg_cheque->Situacao == 'C'){
						$desc_campo = 'Custdia';
					}
					if($reg_cheque->Situacao == 'B'){
						$desc_campo = '1 Depsito';
					}
					if($reg_cheque->Situacao == 'D'){
						$desc_campo = '1 Devoluo';
					}
					if($reg_cheque->Situacao == 'P'){
						$desc_campo = '2 Depsito';
					}
					if($reg_cheque->Situacao == '2'){
						$desc_campo = '2 Devoluo';
					}
					if($reg_cheque->Situacao == 'J'){
						$desc_campo = 'Em cobrana';
					}
					if($reg_cheque->Situacao == 'I'){
						$desc_campo = 'Incobrvel';
					}
					if($reg_cheque->Situacao == 'R'){
						$desc_campo = 'Resgatado';
					}
				}else{
					if($correcao_juros>0){
						$desc_campo = $reg_cheque->Valor;
					}else{
						$desc_campo = '';
					}
					$chq_valor_correcao = 0;
					$chq_dif_datas = data2nr($correcao_data) - data2nr(dataf($reg_cheque->DT_Vencto));
					if($chq_dif_datas>0){
						if($correcao_juros>0){
							//calcula juros
							$chq_dias = $chq_dif_datas;
							$chq_p_juros = $correcao_juros;
							$chq_acrescimo = 0;
							$chq_desconto = 0;
							$chq_t_juros = 'C';

							$chq_meses=0;

							while($chq_dias>=30){
								$chq_meses++;
								$chq_dias-= 30;
							}
							$chq_valor_pagar = round((($reg_cheque->Valor + $chq_acrescimo) - $chq_desconto), 2);
							if(($chq_t_juros=='C')&&($chq_meses>0)){
								for($m=0;$m<$chq_meses;$m++){
									$chq_acrescimo+= $chq_valor_pagar * ($chq_p_juros/100);
									$chq_valor_pagar = ($reg_cheque->Valor + $chq_acrescimo) - $chq_desconto;
								}
							}else if($chq_meses>0){
								$chq_acrescimo+= ($chq_valor_pagar * ($chq_p_juros/100) * $chq_meses);
							}
							if($chq_dias>0){
								$chq_acrescimo+= (($chq_valor_pagar * ($chq_p_juros/100))/30)*$chq_dias;
							}
							$chq_acrescimo = round($chq_acrescimo,2);
							$chq_valor_correcao = $chq_acrescimo;

							$desc_campo = ($reg_cheque->Valor+$chq_valor_correcao);
							$chq_total_correcao+=($reg_cheque->Valor+$chq_valor_correcao);

						}
					}else{
						$chq_total_correcao+=$reg_cheque->Valor;
					}
				}
				$worksheet2->write_number($linha_cheque,$col_cheque,$desc_campo,$formatotpreco);
				$col_cheque++;

				$linha_cheque++;

				$vl_total_cheques+= $reg_cheque->Valor;

			}

			//exibir total cheque
			$col_cheque=0;

			$worksheet2->write_string($linha_cheque,$col_cheque,'Total: '.$nrows_cheque.' cheque(s)',$formatotlb);
			//$col_cheque++;

			for($lnc=0;$lnc<=2;$lnc++){
				$col_cheque++;
				$worksheet2->write_blank($linha_cheque,$col_cheque,$formatotc); //acertar bordas
			}

			$col_cheque++;
			$worksheet2->write_number($linha_cheque,$col_cheque,$vl_total_cheques,$formatotbpreco);


			if($_REQUEST['situacao']!='A'){
				$col_cheque++;
				$worksheet2->write_blank($linha_cheque,$col_cheque,$formatotc);
			}else{
				if($correcao_juros>0){
					$col_cheque++;
					$worksheet2->write_number($linha_cheque,$col_cheque,$chq_total_correcao,$formatotbpreco);
				}else{
					$col_cheque++;
					$worksheet2->write_blank($linha_cheque,$col_cheque,$formatotc);
				}
			}
			$linha_cheque++;
		}
    }//fim cheques


    //aba adiantamentos
    if($adianta=='S'){
		$titulo_sheet3 = 'ADIANTAMENTO';
		$worksheet3 =& $workbook->add_worksheet($titulo_sheet3);

		$worksheet3->write_string(0,0,'RELATRIO DE ADIANTAMENTO',$formatot);
		$worksheet3->write(3,0,config_pad('sistema_licenca'));
		$worksheet3->write(4,0,"Data: ".$hoje." - Hora: ".$hora);
		$worksheet3->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

		$filtro3 = '';

		if(isset($_REQUEST['vendedor'])){
			if($_REQUEST['vendedor']!=''){
				$inner_vend = 'inner join pessoa_cliente pc '.
						   ' on pes.Dominio = pc.Dominio and '.
						   ' pes.Pessoa = pc.Pessoa ';
				$where_vend = ' and pc.Vendedor = "'.$_REQUEST['vendedor'].'"';
			}else{
				$inner_vend = '';
				$where_vend = '';
			}
		}else{
			$inner_vend = '';
			$where_vend = '';
		}

		$cons_adianta = 'select ad.Pessoa, ad.Origem_Tipo, ad.DT_Criacao, '.
                       ' ad.Nr_Adiant, ad.Obs, ad.Valor, ad.TipoPR, '.
                       ' ad.Seq, ad.Empresa, ad.Valor_Pago, ad.DH_Baixa, '.
                       ' ad.Obs, ad.Origem_Obs, ad.Baixa_Obs, ad.Situacao, '.
                       ' pes.Nome_Razao '.
                       ' from contas_ad ad '.
                       ' inner join pessoa pes '.
                       ' on ad.Dominio = pes.Dominio '.
                       ' and ad.Pessoa = pes.Pessoa '.
                       ' '.$inner_vend.' '.
                       ' where ad.Dominio = "'.$_SESSION['Dominio'].'" '.
                       ' and ad.Situacao <> "E" '.
                       ' '.$where_vend.' ';

		if($empresa>0){
			$cons_adianta.= ' and ad.Empresa = "'.$empresa.'" ';

			$cons_empresa = 'select Nome_Listas from pessoa '.
						  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
						  ' and Pessoa = "'.$_REQUEST['empresa'].'"';
			$res_empresa = consulta_sql($cons_empresa);
			$reg_empresa = consulta_ler_linha($res_empresa);
			consulta_limpa($res_empresa);
			$filtro3.= ' Empresa: "'.$reg_empresa[0].'" ';
		}

		$tipo_mov = '';
		if($tipo_mov!=''){
			$cons_adianta.= ' and ad.TipoPR = "'.$tipo_mov.'" ';
			if($tipo_mov=='C'){
				$filtro3.= ' Tipo Movto: "Crdito" ';
			}else if($tipo_mov=='D'){
				$filtro3.= ' Tipo Movto: "Dbito" ';
			}
		}

		if($cliente!=''){
			$cons_fornec = 'select Nome_Listas,CPF_CNPJ from pessoa '.
						 ' where Dominio = "'.$_SESSION["Dominio"].'"'.
						 ' and Pessoa = "'.$cliente.'"';
			$res_fornec = consulta_sql($cons_fornec);
			$reg_fornec = consulta_ler_linha($res_fornec);
			consulta_limpa($res_fornec);
			$filtro.= ' Pessoa: "'.$cliente.'-'.$reg_fornec[0].'" ';

			if($agrupado=='S'){
				if((strlen($reg_fornec[1])==18)&&($reg_fornec[1]!='00.000.000/0000-00')){

				}else{
					$agrupado = 'N';
				}
			}

			if($agrupado=='N'){
				$cons_adianta.= ' and (ad.Pessoa = "'.$cliente.'") ';
			}else{
				$cons_adianta.= ' and (pes.CPF_CNPJ like "'.substr($reg_fornec[1],0,9).'%") ';
				$filtro3.= ' Agrupado';
			}
		}

		if($procuracao!= '' ){        
			if( $procuracao=='S'){
				$filtro.= ' "Com Procurao" ';
				$consulta.= ' AND  cp.Pessoa IN ( '.$pessoas_procuracao.')';
			}else{
				$filtro.= ' "Sem Procurao" ';
				$consulta.= ' AND  cp.Pessoa NOT IN ( '.$pessoas_procuracao.')';
			}
		}

		$tipo_conta = '';
		if($tipo_conta!=''){
			$cons_adianta.= ' and ad.Origem_Tipo = "'.$tipo_conta.'" ';
			if($tipo_conta=='C'){
				$filtro3.= ' Tipo Conta: "Cliente" ';
			}else if($tipo_conta=='F'){
				$filtro3.= ' Tipo Conta: "Fornecedor" ';
			}
		}

		if($tipo_data=="P"){
			$tipo_data_ad='B';
		}else{
			$tipo_data_ad='G';
		}

		if($tipo_data_ad=="B"){
			$filtro3.= ' "Data Baixa"';
			if($tipo_data_ini!=''){
				$cons_adianta.= ' and ad.DH_Baixa >= "'.datad($tipo_data_ini).'" ';
				$filtro3.= ' De: "'.$tipo_data_ini.'"';
			}
			if($tipo_data_fim!=''){
				$cons_adianta.= ' and ad.DH_Baixa <= "'.datad($tipo_data_fim).'" ';
				$filtro3.= ' At: "'.$tipo_data_fim.'"';
			}
		}else if($tipo_data=="G"){
			$filtro3.= ' "Data Criao"';
			if($tipo_data_ini!=''){
				$cons_adianta.= ' and ad.DT_Criacao >= "'.datad($tipo_data_ini).'" ';
				$filtro3.= ' De: "'.$tipo_data_ini.'"';
			}
			if($tipo_data_fim!=''){
				$cons_adianta.= ' and ad.DT_Criacao <= "'.datad($tipo_data_fim).'" ';
				$filtro3.= ' At: "'.$tipo_data_fim.' "';
			}
		}

		if(($valor_ini!='') || ($valor_fim!='')){
			$filtro3.= ' Valor:';
			if($valor_ini!=''){
				$cons_adianta.= ' and ad.Valor >= "'.str2nr(formata_valor($valor_ini)).'" ';
				$filtro3.= ' De "'.$valor_ini.'"';
			}
			if($valor_fim!=''){
				$cons_adianta.= ' and ad.Valor <= "'.str2nr(formata_valor($valor_fim)).'" ';
				$filtro3.= ' At "'.$valor_fim.'"';
			}
		}

		if($nome_parcial!=''){
			$cons_adianta.= ' and pes.Nome_Razao like "%'.$nome_parcial.'%" ';
			$filtro3.= ' Parcial Nome: "'.$nome_parcial.'"';
		}


		$situacao = 'A';
		if(($situacao!='')&&($situacao!='T')){
			$filtro3.= ' Situao:';
			if($situacao=='A'){
				$filtro3.= ' "Em Aberto"';
				$cons_adianta.= ' and ad.Situacao = "A" ';
			}else if(($situacao=='B')||($situacao=='F')){
				$filtro3.= ' "Baixado"';
				$cons_adianta.= ' and ad.Situacao = "F" ';
			}
		}else{
			$filtro3.= ' Situao: "Todas"';
		}

		$cons_adianta.= ' order by pes.Nome_Razao,ad.Pessoa,ad.Nr_Adiant ';
		$filtro3.= ' Ordenao: "Por Nome"';

		$worksheet3->write(7,0,"Filtro: ".$filtro);

		$cons_cli = 'select Pessoa, Nome_Listas from pessoa '.
				   ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				   ' and Pessoa = "'.$cliente.'"';
		$res_cli = consulta_sql($cons_cli);
		$reg_cli = consulta_ler_linha($res_cli);
		consulta_limpa($res_cli);

		$worksheet3->write(9,0,"Cliente: ".$reg_cli[0].'-'.$reg_cli[1].' ('.$cpf_cnpj.')',$formatotit);


		$res_adianta = consulta_sql($cons_adianta);
		$nrows_adianta = consulta_num_registros($res_adianta);

		$linha_adianta = 11;

		if($nrows_adianta>0){
			$col_adianta=0;

			$worksheet3->set_column($col_adianta,$col_adianta,10);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Nr Doc',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,3);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Seq.',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,5);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Tp Conta',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,14);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Dt Gerao',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,14);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Dt Baixa',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,15);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Empresa',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,18);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Valor Doc',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,18);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Valor Baixa',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,12);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Tp Mov.',$formatott);
			$col_adianta++;

			$worksheet3->set_column($col_adianta,$col_adianta,18);
			$worksheet3->write_string($linha_adianta,$col_adianta,'Observao',$formatott);
			$col_adianta++;


			$linha_adianta++;

			$id_pessoa = '';

			$lista_empresas = lista_empresas();

			for($a=0;$a<$nrows_adianta;$a++){
               $reg_adianta = consulta_ler_objeto($res_adianta);
               set_time_limit(30);

               if($id_pessoa!=$registro->Pessoa){
					if($id_pessoa!=''){
						$col_adianta=0;
						$col_adianta++;
						$worksheet3->write_string($linha_adianta,$col_adianta,'Total Dbito:'.str_replace('"','',to_money($total_deb)),$formatotlb);
						$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

						$col_adianta++;
						$worksheet3->write_string($linha_adianta,$col_adianta,'Pago Dbito: '.str_replace('"','',to_money($valor_deb_pag)),$formatotlb);
						$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

						$col_adianta++;
						$worksheet3->write_string($linha_adianta,$col_adianta,'Saldo Dbito: '.str_replace('"','',to_money($total_deb-$valor_deb_pag)),$formatotlb);
						$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

						$linha_adianta++;


						$col_adianta=0;
						$col_adianta++;
						$worksheet3->write_string($linha_adianta,$col_adianta,'Total Crdito:'.str_replace('"','',to_money($total_cred)),$formatotlb);
						$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

						$col_adianta++;
						$worksheet3->write_string($linha_adianta,$col_adianta,'Pago Crdito: '.str_replace('"','',to_money($valor_cred_pag)),$formatotlb);
						$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

						$col_adianta++;
						$worksheet3->write_string($linha_adianta,$col_adianta,'Saldo Crdito: '.str_replace('"','',to_money($total_cred-$valor_cred_pag)),$formatotlb);
						$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);
						$col_adianta++;
						$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

						$linha_adianta++;

						$total_deb=0;
						$valor_deb_pag=0;

						$total_cred=0;
						$valor_cred_pag=0;

					}

					$id_pessoa = $reg_adianta->Pessoa;


					$col_adianta=0;

					$col_adianta++;

					if($reg_adianta->Nome_Razao!=''){
						$desc_pess = $reg_adianta->Nome_Razao;
					}else{
						$cons_pess = 'select Nome_Razao from pessoa '.
								  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
								  ' and Pessoa = "'.$reg_adianta->Pessoa.'"';
						$res_pess = consulta_sql($cons_pess);
						$reg_pess = consulta_ler_linha($res_pess);
						consulta_limpa($res_pess);

						$desc_pess = $reg_desc[0];
					}
					$worksheet3->write_string($linha_adianta,$col_adianta,$reg_adianta->Pessoa.' - '.$desc_pess,$formatotlb);
					$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+3);

					$col_adianta++;
					$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

					$linha_adianta++;

				}

				$col_adianta=0;


				$worksheet3->write_string($linha_adianta,$col_adianta,$reg_adianta->Nr_Adiant,$formatotc);
				$col_adianta++;


				$worksheet3->write_string($linha_adianta,$col_adianta,$reg_adianta->Seq,$formatotc);
				$col_adianta++;


				$worksheet3->write_string($linha_adianta,$col_adianta,$reg_adianta->Origem_Tipo,$formatotc);
				$col_adianta++;


				$worksheet3->write_string($linha_adianta,$col_adianta,dataf($reg_adianta->DT_Criacao),$formatotc);
				$col_adianta++;


				$data_baixa = '';
				if($reg_adianta->DH_Baixa!='0000-00-00 00:00:00'){
					$data_baixa = dataf($reg_adianta->DH_Baixa);
				}
				$worksheet3->write_string($linha_adianta,$col_adianta,$data_baixa,$formatotc);
				$col_adianta++;


				$worksheet3->write_string($linha_adianta,$col_adianta,nome_empresa($lista_empresas,$reg_adianta->Empresa),$formatotc);
				$col_adianta++;


				$valor = '';
				if(formata_qtd($reg_adianta->Valor)>0){
					$valor = $reg_adianta->Valor;
				}
				$worksheet3->write_number($linha_adianta,$col_adianta,$valor,$formatotpreco);
				$col_adianta++;


				$valor_pag = '';
				if(formata_qtd($reg_adianta->Valor_Pago)>0){
					$valor_pag = $reg_adianta->Valor_Pago;
				}
				$worksheet3->write_number($linha_adianta,$col_adianta,$valor_pag,$formatotpreco);
				$col_adianta++;


				$deb_cred = '';
				if($reg_adianta->TipoPR=='C'){
					$deb_cred = 'Crdito';
				}
				if($reg_adianta->TipoPR=='D'){
					$deb_cred = 'Dbito';
				}
				$worksheet3->write_string($linha_adianta,$col_adianta,$deb_cred,$formatotc);
				$col_adianta++;


				$worksheet3->write_string($linha_adianta,$col_adianta,$deb_cred,$formatotc);
				$col_adianta++;

				$linha_adianta++;

			}

			if($id_pessoa!=''){
				$col_adianta=0;
				$col_adianta++;
				$worksheet3->write_string($linha_adianta,$col_adianta,'Total Dbito:'.str_replace('"','',to_money($total_deb)),$formatotlb);
				$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

				$col_adianta++;
				$worksheet3->write_string($linha_adianta,$col_adianta,'Pago Dbito: '.str_replace('"','',to_money($valor_deb_pag)),$formatotlb);
				$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

				$col_adianta++;
				$worksheet3->write_string($linha_adianta,$col_adianta,'Saldo Dbito: '.str_replace('"','',to_money($total_deb-$valor_deb_pag)),$formatotlb);
				$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

				$linha_adianta++;


				$col_adianta=0;
				$col_adianta++;
				$worksheet3->write_string($linha_adianta,$col_adianta,'Total Crdito:'.str_replace('"','',to_money($total_cred)),$formatotlb);
				$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc); //acertar bordas

				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

				$col_adianta++;
				$worksheet3->write_string($linha_adianta,$col_adianta,'Pago Crdito: '.str_replace('"','',to_money($valor_cred_pag)),$formatotlb);
				$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);

				$col_adianta++;
				$worksheet3->write_string($linha_adianta,$col_adianta,'Saldo Crdito: '.str_replace('"','',to_money($total_cred-$valor_cred_pag)),$formatotlb);
				$worksheet3->merge_cells($linha_adianta, $col_adianta, $linha_adianta, $col_adianta+2);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);
				$col_adianta++;
				$worksheet3->write_blank($linha_adianta,$col_adianta,$formatotc);
				$linha_adianta++;

				$total_deb=0;
				$valor_deb_pag=0;

				$total_cred=0;
				$valor_cred_pag=0;

			}
		}

      /* if($cheques == 'S'){
         $_REQUEST['contas_receber'] = 1;
         $_REQUEST['venc_ini'] = $_REQUEST['tipo_data_ini'];
         $_REQUEST['venc_fim'] = $_REQUEST['tipo_data_fim'];
         $_REQUEST['ordenacao'] = 'N';
         $_REQUEST['status_ini'] = '';
         $_REQUEST['status_fim'] = '';

         if($_REQUEST['situacao'] == 'A'){
            $_REQUEST['status'] = 'A';
         }else if($_REQUEST['situacao'] == 'F'){
            $_REQUEST['status'] = 'F';
         }else if($_REQUEST['situacao'] == 'S'){
            $_REQUEST['status'] = 'I';
         }else{
            $_REQUEST['status'] = '';
         }

         require_once('relatorio_cheques_pre_cheque_excel_include.php');
      } */


    }
    //ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE O DIV NO MOMENTO DE GERAR O EXCEL
    $insert = 'insert into relatorio_tmp ( '.
              ' Dominio, '.
              ' Usuario, '.
              ' Descricao ) values ('.
              '"'.$_SESSION['Dominio'].'", '.
              '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
              '"")';
    consulta_sql($insert);

    $workbook->close();
?>