<?php
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	define('FPDF_FONTPATH', '../../fpdf/font/');
	require('../../fpdf/fpdf.php');
if(session::usr_conectado($_REQUEST['USER_ID'])){
	if(isset($_REQUEST['empresa'])){
		$filt_empresa = base64_decode_si($_REQUEST['empresa']);
	}else{
		$filt_empresa = $_SESSION['Empresa_Codigo'];
	}
	$fpdf = new FPDF();
	class PDF extends FPDF{
		var $NrEmpresa ;
		var $NrOS;
		var $TipoOS;      

		function Header(){
			$this->AliasNbPages();
			$base_y = 0;
			$this->SetAutoPageBreak(false,30);
			//$this->Image('../../imgs/os_layout30-A.jpg', 5, (5+$base_y), 200, 280);
			$this->Image(busca_imagem_empresa('logo_menu.jpg', '../../'),12, (14+$base_y), 30,15);

			//Nome da empresa 
			$con_emp = 'SELECT Nome_Fantasia, Web_Site, Nome_Listas, CPF_CNPJ, EMail FROM pessoa '.
					 ' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= " '.$_SESSION['Empresa_Codigo'].' " ';
			$res_emp = consulta_sql($con_emp);
			$reg_emp = consulta_ler_linha($res_emp);
			consulta_limpa($res_emp);
			$lnh1 =  $reg_emp[0];

			$col = 70;	$linha = 10;	$tam = 130 ; 

			$this->SetFont('Arial','B',10); 
			#$this->SetTextColor(0,0,128);
			$this->y= ( $linha + ($base_y));
			$this->x=  $col;
			$this->MultiCell($tam, 3, $lnh1, 0,'L');

			//Endereco empresa
			$con_end_emp = 'SELECT Logradouro, Numero, Complemento, Bairro, Nome_Cidade, UF,Insc_Estadual '.
						' FROM pessoa_endereco '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						' AND Situacao <> "E" '.
						' ORDER BY Seq_Endereco LIMIT 1 ';
			$res_end_emp = consulta_sql($con_end_emp);
			$reg_end_emp = consulta_ler_linha($res_end_emp);
			consulta_limpa($res_end_emp);

			$lnh2 = $reg_end_emp[0].', ';
			if($reg_end_emp[1]!=''){
				$lnh2.='N '.$reg_end_emp[1];
			}else{
					$lnh2.='S/N,';
			}
			$lnh2.=' '.$reg_end_emp[2].', '.$reg_end_emp[3].', '.UpperDados($reg_end_emp[4]).'/'.UpperDados($reg_end_emp[5]); 

			$linha +=5;
			$this->SetFont('Arial','',8); 
			$this->y= ( $linha + ($base_y));
			$this->x= $col;
			$this->MultiCell($tam, 3, $lnh2, 0,'L');

			$lnh3.='CNPJ '.$reg_emp[3].' - IE '.$reg_end_emp[6] ;
			$linha +=5; 
			$this->y= ( $linha + ($base_y));
			$this->x= $col;
			$this->MultiCell($tam, 3, $lnh3, 0,'L'); 

			$con_tel_emp = 'SELECT  Numero_Telefone FROM  pessoa_telefone '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						' AND  Situacao = "A" '.
						' ORDER BY Seq_Telefone ';
			$res_tel_emp = consulta_sql($con_tel_emp);
			$reg_tel_emp = consulta_ler_linha($res_tel_emp);
			consulta_limpa($res_tel_emp);

			if($reg_tel_emp[0] !=''){
					$tel_emp = 'Telefone '.$reg_tel_emp[0];                     
			}
			$linha +=5;  
			$this->y= ($linha + ($base_y));
			$this->x= $col;
			$this->MultiCell($tam , 3, $tel_emp,0,'L');

			//endereo virtual 0 e 1 , e apresentacao
			$end_v1= $reg_emp[4];
			$end_v2= $reg_emp[1];
			$end_v3= $end_v1." - ".$end_v2;
			$linha +=5; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell($tam, 3, $end_v3, 0,'L');

			$linha_fim_apresentacao = UpperDados($reg_end_emp[4]).'/'.UpperDados($reg_end_emp[5]).', '.DataExtenso(date("d/m/Y") ,0) ;

			$tam = 190;	$col = 10;	$linha +=5; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell($tam, 3, $linha_fim_apresentacao , 0,'R');

			$linha +=4;
			$this->Line(10, $linha, 200, $linha+1);
			$linha ++;  

			$con_os= 'SELECT * FROM ordem_servico '.
					' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
					 ' AND Empresa = "'.$_SESSION['Empresa_Codigo'].'" '.
					 ' AND Nr_OrdemServico = "'.base64_decode_si($_REQUEST['idreg']).'" ';              

			$res_os = consulta_sql($con_os);
			$reg_os = consulta_ler_objeto($res_os);
			consulta_limpa($res_os);

			$ln = $linha + 1;	$cel = 10;	$tam = 190;
			//primeiro titulo ordem de servio
			$nr_os = $reg_os->Nr_OrdemServico ;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Oramento da '.UpperDados(busca_nome_os()).' N '.$nr_os, 0,'C',1);

			//////////////////////////////////////////////////////////////////////////////////
			//inicio da Busca do Cliente 
			$con_cli = 'SELECT Nome_Razao, CPF_CNPJ, RG, EMail FROM pessoa '.
						' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= " '.$reg_os->Pessoa.' " ';
			$res_cli = consulta_sql($con_cli);
			$reg_cli = consulta_ler_linha($res_cli);
			consulta_limpa($res_cli);

			$ln += 7;	$cel = 10;	$tam = 30; 
			//Nova linha - apresentacao do cliente - chamada
			$this->SetFont('Arial','',8);  
			$this->SetTextColor(0,0,0);          
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Cliente ', 1,'L');

			$cel += $tam;	$tam = 100; 
			//Nova linha - apresentacao do cliente  - nome 
			$this->SetFont('Arial','',10);  
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;

			$nome_cli = $reg_cli[0] ; 
			$nv_cli = $this->Lines_MultiCell($tam,5,   $nome_cli, 1, 'L');
			while( $nv_cli > 1){
				$nome_cli = substr(  $nome_cli,0,strlen(   $nome_cli )-1);
				$nv_cli = $this->Lines_MultiCell($tam, 5,   $nome_cli , 1, 'L');
			}
			$this->MultiCell($tam, 5,  $nome_cli , 1,'L');

			$con_contato_cli = 'SELECT Nome FROM pessoa_contato '.
								' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= "'.$reg_os->Pessoa.'" '.
								' ORDER BY Seq_Contato  Limit 1  ';
			$res_contato_cli = consulta_sql($con_contato_cli);
			$reg_contato_cli = consulta_ler_linha($res_contato_cli);
			consulta_limpa($res_contato_cli);
			$cel += $tam;	$tam = 15; 

			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Contato', 1,'L');
			$cel += $tam;       $tam = 45; 
			//Nova linha - apresentacao do cliente  - nome 
			$this->SetFont('Arial','',10);  
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $reg_contato_cli[0], 1,'L');

				/////////////////////////// cliente - endereo
			$con_end_cli = 'SELECT Logradouro, Numero, Complemento, Bairro, Nome_Cidade, UF, CEP, Insc_Estadual'.    
						' FROM pessoa_endereco '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						' AND Pessoa = "'.$reg_os->Pessoa.'"'.
						' AND Situacao <> "E"'.
						' ORDER BY Seq_Endereco LIMIT 1';
			$res_end_cli = consulta_sql($con_end_cli);
			$reg_end_cli = consulta_ler_linha($res_end_cli);
			consulta_limpa($res_end_cli);

			$end_cli = $reg_end_cli[0].', '.$reg_end_cli[1].' '.$reg_end_cli[2].' '.$reg_end_cli[3].' - '.$reg_end_cli[4].' - '.$reg_end_cli[5];

			$ln += 5;           $cel = 10;      $tam = 30; 
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Endereo', 1,'L');
			$cel += $tam;       $tam = 130;
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;

			$nv_cli = $this->Lines_MultiCell($tam,5,  $end_cli, 1, 'L');
			while( $nv_cli > 1){
				$end_cli = substr( $end_cli,0,strlen(  $end_cli )-1);
				$nv_cli = $this->Lines_MultiCell($tam, 5,  $end_cli , 1, 'L');
			}
			$this->MultiCell($tam, 5, $end_cli, 1,'L');

			$cel += $tam;	$tam = 10;
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'CEP', 1,'L');

			$cel += $tam;	$tam = 20;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $reg_end_cli[6], 1,'L');
			/////////////////////////////// CNPJ
			$ln += 5;	$cel = 10;	$tam = 30;
			$this->SetFont('Arial','',10);
			//$this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam , 5, 'CPF/CNPJ ', 1,'L');

			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $reg_cli[1], 1,'L');

			/////////////////   TELEFONE:
			$con_cli_tel = 'SELECT  Numero_Telefone FROM pessoa_telefone '.
						  ' where Dominio = "'.$_SESSION["Dominio"].'" '.
						  ' and Pessoa = "'.$reg_os->Pessoa.'"'.
						  ' and Situacao <> "E"'.
						  ' order by Seq_Telefone '.
						  ' limit 3';
			$res_cli_tel = consulta_sql($con_cli_tel);         
			$nrows_tel = consulta_num_registros($res_cli_tel);
			$tel='';
			if($nrows_tel>0){
				for($i=0;$i<$nrows_tel;$i++){
					$reg_cli_tel = consulta_ler_linha($res_cli_tel);
					if ($tel != '') {
						$tel.=', ';
					}
					$tel.= $reg_cli_tel[0];
				}
			}
			consulta_limpa($res_cli_tel);
			$cel += $tam;	$tam = 30;
			$this->SetFont('Arial','',10);
			// $this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 5, 'Telefone ', 1,'L');

			$cel += $tam;	$tam = 90; $lt = 10;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $tel, 1,'L');

			///////////////////////////  EMAIL
			$cel = 10;	$ln += 5;	$tam = 30;
			$this->SetFont('Arial','',$lt);
			// $this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 5, 'E-mail ', 1,'L');

			$cel += $tam;	$tam = 160;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;

			$email_cliente = $reg_cli[3] ;
			$nm = $this->Lines_MultiCell($tam,5,  $email_cliente, 1, 'L');
			while($nm > 1){
				$email_cliente = substr( $email_cliente,0,strlen( $email_cliente )-1);
				$nm = $this->Lines_MultiCell($tam, 5,  $email_cliente , 1, 'L');
			}
			$this->MultiCell($tam, 5, $email_cliente, 1,'L');

			//////////////////////////////////////////////////
			$ln += 6;	$cel = 10;	$tam = 190;
			//segundo primeiro titulo   - maquina
			$this->SetFont('Arial','B',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Mquina', 0,'C',1);
			//////////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////  Equipamento
			///////////////////////////////////////  Marca Modelo 
			$ln += 7;	$cel = 10;	$tam = 20;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'Modelo ', 1,'L');
			$cel += $tam;	$tam = 50;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5,$reg_os->Modelo, 1,'L');

			///////marca  
			$cel += $tam;	$tam = 20;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Marca', 1,'L');
			$cel += $tam;	$tam = 50;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5,$reg_os->Marca, 1,'L');
			//entrada
			$cel += $tam;	$tam = 20; 
			$this->SetFont('Arial','',$lt); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Entrada ', 1,'L');
			$cel += $tam;	$tam = 30;
			//$hora_os = ' '.substr($reg_os->DH_Emissao,11,5);
			$this->SetFont('Arial','',10); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, dataf($reg_os->DH_Emissao), 1,'L');
			//local
			$ln += 5;	$cel = 10;	$tam = 30;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Local', 1,'L');
			$cel += $tam;	$tam = 70;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5,$reg_os->Setor, 1,'L');

			//descricao
			$cel += $tam ;	$tam = 23;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Descrio', 1,'L');
			$cel += $tam;	$tam = 67;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5,$reg_os->Aparelho, 1,'L');
			/////////////////////////   numero de serie  e patrimonio
			$ln += 5;	$cel = 10;	$tam = 30;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Srie ', 1,'L');
			$cel += $tam;	$tam = 60;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5,$reg_os->NrSerie, 1,'L');
			$cel += $tam;	$tam = 30;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5,'Patrimnio ', 1,'L'); 
			$cel += $tam;	$tam = 70;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5,$reg_os->Equipamento, 1,'L');

			//////////////////////   Acessorios
			$ln += 5;	$cel = 10;	$tam = 30;
			$this->SetFont('Arial','',$lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Acessrios ', 1,'L');
			$cel += $tam;	$tam = 160;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;

			$aces  = $reg_os->Solucao ;
			$num = $this->Lines_MultiCell($tam,5, $aces, 1, 'L');
			while(  $num > 1){
				$aces = substr($aces,0,strlen($aces)-1);
				$num  = $this->Lines_MultiCell($tam, 5, $aces, 1, 'L');
			}
			$this->MultiCell($tam, 5,  $aces , 1,'L');
			/////////////////// DEFEITO 

			//echo 'tipo a 03 ';
			$cel = 10;	$tam = 30;	$ln += 5;
			$this->SetFont('Arial','',$lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam , 5, 'Parecer:', 1,'L');
			$cel += $tam;	$tam = 160;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$parecer  =  $reg_os->ParecerCliente;
			$num2 = $this->Lines_MultiCell($tam,5, $parecer , 1, 'L');
			while( $num2 > 2){
				$parecer = substr($parecer,0,strlen($parecer)-1);
				$num2  = $this->Lines_MultiCell($tam, 5,$parecer, 1, 'L');
			}
			$this->MultiCell($tam, 5, $parecer , 1,'L');

			/////////////////// Solucao 
			$cel = 10;	$tam = 30;	$ln += 5;
			$this->SetFont('Arial','',$lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam , 5, 'Soluo:', 1,'L');
			$cel += $tam;	$tam = 160;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$def  =  $reg_os->ObsAtendimento;
			$num3 = $this->Lines_MultiCell($tam,5, $def , 1, 'L');
			while(  $num2 > 2){
				$def = substr($parecer,0,strlen( $def)-1);
				$num3  = $this->Lines_MultiCell($tam, 5, $def, 1, 'L');
			}
			$this->MultiCell($tam, 5,$def , 1,'L');

			//////////////////////   LAUDO TECNICO
			$ln += 12;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','B',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Laudo Tcnico ', 0,'C',1); 

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','', $lt);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;

			$laudo = $reg_os->Laudo;
			$num_laudo = $this->Lines_MultiCell($tam,5, $laudo, 1, 'L');
			while( $num_laudo > 3){
				$laudo = substr($laudo,0,strlen($laudo)-1);
				$num_laudo = $this->Lines_MultiCell($tam, 4, $laudo, 1, 'L');
			}
			$this->MultiCell( $tam , 5, $laudo  , 1,'L');

			$ln += 18;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Valores da Ordem de Servio', 1,'C',1);

			//grade dos itens
			//////////////////////////////////////////////////////////////////////
			if ( ($_SESSION['Dominio'] == '340')||($_SESSION['Dominio'] == '351')){
				$nome = 'Vendedor';
				$tam = 30; 
			}else{
				$nome = 'Responsvel Tcnico'; 
				$tam = 50;  
			}
			$ln += 7;	$cel = 10;
			// //primeiro titulo
			$this->SetFont('Arial','',12); 
			// $this->SetFillColor(0,0,128); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $nome, 1,'L');
			$cel += $tam;  
			if ( ($_SESSION['Dominio'] == '340')||($_SESSION['Dominio'] == '351')){                
				$tam = 160; 
			}else{
				$tam = 140;  
			}

			$con_vend ='SELECT Nome_Razao FROM pessoa WHERE Pessoa =  '.$reg_os->Vendedor.' ';
			$res_vend = consulta_sql($con_vend);
			$reg_vend = consulta_ler_linha($res_vend);
			$vend = $reg_vend[0];

			$this->SetFont('Arial','',12); 
			//$this->SetFillColor(0,0,128); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $vend , 1,'L');

			/*
			//SABER QUAL A LINHA ONDE COMEA OS ITENS  
			//este valor deve ser adicionado na linha  onde contem esta informacao >>> $ln_itens = 150; 
			$ln += 5;	$cel = 10;	$tam = 190; 
			$this->SetFont('Arial','',8);  
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, '  '.$ln, 1,'C');  
			*/
			$ln_fim = 205;
			$ln = $ln_fim;

			$cel = 100;
			$tam = 100;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam, 6, 'Totais ', 0,'C',1);

			$desloc = 0;
			$ln += 6;   $cel = 100;  $tam = 60;
			$this->SetFont('Arial','', $lt);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;
			$this->MultiCell( $tam , 5, 'Mo de Obra/Servios ', 1,'L');
			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','',$lt); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam, 5, str_replace('"','',to_money($reg_os->Valor_Total_Serv - $desloc )), 1,'R');

			$ln += 5;	$cel = 100;	$tam = 60;
			$this->SetFont('Arial','', $lt);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;
			$this->MultiCell( $tam , 5, 'Peas/Produtos ', 1,'L');
			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','',$lt); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam, 5, str_replace('"','',to_money($reg_os->Valor_Total_Prod)), 1,'R');

			$ln += 5;   $cel = 100;  $tam = 60;
			$this->SetFont('Arial','', $lt);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;
			$this->MultiCell( $tam , 5, 'Outros ', 1,'L');
			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','',$lt); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam, 5, str_replace('"','',to_money($reg_os->Valor_Outros)), 1,'R'); 

			$ln += 5; $cel =100;  $tam = 60;
			$this->SetFont('Arial','B',12);
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6,  'TOTAL', 0,'C',1);
			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','',12);
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6,  str_replace('"','',to_money($reg_os->Valor_Total_Liquido)), 0,'C',1);

			$con_pagto = 'SELECT Descricao FROM forma_pagto WHERE Dominio = "'.$_SESSION["Dominio"].'" '.
						' AND  Codigo_Pagto   = "'.$reg_os->Forma_Pagto.'" ';             
			$res_pagto = consulta_sql($con_pagto);         
			$reg_pagto = consulta_ler_linha($res_pagto);
			consulta_limpa($res_pagto);

			$pagto = "teste ";
			if( $_SESSION['Dominio'] == '351' ){
				if ( $reg_os->Valor_Total_Liquido  <=119.99){
					$pagto = "Depsito Antecipado";
				}else if(  ($reg_os->Valor_Total_Liquido  >120) && ($reg_os->Valor_Total_Liquido  <= 199.99) ){
					$pagto = "07 Dias Diretos para Liberao";
				}else if(  ($reg_os->Valor_Total_Liquido  >200) && ($reg_os->Valor_Total_Liquido  <= 499.99) ){
					$pagto = "14 Dias Diretos para Liberao";
				}else if(  ($reg_os->Valor_Total_Liquido  >500) && ($reg_os->Valor_Total_Liquido  <= 799.99) ){
					$pagto = "21 Dias Diretos para Liberao";
				}else if(  ($reg_os->Valor_Total_Liquido  >800) && ($reg_os->Valor_Total_Liquido  <= 1799.99) ){
					$pagto = "25 Dias Diretos para Liberao";
				}else if(  ($reg_os->Valor_Total_Liquido  >1800) && ($reg_os->Valor_Total_Liquido  <= 2499.99) ){
					$pagto = "25 Dias Diretos para Liberao";
				}else if(  ($reg_os->Valor_Total_Liquido  >2500) && ($reg_os->Valor_Total_Liquido  <= 5999.99) ){
					$pagto = "28 e 56 Dias Diretos para Liberao";
				}else if(  ($reg_os->Valor_Total_Liquido  >6000) ){
					$pagto = "28, 56 e 84 Dias Diretos para Liberao";
				}else{  
					$pagto = "Forma de Pagamento No identificada! ";         
				}
			}else{
				$pagto = $reg_pagto[0];
			}
			//echo  $pagto ;
			//condicoes de pagamento 
			$ln += 5;
			////////////////////
			$ln += 6;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Condies de Pagamento ', 0,'C',1);

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6,$pagto, 0,'C');//$reg_pagto[0]

			$ln += 6;	$cel = 10 ;	$tam = 190;
			if ( $_SESSION['Dominio'] == '352') {
				//# code...
				$frase="O grupo inlog no se responsabiliza pela perda de dados contidos no Disco Rgido.  de inteira responsabilidade do cliente ter uma cpia de segurana de seus dados.";
				$frase2 = "ORAMENTO DE REPARO DE IMPRESSORAS E PLACA ME (NOTEBOOK, DESKTOP) REPROVADOS PELO CLIENTE SERA COBRADO UMA TAXA DE R$ 25,00";
				//frases 
				$this->SetFont('Arial','B',5);
				$this->SetTextColor(0,0,0);
				$this->y= ($ln + ($base_y));
				$this->x= $cel;
				$this->MultiCell( $tam, 3,UpperDados($frase), 0,'L');

				$ln += 6;
				//frases 
				$this->SetFont('Arial','B',5);
				$this->SetTextColor(0,0,0);
				$this->y= ($ln + ($base_y));
				$this->x= $cel;
				$this->MultiCell( $tam, 3,UpperDados($frase2), 0,'L');
			}

			if ( $_SESSION['Dominio'] == '351') {
				//# code...
				$frase="Para aprovar este oramento, favor responder em cima deste email autorizando o mesmo. Validade da proposta: 10dd (dias diretos).";
				//frases 
				$this->SetFont('Arial','B',5);
				$this->SetTextColor(0,0,0);
				$this->y= ($ln + ($base_y));
				$this->x= $cel;
				$this->MultiCell( $tam, 4,UpperDados($frase), 0,'L');
			}
			/////////////////////////////////////////////////            //Assinaturas 
			$ln += 12;
			for ($i3=11; $i3 <90 ; $i3++) { 
				$this->SetFont('Arial','',8);             
				$this->y= ( $ln + ($base_y));
				$this->x= $i3;
				$this->MultiCell($i3+1, 4, '_', 0,'L');
			}
			for ($i4=111; $i4 <190 ; $i4++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i4;
				$this->MultiCell($i4+1, 3, '_', 0,'L');
			}

			$ln += 6;	$cel = 11;	$tam = 80;
			$this->SetFont('Arial','',12);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel  ;

			$cliente =  $reg_cli[0];
			$qtd = $this->Lines_MultiCell( $tam, 3,  $cliente, 0, 'C');
			while($qtd > 1){
				$cliente = substr( $cliente,0,strlen( $cliente)-1);
				$qtd = $this->Lines_MultiCell($tam, 3,  $cliente, 0, 'C');
			}

			$this->MultiCell( $tam, 3, $cliente, 0,'C');

			$cel+= $tam + 20;
			$tam = 80; 

			$this->SetFont('Arial','',12);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$emitente =  $reg_emp[0];
			$qtd2 = $this->Lines_MultiCell( $tam, 3, $emitente, 0, 'C');
			while($qtd2 > 1){
				$emitente = substr( $emitente,0,strlen($emitente)-1);
				$qtd2 = $this->Lines_MultiCell($tam, 3, $emitente, 0, 'C');
			}
			$this->MultiCell( $tam, 3,  $emitente, 0,'C');

			$ln += 6;	$cel= 100 ;
			//valores
			$this->SetFont('Arial','B',7);
			$this->SetTextColor(0,0,0);
			/* linha no final da pagina a ser impressa 
			*/
			$ln_fim = 277;
			$ln = $ln_fim;

			$this->SetFont('Arial','',8);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			for ($i=9; $i <190; $i++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i;
				$this->MultiCell($i+1, 4, '_', 0,'L');
			}
			$ln +=4;    $cel=10; $tam = 60;
			$nome = UpperDados(base64_decode($_REQUEST['USER_ID']));

			$this->SetFont('Arial','',6);

			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam , 3 ,'Pg.: '.$this->PageNo().' / {nb}' ,0,'L');   

			$cel += $tam; $tam = 60;
			$date=getdate();
			$hoje = fill_full($date['year'],4).'-'.fill_full($date['mon'],2).'-'.fill_full($date['mday'],2);
			$hora = fill_full($date['hours'],2).':'.fill_full($date['minutes'],2).':'.fill_full($date['seconds'],2);

			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam ,3, dataf($hoje).' '.($hora),0,'C');  
			$cel += $tam; $tam = 62;

			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam ,3 , 'Usurio: '.$nome ,0,'R');     
			$this->y=160; //168
		}///FECHA O HEADER

		function Footer(){
			if($this->Cabecalho != ''){
				$base_y = 0;
				$this->y= (225 + ($base_y));
				$this->x= 10;
				$this->MultiCell(90, 4, 'Continua na prxima pgina...', 0,'L');
			}
			//ainda nao sei o por que o footrer nao aparece em todas as paginas 
		}
	}
	//$pdf->AddPage();

	$pdf=new PDF();
	$pdf->Open();
	$pdf->Cabecalho =  '';
	$pdf->Cabecalho_Filtro =  '';
	$pdf->Sub_Cabecalho_Texto =  '';
	$pdf->Sub_Cabecalho_Style =  'B';
	$pdf->Sub_Cabecalho_Align =  'L';
	$pdf->Sub_Cabecalho_Border =  0;

	$con_ordem = 'SELECT * FROM ordem_servico '.
				  ' WHERE Dominio = "'.$_SESSION["Dominio"].'" '.
				  ' AND Empresa = "'.$filt_empresa.'"'.
				  ' AND Nr_OrdemServico =  "'.base64_decode_si($_REQUEST['idreg']).'"';
	$res_ordem = consulta_sql($con_ordem);
	$reg_ordem = consulta_ler_objeto($res_ordem);
	consulta_limpa($res_ordem);

	//variaveis
	$pdf->NrEmpresa = $reg_ordem->Empresa;
	$pdf->NrOrdem = $reg_ordem->Nr_OrdemServico;

	$k = 0;
	$pdf->AddPage();
	$base_y =0;
	$total_desconto =0;

	$ln_itens = 150; 
	//echo "<br>".
	$con_item = 'SELECT * FROM ordem_servico_item '.
						' WHERE  Dominio = "'.$_SESSION["Dominio"].'" '.
						' AND Empresa = "'.$filt_empresa.'" '.
						' AND Nr_OrdemServico = "'.base64_decode_si($_REQUEST['idreg']).'" '.
						' AND ( Status <> "C"  and Status <> "E" ) '.
						' AND Codigo_Depart <> 0'.
						' ORDER BY Seq_Item asc ';
	$res_item = consulta_sql($con_item);
	$nrows_item = consulta_num_registros($res_item);
	/////////////////// linha onde deve comear os itens 
	$pdf->y = $ln_itens;   
	if( $nrows_item > 0){
		
		$y = $pdf->y;
		$ln += 7;	$cel = 10;	$tam = 100;
		//primeiro titulo
		$pdf->SetFont('Arial','',12); 
		//$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Peas a substituir ', 1,'C');
		$cel += $tam;	$tam = 20;

		$pdf->SetFont('Arial','',12); 
		//$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Qtd ', 1,'C');

		$cel += $tam;	$tam = 35;
		$pdf->SetFont('Arial','',12); 
		//$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Vlr Unit ', 1,'C'); 

		$cel += $tam;	$tam = 35;
		$pdf->SetFont('Arial','',12); 
		$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Vlr Total ', 1,'C');

		$pdf->Cabecalho = 'ITENS';
		$pdf->y= $y + 6;
		$pdf->lMargin= 9 ; // ORIGINAL 9
		$pdf->x=$pdf->lMargin;

		for($i=0;$i<$nrows_item;$i++){
			$reg_item = consulta_ler_objeto($res_item);
			$lns = 3; //TAMANHO DA LINHA 

			$pdf->SetTextColor(0,0,0);
			$pdf->SetFont('Arial','',8);
			$pdf->Cell(1,$lns, '', 0,0,'C');
			$pdf->SetFont('Arial','',8);
			$pdf->SetAutoPageBreak(false,30);

			//echo "<br>". 
			$cons_prod = 'SELECT Codigo_Produto, Descricao_Completa, Unidade_Venda, Codigo_Depart '.
								 ' FROM  produto '.
								 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
								 ' and Id_Produto = "'.$reg_item->Id_Produto.'" ';
			$res_prod = consulta_sql($cons_prod);
			$reg_prod = consulta_ler_linha($res_prod);
			consulta_limpa($res_prod);

			if ( $reg_item->Id_Produto  == 4 ){
				$desloc += $reg_item->Valor_Total;
			}
			$lns += 4;

			$codigo_produto = $reg_prod[0];
			$nome_produto = $reg_prod[1];
			$prod = $codigo_produto.' - '.$nome_produto;
			$nm = $pdf->Lines_MultiCell(10, $lns,$prod, 1, 'C');

			$y=$pdf->y;
			$novo = $pdf->Lines_MultiCell(100,  $lns, $prod, 1, 'L');
			while($novo > 1){
				$prod = substr( $prod ,0,strlen( $prod)-1);
				$novo = $pdf->Lines_MultiCell(100, $lns, $prod, 1, 'L');
			}
			$pdf->MultiCell( 100, $lns, $prod, 1,'L');
			$pdf->y=$y;

			$qtd=formata_qtd($reg_item->Qtd,3,false);
			$y=$pdf->y;
			$pdf->MultiCell(20, $lns, $qtd, 1,'R');
			$pdf->y=$y;
			$qtd_total+=$qtd;

			$y=$pdf->y;
			$pdf->MultiCell(35, $lns , str_replace('"','',to_money($reg_item->Valor_Unitario)), 1,'R');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(35, $lns, str_replace('"','',to_money($reg_item->Valor_Total)), 1,'R');
			$pdf->y=$y;

			$pdf->Cell(1,$lns, ' ', 0,0,'C');

			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			$pdf->y=$y+ $lns ;
			$pdf->SetAutoPageBreak(true,100);
			/*
			//adicionando aqui d certo
			$y=$pdf->y;
			$pdf->MultiCell(190, $lns,  $reg_item->Obs, 1,'R');
			$pdf->y=$y;
			*/

			/*
			 teste para observaoao dos itens 
			*/ 
			$obs = $reg_item->Obs;
			if($obs!=''){
				if(  ($_SESSION['Dominio'] == '351') ||  ($_SESSION['Dominio'] == '352' ) ){
					$lns_obs = 4;

					$pdf->SetFont('Arial','',9);
					$pdf->SetAutoPageBreak(true,80); //true, 50
					$pdf->SetFont('Arial','',6);
					$lns_linha_obs = $pdf->Lines_MultiCell( 190, $lns_obs, $obs, 1,'C');

					$pdf->Cell(1,   $lns_obs*$lns_linha_obs  , '', 0,0,'C');
					$pdf->SetAutoPageBreak(false,50);
					$pdf->SetFont('Arial','',6);

					$y=$pdf->y;
					$pdf->MultiCell( 190, $lns_obs, $obs, 1, 'L');
					$pdf->y=$y;

					$pdf->Cell(1,  $lns_obs, ' ', 0,1,'C');
					//Prxima Linha
					$pdf->x=$pdf->lMargin;
					$pdf->y=$y+($lns_obs*$lns_linha_obs);
					$pdf->SetAutoPageBreak(true,80); //true,50
				}
			}

			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			//$pdf->y=$y+ $lns_obs ;
			$pdf->SetAutoPageBreak(true,100);

			// teste para adicionar as observaes dos itens 
			/*
			// por que e para que tem esta observaoca 2 ?
			$obs2 = $reg_item->Obs;
			if($obs!=''){
				$pdf->SetFont('Arial','',6);
				$pdf->Cell(1,      $lns, ' ', 0,1,'C');
				$pdf->SetFont('Arial','',6);

				$y=$pdf->y;
				$pdf->MultiCell(11, $lns,'', 0,'L');
				$pdf->y=$y;
				$y=$pdf->y;
				$pdf->MultiCell(175, $lns,$obs2 . 'linha 1084', 1,'L');
				$pdf->y=$y;

				$pdf->Cell(1,$lns, ' ', 0,1,'C');
				//Prxima Linha
				$pdf->x=$pdf->lMargin;
				$pdf->y=$y+$lns;
				$pdf->SetAutoPageBreak(true,30);
			}
			*/
		}//for
		consulta_limpa($res_item);
		$pdf->y= $pdf->y + 3;
	}

	$con_item = 'SELECT * FROM ordem_servico_item '.
						' WHERE  Dominio = "'.$_SESSION["Dominio"].'" '.
						' AND Empresa = "'.$filt_empresa.'" '.
						' AND Nr_OrdemServico = "'.base64_decode_si($_REQUEST['idreg']).'" '.
						' AND ( Status <> "C"  and Status <> "E" ) '.
						' AND Codigo_Depart = 0'.
						' ORDER BY Seq_Item asc ';
	$res_item = consulta_sql($con_item);
	$nrows_item = consulta_num_registros($res_item);
	/////////////////// linha onde deve comear os itens 

	if( $nrows_item > 0){
		$y=$pdf->y;
		$ln += 7;	$cel = 10;	$tam = 100;
		// //primeiro titulo
		$pdf->SetFont('Arial','',12); 
		// $pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Servios a executar ', 1,'C');
		$cel += $tam;      $tam = 20;

		$pdf->SetFont('Arial','',12); 
		//$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Qtd ', 1,'C');

		$cel += $tam;	$tam = 35;
		$pdf->SetFont('Arial','',12); 
		//$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Vlr Unit ', 1,'C'); 

		$cel += $tam;	$tam = 35;
		$pdf->SetFont('Arial','',12); 
		$pdf->SetFillColor(0,0,128); 
		$pdf->SetTextColor(0,0,0);
		$pdf->y= $y;
		$pdf->x= $cel;
		$pdf->MultiCell($tam, 6, 'Vlr Total ', 1,'C');

		$pdf->Cabecalho = 'ITENS';
		$pdf->y= $y+6; // original  62 , teswte 150 
		$pdf->lMargin= 9 ; // ORIGINAL 9
		$pdf->x=$pdf->lMargin;

		for($i=0;$i<$nrows_item;$i++){
			$reg_item = consulta_ler_objeto($res_item);
			$lns = 3; //TAMANHO DA LINHA 

			$pdf->SetTextColor(0,0,0);
			$pdf->SetFont('Arial','',8);
			$pdf->Cell(1,      $lns, '', 0,0,'C');
			$pdf->SetFont('Arial','',8);
			$pdf->SetAutoPageBreak(false,80); //false,30

			//echo "<br>". 
			$cons_prod = 'SELECT Codigo_Produto, Descricao_Completa, Unidade_Venda, Codigo_Depart '.
								 ' FROM  produto '.
								 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
								 ' and Id_Produto = "'.$reg_item->Id_Produto.'" ';
			$res_prod = consulta_sql($cons_prod);
			$reg_prod = consulta_ler_linha($res_prod);
			consulta_limpa($res_prod);

			if ( $reg_item->Id_Produto  == 4 ){
				//echo "linha 1054 " . $desloc ; 
				$desloc += $reg_item->Valor_Total;
				//echo "linha 1055 " . $desloc ; 
			}
			/*
			$y=$pdf->y;
			$pdf->MultiCell(10, ($lns*$nm), $item , 0,'C');
			$pdf->y=$y; 
			*/
			$lns += 4;

			$codigo_produto = $reg_prod[0];
			$nome_produto = $reg_prod[1];
			// $obs = $reg_item->Obs;
			$prod = $codigo_produto.' - '.$nome_produto;
			$nm = $pdf->Lines_MultiCell(10, $lns,$prod, 1, 'C');

			$y=$pdf->y;
			$novo = $pdf->Lines_MultiCell(100,  $lns, $prod, 1, 'L');
			while($novo > 1){
				$prod = substr( $prod ,0,strlen( $prod)-1);
				$novo = $pdf->Lines_MultiCell(100, $lns, $prod, 1, 'L');
			}
			$pdf->MultiCell( 100, $lns, $prod, 1,'L');
			$pdf->y=$y;

			$qtd=formata_qtd($reg_item->Qtd,3,false);
			$y=$pdf->y;
			$pdf->MultiCell(20, $lns, $qtd, 1,'R');
			$pdf->y=$y;
			$qtd_total+=$qtd;

			$y=$pdf->y;
			$pdf->MultiCell(35, $lns , str_replace('"','',to_money($reg_item->Valor_Unitario)), 1,'R');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(35, $lns, str_replace('"','',to_money($reg_item->Valor_Total)), 1,'R');
			$pdf->y=$y;

			$pdf->Cell(1,$lns, ' ', 0,0,'C');

			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			$pdf->y=$y+ $lns ;
			$pdf->SetAutoPageBreak(true,80);
			/*
			//adicionando aqui d certo
			$y=$pdf->y;
			$pdf->MultiCell(190, $lns,  $reg_item->Obs, 1,'R');
			$pdf->y=$y;
			 teste para observaoao dos itens 
			*/
			$obs = $reg_item->Obs;     
			if($obs!=''){
				if(  ($_SESSION['Dominio'] == '351') ||  ($_SESSION['Dominio'] == '352' ) ){
					$lns_obs = 4;

					$pdf->SetFont('Arial','',9);
					$pdf->SetAutoPageBreak(true,100); //true, 50
					$pdf->SetFont('Arial','',6);
					$lns_linha_obs = $pdf->Lines_MultiCell( 190, $lns_obs, $obs, 1,'C');

					$pdf->Cell(1,   $lns_obs*$lns_linha_obs  , '', 0,0,'C');
					$pdf->SetAutoPageBreak(false,50);
					$pdf->SetFont('Arial','',6);

					$y=$pdf->y;
					$pdf->MultiCell( 190, $lns_obs, $obs, 1, 'L');
					$pdf->y=$y;

					$pdf->Cell(1,  $lns_obs, ' ', 0,1,'C');
					//Prxima Linha
					$pdf->x=$pdf->lMargin;
					$pdf->y=$y+($lns_obs*$lns_linha_obs);
					$pdf->SetAutoPageBreak(true,100); //true, 50
				}
			}
			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			//$pdf->y=$y+ $lns_obs ;
			$pdf->SetAutoPageBreak(true,100); // true, 80
		}//for
		consulta_limpa($res_item);
	}

	$pdf->SetAutoPageBreak(false,30);
	$pdf->Cabecalho =  '';

	//salva pdf do pedido para mandar por email
	$diretorio = '';

	$arquivo = MD5($_REQUEST['USER_ID']).'.tmp';
	$diretorio = '../../../arquivos_clientes/'.$_SESSION['Dominio'].'/upload/email';

	if(file_exists($diretorio.'/'.$arquivo)){
		 unlink($diretorio.'/'.$arquivo);
	}
	rmkdir($diretorio.'/');
	$pdf->Output($diretorio.'/'.$arquivo,'F');

	echo $pdf->Output('Relatorio_'.config_pad('sistema_sigla').'.pdf','I');
}
?>