<?php
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	define('FPDF_FONTPATH', '../../fpdf/font/');
	require('../../fpdf/fpdf.php');
if(session::usr_conectado($_REQUEST['USER_ID'])){
	if(isset($_REQUEST['empresa'])){
		$filt_empresa = base64_decode_si($_REQUEST['empresa']);
	}else{
		$filt_empresa = $_SESSION['Empresa_Codigo'];
	}
	$fpdf = new FPDF();
	class PDF extends FPDF{
		var $NrEmpresa ;
		var $NrOS;
		var $TipoOS;      

		function Header(){
			$this->AliasNbPages();
			$base_y = 0;
			$this->SetAutoPageBreak(false,30);
			//$this->Image('../../imgs/os_layout30-A.jpg', 5, (5+$base_y), 200, 280);

			$this->Image(busca_imagem_empresa('logo_menu.jpg', '../../'),12, (14+$base_y), 30,15);

			//Nome da empresa 
			$con_emp = 'SELECT Nome_Fantasia, Web_Site, Nome_Listas, CPF_CNPJ, EMail FROM pessoa '.
					 ' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= " '.$_SESSION['Empresa_Codigo'].' " ';
			$res_emp = consulta_sql($con_emp);
			$reg_emp = consulta_ler_linha($res_emp);
			consulta_limpa($res_emp);
			$lnh1 =  $reg_emp[0];

			$col = 50;	$q = 0;
			$linha = 10;	$c=5;
			$tam = 105 ;
			$col2 = $col + $tam; 
			$comp = "C";  //$q = 'TRLB';

			$this->SetFont('Arial','B',10); 
			#$this->SetTextColor(0,0,128);
			$this->y= ( $linha + ($base_y));
			$this->x=  $col;
			$this->MultiCell($tam, $c, $lnh1 , $q, $comp);

			//Endereco empresa
			$con_end_emp = 'SELECT Logradouro, Numero, Complemento, Bairro, Nome_Cidade, UF,Insc_Estadual '.
						' FROM pessoa_endereco '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						' AND Situacao <> "E" '.
						' ORDER BY Seq_Endereco LIMIT 1 ';
			$res_end_emp = consulta_sql($con_end_emp);
			$reg_end_emp = consulta_ler_linha($res_end_emp);
			consulta_limpa($res_end_emp);

			$lnh2 = $reg_end_emp[0].', ';
			if($reg_end_emp[1]!=''){
				$lnh2.='N '.$reg_end_emp[1];
			}else{
				$lnh2.='S/N,';
			}
			//$lnh2.=' '.$reg_end_emp[2].', '.$reg_end_emp[3].', '.UpperDados($reg_end_emp[4]).'/'.UpperDados($reg_end_emp[5]); 
			$lnh2.=' '.$reg_end_emp[2].', '.$reg_end_emp[3];
			$lnh2b = UpperDados($reg_end_emp[4]).'/'.UpperDados($reg_end_emp[5]); 

			$linha +=5;
			$this->SetFont('Arial','',8); 
			$this->y= ( $linha + ($base_y));
			$this->x= $col;
			$this->MultiCell($tam, $c, $lnh2,  $q,$comp);

			$linha +=5;
			$this->SetFont('Arial','',8); 
			$this->y= ( $linha + ($base_y));
			$this->x= $col;
			$this->MultiCell($tam, $c, $lnh2b, $q,$comp);

			$lnh3.='CNPJ '.$reg_emp[3].' - IE '.$reg_end_emp[6] ;

			$con_tel_emp = 'SELECT  Numero_Telefone FROM  pessoa_telefone '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						' AND  Situacao = "A" '.
						' ORDER BY Seq_Telefone ';
			$res_tel_emp = consulta_sql($con_tel_emp);
			$reg_tel_emp = consulta_ler_linha($res_tel_emp);
			consulta_limpa($res_tel_emp);

			if($reg_tel_emp[0] !=''){
				$tel_emp = 'Telefone: '.$reg_tel_emp[0];
			}
			$linha +=5;  
			$this->y= ($linha + ($base_y));
			$this->x= $col;
			$this->MultiCell($tam , $c, $tel_emp, $q, $comp);

			$end_v1= $reg_emp[4];
			$end_v2= $reg_emp[1];
			$end_v3= $end_v1." - ".$end_v2;
			$linha +=5; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell($tam, $c, 'E-mail: '.$end_v1,  $q , $comp);

			$con_os= 'SELECT * FROM ordem_servico '.
					' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
					' AND Empresa = "'.$_SESSION['Empresa_Codigo'].'" '.
					' AND Nr_OrdemServico = "'.base64_decode_si($_REQUEST['idreg']).'" ';
			$res_os = consulta_sql($con_os);
			$reg_os = consulta_ler_objeto($res_os);
			consulta_limpa($res_os);

			$this->SetFont('Arial','B',14); 
			$this->y= ( 10 + ($base_y));
			$this->x=$col2;
			$this->MultiCell( 45, 13, 'N OS ',  $q , $comp);//10, 15

			$nr_os = $reg_os->Nr_OrdemServico ;
			$this->SetFont('Arial','B',14); 
			$this->y= ( 23 + ($base_y));
			$this->x=$col2;
			$this->MultiCell( 45, 12,  $nr_os ,  $q , $comp);//10, 15

			$linha +=6;

			$ln = $linha + 1;	$cel = 10;	$tam = 190; 
			$b= 0 ; // b de borda 

			$this->SetFont('Arial','B',12); 
			$this->SetFillColor(169,169,169); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'DADOS DO CLIENTE',  0,'C',1);

			$con_cli = 'SELECT Pessoa, Nome_Razao, CPF_CNPJ, RG, EMail FROM pessoa '.
					   ' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= " '.$reg_os->Pessoa.' " ';
			$res_cli = consulta_sql($con_cli);
			$reg_cli = consulta_ler_linha($res_cli);
			consulta_limpa($res_cli);

			$ln += 7;	$cel = 10;	$tam = 30;	$b= 0 ; 
			//Nova linha - apresentacao do cliente - chamada
			$this->SetFont('Arial','',10);  
			$this->SetTextColor(0,0,0);          
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Cliente ', $b ,'L');

			$cel += $tam;	$tam = 160; 
			//Nova linha - apresentacao do cliente  - nome 
			$this->SetFont('Arial','',10);  
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;

			$cliente = $reg_cli[0].' - '.$reg_cli[1]. ' CPF/CNPJ: '. $reg_cli[2] ; 
			$nv_cli = $this->Lines_MultiCell($tam,5, $cliente, $b, 'L');
			while( $nv_cli > 1){
					$cliente  = substr(  $nome_cli,0,strlen( $cliente )-1);
					$nv_cli = $this->Lines_MultiCell($tam, 5, $cliente , $b , 'L');
			}
			$this->MultiCell($tam, 5,  $cliente , $b ,'L');

			$con_end_cli = 'SELECT Logradouro, Numero, Complemento, Bairro, Nome_Cidade, UF, CEP, Insc_Estadual'.    
						' FROM pessoa_endereco '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						' AND Pessoa = "'.$reg_os->Pessoa.'"'.
						' AND Situacao <> "E"'.
						' ORDER BY Seq_Endereco LIMIT 1';
			$res_end_cli = consulta_sql($con_end_cli);
			$reg_end_cli = consulta_ler_linha($res_end_cli);
			consulta_limpa($res_end_cli);

			//R. Jacob Germano Baumer, 121 - Vila Nova, Joinville - SC, 89237-660

			$end_cli = $reg_end_cli[0].', '.$reg_end_cli[1].' '.$reg_end_cli[2].' - '.$reg_end_cli[3].', '.$reg_end_cli[4].'/'.$reg_end_cli[5]. ', '.$reg_end_cli[6];

			$ln += 5;	$cel = 10;	$tam = 30; 
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Endereco', $b  ,'L');

			$cel += $tam;	$tam = 160;
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$nv_cli = $this->Lines_MultiCell($tam,5,  $end_cli, $b, 'L');
			while( $nv_cli > 1){
					$end_cli = substr( $end_cli,0,strlen(  $end_cli )-1);
				   $nv_cli = $this->Lines_MultiCell($tam, 5,  $end_cli ,  $b , 'L');
			}
			$this->MultiCell($tam, 5, $end_cli,   $b ,'L');  

			$ln += 5;	$cel = 10;	$tam = 30;
			$this->SetFont('Arial','',10);

			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 5, 'Telefone  ',  $b ,'L');

			$con_cli_tel = 'SELECT  Numero_Telefone FROM pessoa_telefone '.
						  ' where Dominio = "'.$_SESSION["Dominio"].'" '.
						  ' and Pessoa = "'.$reg_os->Pessoa.'"'.
						  ' and Situacao <> "E"'.
						  ' order by Seq_Telefone '; 
						//  ' limit 3';
			$res_cli_tel = consulta_sql($con_cli_tel);         
			$nrows_tel = consulta_num_registros($res_cli_tel);
			$tel='';
			if($nrows_tel>0){
				for($i=0;$i<$nrows_tel;$i++){
					$reg_cli_tel = consulta_ler_linha($res_cli_tel);
					if ($tel != '') {
						$tel.=', ';
					}
					$tel.= $reg_cli_tel[0];
				}
			}
			consulta_limpa($res_cli_tel);

			$cel += $tam;	$tam = 160;	$lt = 10;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, $tel,  $b,'L');

			///////////////////////////  EMAIL
			$cel = 10;	$ln += 5;	$tam = 30;
			$this->SetFont('Arial','',$lt);
			//$this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 5, 'E-mail ',  $b ,'L');

			$cel += $tam;	$tam = 160;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;

			$email_cliente = $reg_cli[3] ;
			$nm = $this->Lines_MultiCell($tam,5,  $email_cliente,  $b , 'L');
			while($nm > 1){
				$email_cliente = substr( $email_cliente,0,strlen( $email_cliente )-1);
				$nm = $this->Lines_MultiCell($tam, 5,  $email_cliente ,   $b , 'L');
			}
			$this->MultiCell($tam, 5, $email_cliente,  $b ,'L');

			$ln += 6;	$cel = 10;	$tam = 190;

			$this->SetFont('Arial','B',12); 
			$this->SetFillColor(169,169,169); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'DETALHES ',  0,'C',1);

			$ln += 7;	$cel = 10;	$tam = 55;
			$this->SetFont('Arial','B',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'Aparelho: '. $reg_os->Aparelho, $b ,'L');

			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','B',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'Modelo: '.$reg_os->Modelo,  $b,'L');

			$cel += $tam;	$tam = 40;
			$this->SetFont('Arial','B',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Marca: '.$reg_os->Marca,   $b ,'L');

			$cel += $tam;	$tam = 55;
			$this->SetFont('Arial','B',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'IMEI: '.$reg_os->NrSerie,  $b ,'L');

			$ln += 5;	$cel = 10;	$tam = 20;
			$this->SetFont('Arial','',$lt); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Entrada ',  $b ,'L');
			$cel += $tam;	$tam = 20;
			$this->SetFont('Arial','',10); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, dataf($reg_os->DH_Emissao), 0,'L');
			$cel += $tam;	$tam = 25;
			$this->SetFont('Arial','B',10); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Acessrios:',  $b ,'L');
			$cel += $tam;	$tam = 130;

			$this->SetFont('Arial','',10); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$conteudo = $reg_os->Solucao;
			$num_cont = $this->Lines_MultiCell($tam,5, $conteudo , $b , 'L');
			while( $num_laudo > 1){
				$conteudo  = substr($laudo,0,strlen( $conteudo   )-1);
				$num_cont = $this->Lines_MultiCell($tam, 4, $conteudo  , $b , 'L');
			}
			$this->MultiCell( $tam , 5, $conteudo  , $b ,'L');

			$ln += 5;	$cel = 10;	$tam = 45;  
			$this->SetFont('Arial','',$lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam , 5, 'Defeito/Reclamao', $b,'L');
			$cel += $tam;	$tam = 145;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$def  =  $reg_os->ParecerCliente ;
			$num2 = $this->Lines_MultiCell($tam,5, $def,  $b  , 'L');
			while(  $num2 > 2){
				$def = substr($def,0,strlen($def)-1);
				$num2  = $this->Lines_MultiCell($tam, 5,$def, $b  , 'L');
			}
			$this->MultiCell($tam, 5, $def , $b  ,'L');

			$ln +=15;	$cel = 10;	$tam = 45;
			$this->SetFont('Arial','',$lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Pr Aprovado ',$b  ,'  L'); 

			$cel += $tam;	$tam = 145;
			$this->SetFont('Arial','', $lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;
			$atend  = $reg_os->ObsAtendimento;
			$num_laudo = $this->Lines_MultiCell($tam,5, $atend, $b  , 'L');
			while( $num_laudo > 3){
				$atend = substr($laudo,0,strlen($atend)-1);
				$num_laudo = $this->Lines_MultiCell($tam, 4, $atend , $b  , 'L');
			}
			$this->MultiCell( $tam , 5, $atend  , $b  ,'L');

			$ln +=15 ;   $cel = 10;  $tam = 45;
			$this->SetFont('Arial','',$lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Descrio do Servio ',$b  ,'  L'); 

			$cel += $tam;	$tam = 145;
			$this->SetFont('Arial','', $lt);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;
			$laudo = $reg_os->Laudo;
			$num_laudo = $this->Lines_MultiCell($tam,5, $laudo, $b  , 'L');
			while( $num_laudo > 3){
				$laudo = substr($laudo,0,strlen($laudo)-1);
				$num_laudo = $this->Lines_MultiCell($tam, 4, $laudo, $b  , 'L');
			}
			$this->MultiCell( $tam , 5, $laudo  , $b  ,'L');

			$ln += 18;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','B',12); 
			$this->SetFillColor(169,169,169); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'TOTAIS', 1,'C',1);

			$ln += 7;	$cel = 10;	$tam = 38;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'Servios: '.str_replace('"','',to_money($reg_os->Valor_Total_Serv  )), $b ,'L');

			$cel += $tam;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'Peas: '.str_replace('"','',to_money($reg_os->Valor_Total_Prod)),  $b ,'L');

			$cel += $tam;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Descontos: '.str_replace('"','',to_money($reg_os->Valor_Desconto)),  $b ,'L');

			$cel += $tam;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Acrscimos: '.str_replace('"','',to_money($reg_os->Valor_Acrescimo)), $b ,'L'); 

			$cel += $tam;
			$this->SetFont('Arial','',$lt);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 5, 'Total: '.str_replace('"','',to_money($reg_os->Valor_Total_Liquido)), $b ,'L');

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','B',12); 
			$this->SetFillColor(169,169,169); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'TERMO DE GARANTIA', 1,'C',1);

			$frase_1= " *No nos responsabilizamos por quaisquer defeitos apresentados pelo equipamento no relatados previamente pelo cliente.";
			$frase_2=" *Prazo de retirada do equipamento: 90dias. Aps este perodo MULTA diria R$ 5,00 (CINCO REAIS).";
			$frase_garantia = "Fica assegurado ao cliente garantia de 90 dias sobre o objeto acima descrito, contada a partir da data de entrega do equipamento.";
			$garantia_1=" 1 - Essa garantia cobre somente os defeitos de funcionamento das peas e componentes dos equipamentos descritos nas condies normais de uso - de acordo com as instrues dos manuais de operao, fornecidos pelos fabricantes.";
			$garantia_2=" 2 - Essa garantia ficar automaticamente cancelada se os equipamentos vierem a sofrer reparos por pessoas no autorizadas, receber maus tratos ou sofrer danos decorrentes de acidentes, quedas, variaes de tenso eltrica e sobrecarga acima do especificado, ou qualquer ocorrncia imprevisvel, decorrentes de m utilizao dos equipamentos por parte do usurio.";
			$garantia_3=" 3 - Essa garantia ficar automaticamente cancelada para os servios de Software e limpeza isoproplica. ";
			$garantia_4=" 4 - Aparelhos resistentes (ou a prova d'gua) perdero estas propriedades aps a triagem/manuteno.";

			$con_motivo  = 'SELECT Descricao  FROM  ordem_servico_motivo '.
							' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
							' AND id = "'.$reg_os->Motivo.'"  ';
			$res_motivo  = consulta_sql($con_motivo );
			$reg_motivo  = consulta_ler_linha($res_motivo );
			consulta_limpa($res_motivo );

			$declaro="Declaro estar recebendo materiais contantes nesta Ordem de Servio com Status: ". $reg_motivo[0];

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $frase_1, $b,'L');

			$ln += 10;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $frase_2, $b,'L');

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'GARANTIA', 0,'C');

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $frase_garantia, $b,'L');

			$ln += 10;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $garantia_1,$b,'L');

			$ln += 10;  $cel = 10;              $tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $garantia_2, $b,'L');

			$ln += 20;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $garantia_3, $b,'L');

			$ln += 5;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $garantia_4, $b ,'L');

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','B',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, 'Garantia at: '.dataf($reg_os->DtAprovacao), $b ,'L');

			$ln += 7;	$cel = 10;	$tam = 190;
			$this->SetFont('Arial','',$lt);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 5, $declaro, $b ,'L');

			$ln= 245;	$cel = 10;	$tam = 190;

			/*$ln_fim = 250;
			$ln = $ln_fim; */

			$cel = 10 ;	$tam = 190;	$ln += 12;
			for ($i3=11; $i3 <90 ; $i3++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i3;
				$this->MultiCell($i3+1, 4, '_', 0,'L');
			}
			for ($i4=111; $i4 <190 ; $i4++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i4;
				$this->MultiCell($i4+1, 3, '_', 0,'L');
			}

			$ln += 6;	$cel = 11;	$tam = 80;
			$this->SetFont('Arial','',12);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel  ;

			$cliente =  $reg_cli[1];
			$qtd = $this->Lines_MultiCell( $tam, 3,  $cliente, 0, 'C');
			while($qtd > 1){
				$cliente = substr( $cliente,0,strlen( $cliente)-1);
				$qtd = $this->Lines_MultiCell($tam, 3,  $cliente, 0, 'C');
			}

			$this->MultiCell( $tam, 3, $cliente, 0,'C');

			$cel+= $tam + 20;
			$tam = 80; 

			$this->SetFont('Arial','',12);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$emitente =  $reg_emp[0];
			$qtd2 = $this->Lines_MultiCell( $tam, 3, $emitente, 0, 'C');
			while($qtd2 > 1){
				$emitente = substr( $emitente,0,strlen($emitente)-1);
				$qtd2 = $this->Lines_MultiCell($tam, 3, $emitente, 0, 'C');
			}
			$this->MultiCell( $tam, 3,  $emitente, 0,'C');

			$ln += 6;	$cel= 100 ;
			//valores
			$this->SetFont('Arial','B',7);
			$this->SetTextColor(0,0,0);
			/* linha no final da pagina a ser impressa 
			*/
			$ln_fim = 277;
			$ln = $ln_fim;

			$this->SetFont('Arial','',8);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			for ($i=9; $i <190; $i++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i;
				$this->MultiCell($i+1, 4, '_', 0,'L');
			}
			$ln +=4;	$cel=10;	$tam = 60;
			$nome = UpperDados(base64_decode($_REQUEST['USER_ID']));

			$this->SetFont('Arial','',6);

			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam , 3 ,'Pg.: '.$this->PageNo().' / {nb}' ,0,'L');   

			$cel += $tam; $tam = 60;
			$date=getdate();
			$hoje = fill_full($date['year'],4).'-'.fill_full($date['mon'],2).'-'.fill_full($date['mday'],2);
			$hora = fill_full($date['hours'],2).':'.fill_full($date['minutes'],2).':'.fill_full($date['seconds'],2);

			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam ,3, dataf($hoje).' '.($hora),0,'C');  
			 $cel += $tam; $tam = 62;

			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam ,3 , 'Usurio: '.$nome ,0,'R');     

			$this->y=145; //168
		}/// FECHA O HEADER

		function Footer(){
			if($this->Cabecalho != ''){
				$base_y = 0;
				$this->y= (225 + ($base_y));
				$this->x= 10;
				$this->MultiCell(90, 4, 'Continua na prxima pgina...', 0,'L');
			}
			//ainda nao sei o por que o footrer nao aparece em todas as paginas 
		}
	}
	//$pdf->AddPage();

	$pdf=new PDF();
	$pdf->Open();
	$pdf->Cabecalho =  '';
	$pdf->Cabecalho_Filtro =  '';
	$pdf->Sub_Cabecalho_Texto =  '';
	$pdf->Sub_Cabecalho_Style =  'B';
	$pdf->Sub_Cabecalho_Align =  'L';
	$pdf->Sub_Cabecalho_Border =  0;

	$con_ordem = 'SELECT * FROM ordem_servico '.
				  ' WHERE Dominio = "'.$_SESSION["Dominio"].'" '.
				  ' AND Empresa = "'.$filt_empresa.'"'.
				  ' AND Nr_OrdemServico =  "'.base64_decode_si($_REQUEST['idreg']).'"';
	$res_ordem = consulta_sql($con_ordem);
	$reg_ordem = consulta_ler_objeto($res_ordem);
	consulta_limpa($res_ordem);

	//variaveis
	$pdf->NrEmpresa = $reg_ordem->Empresa;
	$pdf->NrOrdem = $reg_ordem->Nr_OrdemServico;

	$k = 0;
	$pdf->AddPage();
	$base_y =0;
	$total_desconto =0;

	$ln_itens = 153 -6; 
	//echo "<br>".

	$pdf->Cell(1,      $lns, ' ', 0,0,'C');

	//Pr�xima Linha
	$pdf->x=$pdf->lMargin;
	$pdf->y=$y+ $lns ;
	$pdf->SetAutoPageBreak(true,100);

	$pdf->SetAutoPageBreak(false,30);
	$pdf->Cabecalho =  '';

	//salva pdf do pedido para mandar por email
	$diretorio = '';

	$arquivo = MD5($_REQUEST['USER_ID']).'.tmp';
	$diretorio = '../../../arquivos_clientes/'.$_SESSION['Dominio'].'/upload/email';

	if(file_exists($diretorio.'/'.$arquivo)){
		 unlink($diretorio.'/'.$arquivo);
	}
	rmkdir($diretorio.'/');
	$pdf->Output($diretorio.'/'.$arquivo,'F');

	echo $pdf->Output('Relatorio_'.config_pad('sistema_sigla').'.pdf','I');
}
?>
