<?
	$pdf=new PDF('L','mm',array(29,100)); //altura/largura
	$pdf->Open();

	$pdf->CabecalhoGrid_Texto= '';
	$pdf->SetAutoPageBreak(false,30);

	$color = array(0,0,0);
	$bar = new Barcode();

	foreach($lista_produtos as $chave_pro => $dados_produto){
		$pdf->AddPage();
		$pdf->SetAutoPageBreak(false,30);

		$pdf->y=0;
		$pdf->x=0;
		$pdf->lMargin=0;
		$pdf->tMargin=0;
		$bo =0;
		$tm= 20;
		$margem_base = 4;
		$margem_coluna = 51;
		$colunas = 2;

		$barra = $dados_produto['Codigo_Produto'];
		if ($tp_cod!='C'){
			if ($dados_produto['Codigo_Barras']!=''){
				$barra = $dados_produto['Codigo_Barras'];
			}
		}

		//coluna 1
		$pdf->SetFont('Arial','B',6);
		$texto = $dados_produto['Descricao_Completa'];
		$nm = $pdf->Lines_MultiCell($tm, 2, $texto, $bo, 'L');
		while ($nm>1){
			$texto = substr($texto,0,strlen($texto)-1);
			$nm = $pdf->Lines_MultiCell($tm, 2, $texto, $bo, 'L');
		}

		$margem_atual = $margem_base;
		for($c=0;$c<$colunas;$c++){
			$pdf->y=4;
			$pdf->x=$margem_atual;
			$pdf->SetFont('Arial','B',6);
			$y=$pdf->y;
			$pdf->MultiCell(190, 3, substr($barra,0,13), $bo,'L');
			$pdf->y=$y+2.5;

			$pdf->x=$margem_atual;
			$y=$pdf->y;
			$pdf->MultiCell($tm, 2.1, $texto, $bo,'L');
			$pdf->y=$y+2.5;

			$pdf->x=$margem_atual;
			$y=$pdf->y;
			$pdf->MultiCell(190, 3, $etq_moeda.formata_qtd($dados_produto['Preco'],2,true).' '.$dados_produto['Unid_Venda'], $bo,'L');
			$pdf->y=$y+2.5;

			$x=$margem_atual+3;
			$y=$pdf->y+2;
			$angle =0;
			$type = 'code93';
			$width = 0.23;
			$height = 10;

			if (strlen($barra)==13){
				$pdf->EAN13($x, $y, $barra, $height, $width,'I',7);
			}else{
				$x=$margem_atual+1.2;
				$height = 8;
				$pdf->Code39($x, $y, fill_full($barra,6), $width, $height,false);
				$pdf->y = $pdf->y+11;
				$pdf->x=$margem_atual;
				$y=$pdf->y;
				$pdf->MultiCell($tm, 3, fill_full($barra,6), $bo,'L');
				$pdf->y=$y+4;
			}
			$margem_atual+=$margem_coluna;
		}
		//sl.Add('A50,20,0,1,1,2,N,"' + copy(MTEitquetaProdCodigo_Produto.AsString,1,13) + '"');
		//sl.Add('A50,45,0,1,1,2,N,"' + copy(MTEitquetaProdDescricao_Completa.AsString,1,30) +'"');
		//sl.Add('A50,70,0,1,1,2,N,"' + etq_moeda+ FormatFloat('#,###,##0.00', MTEitquetaProdPreco.AsFloat) + ' '+MTEitquetaProdUnid_Venda.AsString+'"');
		//If etq_tp_cod <> 'C' Then
		//sl.Add('B50,110,0,E30,2,3,80,B,"' + copy(MTEitquetaProdCodigo_Barras.AsString,1,13) + '"')
		//else
		//sl.Add('B50,110,0,3,2,5,80,B,"' + RetZero(MTEitquetaProdCodigo_Produto.AsString,6) + '"');
	}

?>