<?
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	session::usr_conectado($_REQUEST['USER_ID']);
	require_once('../../includes/write_excel/Worksheet.php');
	require_once('../../includes/write_excel/Workbook.php');
	require_once('../../includes/funcoes/boletim_pesagem.php');

	function HeaderingExcel($filename) {
		header("Content-type: application/vnd.ms-excel");
		header("Content-Disposition: attachment; filename=$filename" );
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
		header("Pragma: public");
	}

	function letra_coluna($coluna){
		// echo 'Coluna Agora: '.$coluna;
		$letras[1]='A';  $letras[2]='B';	    $letras[3]='C';
		$letras[4]='D';	$letras[5]='E';	    $letras[6]='F';
		$letras[7]='G';	$letras[8]='H';	    $letras[9]='I';
		$letras[10]='J';	$letras[11]='K';    $letras[12]='L';
		$letras[13]='M'; $letras[14]='N';    $letras[15]='O';
		$letras[16]='P';	$letras[17]='Q';	$letras[18]='R';
		$letras[19]='S';	$letras[20]='T';	$letras[21]='U';
		$letras[22]='V';	$letras[23]='W';	$letras[24]='X';
		$letras[25]='Y';	$letras[26]='Z';

		$primeira_letra = 0;
		while ($coluna>26){
			$primeira_letra++;
			$coluna-=26;
		}
		$letra = $letras[$coluna];
		if ($primeira_letra >0){
			$letra = $letras[$primeira_letra].$letra;
		}
		return $letra;
    }

	$hora = nr2hora(hora_atual());
	$hoje = data_atual('data');


	$date_atual = data_atual('date');
	$ndia_atual = data_atual('num');
	$dia_limite_inf  = data2nr('01/01/'.substr($date_atual,0,4));
	$perc_quebra_mes = 0.5;

	//HTTP headers
	HeaderingExcel('BOLETINS_EXCEL.xls');

	//Creating a workbook
	//Creating a workbook
	$workbook = new Workbook("-");

	// Format for the headings
	$fmt_cabec =& $workbook->add_format();
	$fmt_cabec->set_size(18);

	$fmt_cabec2 =& $workbook->add_format();
	$fmt_cabec2->set_align('left');
	$fmt_cabec2->set_size(12);
	$fmt_cabec2->set_border(2);

	$fmt_titulo =& $workbook->add_format();
	$fmt_titulo->set_align('center');
	$fmt_titulo->set_pattern();
	$fmt_titulo->set_fg_color(40);
	$fmt_titulo->set_bold(1);
	$fmt_titulo->set_border(1);
	$fmt_titulo->set_size(8);

	$fmt_titulo_l =& $workbook->add_format();
	$fmt_titulo_l->set_align('left');
	$fmt_titulo_l->set_pattern();
	$fmt_titulo_l->set_fg_color(40);
	$fmt_titulo_l->set_bold(1);
	$fmt_titulo_l->set_border(1);
	$fmt_titulo_l->set_size(8);

	$fmt_titulo_r =& $workbook->add_format();
	$fmt_titulo_r->set_align('right');
	$fmt_titulo_r->set_pattern();
	$fmt_titulo_r->set_fg_color(40);
	$fmt_titulo_r->set_bold(1);
	$fmt_titulo_r->set_border(1);
	$fmt_titulo_r->set_size(8);

	$fmt_tit_grupo =& $workbook->add_format();
	$fmt_tit_grupo->set_size(14);

	$fmt_texto_l =& $workbook->add_format();
	$fmt_texto_l->set_border(1);
	$fmt_texto_l->set_align('left');
	//$fmt_texto_l->set_size(8);

	$fmt_texto_c =& $workbook->add_format();
	$fmt_texto_c->set_border(1);
	$fmt_texto_c->set_align('center');
	//$fmt_texto_c->set_size(8);

	$fmt_texto_r =& $workbook->add_format();
	$fmt_texto_r->set_border(1);
	$fmt_texto_r->set_align('right');

	$fmt_qtd =& $workbook->add_format();
	$fmt_qtd->set_border(1);
	$fmt_qtd->set_align('right');
	//    $fmt_qtd->set_num_format('[Blue]#,##0_);[Red]-#,##0_)');
	$fmt_qtd->set_num_format('#,##0_);-#,##0_)');

	$fmt_valor =& $workbook->add_format();
	$fmt_valor->set_border(1);
	$fmt_valor->set_align('right');
	$fmt_valor->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');


	$fmt_data_c =& $workbook->add_format();
	$fmt_data_c->set_border(1);
	$fmt_data_c->set_align('center');
	$fmt_data_c->set_num_format('dd/mm/yy');

	$fmt_nr_r =& $workbook->add_format();
	$fmt_nr_r->set_border(1);
	$fmt_nr_r->set_align('right');
	//$fmt_nr_r->set_num_format('#,##0.00_);-#,##0.00_)');

	$fmt_perc =& $workbook->add_format();
	$fmt_perc->set_border(1);
	$fmt_perc->set_align('right');
	$fmt_perc->set_num_format('0.00%;-0.00%');
	//$fmt_nr->set_size(8);

	//negritos
	$fmt_texto_l_b =& $workbook->add_format();
	$fmt_texto_l_b->set_border(1);
	$fmt_texto_l_b->set_align('left');
	$fmt_texto_l_b->set_bold(1);

	// Format for the headings
	$fmt_texto_c_b =& $workbook->add_format();
	$fmt_texto_c_b->set_border(1);
	$fmt_texto_c_b->set_align('center');
	$fmt_texto_c_b->set_bold(1);

	$fmt_texto_c_b2 =& $workbook->add_format();
	$fmt_texto_c_b2->set_border(1);
	$fmt_texto_c_b2->set_align('center');
	$fmt_texto_c_b2->set_valign('vcenter');
	$fmt_texto_c_b2->set_bold(1);
	$fmt_texto_c_b2->set_text_wrap();


	$fmt_texto_r_b =& $workbook->add_format();
	$fmt_texto_r_b->set_border(1);
	$fmt_texto_r_b->set_align('right');
	$fmt_texto_r_b->set_bold(1);

	$fmt_qtd_b =& $workbook->add_format();
	$fmt_qtd_b->set_border(1);
	$fmt_qtd_b->set_bold(1);
	$fmt_qtd_b->set_align('right');
	$fmt_qtd_b->set_num_format('#,##0_);-#,##0_)');

	$fmt_perc_b =& $workbook->add_format();
	$fmt_perc_b->set_border(1);
	$fmt_perc_b->set_bold(1);
	$fmt_perc_b->set_align('right');
	$fmt_perc_b->set_num_format('0,00%;-0,00%');

	$classif_saida = $_REQUEST['classif_saida'];
	$considerar_dev = $_REQUEST['considerar_dev'];
	$transbordo = $_REQUEST['transbordo'];
	
	

	$consulta = 'select bo.*, ((SUBSTRING(pes.Cadastros,7,1) = "N")*1) TipoRel from boletim_pesagem bo '.
				' inner join pessoa pes on '.
				' bo.Dominio = pes.Dominio '.
				' and bo.Pessoa = pes.Pessoa '.
				' Where bo.Dominio = "'.$_SESSION['Dominio'].'"'.
				' and bo.DH_PesoFim >="'.datad($_REQUEST['dt_ini']).'"'.
				' and bo.DH_PesoFim <="'.datad($_REQUEST['dt_fim']).' 23:59:59"'.
				' and bo.Id_Produto > 0 '.
				' and bo.PesoPago > 0 '.
				' and bo.Situacao <> "C"'.
				' and bo.Situacao <> "T"';

	$filtro = 'Perodo: De "'.$_REQUEST['dt_ini'].'"'.
			' At "'.$_REQUEST['dt_fim'].'"';

	if ($_REQUEST['pessoa']!=''){
		$consulta.= ' and bo.Pessoa="'.$_REQUEST['pessoa'].'"';
		$filtro.= ' Pessoa "'.$_REQUEST['pessoa'].'"';
	}
	if($_REQUEST['situacao']=='P'){
		$consulta.= ' and bo.Situacao = "P"';
		$filtro.= ' Situao Atual: Aberto ';
	}else if($_REQUEST['situacao']=='F'){
		$consulta.= ' and bo.Situacao = "F"';
		$filtro.= ' Situao Atual: Fechado ';
	}

	if ($_REQUEST['empresa']!=''){
		$consulta.= ' and bo.Empresa = "'.$_REQUEST['empresa'].'"';

		$con_pessoa = 'Select Nome_Listas from pessoa '.
					  ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					  ' and Pessoa = "'.$_REQUEST['empresa'].'"';
		$res_pessoa = consulta_sql($con_pessoa);
		$reg_pessoa = consulta_ler_linha($res_pessoa);
		consulta_limpa($res_pessoa);
		$filtro.=' Empresa: "'.$reg_pessoa[0].'"';
	}

	if ($_REQUEST['trader']!=''){
		$consulta.= ' and bo.Trader = "'.$_REQUEST['trader'].'"';
		$cons_trader = 'select Nome_Listas, Pessoa from pessoa '.
						' where Dominio = "'.$_SESSION["Dominio"].'"'.
						 ' and Pessoa = "'.$_REQUEST['trader'].'"';
		$res_trader = consulta_sql($cons_trader);
		$reg_trader = consulta_ler_linha($res_trader);
		consulta_limpa($res_trader);
		$filtro.=' Trader: "'.$reg_trader[0].'"';
	}

	if ($_REQUEST['produto']!=''){
		$consulta.= ' and bo.Id_Produto="'.$_REQUEST['produto'].'"';
		$con_prod = 'select Codigo_Produto from produto '.
					' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					' and Id_Produto="'.$_REQUEST['produto'].'"';
		$res_prod = consulta_sql($con_prod);
		$reg_prod = consulta_ler_linha($res_prod);
		consulta_limpa($res_prod);

		$filtro.= ' Produto "'.$reg_prod[0].'"';
	}

	if ($_REQUEST['tipo_emissao']!=''){
		$consulta.= ' and bo.Frete = "'.$_REQUEST['tipo_emissao'].'"';
		if ($_REQUEST['tipo_emissao']=='0'){
			$filtro.= ' "Emisso Prpria"';
		}else{
			$filtro.= ' "Emisso de Terceiros"';
		}
	}

	if($_REQUEST['tipo_prod']!=''){
		if($_REQUEST['tipo_prod']=='T'){
			$consulta.= ' and ((bo.Tipo="0") and (SUBSTRING(pes.Cadastros,7,1) = "N") and (bo.Transgenico_Desc>0)) ';
			$filtro.= ' "Transgnico"';
		}else{
			$consulta.= ' and ((bo.Tipo="0") and (SUBSTRING(pes.Cadastros,7,1) = "N") and (bo.Transgenico_Desc=0)) ';
			$filtro.= ' "Convencional"';
		}
	}

	$entrada = '';
	if ($_REQUEST['tipo_es']!=''){
		$consulta.= ' and bo.Tipo ="'.$_REQUEST['tipo_es'].'"';
		if ($_REQUEST['tipo_es']=='0'){
			$filtro.= ' "Boletins de Entrada"';
			//$entrada = ' Entrada ';
		}else{
			$filtro.= ' "Boletins de Sada"';
			//$entrada = ' Sada ';
		}
	}

	if ($_REQUEST['tipo']!=''){
		if ($_REQUEST['tipo']=='N'){
			$consulta.= ' and (SUBSTRING(pes.Cadastros,7,1) = "N") ';
			$filtro.= ' "Boletins Normais"';
			//$entrada = ' Normal ';
		}else{
			$consulta.= ' and (SUBSTRING(pes.Cadastros,7,1) = "S") ';
			$filtro.= ' "Boletins de Transferncias"';
			//$entrada = ' Transferncia ';
		}
	}

	if($_REQUEST['placa']!=''){
		$consulta.= ' and bo.Placa = "'.$_REQUEST['placa'].'"';
		$filtro.= ' Placa: "'.$_REQUEST['placa'].'"';
	}

	if ($considerar_dev=='S'){
		$consulta.= ' and (bo.Considerar="N" or bo.PesoConsiderar>0)';
		$filtro.= ' Somente Devolvido/Transferido';
	}else if ($considerar_dev=='T'){
		//$consulta.= ' and bo.Considerar="N" or bo.PesoConsiderar>0';
		$filtro.= ' Com Devoluo/Transferncia';
	}else{
		//$consulta.= ' and bo.Considerar="S"';
	}

	if ($transbordo=='N'){
		$consulta.= ' and (bo.Transb_Boletim=0)';
		$filtro.= ' No Considera Transbordo';
	}

	if($_REQUEST['tipo_trigo']!=''){
		if($_REQUEST['tipo_trigo']=='C'){
			$consulta.= ' and bo.Variedade="C"';
			$tipo_trigo="Convencional";
		}else if($_REQUEST['tipo_trigo']=='F'){
			$consulta.= ' and bo.Variedade="F"';
			$tipo_trigo="Fomento";
		}
		$filtro.= ' Variedade do Trigo: '.$tipo_trigo;
	}

	if($_REQUEST['seco_limpo']!=''){
		if($_REQUEST['seco_limpo']=='S'){
			$consulta.= ' and bo.Seco_Limpo="S"';
			$filtro=" Seco/Limpo";
		}else if($_REQUEST['seco_limpo']=='N'){
			$consulta.= ' and bo.Seco_Limpo="N"';
			$filtro=" Classif. Normal";
		}else if($_REQUEST['seco_limpo']=='T'){
			$consulta.= ' and bo.Seco_Limpo="T"';
			$filtro=" Troca NF";
		}else if($_REQUEST['seco_limpo']=='ST'){
			$consulta.= ' and ((bo.Seco_Limpo="T")||(bo.Seco_Limpo="S"))';
			$filtro=" Seco/Limpo e Troca NF";
		}
	}

	if ($_REQUEST['intacta']=='S'){
		$consulta.= ' and bo.Transgenico="S"';
		$filtro.= ' Patente "Positivo"';
	}else if ($_REQUEST['intacta']=='N'){
		$consulta.= ' and bo.Transgenico="N"';
		$filtro.= ' Patente "Negativo"';
	}else if ($_REQUEST['intacta']=='P'){
		$consulta.= ' and bo.Transgenico="S" and bo.TesteGMO<>"S"';
		$filtro.= ' Patente "Positivo Declarada"';
	}else if ($_REQUEST['intacta']=='T'){
		$consulta.= ' and bo.Transgenico="S" and bo.TesteGMO="S"';
		$filtro.= ' Patente "Positivo Testada"';
	}

	$consulta.= ' order by TipoRel, bo.Tipo, bo.Id_Produto, bo.DH_PesoFim, bo.Nr_Boletim ';

	$resultado = consulta_sql($consulta);
	$nrows = consulta_num_registros($resultado);
	$tipo_desc = '';

	$tipo = 0;
	$tem_valor_rec = (BuscaParam('BOLETIM-GERA-REC')=='S');

	if($nrows>0){
		$umid = 0;
		$impu = 0;
		$avar = 0;
		$queb = 0;
		$ph = 0;

		$trig = 0;
		$tran = 0;
		$quebra_tec = 0;

		$classe_1a = 0;
		$classe_1b = 0;
		$classe2 = 0;
		$classe3 = 0;

		$pPagoPH = 0;
		$pPago = 0;
		$pPagoF = 0;
		$pLiquido = 0;
		$pOrigem = 0;
		$qtd_boletim = 0;

		$tot_saldo_produtor = 0;

		$umid_perc = 0;
		$impu_perc = 0;
		$avar_perc = 0;
		$queb_perc = 0;
		$ph_perc = 0;

		$trig_perc = 0;
		$trans_percT = 0;
		$quebra_tec_perc = 0;

		$classe_1a_perc = 0;
		$classe_1b_perc = 0;
		$classe2_perc = 0;
		$classe3_perc = 0;

		$total_gmo_pos = 0;
		$total_gmo_neg = 0;
		$total_gmo_dec = 0;

		$qtd_gmo_pos = 0;
		$qtd_gmo_neg = 0;
		$qtd_gmo_dec = 0;
		

		$produto = 0;
		$tipoEs = '';
		$tipo_mov_ant = -1;
		$tiporel = '';

		for ($i=0;$i<$nrows;$i++){
			$registro = consulta_ler_objeto($resultado);
			set_time_limit(60);

			if (($produto!=$registro->Id_Produto)||($tipo_mov_ant != $registro->Tipo)||($tiporel!=$registro->TipoRel)){
				if ($produto>0){
					$linha++;
					$linha++;
					$col=0;

					$col=4;

					$worksheet1->write_string($linha,$col,'Peso Origem',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'Peso Lquido',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'Peso Pago',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'Veculos',$fmt_texto_r_b);
					$col++;

					if($_REQUEST['pessoa']!=''){
						$worksheet1->write_string($linha,$col,'Saldo Produtor',$fmt_texto_r_b);
						$col++;
					}

					$linha++;
					$col=4;

					$worksheet1->write_number($linha,$col,$pOrigem,$fmt_qtd);
					$col++;

					$worksheet1->write_number($linha,$col,$pLiquido,$fmt_qtd);
					$col++;

					$worksheet1->write_number($linha,$col,$pPago,$fmt_qtd);
					$col++;

					$worksheet1->write_number($linha,$col,$qtd_boletim,$fmt_nr_r);
					$col++;

					if($_REQUEST['pessoa']!=''){
						$worksheet1->write_number($linha,$col,$tot_saldo_produtor,$fmt_qtd);
						$col++;
					}

					$linha++;
					$linha++;
					$col=3;

					$worksheet1->write_string($linha,$col,'Umidade',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'Impureza',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'Avariado',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'Quebrado',$fmt_texto_r_b);
					$col++;

					$worksheet1->write_string($linha,$col,'pH',$fmt_texto_r_b);
					$col++;

					if($tipo_desc=='T'){
						$worksheet1->write_string($linha,$col,'Triguilho',$fmt_texto_r_b);
						$col++;
					}else if($tipo_desc=='G'){
						$worksheet1->write_string($linha,$col,'GMO',$fmt_texto_r_b);
						$col++;

						if (($tipo_mov_ant==0)&&($tiporel==1)){
							$worksheet1->write_string($linha-1,$col+2,'Patente Declarada',$fmt_texto_r_b);
							$worksheet1->write_string($linha,$col+2,'Patente Positivo',$fmt_texto_r_b);
							$worksheet1->write_string($linha+1,$col+2,'Patente Negativo',$fmt_texto_r_b);

							$worksheet1->write_string($linha-1,$col+3,'',$fmt_texto_r_b);
							$worksheet1->write_string($linha,$col+3,'',$fmt_texto_r_b);
							$worksheet1->write_string($linha+1,$col+3,'',$fmt_texto_r_b);

							$worksheet1->merge_cells($linha-1, $col+2, $linha-1, $col+3);
							$worksheet1->merge_cells($linha, $col+2, $linha, $col+3);
							$worksheet1->merge_cells($linha+1, $col+2, $linha+1, $col+3);

							$worksheet1->write_number($linha-1,$col+4,$total_gmo_dec,$fmt_qtd);
							$worksheet1->write_number($linha,$col+4,$total_gmo_pos,$fmt_qtd);
							$worksheet1->write_number($linha+1,$col+4,$total_gmo_neg,$fmt_qtd);	

							$worksheet1->write_string($linha-1,$col+5,'',$fmt_texto_r_b);
							$worksheet1->write_string($linha,$col+5,'',$fmt_texto_r_b);
							$worksheet1->write_string($linha+1,$col+5,'',$fmt_texto_r_b);

							$worksheet1->merge_cells($linha-1, $col+4, $linha-1, $col+5);
							$worksheet1->merge_cells($linha, $col+4, $linha, $col+5);
							$worksheet1->merge_cells($linha+1, $col+4, $linha+1, $col+5);

							$worksheet1->write_string($linha-1,$col+6,$qtd_gmo_dec.' Cargas',$fmt_qtd);
							$worksheet1->write_string($linha,$col+6,$qtd_gmo_pos.' Cargas',$fmt_qtd);
							$worksheet1->write_string($linha+1,$col+6,$qtd_gmo_neg.' Cargas',$fmt_qtd);

							$worksheet1->write_string($linha-1,$col+7,'',$fmt_qtd);
							$worksheet1->write_string($linha,$col+7,'',$fmt_qtd);
							$worksheet1->write_string($linha+1,$col+7,'',$fmt_qtd);

							$worksheet1->merge_cells($linha-1, $col+6, $linha-1, $col+7);
							$worksheet1->merge_cells($linha, $col+6, $linha, $col+7);
							$worksheet1->merge_cells($linha+1, $col+6, $linha+1, $col+7);
						}
					}else if($tipo_desc=='C'){
						$worksheet1->write_string($linha,$col,'Classe1A',$fmt_texto_r_b);
						$col++;

						$worksheet1->write_string($linha,$col,'Classe1B',$fmt_texto_r_b);
						$col++;

						$worksheet1->write_string($linha,$col,'Classe 2',$fmt_texto_r_b);
						$col++;

						$worksheet1->write_string($linha,$col,'Classe 3',$fmt_texto_r_b);
						$col++;
					}
					if(($registro->Tipo==0)||($classif_saida=='S')){
						$total_desc = $umid+$impu+$avar+$queb+$trig+$ph+$tran;
					}else{
						$total_desc = '';
					}

					$worksheet1->write_string($linha,$col,'Total',$fmt_texto_r_b);
					$col++;

					$linha++;
					$col=2;

					$worksheet1->write_string($linha,$col,'Descontos',$fmt_texto_r_b);
					$col++;

					if(($registro->Tipo==0)||($classif_saida=='S')){
						$worksheet1->write_number($linha,$col,$umid,$fmt_qtd);
						$col++;

						$worksheet1->write_number($linha,$col,$impu,$fmt_qtd);
						$col++;

						$worksheet1->write_number($linha,$col,$avar,$fmt_qtd);
						$col++;

						$worksheet1->write_number($linha,$col,$queb,$fmt_qtd);
						$col++;

						$worksheet1->write_number($linha,$col,$ph,$fmt_qtd);
						$col++;
					}else{
						$worksheet1->write_blank($linha,$col,$fmt_texto_r);
						$col++;

						$worksheet1->write_blank($linha,$col,$fmt_texto_r);
						$col++;

						$worksheet1->write_blank($linha,$col,$fmt_texto_r);
						$col++;

						$worksheet1->write_blank($linha,$col,$fmt_texto_r);
						$col++;

						$worksheet1->write_blank($linha,$col,$fmt_texto_r);
						$col++;
					}

					if($tipo_desc=='T'){
						if(($registro->Tipo==0)||($classif_saida=='S')){
							$worksheet1->write_number($linha,$col,$trig,$fmt_qtd);
							$col++;
						}else{
							$worksheet1->write_blank($linha,$col,$fmt_texto_r);
							$col++;
						}
					}else if($tipo_desc=='G'){
						if(($registro->Tipo==0)||($classif_saida=='S')){
							$worksheet1->write_number($linha,$col,$tran,$fmt_qtd);
							$col++;
						}else{
							$worksheet1->write_blank($linha,$col,$fmt_texto_r);
							$col++;
						}
					}else if($tipo_desc=='C'){
						if(($registro->Tipo==0)||($classif_saida=='S')){
							if($classe_1a_perc<=0){
								$classe_1a_perc = '';
							}
							$worksheet1->write_number($linha,$col,$classe_1a,$fmt_qtd);
							$col++;

							if($classe_1b_perc<=0){
								$classe_1b_perc = '';
							}
							$worksheet1->write_number($linha,$col,$classe_1b,$fmt_qtd);
							$col++;

							if($classe2_perc<=0){
								$classe2_perc = '';
							}
							$worksheet1->write_number($linha,$col,$classe2,$fmt_qtd);
							$col++;

							if($classe3_perc<=0){
								$classe3_perc = '';
							}
							$worksheet1->write_number($linha,$col,$classe3,$fmt_qtd);
							$col++;
						}else{
							$worksheet1->write_blank($linha,$col,$fmt_texto_r);
							$col++;

							$worksheet1->write_blank($linha,$col,$fmt_texto_r);
							$col++;

							$worksheet1->write_blank($linha,$col,$fmt_texto_r);
							$col++;

							$worksheet1->write_blank($linha,$col,$fmt_texto_r);
							$col++;
						}
					}

					$worksheet1->write_number($linha,$col,$total_desc,$fmt_qtd);
					$col++;

					$linha++;
					$col=2;

					$worksheet1->write_string($linha,$col,'Mdia',$fmt_texto_r_b);
					$col++;

					if($pLiquido>0){
						$umid = (($umid_perc)/($pLiquido));
						$impu = (($impu_perc)/($pLiquido));
						$avar = (($avar_perc)/($pLiquido));
						$quebrado = (($queb_perc)/($pLiquido));
						$ph = (($ph_perc)/($pLiquido));
						
						$quebra_tecP = (($quebra_tec_perc)/($pLiquido));

						if($tipo_desc=='T'){
							$trig = (($trig_perc)/($pLiquido));
						}else if($tipo_desc=='G'){
							$trans = (($trans_percT)/($pLiquido));
						}else if($tipo_desc=='C'){
							$classe1a = (($classe_1a_perc)/($pLiquido));
							$classe1b = (($classe_1b_perc)/($pLiquido));
							$classe2 = (($classe_2_perc)/($pLiquido));
							$classe3 = (($classe_3_perc)/($pLiquido));
						}
					}else{
						$umid = 0;
						$impu = 0;
						$avar = 0;
						$quebrado = 0;
						$ph = 0;
						$quebra_tecP = 0;

						if($tipo_desc=='T'){
							$trig = 0;
						}else if($tipo_desc=='G'){
							$trans = 0;
						}else if($tipo_desc=='C'){
							$classe1a = 0;
							$classe1b = 0;
							$classe2 = 0;
							$classe3 = 0;
						}
					}
					$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($umid,2,true))/100,$fmt_perc);
					$col++;

					$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($impu,2,true))/100,$fmt_perc);
					$col++;

					$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($avar,2,true))/100,$fmt_perc);
					$col++;

					$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($quebrado,2,true))/100,$fmt_perc);
					$col++;

					$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($ph,2,true))/100,$fmt_perc);
					$col++;

					if($tipo_desc=='T'){
						$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($trig,2,true))/100,$fmt_perc);
						$col++;
					}else if($tipo_desc=='G'){
						$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($trans,2,true))/100,$fmt_perc);
						$col++;	
					}else if($tipo_desc=='C'){
						$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe1a,2,true))/100,$fmt_perc);
						$col++;

						$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe1b,2,true))/100,$fmt_perc);
						$col++;

						$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe2,2,true))/100,$fmt_perc);
						$col++;

						$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe3,2,true))/100,$fmt_perc);
						$col++;
					}

					if (($tipo_mov_ant==0)&&($tiporel==1)){
						if ($tem_valor_rec){
							$linha++;
							$linha++;

							$col = 3;							

							$worksheet1->write_string($linha,$col,'Peso Lquido',$fmt_texto_c_b2);
							$col++;

							$worksheet1->write_string($linha,$col,'Total Recepo',$fmt_texto_c_b2);
							$col++;	
							$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
							$col++;		
							$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);

							$linha++;

							$col = 3;
							$worksheet1->write_number($linha,$col,$total_liquido_recepcao,$fmt_qtd);
							$col++;
							
							$worksheet1->write_number($linha,$col,$total_valor_recepcao,$fmt_valor);
							$col++;
							$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
							$col++;		
							$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);
						}else{
							$linha++;
							$linha++;

							$col = 3;
							$worksheet1->set_row($linha, 26.4);
							

							$worksheet1->write_string($linha,$col,'Peso Pago',$fmt_texto_c_b2);
							$col++;


							$worksheet1->write_string($linha,$col,'Total do Desconto Quebra Tcnica, Armazenagem e Beneficiamento',$fmt_texto_c_b2);
							$col++;						
							$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
							$col++;						
							$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
							$col++;
							$worksheet1->merge_cells($linha, $col-3, $linha, $col-1);



							$worksheet1->write_string($linha,$col,'Peso Pago Final',$fmt_texto_c_b2);
							$col++;						
							$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
							$col++;
							$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);

							
							$linha++;

							$col = 3;

							// if ($_REQUEST['tipo_rel']!='S'){
							// 	$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_pago.'9:'.$col_quebra_pago.($linha-9).')',$fmt_qtd);
							// }else{
								$worksheet1->write_number($linha,$col,$pPagoF,$fmt_qtd);
							//}
							$col++;
							

							// if ($_REQUEST['tipo_rel']!='S'){
							// 	$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_desc.'9:'.$col_quebra_desc.($linha-9).')',$fmt_qtd);
							// }else{
								$worksheet1->write_number($linha,$col,$quebra_tec,$fmt_qtd);
							// }
							$col++;
							$worksheet1->write_blank($linha,$col,$fmt_qtd);
							$col++;
							$worksheet1->write_blank($linha,$col,$fmt_qtd);
							$col++;
							$worksheet1->merge_cells($linha, $col-3, $linha, $col-1);
							

							// if ($_REQUEST['tipo_rel']!='S'){
							// 	$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_final.'9:'.$col_quebra_final.($linha-9).')',$fmt_qtd);
							// }else{
								$worksheet1->write_number($linha,$col,($pPagoF-$quebra_tec),$fmt_qtd);
							// }
							$col++;						
							$worksheet1->write_blank($linha,$col,$fmt_qtd);
							$col++;
							$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);
						}
					}

					

					$umid = 0;
					$impu = 0;
					$avar = 0;
					$queb = 0;
					$ph = 0;
					$trig = 0;
					$tran = 0;
					$quebra_tec = 0;
					$classe_1a = 0;
					$classe_1b = 0;
					$classe2 = 0;
					$classe3 = 0;

					$pPagoPH = 0;
					$pPago = 0;
					$pPagoF = 0;
					$pLiquido = 0;
					$pOrigem = 0;
					$qtd_boletim = 0;

					$umid_perc = 0;
					$impu_perc = 0;
					$avar_perc = 0;
					$queb_perc = 0;
					$ph_perc = 0;
					$trig_perc = 0;
					$trans_percT = 0;
					$quebra_tec_perc = 0;
					$classe_1a_perc = 0;
					$classe_1b_perc = 0;
					$classe2_perc = 0;
					$classe3_perc = 0;

					$total_gmo_pos = 0;
					$total_gmo_neg = 0;
					$total_gmo_dec = 0;

					$qtd_gmo_pos = 0;
					$qtd_gmo_neg = 0;
					$qtd_gmo_dec = 0;

					$tot_saldo_produtor = 0;
				}//fim if produto

				$produto  = $registro->Id_Produto;
				$tipo_desc = $registro->DescTipo;

				$con_prod = 'select Codigo_Produto, Descricao_Completa, Transgenico from produto '.
							' Where Dominio = "'.$_SESSION['Dominio'].'"'.
							' and Id_Produto="'.$produto.'"';
				$res_prod = consulta_sql($con_prod);
				$reg_prod = consulta_ler_linha($res_prod);
				consulta_limpa($res_prod);

				$desc_produto = $reg_prod[0].'-'.$reg_prod[1];

				if((($tipo_desc=='T') || ($tipo_desc=='0')) && ($reg_prod[2]=='S')){
					$tipo_desc = 'G';
				}

				$entrada = $registro->Tipo;
				if(($entrada=="0")&&($registro->TipoRel>0)){
					$entrada = 'Entrada';
					$titulo_sheet = 'ENTRADA';
				}else if(($entrada=="1")&&($registro->TipoRel>0)){
					$entrada = 'Sada';
					$titulo_sheet = 'SAIDA';
				}else if(($entrada=="0")&&($registro->TipoRel==0)){
					$entrada = 'Entrada Transferncia';
					$titulo_sheet = 'ENTRADA_TRANSF';
				}else if(($entrada=="1")&&($registro->TipoRel==0)){
					$entrada = 'Sada Transferncia';
					$titulo_sheet = 'SAIDA_TRANSF';
				}

				//if(($tipo_mov_ant != $registro->Tipo)||($tiporel!=$registro->TipoRel)){
				$worksheet1 =& $workbook->add_worksheet($titulo_sheet.'_'.$reg_prod[0]);
				$worksheet1->write_string(0,0,'RELATRIO DE BOLETINS',$fmt_cabec);
				$worksheet1->write(2,0,config_pad('sistema_licenca'));
				$worksheet1->write(3,0,"Data: ".$hoje." - Hora: ".$hora."  Usurio: ".base64_decode($_REQUEST['USER_ID']));
				$worksheet1->write(4,0,$filtro);
				$worksheet1->write_string(6,0,$entrada.' - '.$desc_produto,$fmt_tit_grupo);
				//}
				$tiporel = $registro->TipoRel;
				$tipo_mov_ant = $registro->Tipo;

				if ($_REQUEST['tipo_rel']!='S'){
					$col=0;
					$linha=6;
					$linha++;

					$worksheet1->set_column($col,$col,10);
					$worksheet1->write_string($linha,$col,'Boletim',$fmt_titulo);
					$col++;

					$worksheet1->set_column($col,$col,10);
					$worksheet1->write_string($linha,$col,'Data',$fmt_titulo);
					$col++;

					$worksheet1->set_column($col,$col,26);
					$worksheet1->write_string($linha,$col,'Pessoa',$fmt_titulo_l);
					$col++;

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'NF Origem',$fmt_titulo);
					$col++;

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'Placa',$fmt_titulo);
					$col++;

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'Origem',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'Lquido',$fmt_titulo_r);
					$col++;
					$col_liquido = letra_coluna($col);

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'Pago',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'%Umid',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,12);
					$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'%Impu',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'%Avar',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'%Queb',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'%pH',$fmt_titulo_r);
					$col++;

					$worksheet1->set_column($col,$col,8);
					$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
					$col++;

					if($tipo_desc=='T'){
						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'%Trig',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'Variedade',$fmt_titulo_l);
						$col++;

						$worksheet1->set_column($col,$col,30);
						$worksheet1->write_string($linha,$col,'Observao',$fmt_titulo_l);
						$col++;
					}else if($tipo_desc=='C'){
						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'Classe1',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'Classe2',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'Classe3',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
						$col++;
					}else if($tipo_desc=='G'){
						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'%Trans',$fmt_titulo_r);
						$col++;

						$worksheet1->set_column($col,$col,8);
						$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
						$col++;

						//if (($registro->Tipo==0)&&($registro->Pessoa>100)){
							$worksheet1->set_column($col,$col,20);
							$worksheet1->write_string($linha,$col,'Teste Patente',$fmt_titulo_l);
							$col++;
						//}

						$worksheet1->set_column($col,$col,30);
						$worksheet1->write_string($linha,$col,'Observao',$fmt_titulo_l);
						$col++;
					}
					$worksheet1->set_column($col,$col,30);
					$worksheet1->write_string($linha,$col,'CPF Fornec.',$fmt_titulo_l);
					$col++;



					if (($tipo_mov_ant==0)&&($tiporel==1)){

						if ($tem_valor_rec){
							$worksheet1->set_column($col,$col,10);
							$worksheet1->write_string($linha,$col,'Tx Recepo',$fmt_titulo);
							$col++;
							$col_quebra_perc = letra_coluna($col);

							$worksheet1->set_column($col,$col,15);
							$worksheet1->write_string($linha,$col,'Valor Recepo',$fmt_titulo);
							$col++;
							$col_quebra_final = letra_coluna($col);

							$tx_recepcao= 0;

							$total_liquido_recepcao=0;
					        $total_valor_recepcao=0;
						}else{
							$worksheet1->set_column($col,$col,10);
							$worksheet1->write_string($linha,$col,'Peso Pago',$fmt_titulo);
							$col++;
							$col_quebra_pago = letra_coluna($col);
	
							$worksheet1->set_column($col,$col,10);
							$worksheet1->write_string($linha,$col,'Data Entrega',$fmt_titulo);
							$col++;
							$col_quebra_entrega = letra_coluna($col);
	
							$worksheet1->set_column($col,$col,10);
							$worksheet1->write_string($linha,$col,'Data Atual',$fmt_titulo);
							$col++;
							$col_quebra_atual = letra_coluna($col);
	
							$worksheet1->set_column($col,$col,14);
							$worksheet1->write_string($linha,$col,'Dias Descontado',$fmt_titulo);
							$col++;
							$col_quebra_dias = letra_coluna($col);
	
							$worksheet1->set_column($col,$col,12);
							$worksheet1->write_string($linha,$col,'%Quebra Tec.',$fmt_titulo_r);
							$col++;
							$col_quebra_perc = letra_coluna($col);
	
							$worksheet1->set_column($col,$col,8);
							$worksheet1->write_string($linha,$col,'-Desc',$fmt_titulo_r);
							$col++;
							$col_quebra_desc = letra_coluna($col);
	
							$worksheet1->set_column($col,$col,14);
							$worksheet1->write_string($linha,$col,'Peso Pago Final',$fmt_titulo_r);
							$col++;
							$col_quebra_final = letra_coluna($col);
						}

						
					}
					
				}
			}//fim if condicao

			$tipo_mov_ant = $registro->Tipo;
			$tiporel = $registro->TipoRel;

			//$pago_considerar = $registro->PesoPago - $registro->PesoConsiderar;
			//if (($registro->PesoConsiderar==0)||($registro->PesoPago==0)){
			//	$perc_base = 1;
			//}else{
			//	$perc_base = $pago_considerar/$registro->PesoPago;
			//}
			$obs_nao_considerou = '';
			if ($considerar_dev=='S'){
				if ($registro->PesoConsiderar>0){
					$pago_considerar = $registro->PesoConsiderar;

					if ($registro->PesoConsiderar==$registro->PesoPago){
						$perc_base = 1;
					}else{
						$perc_base = $pago_considerar/$registro->PesoPago;
					}
				}else{
					$pago_considerar = $registro->PesoPago;
					$perc_base = 1;
				}

			}else if ($considerar_dev=='T'){
				$pago_considerar = $registro->PesoPago;
				$perc_base = 1;
			}else{
				if ($registro->Considerar=='N'){
					$pago_considerar = 0;
					$perc_base = 0;
					$obs_nao_considerou = 'Dev. ('.formata_qtd($registro->PesoPago,2,false).' KG) ';
				}else{
					$pago_considerar = $registro->PesoPago - $registro->PesoConsiderar;
					if (($registro->PesoConsiderar==0)||($registro->PesoPago==0)){
						$perc_base = 1;
					}else{
						$perc_base = $pago_considerar/$registro->PesoPago;
					}
					if ($registro->PesoConsiderar!=0){
						$obs_nao_considerou = 'Dev. ('.formata_qtd($registro->PesoConsiderar,2,false).' KG) ';
					}
				}
			}

			$peso_considerar = round($registro->PesoLiquido*$perc_base);

			if ($registro->Transgenico=='S'){
				if ($registro->TesteGMO=='S'){
					$total_gmo_pos+= round($registro->PesoPago*$perc_base);
					$qtd_gmo_pos++;
				}else{ 
					$total_gmo_dec+= round($registro->PesoPago*$perc_base);
					$qtd_gmo_dec++;
				}
			}else if ($registro->TesteGMO=='N'){
				$total_gmo_neg+= round($registro->PesoPago*$perc_base);
				$qtd_gmo_neg++;
			}else{
				$total_gmo_neg+= round($registro->PesoPago*$perc_base);
				$qtd_gmo_neg++;
			}

			$ndia_bol = data2nr(dataf($registro->DH_Abertura));
			$ndia_bol_atual = $ndia_atual;

			$pago_considerar2 = $pago_considerar;
			//if ($ndia_bol>=$dia_limite_inf){
			//	$ndia_bol_atual = $ndia_bol;
			//}


			$quebra_tecD = $ndia_bol_atual - $ndia_bol;
			if ($_SESSION['Dominio']==2){
				if ($quebra_tecD<=90) $quebra_tecD = 0;
			}
			if ($quebra_tecD<1) $quebra_tecD = 0;

			$quebra_tec_Desc = 0;
			$quebra_tec_Perc = (($perc_quebra_mes/100)/30);

			if ($quebra_tecD>0){
				$quebra_tec_Desc = round($pago_considerar2 * $quebra_tec_Perc * $quebra_tecD);
			}

			if(($registro->Tipo==0)||($classif_saida=='S')){
				$umid+= round($registro->Umidade_Desc*$perc_base);
				$avar+= round($registro->Avariado_Desc*$perc_base);
				$queb+= round($registro->Quebrado_Desc*$perc_base);
				$tran+= round($registro->Transgenico_Desc*$perc_base);
				$impu+= round($registro->Impureza_Desc*$perc_base);
				$trig+= round($registro->Triguilho_Desc*$perc_base);
				$ph+= round($registro->pH_Desc*$perc_base);				

				$classe_1a+= round($registro->Classe1A_Desc*$perc_base);
				$classe_1b+= round($registro->Classe1B_Desc*$perc_base);
				$classe2+= round($registro->Classe2_Desc*$perc_base);
				$classe3+= round($registro->Classe3_Desc*$perc_base);

				$quebra_tec+= round($quebra_tec_Desc*$perc_base);
			}

			if($registro->pH_Desc < $registro->PesoPago){
				if(data2nr(dataf($registro->DH_Abertura))<data2nr('05/10/2011')){ //a partir desta data comecou a descontar o ph direto
					$pPagoPH+= ($pago_considerar - round($registro->pH_Desc*$perc_base));
				}else{
					$pPagoPH+= ($pago_considerar);
				}
			}
			$pPago+= $pago_considerar;
			$pPagoF+= $pago_considerar2;

			if(($registro->Placa=="AAA-0000")&&($registro->Umidade_Perc==0)){
				$nr_boletim_consultar = $registro->Nr_Boletim * (-1);
			}else{
				$nr_boletim_consultar = $registro->Nr_Boletim;
				$pLiquido+= $peso_considerar;
			}
			$qtd_boletim++;
			if ($peso_considerar>0){
				$pOrigem+= round($registro->PesoOrigem*$perc_base);

				$umid_perc+= $registro->Umidade_Perc*$peso_considerar;
				$impu_perc+= $registro->Impureza_Perc*$peso_considerar;
				$avar_perc+= $registro->Avariado_Perc*$peso_considerar;
				$queb_perc+= $registro->Quebrado_Perc*$peso_considerar;
				$trig_perc+= $registro->Triguilho_Perc*$peso_considerar;
				$ph_perc+= $registro->pH_Perc*$peso_considerar;
				$trans_percT+= $registro->Transgenico_Perc*$peso_considerar;
				$classe_1a_perc+= $registro->Classe1A_Perc*$peso_considerar;
				$classe_1b_perc+= $registro->Classe1B_Perc*$peso_considerar;
				$classe2_perc+= $registro->Classe2_Perc*$peso_considerar;
				$classe3_perc+= $registro->Classe3_Perc*$peso_considerar;
				
				$quebra_tec_perc+= $quebra_tec_Perc*$peso_considerar;
			}
			if($_REQUEST['pessoa']!=''){
				$cons_nf = 'select Nr_Nota, Empresa, Nat_Op_CFOP '.
							' from nota_fiscal '.
							' where Dominio = "'.$_SESSION['Dominio'].'" '.
							' and Empresa = "'.$registro->Empresa.'" '.
							' and Nr_Boletim_Pesagem = "'.$nr_boletim_consultar.'" '.
							' and Situacao <> "C" and Situacao <> "E"';
				$res_nf = consulta_sql($cons_nf);
				$nrows_nf = consulta_num_registros($res_nf);
				for($b=0;$b<$nrows_nf;$b++){
					$reg_nf = consulta_ler_linha($res_nf);

					if(($reg_nf[2]=="1.905") || ($reg_nf[2]=="2.905")||
						($reg_nf[2]=="1.934") || ($reg_nf[2]=="2.934")){
						$cons_item = 'select Quantidade_Estoque, Qtd_Devolvida, Qtd_Fixar '.
									' from nota_fiscal_item '.
									' where Dominio = "'.$_SESSION['Dominio'].'"'.
									' and Empresa = "'.$reg_nf[1].'" '.
									' and Nr_Nota = "'.$reg_nf[0].'" ';
					}else{// if(($reg_nf[2]=="1.102") || ($reg_nf[2]=="2.102")){
						$cons_item = 'select Quantidade_Estoque, '.
									' ((Quantidade_Estoque-Qtd_Fixar)+Qtd_Devolvida) as Qtd_Devolvida '.
									' from nota_fiscal_item '.
									' where Dominio = "'.$_SESSION['Dominio'].'"'.
									' and Empresa = "'.$reg_nf[1].'" '.
									' and Nr_Nota = "'.$reg_nf[0].'" ';
					}
					$res_item = consulta_sql($cons_item);
					$nrows_item = consulta_num_registros($res_item);
					if($nrows_item>0){
						for($a=0;$a<$nrows_item;$a++){
							$reg_item = consulta_ler_objeto($res_item);
							if($reg_item->Qtd_Devolvida<$reg_item->Quantidade_Estoque){
								$tot_saldo_produtor+= ($reg_item->Quantidade_Estoque-$reg_item->Qtd_Devolvida);
							}
							//$tot_saldo_produtor+= ($reg_item->Quantidade_Estoque-$reg_item->Qtd_Devolvida);
						}
					}
					consulta_limpa($res_item);
				}
				consulta_limpa($res_nf);
			}

			if ($_REQUEST['tipo_rel']!='S'){
				$linha++;
				$col=0;

				$worksheet1->write_string($linha,$col,$registro->Nr_Boletim,$fmt_texto_c);
				$col++;

				$worksheet1->write_string($linha,$col,dataf2($registro->DH_Abertura),$fmt_texto_c);
				$col++;

				$con_pessoa = 'select Nome_Listas, CPF_CNPJ from pessoa '.
							  ' where Dominio = "'.$_SESSION['Dominio'].'"'.
							  ' and Pessoa = "'.$registro->Pessoa.'"';
				$res_pessoa = consulta_sql($con_pessoa);
				$reg_pessoa = consulta_ler_linha($res_pessoa);
				consulta_limpa($res_pessoa);
				$worksheet1->write_string($linha,$col,$registro->Pessoa.'-'.$reg_pessoa[0],$fmt_texto_l);
				$col++;

				$prod = $registro->NF_Produtor_Nr;
				if($prod<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_string($linha,$col,$prod,$fmt_texto_c);
					$col++;
				}

				$worksheet1->write_string($linha,$col,$registro->Placa,$fmt_texto_c);
				$col++;

				$pOrige = round($registro->PesoOrigem*$perc_base);
				if($pOrige<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$pOrige,$fmt_qtd);
					$col++;
				}

				$pLiquid = $peso_considerar;
				if($pLiquid<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$pLiquid,$fmt_qtd);
					$col++;
				}

				$pp = $pago_considerar;
				if($pp<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$pp,$fmt_qtd);
					$col++;
				}

				$perc_u = $registro->Umidade_Perc;
				if($perc_u<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$perc_u/100,$fmt_perc);
					$col++;
				}

				if(($registro->Tipo==0)||($classif_saida=='S')){
					//Umidade
					$umid_desc = round($registro->Umidade_Desc*$perc_base);
					if($umid_desc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$umid_desc,$fmt_qtd);
						$col++;
					}
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}

				$perc_i = $registro->Impureza_Perc;
				if($perc_i<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$perc_i/100,$fmt_perc);
					$col++;
				}

				if(($registro->Tipo==0)||($classif_saida=='S')){
					//Impureza
					$impu_desc = round($registro->Impureza_Desc*$perc_base);
					if($impu_desc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$impu_desc,$fmt_qtd);
						$col++;
					}
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}

				$perc_a = $registro->Avariado_Perc;
				if($perc_a<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$perc_a/100,$fmt_perc);
					$col++;
				}

				if(($registro->Tipo==0)||($classif_saida=='S')){
					//Impureza
					$avar_desc = round($registro->Avariado_Desc*$perc_base);
					if($avar_desc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$avar_desc,$fmt_qtd);
						$col++;
					}
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}

				$perc_q = $registro->Quebrado_Perc;
				if($perc_q<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$perc_q/100,$fmt_perc);
					$col++;
				}

				if(($registro->Tipo==0)||($classif_saida=='S')){
					//Impureza
					$quebra_desc = round($registro->Quebrado_Desc*$perc_base);
					if($quebra_desc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$quebra_desc,$fmt_qtd);
						$col++;
					}
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}

				$perc_p = $registro->pH_Perc;
				if($perc_p<=0){
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}else{
					$worksheet1->write_number($linha,$col,$perc_p/100,$fmt_perc);
					$col++;
				}

				if(($registro->Tipo==0)||($classif_saida=='S')){
					//Impureza
					$ph_val = round($registro->pH_Desc*$perc_base);
					if($ph_val<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$ph_val,$fmt_qtd);
						$col++;
					}
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_c);
					$col++;
				}

				
				if($tipo_desc=='T'){
					$Triguilho_Perc = $registro->Triguilho_Perc;
					if($Triguilho_Perc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$Triguilho_Perc/100,$fmt_perc);
						$col++;
					}

					if($registro->DescTipo=='T'){
						if(($registro->Tipo==0)||($classif_saida=='S')){
							//Triguilho Desc
							$Triguilho_Desc = round($registro->Triguilho_Desc*$perc_base);
							if($Triguilho_Desc<=0){
								$worksheet1->write_blank($linha,$col,$fmt_texto_c);
								$col++;
							}else{
								$worksheet1->write_number($linha,$col,$Triguilho_Desc,$fmt_qtd);
								$col++;
							}
						}else{
							$worksheet1->write_blank($linha,$col,$fmt_texto_c);
							$col++;
						}
					}
					$variedade = 'Comum';
					if ($registro->Variedade=='F'){
						$variedade = 'Fomento';
					}
					$worksheet1->write_string($linha,$col,$variedade,$fmt_texto_c);
					$col++;

					$worksheet1->write_string($linha,$col,$registro->Observacao,$fmt_texto_l);
					$col++;

				}else if($tipo_desc=='C'){
					$classe_desc_a = round($registro->Classe1A_Desc*$perc_base);
					$classe_desc_b = round($registro->Classe1B_Desc*$perc_base);

					$classe_perc_a = $registro->Classe1A_Perc;
					$classe_perc_b = $registro->Classe1B_Perc;

					$classe1_perc = $classe_perc_a+$classe_perc_b;
					if($classe1_perc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$classe1_perc/100,$fmt_perc);
						$col++;
					}

					if(($registro->Tipo==0)||($classif_saida=='S')){
						//Classe 1
						$classe1 = $classe_desc_a+$classe_desc_b;
						if($classe1<=0){
							$worksheet1->write_blank($linha,$col,$fmt_texto_c);
							$col++;
						}else{
							$worksheet1->write_number($linha,$col,$classe1,$fmt_qtd);
							$col++;
						}
					}else{
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}

					//Classe 2
					$classe2_perc = $registro->Classe2_Perc;
					if($classe2_perc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$classe2_perc/100,$fmt_perc);
						$col++;
					}

					if(($registro->Tipo==0)||($classif_saida=='S')){
						//Classe 2
						$classe2 = round($registro->Classe2_Desc*$perc_base);
						if($classe2<=0){
							$worksheet1->write_blank($linha,$col,$fmt_texto_c);
							$col++;
						}else{
							$worksheet1->write_number($linha,$col,$classe2,$fmt_qtd);
							$col++;
						}
					}else{
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}

					//Classe 3
					$classe3_perc = $registro->Classe3_Perc;
					if($classe3_perc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$classe3_perc/100,$fmt_perc);
						$col++;
					}

					if(($registro->Tipo==0)||($classif_saida=='S')){
						//Classe 3
						$classe3 = round($registro->Classe3_Desc*$perc_base);
						if($classe3<=0){
							$worksheet1->write_blank($linha,$col,$fmt_texto_c);
							$col++;
						}else{
							$worksheet1->write_number($linha,$col,$classe3,$fmt_qtd);
							$col++;
						}
					}else{
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}

				}else if($tipo_desc=='G'){
					$trans_perc = $registro->Transgenico_Perc;
					if($trans_perc<=0){
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$trans_perc/100,$fmt_perc);
						$col++;
					}

					if(($registro->Tipo==0)||($classif_saida=='S')){
						//Transgenico Desc
						$trans_desc = round($registro->Transgenico_Desc*$perc_base);
						if($trans_desc<=0){
							$worksheet1->write_blank($linha,$col,$fmt_texto_c);
							$col++;
						}else{
							$worksheet1->write_number($linha,$col,$trans_desc,$fmt_qtd);
							$col++;
						}
					}else{
						$worksheet1->write_blank($linha,$col,$fmt_texto_c);
						$col++;
					}
					//if (($registro->Tipo==0)&&($registro->Pessoa>100)){	
						if ($registro->Transgenico=='S'){
							if ($registro->TesteGMO=='S'){
								$txt_teste_intacta = 'Positivo';
							}else{
								$txt_teste_intacta = 'Declarado';
							}
						}else if ($registro->TesteGMO=='N'){
							$txt_teste_intacta = 'Negativo';
						}else{
							$txt_teste_intacta = 'No Testado';
						}
						$worksheet1->write_string($linha,$col,$txt_teste_intacta,$fmt_texto_l);
						$col++;
					//}

					$worksheet1->write_string($linha,$col,$obs_nao_considerou.$registro->Observacao,$fmt_texto_l);
					$col++;
				}

				$worksheet1->write_string($linha,$col,$reg_pessoa[1],$fmt_texto_l);
				$col++;

				if (($tipo_mov_ant==0)&&($tiporel==1)){

					if ($tem_valor_rec){
						$taxa = boletim_taxa_recepcao($registro->Empresa,
													$registro->Id_Produto,
													$registro->DH_Abertura,
													$registro->Pessoa,
													$registro->Umidade_Perc);
						$tx_recepcao = $taxa['preco'];					
						$valor_recepcao = round(($peso_considerar/1000 * $tx_recepcao),2);

						$total_liquido_recepcao+=$peso_considerar;
					    $total_valor_recepcao+=$valor_recepcao;
						//$tx_recepcao  por TON

						$worksheet1->write_number($linha,$col,$tx_recepcao,$fmt_valor);
						$col++;

						$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_perc.($linha+1).'*'.($peso_considerar/1000).')',$fmt_valor);
						$col++;
					}else{
						$worksheet1->write_number($linha,$col,$pago_considerar2,$fmt_qtd);
						$col++;

						$worksheet1->write_number($linha,$col,data2nr(dataf($registro->DH_Abertura)),$fmt_data_c);
						$col++;

						$worksheet1->write_number($linha,$col,$ndia_bol_atual,$fmt_data_c);
						$col++;

						// $worksheet1->write_number($linha,$col,$quebra_tecD,$fmt_qtd);
						// $col++;

						// $worksheet1->write_number($linha,$col,$perc_quebra_mes/100,$fmt_perc);
						// $col++;

						// $worksheet1->write_number($linha,$col,$quebra_tec_Desc,$fmt_qtd);
						// $col++;

						// $worksheet1->write_number($linha,$col,($pago_considerar2 - $quebra_tec_Desc),$fmt_qtd);
						// $col++;

						$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_atual.($linha+1).'-'.$col_quebra_entrega.($linha+1).')',$fmt_qtd);
						$col++;

						$worksheet1->write_formula($linha,$col,$perc_quebra_mes/100,$fmt_perc);
						$col++;

						$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_pago.($linha+1).'*'.$col_quebra_dias.($linha+1).'*('.$col_quebra_perc.($linha+1).'/30))',$fmt_qtd);
						$col++;

						$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_pago.($linha+1).'-'.$col_quebra_desc.($linha+1).')',$fmt_qtd);
						$col++;
					}

				}



			}else{
				//fim if tiporel
				$linha=7;
			}
		}//fim for

		if ($produto>0){
			$linha++;
			$linha++;
			$col=0;

			$col=4;

			$worksheet1->write_string($linha,$col,'Peso Origem',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'Peso Lquido',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'Peso Pago',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'Veculos',$fmt_texto_r_b);
			$col++;

			if($_REQUEST['pessoa']!=''){
				$worksheet1->write_string($linha,$col,'Saldo Produtor',$fmt_texto_r_b);
				$col++;
			}			
			$linha++;

			$col=4;

			$worksheet1->write_number($linha,$col,$pOrigem,$fmt_qtd);
			$col++;

			$worksheet1->write_number($linha,$col,$pLiquido,$fmt_qtd);
			$col++;

			$worksheet1->write_number($linha,$col,$pPago,$fmt_qtd);
			$col++;

			$worksheet1->write_number($linha,$col,$qtd_boletim,$fmt_nr_r);
			$col++;

			if($_REQUEST['pessoa']!=''){
				$worksheet1->write_number($linha,$col,$tot_saldo_produtor,$fmt_qtd);
				$col++;
			}

			$linha++;
			$linha++;
			$col=3;

			$worksheet1->write_string($linha,$col,'Umidade',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'Impureza',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'Avariado',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'Quebrado',$fmt_texto_r_b);
			$col++;

			$worksheet1->write_string($linha,$col,'pH',$fmt_texto_r_b);
			$col++;

			if($tipo_desc=='T'){
				$worksheet1->write_string($linha,$col,'Triguilho',$fmt_texto_r_b);
				$col++;
			}else if($tipo_desc=='G'){
				$worksheet1->write_string($linha,$col,'GMO',$fmt_texto_r_b);
				$col++;
				if (($registro->Tipo==0)&&($registro->Pessoa>100)){	
					$worksheet1->write_string($linha-1,$col+2,'Patente Declarada',$fmt_texto_r_b);
					$worksheet1->write_string($linha,$col+2,'Patente Positivo',$fmt_texto_r_b);
					$worksheet1->write_string($linha+1,$col+2,'Patente Negativo',$fmt_texto_r_b);

					$worksheet1->write_string($linha-1,$col+3,'',$fmt_texto_r_b);
					$worksheet1->write_string($linha,$col+3,'',$fmt_texto_r_b);
					$worksheet1->write_string($linha+1,$col+3,'',$fmt_texto_r_b);

					$worksheet1->merge_cells($linha-1, $col+2, $linha-1, $col+3);
					$worksheet1->merge_cells($linha, $col+2, $linha, $col+3);
					$worksheet1->merge_cells($linha+1, $col+2, $linha+1, $col+3);			

					$worksheet1->write_number($linha-1,$col+4,$total_gmo_dec,$fmt_qtd);
					$worksheet1->write_number($linha,$col+4,$total_gmo_pos,$fmt_qtd);
					$worksheet1->write_number($linha+1,$col+4,$total_gmo_neg,$fmt_qtd);	

					$worksheet1->write_string($linha-1,$col+5,'',$fmt_texto_r_b);
					$worksheet1->write_string($linha,$col+5,'',$fmt_texto_r_b);
					$worksheet1->write_string($linha+1,$col+5,'',$fmt_texto_r_b);

					$worksheet1->merge_cells($linha-1, $col+4, $linha-1, $col+5);
					$worksheet1->merge_cells($linha, $col+4, $linha, $col+5);
					$worksheet1->merge_cells($linha+1, $col+4, $linha+1, $col+5);

					$worksheet1->write_string($linha-1,$col+6,$qtd_gmo_dec.' Cargas',$fmt_qtd);
					$worksheet1->write_string($linha,$col+6,$qtd_gmo_pos.' Cargas',$fmt_qtd);
					$worksheet1->write_string($linha+1,$col+6,$qtd_gmo_neg.' Cargas',$fmt_qtd);

					$worksheet1->write_string($linha-1,$col+7,'',$fmt_qtd);
					$worksheet1->write_string($linha,$col+7,'',$fmt_qtd);
					$worksheet1->write_string($linha+1,$col+7,'',$fmt_qtd);

					$worksheet1->merge_cells($linha-1, $col+6, $linha-1, $col+7);
					$worksheet1->merge_cells($linha, $col+6, $linha, $col+7);
					$worksheet1->merge_cells($linha+1, $col+6, $linha+1, $col+7);
				}
			}else if($tipo_desc=='C'){
				$worksheet1->write_string($linha,$col,'Classe1A',$fmt_texto_r_b);
				$col++;

				$worksheet1->write_string($linha,$col,'Classe1B',$fmt_texto_r_b);
				$col++;

				$worksheet1->write_string($linha,$col,'Classe 2',$fmt_texto_r_b);
				$col++;

				$worksheet1->write_string($linha,$col,'Classe 3',$fmt_texto_r_b);
				$col++;
			}
			if(($registro->Tipo==0)||($classif_saida=='S')){
				$total_desc = $umid+$impu+$avar+$queb+$trig+$ph+$tran;
			}else{
				$total_desc = '';
			}

			$worksheet1->write_string($linha,$col,'Total',$fmt_texto_r_b);
			$col++;

			$linha++;
			$col=2;

			$worksheet1->write_string($linha,$col,'Descontos',$fmt_texto_r_b);
			$col++;

			if(($registro->Tipo==0)||($classif_saida=='S')){
				$worksheet1->write_number($linha,$col,$umid,$fmt_qtd);
				$col++;

				$worksheet1->write_number($linha,$col,$impu,$fmt_qtd);
				$col++;

				$worksheet1->write_number($linha,$col,$avar,$fmt_qtd);
				$col++;

				$worksheet1->write_number($linha,$col,$queb,$fmt_qtd);
				$col++;

				$worksheet1->write_number($linha,$col,$ph,$fmt_qtd);
				$col++;
			}else{
				$worksheet1->write_blank($linha,$col,$fmt_texto_r);
				$col++;

				$worksheet1->write_blank($linha,$col,$fmt_texto_r);
				$col++;

				$worksheet1->write_blank($linha,$col,$fmt_texto_r);
				$col++;

				$worksheet1->write_blank($linha,$col,$fmt_texto_r);
				$col++;

				$worksheet1->write_blank($linha,$col,$fmt_texto_r);
				$col++;
			}

			if($tipo_desc=='T'){
				if(($registro->Tipo==0)||($classif_saida=='S')){
					$worksheet1->write_number($linha,$col,$trig,$fmt_qtd);
					$col++;
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_r);
					$col++;
				}
			}else if($tipo_desc=='G'){
				if(($registro->Tipo==0)||($classif_saida=='S')){
					$worksheet1->write_number($linha,$col,$tran,$fmt_qtd);
					$col++;
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_r);
					$col++;
				}
			}else if($tipo_desc=='C'){
				if(($registro->Tipo==0)||($classif_saida=='S')){
					if($classe_1a_perc<=0){
						$classe_1a_perc = '';
					}
					$worksheet1->write_number($linha,$col,$classe_1a,$fmt_qtd);
					$col++;

					if($classe_1b_perc<=0){
						$classe_1b_perc = '';
					}
					$worksheet1->write_number($linha,$col,$classe_1b,$fmt_qtd);
					$col++;

					if($classe2_perc<=0){
						$classe2_perc = '';
					}
					$worksheet1->write_number($linha,$col,$classe2,$fmt_qtd);
					$col++;

					if($classe3_perc<=0){
						$classe3_perc = '';
					}
					$worksheet1->write_number($linha,$col,$classe3,$fmt_qtd);
					$col++;
				}else{
					$worksheet1->write_blank($linha,$col,$fmt_texto_r);
					$col++;

					$worksheet1->write_blank($linha,$col,$fmt_texto_r);
					$col++;

					$worksheet1->write_blank($linha,$col,$fmt_texto_r);
					$col++;

					$worksheet1->write_blank($linha,$col,$fmt_texto_r);
					$col++;
				}
			}

			$worksheet1->write_number($linha,$col,$total_desc,$fmt_qtd);
			$col++;

			$linha++;
			$col=2;

			$worksheet1->write_string($linha,$col,'Mdia',$fmt_texto_r_b);
			$col++;

			if($pLiquido>0){
				$umid = (($umid_perc)/($pLiquido));
				$impu = (($impu_perc)/($pLiquido));
				$avar = (($avar_perc)/($pLiquido));
				$quebrado = (($queb_perc)/($pLiquido));
				$ph = (($ph_perc)/($pLiquido));

				if($tipo_desc=='T'){
					$trig = (($trig_perc)/($pLiquido));
				}else if($tipo_desc=='G'){
					$trans = (($trans_percT)/($pLiquido));
				}else if($tipo_desc=='C'){
					$classe1a = (($classe_1a_perc)/($pLiquido));
					$classe1b = (($classe_1b_perc)/($pLiquido));
					$classe2 = (($classe_2_perc)/($pLiquido));
					$classe3 = (($classe_3_perc)/($pLiquido));
				}
			}else{
				$umid = 0;
				$impu = 0;
				$avar = 0;
				$quebrado = 0;
				$ph = 0;

				if($tipo_desc=='T'){
					$trig = 0;
				}else if($tipo_desc=='G'){
					$trans = 0;
				}else if($tipo_desc=='C'){
					$classe1a = 0;
					$classe1b = 0;
					$classe2 = 0;
					$classe3 = 0;
				}
			}
			$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($umid,2,true))/100,$fmt_perc);
			$col++;

			$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($impu,2,true))/100,$fmt_perc);
			$col++;

			$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($avar,2,true))/100,$fmt_perc);
			$col++;

			$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($quebrado,2,true))/100,$fmt_perc);
			$col++;

			$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($ph,2,true))/100,$fmt_perc);
			$col++;

			if($tipo_desc=='T'){
				$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($trig,2,true))/100,$fmt_perc);
				$col++;
			}else if($tipo_desc=='G'){
				$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($trans,2,true))/100,$fmt_perc);
				$col++;
			}else if($tipo_desc=='C'){
				$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe1a,2,true))/100,$fmt_perc);
				$col++;

				$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe1b,2,true))/100,$fmt_perc);
				$col++;

				$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe2,2,true))/100,$fmt_perc);
				$col++;

				$worksheet1->write_number($linha,$col,formata_valor(formata_qtd($classe3,2,true))/100,$fmt_perc);
				$col++;
			}

			if (($tipo_mov_ant==0)&&($tiporel==1)){
				if ($tem_valor_rec){

					$linha++;
					$linha++;

					$col = 3;

					$worksheet1->write_string($linha,$col,'Peso Lquido',$fmt_texto_c_b2);
					$col++;

					$worksheet1->write_string($linha,$col,'Total Recepo',$fmt_texto_c_b2);
					$col++;
					$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
					$col++;		
					$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);	

					$linha++;

					$col = 3;
					$worksheet1->write_number($linha,$col,$total_liquido_recepcao,$fmt_qtd);
					$col++;
					
					$worksheet1->write_number($linha,$col,$total_valor_recepcao,$fmt_valor);
					$col++;
					$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
					$col++;		
					$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);

				}else{
					$linha++;
					$linha++;

					$col = 3;
					$worksheet1->set_row($linha, 26.4);
					

					$worksheet1->write_string($linha,$col,'Peso Pago',$fmt_texto_c_b2);
					$col++;


					$worksheet1->write_string($linha,$col,'Total do Desconto Quebra Tcnica, Armazenagem e Beneficiamento',$fmt_texto_c_b2);
					$col++;						
					$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
					$col++;						
					$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
					$col++;
					$worksheet1->merge_cells($linha, $col-3, $linha, $col-1);



					$worksheet1->write_string($linha,$col,'Peso Pago Final',$fmt_texto_c_b2);
					$col++;						
					$worksheet1->write_blank($linha,$col,$fmt_texto_c_b2);
					$col++;
					$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);

					
					$linha++;

					$col = 3;

					// if ($_REQUEST['tipo_rel']!='S'){
					// 	$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_pago.'9:'.$col_quebra_pago.($linha-9).')',$fmt_qtd);
					// }else{
						$worksheet1->write_number($linha,$col,$pPagoF,$fmt_qtd);
					//}
					$col++;
					

					// if ($_REQUEST['tipo_rel']!='S'){
					// 	$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_desc.'9:'.$col_quebra_desc.($linha-9).')',$fmt_qtd);
					// }else{
						$worksheet1->write_number($linha,$col,$quebra_tec,$fmt_qtd);
					//}
					$col++;
					$worksheet1->write_blank($linha,$col,$fmt_qtd);
					$col++;
					$worksheet1->write_blank($linha,$col,$fmt_qtd);
					$col++;
					$worksheet1->merge_cells($linha, $col-3, $linha, $col-1);
					

					// if ($_REQUEST['tipo_rel']!='S'){
					// 	$worksheet1->write_formula($linha,$col,'=SUM('.$col_quebra_final.'9:'.$col_quebra_final.($linha-9).')',$fmt_qtd);
					// }else{
						$worksheet1->write_number($linha,$col,($pPagoF-$quebra_tec),$fmt_qtd);
					//}
					$col++;						
					$worksheet1->write_blank($linha,$col,$fmt_qtd);
					$col++;
					$worksheet1->merge_cells($linha, $col-2, $linha, $col-1);
				}
			}

			$umid = 0;
			$impu = 0;
			$avar = 0;
			$queb = 0;
			$ph = 0;
			$trig = 0;
			$tran = 0;
			$classe_1a = 0;
			$classe_1b = 0;
			$classe2 = 0;
			$classe3 = 0;

			$pPagoPH = 0;
			$pPago = 0;
			$pLiquido = 0;
			$pOrigem = 0;
			$qtd_boletim = 0;

			$umid_perc = 0;
			$impu_perc = 0;
			$avar_perc = 0;
			$queb_perc = 0;
			$ph_perc = 0;
			$trig_perc = 0;
			$trans_percT = 0;
			$classe_1a_perc = 0;
			$classe_1b_perc = 0;
			$classe2_perc = 0;
			$classe3_perc = 0;

			$tot_saldo_produtor = 0;
		}//fim if produto
	}else{
		$worksheet1 =& $workbook->add_worksheet('');
		$worksheet1->write(10,0,"No existem registros para este filtro!");        
	}

	//ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE O DIV NO MOMENTO DE GERAR O EXCEL
	$insert = 'insert into relatorio_tmp ( '.
			  ' Dominio, '.
			  ' Usuario, '.
			  ' Descricao ) values ('.
			  '"'.$_SESSION['Dominio'].'", '.
			  '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
			  '"")';
	consulta_sql($insert);

	consulta_limpa($resultado);
	$workbook->close();
?>