<?
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	session::usr_conectado($_REQUEST['USER_ID']);
	require_once('../../includes/write_excel/Worksheet.php');
	require_once('../../includes/write_excel/Workbook.php');

	function HeaderingExcel($filename) {
		header("Content-type: application/vnd.ms-excel");
		header("Content-Disposition: attachment; filename=$filename" );
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
		header("Pragma: public");
	}

	$hora = nr2hora(hora_atual());
	$hoje = data_atual('data');

	// HTTP headers
	HeaderingExcel('BOLETINS_ARMAZEM.xls');

	// Creating a workbook
	// Creating a workbook
	$workbook = new Workbook("-");

	$dt_ini = $_REQUEST['dt_ini'];
	$dt_fim = $_REQUEST['dt_fim'];
	$empresa = $_REQUEST['empresa'];
	$pessoa = $_REQUEST['pessoa'];
	$produto = $_REQUEST['produto'];
	$tipo_rel = $_REQUEST['tipo_rel'];

	$saldo_armazem = array();

	$consulta = 'select * from boletim_pesagem '.
				' Where Dominio = "'.$_SESSION['Dominio'].'"'.
				' and DH_PesoFim >="'.datad($dt_ini).'"'.
				' and DH_PesoFim <="'.datad($dt_fim).' 23:59:59"'.
				' and Id_Produto > 0 '.
				' and PesoPago > 0 '.
				' and Pessoa = "'.$pessoa.'"'.
				' and Tipo = "0" '.
				' and ((Situacao = "F") or (Situacao = "P"))';
	$filtro = 'Perodo: De "'.$dt_ini.'" At "'.$dt_fim.'"';

	$con_pess = 'select Pessoa, Nome_Listas from pessoa '.
				' where Dominio = "'.$_SESSION['Dominio'].'" '.
				' and Pessoa = "'.$pessoa.'" '.
				' and Situacao <> "E" ';
	$res_pess = consulta_sql($con_pess);
	$reg_pess = consulta_ler_linha($res_pess);
	consulta_limpa($res_pess);

	if($empresa!=''){
		$consulta.= ' and Empresa = "'.$empresa.'"';
		$con_empre ='select Pessoa, Nome_Listas from pessoa '.
					' where Dominio = "'.$_SESSION['Dominio'].'" '.
					' and Pessoa = "'.$_REQUEST['empresa'].'" '.
					' and Situacao <> "E" '.
					' order by Nome_Listas';
		$res_empre = consulta_sql($con_empre);
		$reg_empre = consulta_ler_linha($res_empre);
		consulta_limpa($res_empre);
		$filtro.= ' Empresa: "'.$empresa.'-'.$reg_empre[1].'"';
	}

	$filtro_prod = '';
	$retido = 0;
	$tipo_trigo = true;
	$tipo_avariado = false;
	if($produto!=''){
		$consulta.= ' and Id_Produto = "'.$produto.'"';
		$con_prod = 'select Codigo_Produto, Descricao_Curta, Descricao_Completa, Retencao_Tecnica, Codigo_Grupo from produto '.
					' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					' and Id_Produto = "'.$produto.'"';
		$res_prod = consulta_sql($con_prod);
		$reg_prod = consulta_ler_linha($res_prod);
		consulta_limpa($res_prod);
		$retido = $reg_prod[3];
		
		$tipo_trigo = ($reg_prod[4]==3);
		$tipo_avariado = (($produto==9950)||($produto==10066));//($produto==9950);
		$filtro.= ' Produto: "'.$reg_prod[0].'-'.$reg_prod[1].'"';
		$filtro_prod = ''.$reg_prod[2].'';
	}

	$consulta.= ' order by Tipo, DH_PesoFim, Nr_Boletim';

	// Format for the headings
	$formatot =& $workbook->add_format();
	$formatot->set_size(8);
	$formatot->set_align('center');
	$formatot->set_bold(1);

	// Format for the headings
	$formatott =& $workbook->add_format();
	$formatott->set_align('center');
	$formatott->set_pattern();
	$formatott->set_fg_color(40);
	$formatott->set_bold(1);
	$formatott->set_border(1);
	$formatott->set_size(8);

	// Format for the headings
	$formatottl =& $workbook->add_format();
	$formatottl->set_align('left');
	$formatottl->set_pattern();
	$formatottl->set_fg_color(40);
	$formatottl->set_bold(1);
	$formatottl->set_size(8);

	// Format for the headings
	$formatottc =& $workbook->add_format();
	$formatottc->set_align('center');
	$formatottc->set_bold(1);
	$formatottc->set_border(1);
	$formatottc->set_size(8);

	$formatottnr =& $workbook->add_format();
	$formatottnr->set_border(1);
	$formatottnr->set_align('right');
	$formatottnr->set_bold(1);
	$formatottnr->set_pattern();
	$formatottnr->set_fg_color(40);
	$formatottnr->set_num_format('#,##0_);-#,##0_)');
	$formatottnr->set_size(8);

	// Format for the headings
	$formatotl =& $workbook->add_format();
	$formatotl->set_border(1);
	$formatotl->set_align('left');
	$formatotl->set_size(8);

	// Format for the headings
	$formatotr =& $workbook->add_format();
	$formatotr->set_border(1);
	$formatotr->set_align('right');
	$formatotr->set_size(8);

	// Format for the headings
	$formatotc =& $workbook->add_format();
	$formatotc->set_border(1);
	$formatotc->set_align('center');
	$formatotc->set_size(8);

	// Format for the headings
	$formatotqtd =& $workbook->add_format();
	$formatotqtd->set_border(1);
	$formatotqtd->set_align('right');
	$formatotqtd->set_num_format('#,##0_);-#,##0_)');
	$formatotqtd->set_size(8);

	// Format for the headings
	$formatotqtd_res =& $workbook->add_format();
	$formatotqtd_res->set_align('center');
	$formatotqtd_res->set_num_format('#,##0_);-#,##0_)');
	$formatotqtd_res->set_size(10);
	$formatotqtd_res->set_bold(1);

	$formatotqtd_res_dec =& $workbook->add_format();
	$formatotqtd_res_dec->set_align('center');
	$formatotqtd_res_dec->set_num_format('#,##0.00_);-#,##0.00_)');
	$formatotqtd_res_dec->set_size(10);
	$formatotqtd_res_dec->set_bold(1);

	// Format for the headings
	$formatotqtdl =& $workbook->add_format();
	$formatotqtdl->set_align('right');
	$formatotqtdl->set_fg_color(40);
	$formatotqtdl->set_num_format('#,##0.00_);-#,##0.00_)');
	$formatotqtdl->set_bold(1);
	$formatotqtdl->set_size(8);

	// Format for the headings
	$formatotrr =& $workbook->add_format();
	$formatotrr->set_align('right');
	$formatotrr->set_pattern();
	$formatotrr->set_fg_color(40);
	$formatotrr->set_bold(1);
	$formatotrr->set_border(1);
	$formatotrr->set_size(8);

	$formatotnc =& $workbook->add_format();
	$formatotnc->set_border(1);
	$formatotnc->set_align('center');
	$formatotnc->set_num_format('#,##0.00_);-#,##0.00_)');
	$formatotnc->set_size(8);

	$formato_nv =& $workbook->add_format();
	$formato_nv->set_align('center');
	$formato_nv->set_pattern();
	$formato_nv->set_fg_color(50);
	$formato_nv->set_color('white');
	$formato_nv->set_bold(1);
	$formato_nv->set_border(1);

	// Format for the headings
	$formatov =& $workbook->add_format();
	$formatov->set_align('center');
	$formatov->set_size(8);
	/*
	// Format for the headings
	$formato_rodape_c =& $workbook->add_format();
	$formato_rodape_c->set_align('center');
	$formato_rodape_c->set_size(8);
	$formato_rodape_c->set_color('red');
	$formato_rodape_c->set_bold(1);
	$formato_rodape_c->set_border(2);

	// Format for the headings
	$formato_rodape_r =& $workbook->add_format();
	$formato_rodape_r->set_align('right');
	$formato_rodape_r->set_size(8);
	$formato_rodape_r->set_color('red');
	$formato_rodape_r->set_bold(1);
	$formato_rodape_r->set_border(2);
	*/

	//Aba de Entradas
	$titulo_sheet = 'Entrada';
	$worksheet1 =& $workbook->add_worksheet($titulo_sheet);
	$worksheet1->write_string(0,0,'RELATRIO DE BOLETINS - ENTRADA',$formatot);
	$worksheet1->merge_cells(0,0,1,14);
	$worksheet1->write(2,0,config_pad('sistema_licenca'));
	$worksheet1->write(3,0,"Data: ".$hoje." - Hora: ".$hora);
	$worksheet1->write(3,4,"Usurio: ".base64_decode($_REQUEST['USER_ID']));
	//$worksheet1->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));
	//$worksheet1->merge_cells(6, 0, 3, 19);
	$worksheet1->write(5,0,"Filtro: ".$filtro);
	$worksheet1->write_string(7,0,'Entrada de '.$filtro_prod);
	$worksheet1->merge_cells(7,0,7,4);
	//if($produto!=''){
	//   $worksheet1->write_string(7,5,'Reteno:');
	//   $worksheet1->merge_cells(7,5,7,6);
	//   $worksheet1->write_number(7,7,$retido,$formatotqtd_res_dec);
	//}

	$worksheet1->insert_bitmap(6,12,busca_imagem_empresa('logo_menu.bmp', '../../'),0,0,1.23,0.76);

	$resultado = consulta_sql($consulta);
	$nrows = consulta_num_registros($resultado);

	$linha_ini = 10;
	$coluna =0;

	$worksheet1->set_column($coluna,$coluna,8);
	$worksheet1->write_string($linha_ini,$coluna,'DATA',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'BOLETIM',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'NF',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'PLACA',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'PESO ORIG.',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,6);
	$worksheet1->write_string($linha_ini,$coluna,'UMID.',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,6);
	$worksheet1->write_string($linha_ini,$coluna,'DESC.',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,6);
	$worksheet1->write_string($linha_ini,$coluna,'IMP.',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,6);
	$worksheet1->write_string($linha_ini,$coluna,'DESC.',$formatott);
	$coluna++;

	if ($tipo_avariado){
		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'AVAR.',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'DESC.',$formatott);
		$coluna++;
	}else if ($tipo_trigo){
		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'TRIG.',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'DESC.',$formatott);
		$coluna++;
	}else{
		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'GMO',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'DESC.',$formatott);
		$coluna++;
	}

	if (!$tipo_avariado){
		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'PH',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'DESC.',$formatott);
		$coluna++;
	}else{
		/*
		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,6);
		$worksheet1->write_string($linha_ini,$coluna,'',$formatott);
		$coluna++;
		*/
	}

	$worksheet1->set_column($coluna,$coluna,25);
	$worksheet1->write_string($linha_ini,$coluna,'ARMAZM',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'PESO LIQ.',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'PESO PAGO',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'DIF',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'Perc. RET.',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'RETENO',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,10);
	$worksheet1->write_string($linha_ini,$coluna,'PES. DISP',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,25);
	$worksheet1->write_string($linha_ini,$coluna,'OBS',$formatott);
	$coluna++;

	$contE = 0;
	$desc_nf = '';

	$total_peso_origE = 0;
	$total_peso_liqE = 0;
	$total_difE = 0;
	$total_retencaoE = 0;
	$total_peso_dispE = 0;

	for($b=0;$b<$nrows;$b++){
		$registro = consulta_ler_objeto($resultado);

		//if($registro->Tipo==0){
		//if(($registro->Tipo=='0')&&($registro->Pessoa>100)){
		//trabalha com $worksheet1
		$contE++;

		$linha_ini++;
		$colunaE = 0;

		//Data
		$worksheet1->write_string($linha_ini,$colunaE,dataf($registro->DH_PesoFim),$formatotc);
		$colunaE++;

		//Boletim
		$worksheet1->write_string($linha_ini,$colunaE,$registro->Nr_Boletim,$formatotc);
		$colunaE++;

		if($registro->NF_Produtor_Outros!=''){
			$desc_nf = $registro->NF_Produtor_Nr.', '.$registro->NF_Produtor_Outros;
		}else{
			$desc_nf = $registro->NF_Produtor_Nr;
		}
		//Nr NF
		$worksheet1->write_string($linha_ini,$colunaE,$desc_nf,$formatotc);
		$colunaE++;

		//Placa
		$worksheet1->write_string($linha_ini,$colunaE,$registro->Placa,$formatotc);
		$colunaE++;

		//Peso Origem
		$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoOrigem,$formatotqtd);
		$colunaE++;

		//Umidade
		if($registro->Umidade_Perc<=0){
			$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
		}else{
			$worksheet1->write_number($linha_ini,$colunaE,$registro->Umidade_Perc,$formatotnc);
		}
		$colunaE++;
		//Umidade
		if($registro->Umidade_Desc<=0){
			$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
		}else{
			$worksheet1->write_number($linha_ini,$colunaE,$registro->Umidade_Desc,$formatotqtd);
		}
		$colunaE++;

		//Impureza Percentual
		if($registro->Impureza_Perc<=0){
			$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
		}else{
			$worksheet1->write_number($linha_ini,$colunaE,$registro->Impureza_Perc,$formatotnc);
		}
		$colunaE++;
		//Impureza
		if($registro->Impureza_Desc<=0){
			$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
		}else{
			$worksheet1->write_number($linha_ini,$colunaE,$registro->Impureza_Desc,$formatotqtd);
		}
		$colunaE++;
		if ($tipo_avariado){
			//Avariado Percentual
			if($registro->Avariado_Perc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Avariado_Perc,$formatotnc);
			}
			$colunaE++;
			//Triguilho
			if($registro->Avariado_Desc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Avariado_Desc,$formatotqtd);
			}
			$colunaE++;
		}else if ($tipo_trigo){
			//Triguilho Percentual
			if($registro->Triguilho_Perc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Triguilho_Perc,$formatotnc);
			}
			$colunaE++;
			//Triguilho
			if($registro->Triguilho_Desc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Triguilho_Desc,$formatotqtd);
			}
			$colunaE++;
		}else{
			//GMO Percentual
			if($registro->Transgenico_Perc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Transgenico_Perc,$formatotnc);
			}
			$colunaE++;
			//GMO
			if($registro->Transgenico_Desc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Transgenico_Desc,$formatotqtd);
			}
			$colunaE++;
		}
		if (!$tipo_avariado){
			//PH Percentual
			if($registro->pH_Perc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->pH_Perc,$formatotnc);
			}
			$colunaE++;
			
			if($registro->pH_Desc<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->pH_Desc,$formatotqtd);
			}
			$colunaE++;
			
		}else{
			//PH Percentual
			/*$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
			$colunaE++;

			$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
			$colunaE++;*/
		}

		$con_celula='select * from boletim_pesagem_celula '.
					' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					' and Empresa ="'.$registro->Empresa.'"'.
					' and Nr_Boletim ="'.$registro->Nr_Boletim.'"'.
					' order by Codigo_Armazem, Codigo_Celula';
		$res_celula = consulta_sql($con_celula);
		$nrw_celula = consulta_num_registros($res_celula);
		if ($nrw_celula<=1){
			if ($nrw_celula==0){
				//Observacao
				if (!isset($saldo_armazem['0;0'])){
					$saldo_armazem['0;0']['Nome'] = 'Armazm/Celula No Definido';
					$saldo_armazem['0;0']['Qtd'] = 0;
					$saldo_armazem['0;0']['Transf'] = 0;
					$saldo_armazem['0;0']['Saida'] = 0;
				}
				$saldo_armazem['0;0']['Qtd']+=$registro->PesoPago;

				$worksheet1->write_string($linha_ini,$colunaE,'Armazm/Celula No Definido',$formatotc);
				$colunaE++;

				//Peso Liquido
				$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoLiquido,$formatotqtd);
				$colunaE++;

				//Peso Pago
				$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoPago,$formatotqtd);
				$colunaE++;
			}else{
				$reg_celula = consulta_ler_objeto($res_celula);

				$cons_armazem = 'select Nome_Armazem from armazem '.
								' where Dominio = "'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"';
				$res_armazem = consulta_sql($cons_armazem);
				$reg_armazem = consulta_ler_linha($res_armazem);
				consulta_limpa($res_armazem);

				$cons_dscelula ='select Codigo_Celula, Descricao from armazem_celula '.
								' where Dominio="'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"'.
								' and Codigo_Celula = "'.$reg_celula->Codigo_Celula.'"';
				$res_dscelula = consulta_sql($cons_dscelula);
				$reg_dscelula = consulta_ler_linha($res_dscelula);
				consulta_limpa($res_dscelula);

				$nm_armazem = $reg_armazem[0].' - Clula: '.$reg_dscelula[1];

				if (!isset($saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula])){
					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Nome'] = $nm_armazem;
					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Qtd'] = 0;
					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Saida'] = 0;

					$con_transf='select sum(PesoPago) from armazem_historico_mov_fornec '.
								' where Dominio="'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"'.
								' and Codigo_Celula = "'.$reg_celula->Codigo_Celula.'"'.
								' and Nr_Boletim=0 '.
								' and Data  >="'.datad($dt_ini).'"'.
								' and Data  <="'.datad($dt_fim).'"'.
								' and Pessoa = "'.$pessoa.'"'.
								' and Id_Produto="'.$produto.'"';
					$res_transf = consulta_sql($con_transf);
					$reg_transf = consulta_ler_linha($res_transf);
					consulta_limpa($res_transf);

					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Transf'] = $reg_transf[0];
				}
				$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Qtd']+=$registro->PesoPago;

				$worksheet1->write_string($linha_ini,$colunaE,$nm_armazem,$formatotc);
				$colunaE++;

				//Peso Liquido
				$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoLiquido,$formatotqtd);
				$colunaE++;

				//Peso Pago
				$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoPago,$formatotqtd);
				$colunaE++;
			}

			//DIF
			//$worksheet1->write_number($linha_ini,$colunaE,($registro->PesoOrigem-$registro->PesoLiquido),$formatotqtd);
			if (!$tipo_avariado){
				$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(O'.($linha_ini+1).'-E'.($linha_ini+1).')',$formatotqtd);
				$colunaE++;
			}else{
				$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(M'.($linha_ini+1).'-E'.($linha_ini+1).')',$formatotqtd);
				$colunaE++;
			}
			if($registro->Perc_Retencao<=0){
				$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
			}else{
				$worksheet1->write_number($linha_ini,$colunaE,$registro->Perc_Retencao,$formatotnc);
			}
			$colunaE++;
			if (!$tipo_avariado){
				//Reteno
				$worksheet1->write_formula($linha_ini,$colunaE,'=ROUND(SUM(P'.($linha_ini+1).'*R'.($linha_ini+1).'/100);0)',$formatotqtd);
				//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoDesconto,$formatotqtd); //desconto
				$colunaE++;

				//Peso Pago
				$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(P'.($linha_ini+1).'-S'.($linha_ini+1).')',$formatotqtd);
				//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoPago,$formatotqtd);
				$colunaE++;
			}else{
				//Reteno
				$worksheet1->write_formula($linha_ini,$colunaE,'=ROUND(SUM(N'.($linha_ini+1).'*P'.($linha_ini+1).'/100);0)',$formatotqtd);
				//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoDesconto,$formatotqtd); //desconto
				$colunaE++;

				//Peso Pago
				$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(N'.($linha_ini+1).'-Q'.($linha_ini+1).')',$formatotqtd);
				//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoPago,$formatotqtd);
				$colunaE++;
			}

			$worksheet1->write_string($linha_ini,$colunaE, $registro->Observacao,$formatotl);
			$colunaE++;
		}else{
			$total_celula = 0;
			for($cel=0;$cel<$nrw_celula;$cel++){
				$reg_celula = consulta_ler_objeto($res_celula);
				if ($cel!=0){
					$colunaE = 0;
					$linha_ini++;
					for($lnE_cel=0;$lnE_cel<=8;$lnE_cel++){
						$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
						$colunaE++;
					}
				}

				$cons_armazem = 'select Nome_Armazem from armazem '.
								' where Dominio = "'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"';
				$res_armazem = consulta_sql($cons_armazem);
				$reg_armazem = consulta_ler_linha($res_armazem);
				consulta_limpa($res_armazem);

				$cons_dscelula ='select Codigo_Celula, Descricao from armazem_celula '.
								' where Dominio="'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"'.
								' and Codigo_Celula = "'.$reg_celula->Codigo_Celula.'"';
				$res_dscelula = consulta_sql($cons_dscelula);
				$reg_dscelula = consulta_ler_linha($res_dscelula);
				consulta_limpa($res_dscelula);

				$nm_armazem = $reg_armazem[0].' - Clula: '.$reg_dscelula[1];

				if (!isset($saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula])){
					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Nome']  = $nm_armazem;
					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Qtd']   = 0;
					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Saida'] = 0;

					$con_transf='select sum(PesoPago) from armazem_historico_mov_fornec '.
								' where Dominio="'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"'.
								' and Codigo_Celula = "'.$reg_celula->Codigo_Celula.'"'.
								' and Nr_Boletim=0 '.
								' and Data  >="'.datad($dt_ini).'"'.
								' and Data  <="'.datad($dt_fim).'"'.
								' and Pessoa = "'.$pessoa.'"'.
								' and Id_Produto="'.$produto.'"';
					$res_transf = consulta_sql($con_transf);
					$reg_transf = consulta_ler_linha($res_transf);
					consulta_limpa($res_transf);

					$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Transf'] = $reg_transf[0];
				}
				$saldo_armazem[$reg_celula->Codigo_Armazem.';'.$reg_celula->Codigo_Celula]['Qtd']+=$reg_celula->PesoPago;

				$worksheet1->write_string($linha_ini,$colunaE,$nm_armazem,$formatotc);
				$colunaE++;

				//Peso Liquido
				$worksheet1->write_number($linha_ini,$colunaE,$reg_celula->PesoPago,$formatotqtd);
				$colunaE++;

				//Peso Liquido
				$worksheet1->write_number($linha_ini,$colunaE,$reg_celula->PesoPago,$formatotqtd);
				$colunaE++;

				$total_celula+=$reg_celula->PesoPago;
				if ($cel==($nrw_celula-1)){
					//DIF
					//$worksheet1->write_number($linha_ini,$colunaE,($registro->PesoOrigem-$registro->PesoLiquido),$formatotqtd);
					$worksheet1->write_number($linha_ini,$colunaE,($total_celula-$registro->PesoOrigem),$formatotqtd);
					$colunaE++;
				}else{
					$worksheet1->write_blank($linha_ini,$colunaE,$formatotqtd);
					$colunaE++;
				}

				if($registro->Perc_Retencao<=0){
					$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
				}else{
					$worksheet1->write_number($linha_ini,$colunaE,$registro->Perc_Retencao,$formatotnc);
				}
				$colunaE++;
				if (!$tipo_avariado){
					//Reteno
					$worksheet1->write_formula($linha_ini,$colunaE,'=ROUND(SUM(P'.($linha_ini+1).'*R'.($linha_ini+1).'/100);0)',$formatotqtd);
					//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoDesconto,$formatotqtd); //desconto
					$colunaE++;

					//Peso Pago
					$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(P'.($linha_ini+1).'-S'.($linha_ini+1).')',$formatotqtd);
					//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoPago,$formatotqtd);
					$colunaE++;
				}else{
					//Reteno
					$worksheet1->write_formula($linha_ini,$colunaE,'=ROUND(SUM(N'.($linha_ini+1).'*P'.($linha_ini+1).'/100);0)',$formatotqtd);
					//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoDesconto,$formatotqtd); //desconto
					$colunaE++;

					//Peso Pago
					$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(N'.($linha_ini+1).'-Q'.($linha_ini+1).')',$formatotqtd);
					//$worksheet1->write_number($linha_ini,$colunaE,$registro->PesoPago,$formatotqtd);
					$colunaE++;
				}
				$worksheet1->write_string($linha_ini,$colunaE, $registro->Observacao,$formatotl);
				$colunaE++;
			}
		}
		consulta_limpa($res_celula);

		$total_peso_origE+= $registro->PesoOrigem;
		$total_peso_liqE+= $registro->PesoLiquido;
		$total_difE+= ($registro->PesoOrigem-$registro->PesoLiquido);
		$total_retencaoE+= $registro->PesoDesconto;
		$total_peso_dispE+= $registro->PesoPago;
	}
	consulta_limpa($resultado);

	$linha_ini++;
	$colunaE=0;
	$qtd=15;
	if ($tipo_avariado){
		$qtd=14;
	}
	for($lnE=0;$lnE<=$qtd;$lnE++){
		$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
		$colunaE++;
	}

	$linha_ini++;
	$colunaE=0;

	//TOTAL ABA ENTRADA
	$worksheet1->write_string($linha_ini,$colunaE,'TOTAL',$formatott);
	$colunaE++;
	$worksheet1->write_string($linha_ini,$colunaE,$contE.' Carga(s)',$formatotrr);
	$colunaE++;
	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;
	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;
	//$worksheet1->write_number($linha_ini,$colunaE,$total_peso_origE,$formatottnr);
	$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(E12:E'.($linha_ini).')',$formatottnr);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;
	$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(G12:G'.($linha_ini).')',$formatottnr);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;
	$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(I12:I'.($linha_ini).')',$formatottnr);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;
	$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(K12:K'.($linha_ini).')',$formatottnr);
	$colunaE++;
	if (!$tipo_avariado){
		$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
		$colunaE++;
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(M12:M'.($linha_ini).')',$formatottnr);
		$colunaE++;
	}
	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;
	if (!$tipo_avariado){
		//$worksheet1->write_number($linha_ini,$colunaE,$total_peso_liqE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(O12:O'.($linha_ini).')',$formatottnr);
		$colunaE++;
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(P12:P'.($linha_ini).')',$formatottnr);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_difE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(Q12:Q'.($linha_ini).')',$formatottnr);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_retencaoE,$formatottnr);
		$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_retencaoE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(S12:S'.($linha_ini).')',$formatottnr);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_peso_dispE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(T12:T'.($linha_ini).')',$formatottnr);
		$colunaE++;
	}else{
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(M12:M'.($linha_ini).')',$formatottnr);
		$colunaE++;
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(N12:N'.($linha_ini).')',$formatottnr);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_peso_liqE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(O12:O'.($linha_ini).')',$formatottnr);
		$colunaE++;

		//$worksheet1->write_number($linha_ini,$colunaE,$total_retencaoE,$formatottnr);
		$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_retencaoE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(Q12:Q'.($linha_ini).')',$formatottnr);
		$colunaE++;
		//$worksheet1->write_number($linha_ini,$colunaE,$total_difE,$formatottnr);
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(R12:R'.($linha_ini).')',$formatottnr);
		$colunaE++;
	}

	$worksheet1->write_blank($linha_ini,$colunaE,$formatott);
	$colunaE++;

	$linha_entrada = $linha_ini;

	$linha_ini++;
	$linha_ini++;
	$colunaE=1;

	$worksheet1->write_string($linha_ini,$colunaE,'Reteno:',$formatottc);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatottc);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatottc);
	$colunaE++;
	$worksheet1->merge_cells($linha_ini,1,$linha_ini,3);
	if (!$tipo_avariado){
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(R'.($linha_ini-1-2).')',$formatotnc);
	}else{
		$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(P'.($linha_ini-1-2).')',$formatotnc);
	}
	$colunaE++;

	$linha_ini++;
	$linha_ini++;
	$colunaE=1;

	$worksheet1->write_string($linha_ini,$colunaE,'Total de Cargas recebidas:',$formatottc);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatottc);
	$colunaE++;

	$worksheet1->write_blank($linha_ini,$colunaE,$formatottc);
	$colunaE++;
	$worksheet1->merge_cells($linha_ini,1,$linha_ini,3);

	//$worksheet1->write_number($linha_ini,$colunaE,$total_nf_quant,$formatotqtd);
	$worksheet1->write_string($linha_ini,$colunaE,$contE,$formatotqtd);
	$colunaE++;  

	$colunaE = 0;
	$linha_ini++;
	$linha_ini++;

	$linha_base_remessas = $linha_ini;

	$worksheet1->write_string($linha_ini,$colunaE,'Notas de Remessa',$formatottc);
	$colunaE++;
	for($ln=1;$ln<=2;$ln++){
		$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
		$colunaE++;
	}
	$worksheet1->merge_cells($linha_ini,0,$linha_ini,2);

	$colunaE = 0;
	$linha_ini++;

	$worksheet1->write_string($linha_ini,$colunaE,'Emisso',$formatottc);
	$colunaE++;

	$worksheet1->write_string($linha_ini,$colunaE,'Nmero',$formatottc);
	$colunaE++;

	$worksheet1->write_string($linha_ini,$colunaE,'Quantidade',$formatottc);
	$colunaE++;

	//$colunaE = 0;
	//$linha_ini++;

	$cons_n='SELECT '.
			' nf.DH_Emissao, '.
			' nf.Nr_Boletim_Pesagem, '.
			' nf.NrDoc, '.
			' nf.Serie, '.
			' nf.Modelo, '.
			' nf.Veiculo_Placa, '.
			' (nfi.Quantidade_Estoque * 1000) Peso_Liquido '.
			' FROM nota_fiscal nf '.
			' INNER JOIN nota_fiscal_item nfi '.
			' ON nf.Dominio = nfi.Dominio '.
			' AND nf.Empresa = nfi.Empresa '.
			' AND nf.Nr_Nota = nfi.Nr_Nota '.
			' WHERE nf.Dominio = "'.$_SESSION['Dominio'].'" '.
			' AND nf.Destinatario = "'.$pessoa.'" '.
			' AND nf.TipoES = "0" '.
			' and nf.Situacao="F" '.
			' AND nfi.Id_Produto = "'.$produto.'" '.
			' AND (nf.DH_Emissao >= "'.datad($dt_ini).'" '.
			' AND nf.DH_Emissao <= "'.datad($dt_fim).' 23:59:59") ';
	if($empresa!=''){
		$cons_n.= ' and nf.Empresa = "'.$empresa.'"';
	}
	$cons_n.= 'order by nf.DH_Emissao, nf.NrDoc, nf.Empresa, nf.Nr_Nota';
	$res_n = consulta_sql($cons_n);
	$nrows_n = consulta_num_registros($res_n);

	$total_nf_quant = 0;

	for($n=0;$n<$nrows_n;$n++){
		$reg_n = consulta_ler_objeto($res_n);

		$linha_ini++;
		$colunaE = 0;

		$worksheet1->write_string($linha_ini,$colunaE,dataf($reg_n->DH_Emissao),$formatotc);
		$colunaE++;

		$worksheet1->write_string($linha_ini,$colunaE,$reg_n->NrDoc.'/'.$reg_n->Serie.'-'.$reg_n->Modelo,$formatotc);
		$colunaE++;

		$worksheet1->write_number($linha_ini,$colunaE,($reg_n->Peso_Liquido*1),$formatotqtd);
		$colunaE++;

		$total_nf_quant+= $reg_n->Peso_Liquido;
	}
	consulta_limpa($res_n);

	$linha_ini++;
	$colunaE=0;
	$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
	$colunaE++;
	$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
	$colunaE++;
	$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
	$colunaE++;

	$linha_ini++;
	$colunaE=0;
	$worksheet1->write_string($linha_ini,$colunaE,'TOTAL',$formatottc);
	$colunaE++;
	$worksheet1->write_blank($linha_ini,$colunaE,$formatotc);
	$colunaE++;
	//$worksheet1->write_number($linha_ini,$colunaE,$total_nf_quant,$formatotqtd);
	$worksheet1->write_formula($linha_ini,$colunaE,'=SUM(C'.($linha_base_remessas+3).':C'.($linha_ini).')',$formatotqtd);
	$colunaE++;

	$linha_remessas = $linha_ini;

	$linha_ini = $linha_base_remessas;

	$worksheet1->write_string($linha_ini,4,'RESTANTE NF',$formatottc);
	$worksheet1->write_blank($linha_ini,5,$formatottc);
	$worksheet1->merge_cells($linha_ini,4,$linha_ini,5);
	$linha_ini++;
	$worksheet1->write_formula($linha_ini,4,'=SUM(E'.($linha_entrada+1).'-C'.($linha_remessas+1).')',$formatotqtd);
	$worksheet1->write_blank($linha_ini,5,$formatotqtd);
	$worksheet1->merge_cells($linha_ini,4,$linha_ini,5);
	$linha_ini++;
	//WORKSHEET 2

	//trabalha com $worksheet2
	//busca dados da nota referenciada ao boletim

	/*
	$cons_nf = 'SELECT nf.DH_Emissao, nf.Nr_Boletim_Pesagem, nf.NrDoc, nf.Veiculo_Placa, nf.Peso_Liquido '.
			   'FROM nota_fiscal nf '.
			   'INNER JOIN boletim_pesagem bp ON nf.Dominio = bp.Dominio '.
			   'AND nf.Empresa = bp.Empresa AND nf.Nr_Boletim_Pesagem = bp.Nr_Boletim '.
			   'WHERE nf.Dominio = "'.$_SESSION['Dominio'].'" '.
			   'AND nf.Destinatario = "'.$pessoa.'" '.
			   'AND (nf.DH_Emissao >= "'.datad($dt_ini).'" AND nf.DH_Emissao <= "'.datad($dt_fim).' 23:59:59") ';
	*/

	$cons_nf =	'SELECT nf.DH_PesoFim, nf.Nr_Boletim, nf.Empresa ,nf.Placa, nf.PesoLiquido '.
				'FROM boletim_pesagem nf '.
				'WHERE nf.Dominio = "'.$_SESSION['Dominio'].'" '.
				'AND nf.Pessoa = "'.$pessoa.'" '.
				'AND nf.Tipo = "1" '.
				'and ((nf.Situacao = "F") or (nf.Situacao = "P")) '.
				'AND nf.Id_Produto = "'.$produto.'" '.
				'AND (nf.DH_PesoFim >= "'.datad($dt_ini).'" AND nf.DH_PesoFim <= "'.datad($dt_fim).' 23:59:59") ';
	if($empresa!=''){
		$cons_nf.= ' and nf.Empresa = "'.$empresa.'"';
	}
	$cons_nf.= ' order by nf.DH_PesoFim, nf.Nr_Boletim';

	$res_nf = consulta_sql($cons_nf);
	$nrows_nf = consulta_num_registros($res_nf);

	$saidas = array();

	for($nf=0;$nf<$nrows_nf;$nf++){
		$reg_nf = consulta_ler_objeto($res_nf);

		$cons_nota ='select Modelo,Serie,NrDoc from nota_fiscal '.
					' where Dominio = "'.$_SESSION["Dominio"].'"'.
					' and Empresa = "'.$reg_nf->Empresa.'"'.
					' and Nr_Boletim_Pesagem = "'.$reg_nf->Nr_Boletim.'"'.
					' and Situacao<>"E" '.
					' and Situacao<>"C"';
		$res_nota = consulta_sql($cons_nota);
		$reg_nota = consulta_ler_objeto($res_nota);
		consulta_limpa($res_nota);

		$nota_fiscal = '';
		if ($reg_nota->NrDoc!=''){
			$nota_fiscal = $reg_nota->NrDoc.'/'.$reg_nota->Serie.'-'.$reg_nota->Modelo;
		}

		$con_celula='select * from boletim_pesagem_celula '.
					' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					' and Empresa ="'.$reg_nf->Empresa.'"'.
					' and Nr_Boletim ="'.$reg_nf->Nr_Boletim.'"'.
					' order by Codigo_Armazem, Codigo_Celula';
		$res_celula = consulta_sql($con_celula);
		$nrw_celula = consulta_num_registros($res_celula);
		if ($nrw_celula<=1){
			if ($nrw_celula==0){
				$nm_armazem = '0-0';
				if (!isset($saidas[$nm_armazem])){
					$saidas[$nm_armazem]['Descricao'] = 'Armazm/Celula No Definido';
					$saidas[$nm_armazem]['Desc_Aba'] = 'Arm. ND';
					$saidas[$nm_armazem]['boletins'] = array();
				}

				$boletim['Boletim'] = $reg_nf->Nr_Boletim;
				$boletim['Data']    = datad(dataf($reg_nf->DH_PesoFim));
				$boletim['Placa']   = $reg_nf->Placa;
				$boletim['Nota']    = $nota_fiscal;
				$boletim['Peso']    = $reg_nf->PesoLiquido;

				$saidas[$nm_armazem]['boletins'][$reg_nf->Empresa.';'.$reg_nf->Nr_Boletim] = $boletim;
			}else{
				$reg_celula = consulta_ler_objeto($res_celula);

				$cons_armazem = 'select Nome_Armazem from armazem '.
								' where Dominio = "'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"';
				$res_armazem = consulta_sql($cons_armazem);
				$reg_armazem = consulta_ler_linha($res_armazem);
				consulta_limpa($res_armazem);

				$cons_dscelula ='select Codigo_Celula, Descricao from armazem_celula '.
								' where Dominio="'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"'.
								' and Codigo_Celula = "'.$reg_celula->Codigo_Celula.'"';
				$res_dscelula = consulta_sql($cons_dscelula);
				$reg_dscelula = consulta_ler_linha($res_dscelula);
				consulta_limpa($res_dscelula);

				$ds_armazem = $reg_armazem[0].' - Clula: '.$reg_dscelula[1];

				$nm_armazem = $reg_celula->Codigo_Armazem.'-'.$reg_celula->Codigo_Celula;
				if (!isset($saidas[$nm_armazem])){
					$saidas[$nm_armazem]['Descricao'] = $ds_armazem;
					$saidas[$nm_armazem]['Desc_Aba'] = $reg_armazem[0].'-'.$reg_celula->Codigo_Celula;
					$saidas[$nm_armazem]['boletins'] = array();
				}

				$boletim['Boletim'] = $reg_nf->Nr_Boletim;
				$boletim['Data']    = datad(dataf($reg_nf->DH_PesoFim));
				$boletim['Placa']   = $reg_nf->Placa;
				$boletim['Nota']    = $nota_fiscal;
				$boletim['Peso']    = $reg_celula->PesoPago;

				$saidas[$nm_armazem]['boletins'][$reg_nf->Empresa.';'.$reg_nf->Nr_Boletim] = $boletim;
			}
		}else{
			$total_celula = 0;
			for($cel=0;$cel<$nrw_celula;$cel++){
				$reg_celula = consulta_ler_objeto($res_celula);

				$cons_armazem = 'select Nome_Armazem from armazem '.
								' where Dominio = "'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"';
				$res_armazem = consulta_sql($cons_armazem);
				$reg_armazem = consulta_ler_linha($res_armazem);
				consulta_limpa($res_armazem);

				$cons_dscelula ='select Codigo_Celula, Descricao from armazem_celula '.
								' where Dominio="'.$_SESSION["Dominio"].'"'.
								' and Empresa = "'.$reg_celula->Empresa.'"'.
								' and Codigo_Armazem = "'.$reg_celula->Codigo_Armazem.'"'.
								' and Codigo_Celula = "'.$reg_celula->Codigo_Celula.'"';
				$res_dscelula = consulta_sql($cons_dscelula);
				$reg_dscelula = consulta_ler_linha($res_dscelula);
				consulta_limpa($res_dscelula);

				$ds_armazem = $reg_armazem[0].' - Clula: '.$reg_dscelula[1];

				$nm_armazem = $reg_celula->Codigo_Armazem.'-'.$reg_celula->Codigo_Celula;
				if (!isset($saidas[$nm_armazem])){
					$saidas[$nm_armazem]['Descricao'] = $ds_armazem;
					$saidas[$nm_armazem]['Desc_Aba'] = $reg_armazem[0].'-'.$reg_celula->Codigo_Celula;
					$saidas[$nm_armazem]['boletins'] = array();
				}

				$boletim['Boletim'] = $reg_nf->Nr_Boletim;
				$boletim['Data']    = datad(dataf($reg_nf->DH_PesoFim));
				$boletim['Placa']   = $reg_nf->Placa;
				$boletim['Nota']    = $nota_fiscal;
				$boletim['Peso']    = $reg_celula->PesoPago;

				$saidas[$nm_armazem]['boletins'][$reg_nf->Empresa.';'.$reg_nf->Nr_Boletim] = $boletim;
			}

		}
		consulta_limpa($res_celula);
	}
	consulta_limpa($res_nf);
	$total_saidas = 0;
	ksort($saidas);
	foreach($saidas as $keys => $valors){
		$titulo_sheet2 = 'Sada - '.$saidas[$keys]['Desc_Aba'];

		$total_prod = 0;
		$key_arma = str_replace('-',';',$keys);
		if (isset($saldo_armazem[$key_arma]['Qtd'])){
			$total_prod = $saldo_armazem[$key_arma]['Qtd'] + $saldo_armazem[$key_arma]['Transf'];
		}else{
			$keys_sperado = explode(';',$key_arma);//$reg_celula->Codigo_Armazem.'-'.$reg_celula->Codigo_Celula;

			$con_transf='select sum(PesoPago) from armazem_historico_mov_fornec '.
						' where Dominio="'.$_SESSION["Dominio"].'"'.
						' and Empresa = "'.$empresa.'"'.
						' and Codigo_Armazem = "'.$keys_sperado[0].'"'.
						' and Codigo_Celula = "'.$keys_sperado[1].'"'.
						' and Nr_Boletim=0 '.
						' and Data  >="'.datad($dt_ini).'"'.
						' and Data  <="'.datad($dt_fim).'"'.
						' and Pessoa = "'.$pessoa.'"'.
						' and Id_Produto="'.$reg_prod[0].'"';
			$res_transf = consulta_sql($con_transf);
			$reg_transf = consulta_ler_linha($res_transf);
			consulta_limpa($res_transf);

			$total_prod = $reg_transf[0];
		}

		$worksheet2 =& $workbook->add_worksheet($titulo_sheet2);
		$worksheet2->write_string(0,0,'RELATRIO DE BOLETINS - SADAS',$formatot);
		$worksheet2->merge_cells(0,0,1,5);
		$worksheet2->write(2,0,"Expedio");
		$worksheet2->write(2,2,"Cdigo: ".$reg_prod[0]);
		$worksheet2->write(3,0,"Cliente: ".$reg_pess[1]);
		$worksheet2->write(4,0,"Armazm: ".$saidas[$keys]['Descricao']);
		$worksheet2->write(5,0,"Quantidade  embarcar:");
		$worksheet2->write_number(5,3,$total_prod,$formatotqtd_res);
		$worksheet2->write(6,0,"Produto: ".$reg_prod[2]);
		//$worksheet2->write_string(7,0,'SADA',$formatott);
		$worksheet2->insert_bitmap(2,4,busca_imagem_empresa('logo_menu.bmp', '../../'),0,0,0.82,0.75);

		//Aba de Sadas
		$linha_iniS = 8;
		$colunaS = 0;

		$worksheet2->set_column($colunaS,$colunaS,4); //Nr
		$worksheet2->write_string($linha_iniS,$colunaS,'',$formatott);
		$colunaS++;

		$worksheet2->set_column($colunaS,$colunaS,8); //Data
		$worksheet2->write_string($linha_iniS,$colunaS,'DATA',$formatott);
		$colunaS++;

		$worksheet2->set_column($colunaS,$colunaS,15); //Boletim
		$worksheet2->write_string($linha_iniS,$colunaS,'BOLETIM',$formatott);
		$colunaS++;

		$worksheet2->set_column($colunaS,$colunaS,15); //Nota Fiscal
		$worksheet2->write_string($linha_iniS,$colunaS,'NOTA FISCAL',$formatott);
		$colunaS++;

		$worksheet2->set_column($colunaS,$colunaS,15); //Placa
		$worksheet2->write_string($linha_iniS,$colunaS,'PLACA',$formatott);
		$colunaS++;

		$worksheet2->set_column($colunaS,$colunaS,15); //Peso Liquido
		$worksheet2->write_string($linha_iniS,$colunaS,'PESO LIQ',$formatott);
		$colunaS++;

		//------------------
		$contS = 0;
		$total_liquidoS = 0;

		$saidas_boletins = $saidas[$keys]['boletins'];
		$linhaDia = 9;
		$dia_antes = '';
		foreach($saidas_boletins as $keyb => $valorb){
			$contS++;

			$linha_iniS++;
			$colunaS = 0;

			$worksheet2->write_string($linha_iniS,$colunaS,$contS,$formatotr);
			$colunaS++;

			//Data
			$worksheet2->write_string($linha_iniS,$colunaS,dataf($saidas_boletins[$keyb]['Data']),$formatotc);
			$colunaS++;

		   //Boletim
			$worksheet2->write_string($linha_iniS,$colunaS,$saidas_boletins[$keyb]['Boletim'],$formatotc);
			$colunaS++;

			//Nota Fiscal
			$worksheet2->write_string($linha_iniS,$colunaS,$saidas_boletins[$keyb]['Nota'],$formatotc);
			$colunaS++;

			//Placa
			$worksheet2->write_string($linha_iniS,$colunaS,$saidas_boletins[$keyb]['Placa'],$formatotc);
			$colunaS++;

			//PesoLiquido
			$worksheet2->write_number($linha_iniS,$colunaS,$saidas_boletins[$keyb]['Peso'],$formatotqtd);
			$colunaS++;

			$total_saidas+= $saidas_boletins[$keyb]['Peso'];

			if($dia_antes!=$saidas_boletins[$keyb]['Data']){
				$linhaDia = $linha_iniS;
			}
			$dia_antes = $saidas_boletins[$keyb]['Data'];
			
			//echo $keys.'-'.$saidas_boletins[$keyb]['Peso'].'<BR>';
			if (isset($saldo_armazem[$key_arma])){
				$saldo_armazem[$key_arma]['Saida']+= $saidas_boletins[$keyb]['Peso'];
			}
		}

		$linha_iniS++;
		$colunaS=0;

		for($lnE=0;$lnE<=5;$lnE++){
			$worksheet2->write_blank($linha_iniS,$colunaS,$formatotc);
			$colunaS++;
		}

		$linha_iniS++;
		$colunaS=0;

		//TOTAIS

		//TOTAL ABA SAIDA
		$worksheet2->write_string($linha_iniS,$colunaS,'TOTAL',$formatott);
		$colunaS++;

		$worksheet2->write_blank($linha_iniS,$colunaS,$formatott);
		$colunaS++;

		$worksheet2->write_string($linha_iniS,$colunaS,$contS.' Notas Fiscais',$formatotrr);
		$colunaS++;
		for($nr2=0;$nr2<=1;$nr2++){
			$worksheet2->write_blank($linha_iniS,$colunaS,$formatott);
			$colunaS++;
		}
		$worksheet2->write_formula($linha_iniS,$colunaS,'=SUM(F10:F'.$linha_iniS.')',$formatottnr);
		$colunaS++;

		$worksheet2->merge_cells($linha_iniS,0,$linha_iniS,1);

		//TOTAIS
		$linha_iniS++;
		$linha_iniS++;
		$colunaS=1;

		$worksheet2->write_string($linha_iniS,$colunaS,'Saldo: ',$formatottc);
		$colunaS++;

		$worksheet2->write_formula($linha_iniS,$colunaS,'=SUM(D6-F'.($linha_iniS-1).')',$formatotqtd);
		$colunaS++;

		$colunaS++;

		$worksheet2->write_string($linha_iniS,$colunaS,'Total do Dia: ',$formatottc);
		$colunaS++;

		$worksheet2->write_formula($linha_iniS,$colunaS,'=SUM(F'.($linhaDia+1).':F'.($linha_iniS-2).')',$formatotqtd);
		$colunaS++;

		$colunaS=1;
		$linha_iniS++;
		$linha_iniS++;

		$worksheet2->write_string($linha_iniS,$colunaS,'Cargas: ',$formatottc);
		$colunaS++;

		$worksheet2->write_formula($linha_iniS,$colunaS,'=SUM(A'.($linha_iniS-5).')',$formatotqtd);
		$colunaS++;
	}

	$linha_ini = $linha_base_remessas;
	$linha_ini++;
	$linha_ini++;
	$linha_ini++;

	$worksheet1->write_string($linha_ini,4,'SALDO FISCAL',$formatottc);
	$worksheet1->write_blank($linha_ini,5,$formatottc);
	$worksheet1->merge_cells($linha_ini,4,$linha_ini,5);
	$linha_ini++;

	$worksheet1->write_formula($linha_ini,4,'=SUM(C'.($linha_remessas+1).'-'.($total_saidas).')',$formatotqtd);
	$worksheet1->write_blank($linha_ini,5,$formatotqtd);
	$worksheet1->merge_cells($linha_ini,4,$linha_ini,5);
	$linha_ini++;

	$linha_ini = $linha_base_remessas;
	if (!$tipo_avariado){
		if (count($saldo_armazem)>0){
			
			$worksheet1->write_string($linha_ini,13,'Armazm/Clula',$formatottc);
			$worksheet1->write_string($linha_ini,14,'Peso Lq.',$formatottc);
			$worksheet1->write_string($linha_ini,15,'Transf.',$formatottc);
			$worksheet1->write_string($linha_ini,16,'Sada',$formatottc);
			$worksheet1->write_string($linha_ini,17,'Saldo',$formatottc);
			$linha_ini++;

			ksort($saldo_armazem);
			foreach($saldo_armazem as $key => $valor){
				$worksheet1->write_string($linha_ini,13,$saldo_armazem[$key]['Nome'],$formatotc);
				$worksheet1->write_number($linha_ini,14,$saldo_armazem[$key]['Qtd'],$formatotqtd);
				$worksheet1->write_number($linha_ini,15,$saldo_armazem[$key]['Transf'],$formatotqtd);
				$worksheet1->write_number($linha_ini,16,$saldo_armazem[$key]['Saida'],$formatotqtd);
				$worksheet1->write_formula($linha_ini,17,'=SUM(O'.($linha_ini+1).'+P'.($linha_ini+1).'-Q'.($linha_ini+1).')',$formatotqtd);
				$linha_ini++;
			}
		}
	}else{
		if (count($saldo_armazem)>0){
			
			$worksheet1->write_string($linha_ini,11,'Armazm/Clula',$formatottc);
			$worksheet1->write_string($linha_ini,12,'Peso Lq.',$formatottc);
			$worksheet1->write_string($linha_ini,13,'Transf.',$formatottc);
			$worksheet1->write_string($linha_ini,14,'Sada',$formatottc);
			$worksheet1->write_string($linha_ini,15,'Saldo',$formatottc);
			$linha_ini++;

			ksort($saldo_armazem);
			foreach($saldo_armazem as $key => $valor){
				$worksheet1->write_string($linha_ini,11,$saldo_armazem[$key]['Nome'],$formatotc);
				$worksheet1->write_number($linha_ini,12,$saldo_armazem[$key]['Qtd'],$formatotqtd);
				$worksheet1->write_number($linha_ini,13,$saldo_armazem[$key]['Transf'],$formatotqtd);
				$worksheet1->write_number($linha_ini,14,$saldo_armazem[$key]['Saida'],$formatotqtd);
				$worksheet1->write_formula($linha_ini,15,'=SUM(M'.($linha_ini+1).'+N'.($linha_ini+1).'-O'.($linha_ini+1).')',$formatotqtd);
				$linha_ini++;
			}
		}
	}

	//ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE O DIV NO MOMENTO DE GERAR O EXCEL
	$insert='insert into relatorio_tmp ( '.
			' Dominio, '.
			' Usuario, '.
			' Descricao ) values ('.
			'"'.$_SESSION['Dominio'].'", '.
			'"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
			'"")';
	consulta_sql($insert);

	$workbook->close();
?>