<?
    require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
    session::usr_conectado($_REQUEST['USER_ID']);
    require_once('../../includes/write_excel/Worksheet.php');
    require_once('../../includes/write_excel/Workbook.php');

    function HeaderingExcel($filename) {
		header("Content-type: application/vnd.ms-excel");
		header("Content-Disposition: attachment; filename=$filename" );
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
		header("Pragma: public");
    }

    $dominios = array();
    $dominios['71'] = '71';

    $hora = nr2hora(hora_atual());
    $hoje = data_atual('data');
    $label = label_vendedor_ou_rep_comercial('S');
    // HTTP headers
    HeaderingExcel('CONTAS_RECEBER.xls');

    // Creating a workbook
    $workbook = new Workbook("-");
    // Creating the first worksheet
    $titulo_sheet = 'CONTAS A RECEBER';
    $worksheet1 =& $workbook->add_worksheet($titulo_sheet);

    // Format for the headings
    $formatot =& $workbook->add_format();
    $formatot->set_size(18);

    $formatost =& $workbook->add_format();
    $formatost->set_size(14);

    $worksheet1->write_string(0,0,'RELATRIO DE CONTAS A RECEBER',$formatot);
    $worksheet1->write(3,0,config_pad('sistema_licenca'));
    $worksheet1->write(4,0,"Data: ".$hoje." - Hora: ".$hora);
    $worksheet1->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

    $filtro = '';

    $empresa = $_REQUEST['empresa'];
    $cliente = $_REQUEST['pessoa'];
    $familia = $_REQUEST['familia'];
    $fam_grupo = $_REQUEST['fam_grupo'];
    $vendedor = $_REQUEST['vendedor'];
    $tipo_data = $_REQUEST['tipo_data'];
    $tipo_data_ini = $_REQUEST['tipo_data_ini'];
    $tipo_data_fim = $_REQUEST['tipo_data_fim'];
    $valor_ini = $_REQUEST['valor_ini'];
    $valor_fim = $_REQUEST['valor_fim'];
    $nome_parcial = $_REQUEST['nome_parcial'];
    $situacao = $_REQUEST['situacao'];
    $modelo = $_REQUEST['modelo'];
    $serie = $_REQUEST['serie'];
    $nr_fatura = $_REQUEST['nr_fatura'];
    $tipo_emissao = $_REQUEST['tipo_emissao'];
    $adianta = $_REQUEST['adianta'];
    $cheques = $_REQUEST['cheques'];
    $agrupado = $_REQUEST['agrupado'];
    $grupo = $_REQUEST['grupo'];
    $contrato = $_REQUEST['contrato'];
    $antecipacao = $_REQUEST['antecipacao'];
    $aceite = $_REQUEST['aceite'];
    $banco_envio = $_REQUEST['banco_envio'];
    $AceiteConfere = $_REQUEST['AceiteConfere'];
	$procuracao = $_REQUEST['procuracao'];
	

    /* if($grupo == ''){
       $grupo = 'C';
    } */

    if (isset($_REQUEST['observ'])){
		$observ = $_REQUEST['observ'];
    }else{
		$observ = 'S';
    }
    if (isset($_REQUEST['tp_receb'])){
		$tp_receb = $_REQUEST['tp_receb'];
    }else{
		$tp_receb = '';
    }

    $uf = $_REQUEST['uf'];
    $cidade = $_REQUEST['cidade'];
    $itens = $_REQUEST['itens'];

    $correcao_data = $_REQUEST['correcao_data'];
    $correcao_juros = $_REQUEST['correcao_juros'];

    $vendedor_origem = $_REQUEST['vend_origem'];

    if($vendedor!=''){
		if($vendedor_origem=='C'){
			$inner_vendedor = 'inner join pessoa_cliente pes_cli on '.
                            'pes.Dominio = pes_cli.Dominio '.
                            'and pes.Pessoa = pes_cli.Pessoa';
		}else{
			$inner_vendedor = '';
		}
    }else{
		$inner_vendedor = '';
    }

	if ($banco_envio!=''){
		$inner_vendedor.=' left outer join banco_envio_det det '.
						' on det.Contas_Empresa=cp.Empresa'.
						' and det.Contas_Nr_Contas=cp.Nr_Contas'.
						' and det.Contas_Seq=cp.Seq';
	}

    $meio_pagto = $_REQUEST['meio_pagto'];
    $forma_pagto_contas = $_REQUEST['forma_pagto_contas'];

    $consulta = 'select cp.Nr_Doc, cp.Modelo, cp.Serie, cp.Pessoa, cp.Parcela, cp.DT_Vencto, cp.DH_Baixa, cp.DT_Pagto, '.
                ' cp.Valor, cp.Valor_Desconto, cp.Valor_Acrescimo, cp.Valor_Liquido, cp.Valor_Pago, '.
                ' cp.Empresa, cp.Vendedor, cp.Tipo_Docto, pes.Nome_Razao, cp.Observacao, cp.Contrato, cp.DH_Criacao, '.
                ' cp.Nr_Contas, cp.Seq, cp.PRC, cp.PRC_DT, cp.Adiantado, '.
                ' cp.Forma_Pagto_Contas, pes.CPF_CNPJ, cp.Nr_Nota, cp.UsuarioCriacao, '.
				' cp.Finalizadora, cp.Banco_Conta, cp.Situacao, '.
				' cp.Boleto_Banco, cp.Boleto_NrAgencia, cp.Boleto_NrConta,'.
				' cp.Boleto_Barra, cp.Boleto_Envio from contas_pr cp '.
                ' inner join pessoa pes '.
                ' on cp.Dominio = pes.Dominio '.
                ' and cp.Pessoa = pes.Pessoa '.
                ' '.$inner_vendedor.' '.
                ' where cp.Dominio = "'.$_SESSION['Dominio'].'" '.
                ' and cp.TipoPR = "R" '.
                ' and cp.Situacao <> "E" ';

    if($situacao=='F'){
        $consulta.= ' and cp.Situacao = "F" and cp.Valor_Pago>0';
        $tipo_rel = 'Recebidos';
    }else if($situacao=='C'){
        $consulta.= ' and cp.Situacao = "C" ';
        $tipo_rel = 'Cancelados';
    }else{
        $consulta.= ' and ((cp.Situacao <> "C") and ((cp.PRC <> "S") or ((cp.Situacao = "F")and (cp.Valor_Pago>0)))) ';
        $tipo_rel = 'Todos';
    }

    if($empresa>0){
		$consulta.= ' and cp.Empresa = "'.$empresa.'" ';

		$cons_empresa = 'select Nome_Listas from pessoa '.
				   ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				   ' and Pessoa = "'.$_REQUEST['empresa'].'"';
		$res_empresa = consulta_sql($cons_empresa);
		$reg_empresa = consulta_ler_linha($res_empresa);
		consulta_limpa($res_empresa);
		$filtro.= ' Empresa: "'.$reg_empresa[0].'"';
		if($grupo == 'E'){
			$grupo = 'C';  //tira o agrupamento de empresa que no vai precisar por j faz parte do filtro
		}
    }

    if (isset($_REQUEST['pesquisa'])) {
		if($_REQUEST['pesquisa']!=''){
			$_REQUEST['pesquisa'] = str_replace('"',"",$_REQUEST['pesquisa']);
			$consulta.= ' and ( ';


			$data = '';

			if ((strlen($_REQUEST['pesquisa'])==7)&& (is_numeric(substr($_REQUEST['pesquisa'],0,2))) &&
				(substr($_REQUEST['pesquisa'],2,1)=='/') && (is_numeric(substr($_REQUEST['pesquisa'],3,4)))
				){
				$pesq_ini = '01/'.$_REQUEST['pesquisa'];
				$pesq_fim = '31/'.$_REQUEST['pesquisa'];
				$data = datad($pesq_ini);

				$consulta.= ' (cp.DT_Vencto>="'.datad($pesq_ini).'")'.
						    ' and (cp.DT_Vencto<="'.datad($pesq_fim).'")';
			}else if ((strlen($_REQUEST['pesquisa'])==10)&&(strlen(limpa_numero($_REQUEST['pesquisa']))==8)){
			    $data = datad($_REQUEST['pesquisa']);
			    if (($data[4]=='-')&&
					($data[7]=='-')){
					if (checkdate($data[5].$data[6],
								$data[8].$data[9],
								$data[0].$data[1].$data[2].$data[3])){
						$consulta.= ' (cp.DT_Vencto="'.$data.'")'.
									' or (cp.DT_Pagto="'.$data.'")';

					}else{
						$data = '';
					}
				}
			}else if(strlen($_REQUEST['pesquisa'])==11){
                if(is_numeric($_REQUEST['pesquisa'])){
                    $cpf.=substr($_REQUEST['pesquisa'],0,3).'.';
                    $cpf.=substr($_REQUEST['pesquisa'],3,3).'.';
                    $cpf.=substr($_REQUEST['pesquisa'],6,3).'-';
                    $cpf.=substr($_REQUEST['pesquisa'],9,2);

                    //Busca o codigo atraves do cpf no cadastro pessoa.
                    $con_cpf = 'select Pessoa from pessoa '.
                                ' where Dominio="'.$_SESSION["Dominio"].'" '.
                                ' and CPF_CNPJ like "'.$cpf.'"';
                    $res_cpf = consulta_sql($con_cpf);
                    $reg_cpf = consulta_ler_linha($res_cpf);
                    consulta_limpa($res_cpf);
                    $consulta.= ' ( Pessoa = "'.$reg_cpf[0].'" ) or ';
                }//formata o cpf
            }else if(strlen($_REQUEST['pesquisa'])==14){
                //formata o cnpj
                if(is_numeric($_REQUEST['pesquisa'])){
                    $cnpj.=substr($_REQUEST['pesquisa'],0,2).'.';
                    $cnpj.=substr($_REQUEST['pesquisa'],2,3).'.';
                    $cnpj.=substr($_REQUEST['pesquisa'],5,3).'/';
                    $cnpj.=substr($_REQUEST['pesquisa'],8,4).'-';
                    $cnpj.=substr($_REQUEST['pesquisa'],12,2);

                    //Busca o codigo atraves do cpf no cadastro pessoa.
                    $con_cnpj = 'select Pessoa from pessoa '.
                                 ' where Dominio="'.$_SESSION["Dominio"].'" '.
                                 ' and CPF_CNPJ like "'.$cnpj.'"';
                    $res_cnpj = consulta_sql($con_cnpj);
                    $reg_cnpj = consulta_ler_linha($res_cnpj);
                    consulta_limpa($res_cnpj);
                    $consulta.= ' ( Pessoa = "'.$reg_cnpj[0].'" ) or ';
                }
            }

			if ($data==''){
				$consulta.=' (cp.Nr_Doc like "%'.$_REQUEST['pesquisa'].'%")';
				if (is_numeric(str2nr(formata_valor(  $_REQUEST['pesquisa'])))){
					$consulta.= ' or (cp.Valor="'.str2nr(formata_valor(  $_REQUEST['pesquisa'])).'")'.
								' or (cp.Pessoa="'.$_REQUEST['pesquisa'].'") ';
				}else if (strlen($_REQUEST['pesquisa'])>2){
					$con_pessoa = 'select Pessoa from pessoa '.
								  ' WHERE Dominio="'.$_SESSION["Dominio"].'"'.
								  ' and ((Nome_Listas like "%'.$_REQUEST['pesquisa'].'%")'.
								  ' or  (Nome_Razao like "%'.$_REQUEST['pesquisa'].'%"))';
					$res_pessoa = consulta_sql($con_pessoa);
					$nrw_pessoa = consulta_num_registros($res_pessoa);
					for($p=0;$p<$nrw_pessoa;$p++){
						$reg_pessoa = consulta_ler_linha($res_pessoa);
						$consulta.= ' or (cp.Pessoa="'.$reg_pessoa[0].'")';
					}
					consulta_limpa($res_pessoa);
				}
			}
			$consulta.= ')';
			$filtro.= ' Nr da Fatura/Pessoa/Valor/Vencimento ou Pagamento Contm "'.$_REQUEST['pesquisa'].'"';
		}
    }else{

		if($vendedor!=''){
			if($vendedor_origem=='C'){
				$consulta.= ' and pes_cli.Vendedor = "'.$vendedor.'" ';
			}else{
				$consulta.= ' and cp.Vendedor = "'.$vendedor.'" ';
			}

			$cons_fornec = 'select Nome_Listas from pessoa '.
						 ' where Dominio = "'.$_SESSION["Dominio"].'"'.
						 ' and Pessoa = "'.$vendedor.'"';
			$res_fornec = consulta_sql($cons_fornec);
			$reg_fornec = consulta_ler_linha($res_fornec);
			consulta_limpa($res_fornec);


			$label_emp = empresa_representante($vendedor,'S');

			$tipo_rel.= '
'.$label.': '.$label_emp.'';
			if($grupo =='V'){
				$grupo = 'C';  //tira o agrupamento de vendedor que no vai precisar por j faz parte do filtro
			}
		}

		if($grupo =='C'){
			$grupo = 'E';  //tira o agrupamento de vendedor que no vai precisar por j faz parte do filtro
		}

		if($tipo_data=="V"){
			if(($tipo_data_ini!='')||($tipo_data_fim!='')){
				$filtro.= ' Data de: "Vencimento":';
				if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
					$consulta.= ' and (cp.DT_Vencto >= "'.datad($tipo_data_ini).'" '.
								' and cp.DT_Vencto <= "'.datad($tipo_data_fim).'") ';
					$filtro.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'"';
				}else if($tipo_data_ini!=''){
					$consulta.= ' and (cp.DT_Vencto >= "'.datad($tipo_data_ini).'") ';
					$filtro.= ' De "'.$tipo_data_ini.'"';
				}else if($tipo_data_fim!=''){
					$consulta.= ' and (cp.DT_Vencto <= "'.datad($tipo_data_fim).'") ';
					$filtro.= ' At "'.$tipo_data_fim.'"';
				}
			}
		}else if($tipo_data=="P"){
			if(($tipo_data_ini!='')||($tipo_data_fim!='')){
				$filtro.= ' Data de: "Pagamento":';
				if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
					$consulta.= ' and (cp.DT_Pagto >= "'.datad($tipo_data_ini).'" '.
								' and cp.DT_Pagto <= "'.datad($tipo_data_fim).'") ';
					$filtro.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'" ';
				}else if($tipo_data_ini!=''){
					$consulta.= ' and (cp.DT_Pagto >= "'.datad($tipo_data_ini).'") ';
					$filtro.= ' De "'.$tipo_data_ini.'"';
				}else if($tipo_data_fim!=''){
					$consulta.= ' and (cp.DT_Pagto <= "'.datad($tipo_data_fim).'") ';
					$filtro.= ' At "'.$tipo_data_fim.'"';
				}
			}
		}else{
			if(($tipo_data_ini!='')||($tipo_data_fim!='')){
				$filtro.= ' Data de: "Emisso":';
				if(($tipo_data_ini!='')&&($tipo_data_fim!='')){
					$consulta.= ' and (cp.DH_Criacao >= "'.datad($tipo_data_ini).'" '.
								' and cp.DH_Criacao <= "'.datad($tipo_data_fim).' 23:59:59") ';
					$filtro.= ' De "'.$tipo_data_ini.'" At "'.$tipo_data_fim.'"';
				}else if($tipo_data_ini!=''){
					$consulta.= ' and (cp.DH_Criacao >= "'.datad($tipo_data_ini).'") ';
					$filtro.= ' De "'.$tipo_data_ini.'"';
				}else if($tipo_data_fim!=''){
					$consulta.= ' and (cp.DH_Criacao <= "'.datad($tipo_data_fim).' 23:59:59") ';
					$filtro.= ' At "'.$tipo_data_fim.'"';
				}
			}
		}

		if(($valor_ini!='') || ($valor_fim!='')){
			$filtro.= ' Valor:';
			if($valor_ini!=''){
				$consulta.= ' and cp.Valor >= "'.str2nr(formata_valor($valor_ini)).'" ';
				$filtro.= ' De "'.$valor_ini.'"';
			}
			if($valor_fim!=''){
				$consulta.= ' and cp.Valor <= "'.str2nr(formata_valor($valor_fim)).'" ';
				$filtro.= ' At "'.$valor_fim.'"';
			}
		}

		if($tipo_emissao!=''){
			if($tipo_emissao=='P'){
				$filtro.= ' Cereais: "Somente Cereais"';
				$consulta.= ' and (cp.Nr_Boletim_Pesagem <> 0)';
			}else{
				$filtro.= ' Cereais: "Somente No Cereais"';
				$consulta.= ' and (cp.Nr_Boletim_Pesagem = 0)';
			}
		}

		if($nome_parcial!=''){
			$consulta.= ' and pes.Nome_Razao like "%'.$nome_parcial.'%" ';
			$filtro.= ' Parcial Nome: "'.$nome_parcial.'"';
		}

		if($familia!=''){
			$consulta.= ' and pes.Familia = "'.$familia.'"';
			$cons_familia = 'select Descricao from pessoa_familia '.
						  ' where Dominio = "'.$_SESSION['Dominio'].'"'.
						  ' and Cod_Familia = "'.$familia.'"';
			$res_familia = consulta_sql($cons_familia);
			$reg_familia = consulta_ler_linha($res_familia);
			consulta_limpa($res_familia);

			$filtro.= ' Famlia: "'.$reg_familia[0].'"';
		}

		if($fam_grupo!=''){
			$consulta.= ' and pes.Grupo = "'.$fam_grupo.'"';

			$cons_grupo = 'select Descricao from pessoa_grupo '.
						' where Dominio = "'.$_SESSION['Dominio'].'"'.
						' and Cod_Grupo = "'.$fam_grupo.'"';
			$res_grupo = consulta_sql($cons_grupo);
			$reg_grupo = consulta_ler_linha($res_grupo);
			consulta_limpa($res_grupo);

			$filtro.= ' Grupo: "'.$reg_grupo[0].'"';
		}

		if($modelo!=''){
			$consulta.= ' and cp.Modelo = "'.$modelo.'" ';
			$filtro.= ' Modelo: "'.$modelo.'"';
		}

		if($serie!=''){
			$consulta.= ' and cp.Serie = "'.$serie.'" ';
			$filtro.= ' Srie: "'.$serie.'"';
		}

		if($nr_fatura!=''){
			$consulta.= ' and cp.Nr_Doc = "'.$nr_fatura.'" ';
			$filtro.= ' NrFatura: "'.$nr_fatura.'"';
		}

		if($tp_receb!=''){
			if($tp_receb=='S'){
				$consulta.= ' and cp.Valor_Acrescimo > 0 ';
				$filtro.= ' Recebidas: Com Juros';
			}else if($tp_receb=='N'){
				$consulta.= ' and cp.Valor_Acrescimo = 0 ';
				$filtro.= ' Recebidas: Sem Juros';
			}
		}

		if($meio_pagto!=''){
			$consulta.= ' and cp.Tipo_Docto = "'.$meio_pagto.'" ';
			$filtro.= ' Tipo Docto: "'.busca_dados_combo('tipo_fatura',$meio_pagto).'"';
		}

		if($forma_pagto_contas!=''){
			if($contas_finaliza=='SIMP'){
				$consulta.= ' and cp.Forma_Pagto_Contas = "'.$forma_pagto_contas.'" ';
			}else{
				$consulta.= ' and cp.Finalizadora = "'.$forma_pagto_contas.'" ';
			}

			$sql_forma ='select Descricao from forma_pagto_contas '.
						' where Dominio = "'.$_SESSION['Dominio'].'"'.
						' and Codigo_Pagto = "'.$forma_pagto_contas.'"';
			$res_forma = consulta_sql($sql_forma);
			$reg_forma = consulta_ler_linha($res_forma);
			consulta_limpa($res_forma);

			$filtro.= ' Forma Pagto: "'.$reg_forma[0].'"';
		}

		if($contrato!=''){
			$consulta.= ' and cp.Contrato = "'.$contrato.'" ';
			if($contrato=='S'){
				$filtro.= ' "Com Contratos"';
			}else{
				$filtro.= ' "Sem Contratos"';
			}
		}

		if($antecipacao!=''){
			$consulta.= ' and cp.Adiantado = "'.$antecipacao.'" ';
			if($antecipacao=='S'){
				$filtro.= ' "Somente Antecipao"';
			}else{
				$filtro.= ' "Sem Antecipao"';
			}
		}

		if($uf!=''){
			$filtro.= ' Estado: "'.$uf.'"';
		}

		if($cidade!=''){
			$con_cid = 'select Nome from cidade '.
					 ' where Dominio="'.$_SESSION['Dominio'].'"'.
					 ' and Codigo_Cidade = "'.$cidade.'"';
			$res_cid = consulta_sql($con_cid);
			$reg_cid = consulta_ler_linha($res_cid);
			consulta_limpa($res_cid);

			$filtro.= ' Cidade: "'.$reg_cid[0].'"';
		}

    }

	if( isset($_REQUEST['procuracao'])){
		$pessoas_procuracao = busca_pessoas_com_procuracao();    
		if( $procuracao=='S'){            
			$consulta.= ' AND  cp.Pessoa IN ( '.$pessoas_procuracao.')';
		}else{            
			$consulta.= ' AND  cp.Pessoa NOT IN ( '.$pessoas_procuracao.')';
		}
	}
	if($banco_envio != ''){
		$filtro.= ' Boleto:';
		if($banco_envio == 'S'){
			$filtro.= ' Somente Enviados ao Banco';
			$consulta.= ' and det.Contas_Empresa>0';
		}else if($banco_envio == 'N'){
			$filtro.= ' Somente No Enviados ao Banco';
			$consulta.= ' and det.Contas_Empresa is null';
		}
	}
	if($aceite != ''){
		$filtro.= ' Aceite:';
		if($aceite == 'S'){
			$filtro.= ' Com Aceite';
		}else if($aceite == 'N'){
			$filtro.= ' Sem Aceite';
		}else if($aceite == 'T'){
			$filtro.= ' Terceiros';
		}
		$consulta.= ' AND (cp.Aceite2 = "'.$aceite.'")';
	}
	if ($banco_envio!=''){
		$consulta.= ' group by cp.Empresa, cp.Nr_Contas, cp.Seq';
	}
	if($grupo == ''){
        $consulta.= ' order by cp.Empresa, pes.Nome_Razao, cp.Pessoa, cp.DT_Vencto, cp.Nr_Doc, cp.Serie, cp.Modelo, cp.Parcela, cp.Seq';
    }else{
		$filtro.= ' Agrupado Por: ';
		/*if($grupo=='C'){
		$consulta.= ' order by pes.Nome_Razao, cp.Pessoa, cp.DT_Vencto, cp.Empresa, cp.Nr_Doc, cp.Serie, cp.Modelo, cp.Parcela, cp.Seq';
		$filtro.= '"Cliente"';
		}else*/
		if($grupo=='V'){
			$consulta.= ' order by cp.Vendedor, pes.Nome_Razao, cp.Pessoa, cp.DT_Vencto, cp.Empresa, cp.Nr_Doc, cp.Serie, cp.Modelo, cp.Parcela, cp.Seq';
			$filtro.= '"'.$label.'"';
		}else{
			$filtro.= '"Empresa"';
			$consulta.= ' order by cp.Empresa, pes.Nome_Razao, cp.Pessoa, cp.DT_Vencto, cp.Nr_Doc, cp.Serie, cp.Modelo, cp.Parcela, cp.Seq';
		}
    }


    if((isset($_REQUEST['pesquisa']))){
		$consulta.= ' limit 10000 ';
    }
	//echo 'SQL: '.$consulta;

    $worksheet1->write(7,0,"Filtro: ".$filtro);
    //$worksheet1->insert_bitmap(9,0,"../../imgs/logo_menu.bmp",0,0);

    // Format for the headings
    $formatott =& $workbook->add_format();
    $formatott->set_align('center');
    $formatott->set_pattern();
    $formatott->set_fg_color(40);
    $formatott->set_bold(1);
    $formatott->set_border(1);

    // Formato texto
    $formatotl =& $workbook->add_format();
    $formatotl->set_border(1);
    $formatotl->set_align('left');

    $formatotli =& $workbook->add_format();
    $formatotli->set_border(1);
    $formatotli->set_align('left');
    $formatotli->set_italic(1);

    $formatotr =& $workbook->add_format();
    $formatotr->set_border(1);
    $formatotr->set_align('right');

    $formatotri =& $workbook->add_format();
    $formatotri->set_border(1);
    $formatotri->set_align('right');
    $formatotri->set_italic(1);

    $formatotc =& $workbook->add_format();
    $formatotc->set_border(1);
    $formatotc->set_align('center');

    $formatotlb =& $workbook->add_format();
    $formatotlb->set_border(1);
    $formatotlb->set_size(10);
    $formatotlb->set_align('left');
    $formatotlb->set_bold(1);


    // Formato qtd
    $formatotqtdb =& $workbook->add_format();
    $formatotqtdb->set_border(1);
    $formatotqtdb->set_align('right');
    $formatotqtdb->set_size(10);
    $formatotqtdb->set_bold(1);
//    $formatotqtdb->set_num_format('#,##0_);-#,##0_)');
    $formatotqtdb->set_num_format('#,##0.000_);-#,##0.000_)');

    $formatotqtdi =& $workbook->add_format();
    $formatotqtdi->set_border(1);
    $formatotqtdi->set_italic(1);
    $formatotqtdi->set_align('right');
//    $formatotqtdi->set_num_format('#,##0_);-#,##0_)');
    $formatotqtdi->set_num_format('#,##0.000_);-#,##0.000_)');

    $formatotqtd =& $workbook->add_format();
    $formatotqtd->set_border(1);
    $formatotqtd->set_align('right');
//    $formatotqtd->set_num_format('#,##0_);-#,##0_)');
    $formatotqtd->set_num_format('#,##0.000_);-#,##0.000_)');


    // Formato precos
    $formatotpreco =& $workbook->add_format();
    $formatotpreco->set_border(1);
    $formatotpreco->set_align('right');
    $formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

    // Format for the headings
    $formatotbpreco =& $workbook->add_format();
    $formatotbpreco->set_border(1);
    $formatotbpreco->set_align('right');
    $formatotbpreco->set_bold(1);
    $formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

    $formatotipreco =& $workbook->add_format();
    $formatotipreco->set_border(1);
    $formatotipreco->set_align('right');
    $formatotipreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

    $formato_data =& $workbook->add_format();
    $formato_data->set_border(1);
    $formato_data->set_align('center');
    $formato_data->set_num_format('dd/mm/yyyy');


    $resultado = consulta_sql($consulta);
    $nrows = consulta_num_registros($resultado);

    $worksheet1->write_string(1,0,'Todos os Clientes - '.$tipo_rel,$formatost);

    $linha_ini = 9;

    if ($nrows>0){
        $coluna=0;

        $worksheet1->set_column($coluna,$coluna,3);
        $worksheet1->write_string($linha_ini,$coluna,'',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'NrFatura',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,5);
        $worksheet1->write_string($linha_ini,$coluna,'Par',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,3);
        $worksheet1->write_string($linha_ini,$coluna,'C',$formatott);
        $coluna++;

        if($grupo == ''){
			$worksheet1->set_column($coluna,$coluna,50);
			$worksheet1->write_string($linha_ini,$coluna,'Cliente',$formatott);
			$coluna++;
        }

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'Dt Digit',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'Dt Venc',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
        $worksheet1->write_string($linha_ini,$coluna,'Dt Baixa',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,16);
        $worksheet1->write_string($linha_ini,$coluna,'Empresa',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,40);
        $worksheet1->write_string($linha_ini,$coluna,$label,$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,14);
        $worksheet1->write_string($linha_ini,$coluna,'Desconto',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,14);
        $worksheet1->write_string($linha_ini,$coluna,'Acrscimo',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
        $worksheet1->write_string($linha_ini,$coluna,'Valor',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,16);
        $worksheet1->write_string($linha_ini,$coluna,'Valor Pago',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,36);
        $worksheet1->write_string($linha_ini,$coluna,'Observao',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
        $worksheet1->write_string($linha_ini,$coluna,'CPF/CNPJ',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
        $worksheet1->write_string($linha_ini,$coluna,'Usuario Criao',$formatott);
        $coluna++;

		$worksheet1->set_column($coluna,$coluna,52);
        $worksheet1->write_string($linha_ini,$coluna,'Linha Digitvel Boleto',$formatott);
        $coluna++;

		if ($banco_envio=='S'){
			$worksheet1->set_column($coluna,$coluna,40);
			$worksheet1->write_string($linha_ini,$coluna,'Lote Envio',$formatott);
			$coluna++;
		}

        $linha_ini++;

        $vl_desconto = 0;
        $vl_acrescimo = 0;
        $vl_valor = 0;
        $vl_pago = 0;

        $vl_com_contratos = 0;
        $vl_sem_contratos = 0;

        $vl_desconto_geral = 0;
        $vl_acrescimo_geral = 0;
        $vl_valor_geral = 0;
        $vl_pago_geral = 0;

        $vl_com_contratos_geral = 0;
        $vl_sem_contratos_geral = 0;


        $vl_desconto_grupo = 0;
        $vl_acrescimo_grupo = 0;
        $vl_valor_grupo = 0;
        $vl_pago_grupo = 0;

        $vl_com_contratos_grupo = 0;
        $vl_sem_contratos_grupo = 0;

        $id_data = '';
        $id_fornec = '';
        $id_vendedor = '';
        $id_empresa = '';

        $total_vencido = 0;
        $total_vencer = 0;

        $lista_empresas = lista_empresas();

        for($i=0;$i<$nrows;$i++){
            $registro = consulta_ler_objeto($resultado);
            set_time_limit(30);


            $ok_linha1 = true;
            if(($uf!='')||($cidade!='')){
				$array_uf = array();
				$array_cid = array();
				$con_cidade = 'select UF, Codigo_Cidade from pessoa_endereco '.
							 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
							 ' and Pessoa = "'.$registro->Pessoa.'" '.
							 ' and Situacao <> "E"';
				$res_cidade = consulta_sql($con_cidade);
				$nro_cidade = consulta_num_registros($res_cidade);
				for($u=0;$u<$nro_cidade;$u++){
					$reg_cidade = consulta_ler_linha($res_cidade);
					if(!isset($array_uf[$reg_cidade[0]])){
						$array_uf[$reg_cidade[0]] = $reg_cidade[0];
					}
					if(!isset($array_uf[$reg_cidade[1]])){
						$array_cid[$reg_cidade[1]] = $reg_cidade[1];
					}
				}
				consulta_limpa($res_cidade);

				if($ok_linha1){
					if(($uf!='')&&($cidade!='')){
						//$ok_linha1 = ($uf==$reg_cidade[0]);
						$ok_linha1 = ((isset($array_uf[$uf])) && (isset($array_cid[$cidade])));
					}else{
						if($ok_linha1){
							if($uf!=''){
								//$ok_linha1 = ($cidade==$reg_cidade[1]);
								$ok_linha1 = (isset($array_uf[$uf]));
							}
						}

						if($ok_linha1){
							if($cidade!=''){
								//$ok_linha1 = ($cidade==$reg_cidade[1]);
								$ok_linha1 = (isset($array_cid[$cidade]));
							}
						}
					}
				}
            }

            if($ok_linha1){
				$cpf_cnpj = $registro->CPF_CNPJ;
				if($grupo=='V'){
					if(($id_vendedor!=$registro->Vendedor)&&
						($id_vendedor!='')){
						$id_fornec = -1;
					}
				}else if($grupo=='E'){
					if(($id_empresa!=$registro->Empresa)&&
						($id_empresa!='')){
						$id_fornec = -1;
					}
				}

				if($id_fornec!=$registro->Pessoa){
					if($grupo != ''){
						if($id_fornec!=''){
							$coluna=0;
							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'TOTAL CLIENTE',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.str_replace('"','',to_money($vl_com_contratos)),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.str_replace('"','',to_money($vl_sem_contratos)),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Saldo: '.str_replace('"','',to_money($vl_valor-($vl_pago+$vl_desconto-$vl_acrescimo))),$formatotlb);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_desconto,$formatotbpreco);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_acrescimo,$formatotbpreco);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_valor,$formatotbpreco);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_pago,$formatotbpreco);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$linha_ini++;

							$vl_desconto = 0;
							$vl_acrescimo = 0;
							$vl_valor = 0;
							$vl_pago = 0;

							$vl_com_contratos = 0;
							$vl_sem_contratos = 0;

						}


						if((($id_vendedor!='')&&($grupo=='V')&&($id_vendedor!=$registro->Vendedor))||
							(($id_empresa!='')&&($grupo=='E')&&($id_empresa!=$registro->Empresa))){
							$coluna=0;


							if($grupo=='V'){
								$coluna++;
								$worksheet1->write_string($linha_ini,$coluna,'TOTAL '.UpperDados($label),$formatotlb);
								$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							}else{
								$coluna++;
								$worksheet1->write_string($linha_ini,$coluna,'TOTAL EMPRESA',$formatotlb);
								$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							}

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.str_replace('"','',to_money($vl_com_contratos_grupo)),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.str_replace('"','',to_money($vl_sem_contratos_grupo)),$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Saldo: '.str_replace('"','',to_money($vl_valor_grupo-($vl_pago_grupo+$vl_desconto_grupo-$vl_acrescimo_grupo))),$formatotlb);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_desconto_grupo,$formatotbpreco);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_acrescimo_grupo,$formatotbpreco);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_valor_grupo,$formatotbpreco);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$vl_pago_grupo,$formatotbpreco);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$linha_ini++;

							$vl_desconto_grupo = 0;
							$vl_acrescimo_grupo = 0;
							$vl_valor_grupo = 0;
							$vl_pago_grupo = 0;

							$vl_com_contratos_grupo = 0;
							$vl_sem_contratos_grupo = 0;

						}

						if(($id_fornec!='') && ($_SESSION['Dominio'] == $dominios['71'])){
							$coluna=0;
							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCIDO',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$total_vencido,$formatotbpreco);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$linha_ini++;



							$coluna=0;
							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCER',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_number($linha_ini,$coluna,$total_vencer,$formatotbpreco);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$linha_ini++;

							$total_vencido = 0;
							$total_vencer = 0;
						}

					}


					if($grupo=='V'){
						if($id_vendedor!=$registro->Vendedor){
							$id_fornec = -1;

							$con_ender = 'select Nome_Razao from pessoa '.
										 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
										 ' and Pessoa="'.$registro->Vendedor.'"';
							$res_ender = consulta_sql($con_ender);
							$reg_ender = consulta_ler_linha($res_ender);
							consulta_limpa($res_ender);

							//$linha_ini++;
							$coluna=0;

							$label_emp = empresa_representante($registro->Vendedor,'S');

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,$label.': '.$label_emp,$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+12);

							for($lne=0;$lne<=11;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$linha_ini++;

						}
					}else if($grupo=='E'){
						if($id_empresa!=$registro->Empresa){
							$id_fornec = -1;

							$con_ender = 'select Nome_Listas from pessoa '.
										 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
										 ' and Pessoa="'.$registro->Empresa.'"';
							$res_ender = consulta_sql($con_ender);
							$reg_ender = consulta_ler_linha($res_ender);
							consulta_limpa($res_ender);

							//$linha_ini++;
							$coluna=0;

							$coluna++;
							$worksheet1->write_string($linha_ini,$coluna,'Empresa: '.$reg_ender[0],$formatotlb);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+14);

							for($lne=0;$lne<=13;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$linha_ini++;

						}
					}

					$id_fornec = $registro->Pessoa;
					$id_empresa = $registro->Empresa;
					$id_vendedor = $registro->Vendedor;

					if($grupo != ''){
						$coluna=0;

						$coluna++;

						if($registro->Nome_Razao!=''){
							$desc_pess = $registro->Nome_Razao;
						}else{
							$cons_pess = 'select Nome_Razao from pessoa '.
										 ' where Dominio = "'.$_SESSION["Dominio"].'"'.
										 ' and Pessoa = "'.$registro->Pessoa.'"';
							$res_pess = consulta_sql($cons_pess);
							$reg_pess = consulta_ler_linha($res_pess);
							consulta_limpa($res_pess);

							$desc_pess = $reg_desc[0];
						}
						$worksheet1->write_string($linha_ini,$coluna,$registro->Pessoa.' - '.$desc_pess,$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+3);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

						//               $coluna+=3;


						//consulta endereco padro do cliente
						$con_ender = 'select Logradouro, Numero, Nome_Cidade, UF from pessoa_endereco '.
									' where Dominio = "'.$_SESSION['Dominio'].'" '.
									' and Pessoa="'.$registro->Pessoa.'"'.
									' and Situacao <> "E"'.
									' order by Seq_Endereco limit 1';
						$res_ender = consulta_sql($con_ender);
						$reg_ender = consulta_ler_linha($res_ender);
						consulta_limpa($res_ender);
						$endereco_log = $reg_ender[0].', ';
						if($reg_ender[1]!=''){
							$endereco_log.=$reg_ender[1];
						}else{
							$endereco_log.='S/N';
						}
						$endereco_cidade = $reg_ender[2].'-'.$reg_ender[3];

						$coluna++;
						$worksheet1->write_string($linha_ini,$coluna,$endereco_log,$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+2);
						$coluna++;
						$coluna+=2;


						//consulta telefone do cliente
						$con_ender = 'select Numero_Telefone from pessoa_telefone '.
                                  ' where Dominio = "'.$_SESSION['Dominio'].'" '.
                                  ' and Pessoa="'.$registro->Pessoa.'"'.
                                  ' and Situacao <> "E"'.
                                  ' order by Seq_Telefone limit 2';
						$res_ender = consulta_sql($con_ender);
						$reg_ender = consulta_ler_linha($res_ender);
						$reg_ender2 = consulta_ler_linha($res_ender);
						consulta_limpa($res_ender);
						$telefones = $reg_ender[0];
						if($reg_ender2[0]!=''){
							$telefones.=', '.$reg_ender2[0];
						}

						$worksheet1->write_string($linha_ini,$coluna,$telefones,$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+2);
						$coluna++;
						$coluna++;

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$worksheet1->write_string($linha_ini,$coluna,$endereco_cidade,$formatotlb);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+2);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$linha_ini++;
					}
				}
				
				$coluna = 0;
				$contar_total = true;
				if(isset($listas_contados[$registro->Empresa.'-'.$registro->Nr_Contas])){
					$contar_total = false;
				}else{
					$listas_contados[$registro->Empresa.'-'.$registro->Nr_Contas] = $registro->Seq;
				}


				$worksheet1->write_string($linha_ini,$coluna,$registro->Tipo_Docto,$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,$registro->Nr_Doc.'/'.$registro->Serie.'-'.$registro->Modelo,$formatotc);
				$coluna++;


				$worksheet1->write_string($linha_ini,$coluna,$registro->Parcela,$formatotc);
				$coluna++;


				if($registro->Contrato=='S'){
					$txt_cont = 'C';
					if($contar_total){
						$vl_com_contratos+=$registro->Valor;
						$vl_com_contratos_geral+=$registro->Valor;
						$vl_com_contratos_grupo+=$registro->Valor;
					}
				}else{
					$txt_cont = '';
					if($contar_total){
						$vl_sem_contratos+=$registro->Valor;
						$vl_sem_contratos_geral+=$registro->Valor;
						$vl_sem_contratos_grupo+=$registro->Valor;
					}
				}
				$worksheet1->write_string($linha_ini,$coluna,$txt_cont,$formatotc);
				$coluna++;

				if($grupo == ''){
					if($registro->Nome_Razao != ''){
						$desc_pess = $registro->Nome_Razao;
					}else{
                        $cons_pess = 'select Nome_Razao,EMail from pessoa '.
                                     ' where Dominio = "'.$_SESSION["Dominio"].'"'.
                                     ' and Pessoa = "'.$registro->Pessoa.'"';
                        $res_pess = consulta_sql($cons_pess);
                        $reg_pess = consulta_ler_linha($res_pess);
                        consulta_limpa($res_pess);

                        $desc_pess = $reg_desc[0];
					}
					$worksheet1->write_string($linha_ini,$coluna,$registro->Pessoa.' - '.$desc_pess,$formatotl);
					$coluna++;
				}


				$worksheet1->write_number($linha_ini,$coluna,data2nr(dataf($registro->DH_Criacao)),$formato_data);
				$coluna++;


				$worksheet1->write_number($linha_ini,$coluna,data2nr(dataf($registro->DT_Vencto)),$formato_data);
				$coluna++;

				if(($registro->DT_Pagto == '') || ($registro->DT_Pagto == '0000-00-00')){
					$txt_dt_baixa = '';
					$worksheet1->write_string($linha_ini,$coluna,$txt_dt_baixa,$formatotc);
					$coluna++;
				}else{
					$txt_dt_baixa = data2nr(dataf($registro->DT_Pagto));
					$worksheet1->write_number($linha_ini,$coluna,$txt_dt_baixa,$formato_data);
					$coluna++;
				}

				$worksheet1->write_string($linha_ini,$coluna,nome_empresa($lista_empresas,$registro->Empresa),$formatotl);
				$coluna++;


				if($registro->Vendedor>0){
					$con_ender = 'select Nome_Razao from pessoa '.
					   ' where Dominio = "'.$_SESSION['Dominio'].'" '.
					   ' and Pessoa="'.$registro->Vendedor.'"';
					$res_ender = consulta_sql($con_ender);
					$reg_ender = consulta_ler_linha($res_ender);
					consulta_limpa($res_ender);

					$label_emp = empresa_representante($registro->Vendedor,'S');

					$nm_vend = $label_emp;
				}else{
					$nm_vend = '';
				}
				$worksheet1->write_string($linha_ini,$coluna,$nm_vend,$formatotl);
				$coluna++;


				if(($registro->Valor_Desconto=='')||($registro->Valor_Desconto==0)){
					$txt_vl_desconto = '';
				}else{
					$txt_vl_desconto = $registro->Valor_Desconto;
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_vl_desconto,$formatotpreco);
				$coluna++;


				if(($registro->Valor_Acrescimo=='')||($registro->Valor_Acrescimo==0)){
					$txt_vl_acresc = '';
				}else{
					$txt_vl_acresc = $registro->Valor_Acrescimo;
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_vl_acresc,$formatotpreco);
				$coluna++;


				if(($registro->Valor=='')||($registro->Valor==0)){
					$txt_valor = '';
				}else{
					$txt_valor = $registro->Valor;
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_valor,$formatotpreco);
				$coluna++;

				if(($registro->DT_Pagto == '') || ($registro->DT_Pagto == '0000-00-00')){
					if(data2nr(dataf($registro->DT_Vencto)) < data_atual()){
						$total_vencido+= $registro->Valor;
					}else{
						$total_vencer+= $registro->Valor;
					}
				}


				if(($registro->Valor_Liquido=='')||($registro->Valor_Liquido==0)){
					$txt_valor_pago = '';
				}else{
					$txt_valor_pago = $registro->Valor_Liquido;
				}
				$worksheet1->write_number($linha_ini,$coluna,$txt_valor_pago,$formatotpreco);
				$coluna++;


				$desc_obs = '';
				if($registro->Adiantado=='S'){
					$desc_obs.= 'Antecipado';

					$cons_ant_con = 'select Empresa, Nr_Antecipa from contas_antecipa_contas '.
								  ' where Dominio = "'.$_SESSION['Dominio'].'"'.
								  ' and Contas_Empresa = "'.$registro->Empresa.'"'.
								  ' and Contas_Nr_Contas = "'.$registro->Nr_Contas.'"'.
								  ' and Contas_Seq = "'.$registro->Seq.'"';
					$res_ant_con = consulta_sql($cons_ant_con);
					$nrow_ant_cont = consulta_num_registros($res_ant_con);
					if($nrow_ant_cont>0){
						$reg_ant_con = consulta_ler_linha($res_ant_con);

						$cons_ant = 'select Data from contas_antecipa '.
								 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
								 ' and Empresa = "'.$reg_ant_con[0].'"'.
								 ' and Nr_Antecipa = "'.$reg_ant_con[1].'"'.
								 ' and Situacao = "A" and Tipo_Mov = "A"';
						$res_ant = consulta_sql($cons_ant);
						$reg_ant = consulta_ler_linha($res_ant);
						consulta_limpa($res_ant);

						if($reg_ant[0]!='0000-00-00'){
							$desc_obs.= ' Dia '.dataf($reg_ant[0]);
						}
					}
					consulta_limpa($res_ant_con);

					$con_contas = 'SELECT Nr_Doc, Modelo, Serie FROM contas_pr '.
								' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
								' AND Empresa = "'.$registro->Empresa.'" '.
								' AND Nr_Contas = "'.$registro->Nr_Contas.'" '.
								' AND Seq = "'.$registro->Seq.'" ';
					$res_contas = consulta_sql($con_contas);
					$reg_contas = consulta_ler_objeto($res_contas);
					consulta_limpa($res_contas);

					$desc_obs.= ' Referente  fatura '.$reg_contas->Nr_Doc.'/'.$reg_contas->Serie.'-'.$reg_contas->Modelo;
				}
				if($desc_obs!=''){
					$desc_obs.= ' ';
				}

				$desc_obs.= $registro->Observacao;
				if($registro->Forma_Pagto_Contas>0){
					$con_pgto = 'select Descricao from forma_pagto_contas '.
							  ' where Dominio = "'.$_SESSION['Dominio'].'"'.
							  ' and Codigo_Pagto = "'.$registro->Forma_Pagto_Contas.'"';
					$res_pgto = consulta_sql($con_pgto);
					$reg_pgto = consulta_ler_linha($res_pgto);
					consulta_limpa($res_pgto);

					if($desc_obs!=''){
						$desc_obs.= ' Forma Pagto: '.$reg_pgto[0];
					}else{
						$desc_obs = 'Forma Pagto: '.$reg_pgto[0];
					}
				}
				
				if ($registro->Situacao=='F'){
					if ($_SESSION['Dominio']==386){
						if($desc_obs!=''){
							$desc_obs = ' '.$desc_obs;
						}
						if ($registro->Finalizadora==0){
							$desc_fin = 'Dinheiro';
						}else{
							$desc_fin = busca_dados_combo('meio_pagamento',$registro->Finalizadora);
						}					
						if ($registro->Banco_Conta>0){
							$con_contaB = 'SELECT Banco,Agencia,Conta FROM  banco_contas '.
										' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
										' AND Nr_Conta = "'.$registro->Banco_Conta.'"';
							$res_contaB = consulta_sql($con_contaB);
							$reg_contaB = consulta_ler_objeto($res_contaB);
							consulta_limpa($res_contaB);
							
							$desc_fin = 'Depsito - '.
										' Banco '.$reg_contaB->Banco.
										' Ag. '.$reg_contaB->Agencia.
										' CC '.$reg_contaB->Conta;
						}else if ($registro->Finalizadora==2){
							if ($registro->Boleto_Banco!=''){
								$desc_fin = 'Boleto - '.
										' Banco '.$registro->Boleto_Banco.
										' Ag. '.$registro->Boleto_NrAgencia.
										' CC '.$registro->Boleto_NrConta;
							}							
						}					 
						//cp.Finalizadora, cp.Banco_Conta	
						$desc_obs = 'Forma Pagto: '.$desc_fin.$desc_obs;						
					}
				}
				
				$worksheet1->write_string($linha_ini,$coluna,$desc_obs,$formatotl);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$cpf_cnpj,$formatotc);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$registro->UsuarioCriacao,$formatotc);
				$coluna++;

				$barra_boleto = $registro->Boleto_Barra;
				if (strlen($barra_boleto)==44){
					$barra_boleto = financeiro_boleto_monta_linha_digitavel($barra_boleto);
				}
				$worksheet1->write_string($linha_ini,$coluna,$barra_boleto,$formatotl);
				$coluna++;

				if ($banco_envio=='S'){
					$con_envio = 'select env.Nr_Envio, env.Usuario_Processo, env.Data_Processo, env.Nr_Lote '.
									' from banco_envio env '.
									' inner join banco_envio_det det'.
									' on env. Dominio=det.Dominio '.
									' and env.Empresa=det.Empresa '.
									' and env.Nr_Envio=det.Nr_Envio '.
								' where env.Dominio="'.$_SESSION['Dominio'].'"'.
								' and det.Contas_Empresa="'.$registro->Empresa.'"'.
								' and det.Contas_Nr_Contas="'.$registro->Nr_Contas.'"'.
								' and det.Contas_Seq="'.$registro->Seq.'"'.
								' and env.Situacao<>"E"'.
								' order by env.Data_Processo desc, env.Nr_Envio desc limit 1';
					$res_envio = consulta_sql($con_envio);
					$reg_envio = consulta_ler_linha($res_envio);
					consulta_limpa($res_envio);
					$dados_envio = '';
					if ($reg_envio[0]>0){
						$dados_envio = 'Envio: '.$reg_envio[0].' ('.dataf($reg_envio[2]).') '.
										$reg_envio[1].' Lote:'.$reg_envio[3];
					}
					$worksheet1->write_string($linha_ini,$coluna,$dados_envio,$formatotl);
					$coluna++;
				}


				$linha_ini++;


				if(($itens=='S') && ($registro->Nr_Nota>0) &&
					(($registro->Modelo=='01')||($registro->Modelo=='02')||
					($registro->Modelo=='55')||($registro->Modelo=='65')||
					($registro->Modelo=='97')||($registro->Modelo=='98'))
					){
					$cons_item = 'select Id_Produto, Quantidade_Estoque, Valor_Unitario, Valor_Total '.
							   ' from nota_fiscal_item '.
							   ' where Dominio="'.$_SESSION['Dominio'].'"'.
							   ' and Empresa="'.$registro->Empresa.'"'.
							   ' and Nr_Nota="'.$registro->Nr_Nota.'"'.
							   ' order by Seq_Item';
					$res_item = consulta_sql($cons_item);
					$nrw_item = consulta_num_registros($res_item);
					if($nrw_item>0){
						$coluna=0;

						$worksheet1->write_string($linha_ini,$coluna,'',$formatotc);
						$coluna++;

						$worksheet1->write_string($linha_ini,$coluna,'Produto',$formatotli);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+5);
						for($lne=0;$lne<=5;$lne++){
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
						}

						$worksheet1->write_string($linha_ini,$coluna,'Quantidade',$formatotri);
						$coluna++;

						$worksheet1->write_string($linha_ini,$coluna,'Valor Unitrio',$formatotri);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						for($lne=0;$lne<=1;$lne++){
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
						}

						$worksheet1->write_string($linha_ini,$coluna,'Valor Total',$formatotri);
						$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
						for($lne=0;$lne<=1;$lne++){
							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
						}

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

						$linha_ini++;

						for($it=0;$it<$nrw_item;$it++){
							$reg_item = consulta_ler_linha($res_item);
							$coluna=0;

							$worksheet1->write_string($linha_ini,$coluna,'',$formatotc);
							$coluna++;

							$desc_prod = '';
							if($reg_item[0]>0){
								$cons_prod = 'select Codigo_Produto, Descricao_Completa from produto '.
											' where Dominio = "'.$_SESSION['Dominio'].'" '.
											' and Id_Produto = "'.$reg_item[0].'" ';
								$res_prod = consulta_sql($cons_prod);
								$reg_prod = consulta_ler_linha($res_prod);
								consulta_limpa($res_prod);
								$desc_prod = $reg_prod[0].'-'.$reg_prod[1];
							}
							$worksheet1->write_string($linha_ini,$coluna,$desc_prod,$formatotli);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+5);
							for($lne=0;$lne<=5;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$worksheet1->write_number($linha_ini,$coluna,$reg_item[1],$formatotqtdi);
							$coluna++;

							$worksheet1->write_number($linha_ini,$coluna,$reg_item[2],$formatotipreco);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							for($lne=0;$lne<=1;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$worksheet1->write_number($linha_ini,$coluna,$reg_item[3],$formatotipreco);
							$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
							for($lne=0;$lne<=1;$lne++){
								$coluna++;
								$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
							}

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$coluna++;
							$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

							$linha_ini++;
						}
					}
					consulta_limpa($res_item);
				}


				$vl_desconto+= $registro->Valor_Desconto;
				$vl_acrescimo+= $registro->Valor_Acrescimo;

				if($contar_total){
					$vl_valor+= $registro->Valor;
					$vl_valor_geral+= $registro->Valor;
					$vl_valor_grupo+= $registro->Valor;
				}
				$vl_pago+= $registro->Valor_Liquido;

				$vl_desconto_geral+= $registro->Valor_Desconto;
				$vl_acrescimo_geral+= $registro->Valor_Acrescimo;
				$vl_pago_geral+= $registro->Valor_Liquido;


				$vl_desconto_grupo+= $registro->Valor_Desconto;
				$vl_acrescimo_grupo+= $registro->Valor_Acrescimo;
				$vl_pago_grupo+= $registro->Valor_Liquido;
            }
        }

        if($grupo != ''){
			if($id_fornec!=''){
				$coluna=0;
				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'TOTAL CLIENTE',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.str_replace('"','',to_money($vl_com_contratos)),$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.str_replace('"','',to_money($vl_sem_contratos)),$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'Saldo: '.str_replace('"','',to_money($vl_valor-($vl_pago+$vl_desconto-$vl_acrescimo))),$formatotlb);

				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$vl_desconto,$formatotbpreco);

				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$vl_acrescimo,$formatotbpreco);

				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$vl_valor,$formatotbpreco);

				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$vl_pago,$formatotbpreco);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$linha_ini++;

				$vl_desconto = 0;
				$vl_acrescimo = 0;
				$vl_valor = 0;
				$vl_pago = 0;

				$vl_com_contratos = 0;
				$vl_sem_contratos = 0;

			}

			if((($id_vendedor!='')&&($grupo=='V'))||
				(($id_empresa!='')&&($grupo=='E'))){
                $coluna=0;

                if($grupo=='V'){
					$coluna++;
					$worksheet1->write_string($linha_ini,$coluna,'TOTAL '.UpperDados($label),$formatotlb);
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
                }else{
					$coluna++;
					$worksheet1->write_string($linha_ini,$coluna,'TOTAL EMPRESA',$formatotlb);
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
                }

                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.str_replace('"','',to_money($vl_com_contratos_grupo)),$formatotlb);
                $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.str_replace('"','',to_money($vl_sem_contratos_grupo)),$formatotlb);
                $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $coluna++;
                $worksheet1->write_string($linha_ini,$coluna,'Saldo: '.str_replace('"','',to_money($vl_valor_grupo-($vl_pago_grupo+$vl_desconto_grupo-$vl_acrescimo_grupo))),$formatotlb);

                $coluna++;
                $worksheet1->write_number($linha_ini,$coluna,$vl_desconto_grupo,$formatotbpreco);

                $coluna++;
                $worksheet1->write_number($linha_ini,$coluna,$vl_acrescimo_grupo,$formatotbpreco);

                $coluna++;
                $worksheet1->write_number($linha_ini,$coluna,$vl_valor_grupo,$formatotbpreco);

                $coluna++;
                $worksheet1->write_number($linha_ini,$coluna,$vl_pago_grupo,$formatotbpreco);

                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $coluna++;
                $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

                $linha_ini++;

                $vl_desconto_grupo = 0;
                $vl_acrescimo_grupo = 0;
                $vl_valor_grupo = 0;
                $vl_pago_grupo = 0;

                $vl_com_contratos_grupo = 0;
                $vl_sem_contratos_grupo = 0;

			}

			if(($id_fornec!='') && ($_SESSION['Dominio'] == $dominios['71'])){
				$coluna=0;
				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCIDO',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$total_vencido,$formatotbpreco);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$linha_ini++;



				$coluna=0;
				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'TOTAL VENCER',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas


				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);
				$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_string($linha_ini,$coluna,'',$formatotlb);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_number($linha_ini,$coluna,$total_vencer,$formatotbpreco);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$coluna++;
				$worksheet1->write_blank($linha_ini,$coluna,$formatotc);

				$linha_ini++;

				$total_vencido = 0;
				$total_vencer = 0;
            }
        }
        $linha_ini++;
        $coluna=0;

        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,'TOTAL GERAL',$formatotlb);
        $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas

        if($grupo == ''){
			$coluna++;
			$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
        }

        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,'S Contratos: '.str_replace('"','',to_money($vl_com_contratos_geral)),$formatotlb);
        $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,'Sem Contratos: '.str_replace('"','',to_money($vl_sem_contratos_geral)),$formatotlb);
        $worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+1);
        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,'Saldo: '.str_replace('"','',to_money($vl_valor_geral-($vl_pago_geral+$vl_desconto_geral-$vl_acrescimo_geral))),$formatotlb);

        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,$vl_desconto_geral,$formatotbpreco);

        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,$vl_acrescimo_geral,$formatotbpreco);

        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,$vl_valor_geral,$formatotbpreco);

        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,$vl_pago_geral,$formatotbpreco);

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $coluna++;
        $worksheet1->write_blank($linha_ini,$coluna,$formatotc);

        $linha_ini++;

		if($cheques == 'S'){
			$_REQUEST['contas_receber'] = 1;
			$_REQUEST['venc_ini'] = $_REQUEST['tipo_data_ini'];
			$_REQUEST['venc_fim'] = $_REQUEST['tipo_data_fim'];
			$_REQUEST['ordenacao'] = 'N';
			$_REQUEST['status_ini'] = '';
			$_REQUEST['status_fim'] = '';

			if($_REQUEST['situacao'] == 'A'){
				$_REQUEST['status'] = 'A';
			}else if($_REQUEST['situacao'] == 'F'){
				$_REQUEST['status'] = 'F';
			}else if($_REQUEST['situacao'] == 'S'){
				$_REQUEST['status'] = 'I';
			}else{
				$_REQUEST['status'] = '';
			}
			require_once('relatorio_cheques_pre_cheque_excel_include.php');
		}
    }else{
        $worksheet1->write(10,0,"No existem registros para este filtro!");
    }
    consulta_limpa($resultado);

    $insert = 'insert into relatorio_tmp ( '.
              ' Dominio, '.
              ' Usuario, '.
              ' Descricao ) values ('.
              '"'.$_SESSION['Dominio'].'", '.
              '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
              '"")';
    consulta_sql($insert);
    $workbook->close();
?>