<?
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	require_once('../../includes/write_excel/Worksheet.php');
	require_once('../../includes/write_excel/Workbook.php');
if(session::usr_conectado($_REQUEST['USER_ID'])){
	function HeaderingExcel($filename) {
		header("Content-type: application/vnd.ms-excel");
		header("Content-Disposition: attachment; filename=$filename" );
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
		header("Pragma: public");
	}

	$nm_arquivo = 'venda.xls';
	HeaderingExcel($nm_arquivo);

	$dt_ini = datad($_REQUEST['dt_ini']);
	$dt_fim = datad($_REQUEST['dt_fim']);

	//consulta empresa emitente
	$con_empresa = 'select * from pessoa '.
				   ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
				   ' and Pessoa="'.$_REQUEST['empresa'].'"';
	$res_empresa = consulta_sql($con_empresa);
	$reg_empresa = consulta_ler_objeto($res_empresa);
	consulta_limpa($res_empresa);

	// Creating a workbook
	$workbook = new Workbook("-");
	// Creating the first worksheet
	$titulo_sheet = 'SIAGRO';
	$worksheet1 =& $workbook->add_worksheet($titulo_sheet);

	// Format for the headings
	$formatot =& $workbook->add_format();
	$formatot->set_size(18);

	$formatost =& $workbook->add_format();
	$formatost->set_size(14);

	$hoje = DATE("d/m/Y");
	$hora = DATE("H:m");
	$worksheet1->write_string(0,0,'RELATRIO SIAGRO',$formatot);
	$worksheet1->write(3,0,config_pad('sistema_licenca'));
	$worksheet1->write(4,0,"Data: ".$hoje." - Hora: ".$hora);
	$worksheet1->write(5,0,"Usurio: ".base64_decode_si($_REQUEST['USER_ID']));

	$filtro = "Empresa: ".  $reg_empresa->Nome_Listas . " De: ".dataf($dt_ini) ." At: " . dataf($dt_fim);
	$worksheet1->write(7,0,"Filtro: ".$filtro);
	//$worksheet1->insert_bitmap(9,0,"../../imgs/logo_menu.bmp",0,0);

	// Format for the headings
	$formatott =& $workbook->add_format();
	$formatott->set_align('center');
	$formatott->set_pattern();
	$formatott->set_fg_color(40);
	$formatott->set_bold(1);
	$formatott->set_border(1);

	// Format for the headings
	$formatotl =& $workbook->add_format();
	$formatotl->set_border(1);
	$formatotl->set_align('left');

	$formatotr =& $workbook->add_format();
	$formatotr->set_border(1);
	$formatotr->set_align('right');

	$formatotlb =& $workbook->add_format();
	$formatotlb->set_border(1);
	$formatotlb->set_size(10);
	$formatotlb->set_align('left');
	$formatotlb->set_bold(1);

	$formatotrb =& $workbook->add_format();
	$formatotrb->set_border(1);
	$formatotrb->set_size(10);
	$formatotrb->set_align('right');
	$formatotrb->set_bold(1);

	$formatotqtdb =& $workbook->add_format();
	$formatotqtdb->set_border(1);
	$formatotqtdb->set_align('right');
	$formatotqtdb->set_size(10);
	$formatotqtdb->set_bold(1);
	$formatotqtdb->set_num_format('[Blue]#,##0_);[Red]-#,##0_)');

	// Format for the headings
	$formatotc =& $workbook->add_format();
	$formatotc->set_border(1);
	$formatotc->set_align('center');

	// Format for the headings
	$formatotqtd =& $workbook->add_format();
	$formatotqtd->set_border(1);
	$formatotqtd->set_align('right');
	$formatotqtd->set_num_format('[Blue]#,##0_);[Red]-#,##0_)');

	// Format for the headings
	$formatotpreco =& $workbook->add_format();
	$formatotpreco->set_border(1);
	$formatotpreco->set_align('right');
	$formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

	// Format for the headings
	$formatotbpreco =& $workbook->add_format();
	$formatotbpreco->set_border(1);
	$formatotbpreco->set_align('right');
	$formatotbpreco->set_bold(1);
	$formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

	$fim_Linha = '';

	//endereco
	$con_empresa = 'select * from pessoa_endereco '.
				   ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
				   ' and Pessoa="'.$_REQUEST['empresa'].'"'.
				   ' and Situacao<>"E"'.
				   ' order by Seq_Endereco';
	$res_empresa = consulta_sql($con_empresa);
	$reg_empresae = consulta_ler_objeto($res_empresa);
	consulta_limpa($res_empresa);

	$cpf_agronomo = '';
	//vieras
	$agronomo_p='';
	if ($_SESSION['Dominio'] == 2){
		if ($_SESSION['Empresa_Codigo']=='1'){
			$agronomo_p = '145';
		}else if ($_SESSION['Empresa_Codigo']=='2'){
			$agronomo_p = '86807';
		}
		//mafrta
		//contenda
		else if ($_SESSION['Empresa_Codigo']=='7'){
			$agronomo_p = '149';
		}else if ($_SESSION['Empresa_Codigo']=='8'){
			$agronomo_p = '107';
		}else if ($_SESSION['Empresa_Codigo']=='9'){
			$agronomo_p = '88246';
		}else if ($_SESSION['Empresa_Codigo']=='10'){
			$agronomo_p = '12612';
		}else if ($_SESSION['Empresa_Codigo']=='13'){
			$agronomo_p = '151';
		}
	}
	if ($_SESSION['Dominio']==358){
		$agronomo_p = '3045';
	}

	$texto_final = '';
	$linhas_dados = array();
	$linhas_receita = array();
	$venda = 0;
	$receita_anterior='';
	$qtd_acuml = 0;

	$filtro_dep = '';

	/*
	if ($_SESSION['Dominio']==2){
		$filtro_dep = ' and ((Prod_Depart = 1) or '.
							'(Prod_Depart = 2) or '.
							'(Prod_Depart = 3) or '.
							'(Prod_Depart = 15) or '.
							'(Prod_Depart = 21))  '.
					 ' and (Id_Produto not in (606,763,955,662,7561,4029,698,3961,4949,4562,'.
											' 6392,4331,3760,3984,696,423,8080,3678,2617, '.
											' 1304,1205,1848,4183,1116,4384,428,429,430,432,431,4084,9341, '.
											' 9369,9304,9368,9530'.
											')) ';
	}
	if ($_SESSION['Dominio']==333){
		$filtro_dep = ' and (Prod_Depart = 2)  ';
	}

	//consulta nota
	$con_notas = 'select * from nota_fiscal '.
				 ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
				 ' and Empresa = "'.$_REQUEST['empresa'].'"'.
				 ' and DH_EntSai>="'.$dt_ini.'"'.
				 ' and DH_EntSai<="'.$dt_fim.' 23:59:59"'.
				 ' and Situacao="F" and TipoES="1" and Nat_Op_Mov_Estoque="D"'.
				 ' order by DH_EntSai';
	$res_notas = consulta_sql($con_notas);
	$nrw_notas = consulta_num_registros($res_notas);
	for($n=0;$n<$nrw_notas;$n++){
		$reg_notas = consulta_ler_objeto($res_notas);
		//caso no esteja na prpria nota
		$receita_anterior = '';
		$qtd_acuml = 0;
		//consulta aliquota usada dos itens
		$con_item = 'select Seq_Item, Quantidade_Estoque, Id_Produto, Nr_Receituario, Agronomo '.
				   ' from nota_fiscal_item '.
				   ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
				   ' and Empresa = "'.$reg_notas->Empresa.'"'.
				   ' and Nr_Nota="'.$reg_notas->Nr_Nota.'"'.
				   ' and Nr_Receituario<>"N"'.
				   $filtro_dep.
				   ' order by Nr_Receituario, Seq_Item';

		$res_item = consulta_sql($con_item);
		$nrw_item = consulta_num_registros($res_item);

		if ($nrw_item >0){
			if($reg_notas->Nat_Op_Gera_Contas=='R'){
				//nao precisa fazer nada
			}else{
				$cons_ref = 'select Seq_Item from nota_fiscal_item_ref '.
						 ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
						 ' and Empresa = "'.$reg_notas->Empresa.'"'.
						 ' and Nr_Nota="'.$reg_notas->Nr_Nota.'"'.
						 ' and Campo = "Qtd_Remetida"';
				$res_ref = consulta_sql($cons_ref);
				$nrw_ref = consulta_num_registros($res_ref);
				consulta_limpa($res_ref);
				if($nrw_ref>0){
					//nao precisa fazer nada
				}else{
					$nrw_item = 0;
				}
			}
		}

		for($r=0;$r<$nrw_item;$r++){
			$reg_qtd = consulta_ler_linha($res_item);
			//consulta cliente
			$con_pessoa = 'select Nome_Razao, CPF_CNPJ from pessoa '.
					  ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					  ' and Pessoa="'.$reg_notas->Destinatario.'"';
			$res_pessoa = consulta_sql($con_pessoa);
			$reg_pessoa = consulta_ler_linha($res_pessoa);
			consulta_limpa($res_pessoa);

			$pessoa_nome = $reg_pessoa[0];
			$pessoa_cpf  = $reg_pessoa[1];
			$qtd         = $reg_qtd[1];

			$con_desc = 'select * from produto '.
					  ' Where Dominio = "'.$_SESSION['Dominio'].'"'.
					  ' and Id_Produto="'.$reg_qtd[2].'"';
			$res_desc = consulta_sql($con_desc);
			$reg_desc = consulta_ler_objeto($res_desc);
			consulta_limpa($res_desc);

			if(($reg_desc->Embalagem_Qtd != 0)&&($reg_desc->Embalagem_Qtd != 1)){
				$qtd = $qtd * $reg_desc->Embalagem_Qtd;
			}

			

			if (($receita_anterior==$reg_qtd[3])&&($receita_anterior!='')){
				$qtd_acuml+= $qtd;//somente acumula pro prox item
			}else{
				$qtd_acuml = $qtd;  //incializa e no acumula
				//cria o novo registro
				$venda++;
			}

			$agronomo = ($reg_qtd[4]>0) ? $reg_qtd[4] : $agronomo_p;
			$sqlag = 'select Nome_Listas, CPF_CNPJ from pessoa where Dominio="'.$_SESSION['Dominio'].'" and Pessoa="'.$agronomo.'"';
			$resag = consulta_sql($sqlag);
			$regag = consulta_ler_objeto($resag);
			consulta_limpa($resag);

			if($agronomo!=''){
				$cpf_agronomo = ($regag->CPF_CNPJ);
			}

			$receita_anterior = $reg_qtd[3];
			$linhas_dados[$venda]['Nr_Receita']= $reg_qtd[3];
			$linhas_dados[$venda]['Produto']= $reg_qtd[2];
			$linhas_dados[$venda]['Produto_Descricao']= $reg_desc->Descricao_Completa;
			$linhas_dados[$venda]['Qtd'] = $qtd;
			$linhas_dados[$venda]['Cpf_Cliente']= $pessoa_cpf;
			$linhas_dados[$venda]['Nome_Cliente']= $pessoa_nome;
			$linhas_dados[$venda]['Cpf_Agronomo']= $cpf_agronomo;
			$linhas_dados[$venda]['Nome_Agronomo']= $regag->Nome_Listas;
			if($reg_notas->Serie!=''){
				$linhas_dados[$venda]['NrDoc']= $reg_notas->NrDoc . '-' . $reg_notas->Serie;
			}else{
				$linhas_dados[$venda]['NrDoc']= $reg_notas->NrDoc;
			}
			$linhas_dados[$venda]['UF']= $reg_empresae->UF;
			$linhas_dados[$venda]['DH_Emissao']= dataf($reg_notas->DH_Emissao);
			$linhas_dados[$venda]['CNPJ_Empresa']= ($reg_empresa->CPF_CNPJ);
			$linhas_dados[$venda]['Acumulado']= formata_valor(formata_qtd($qtd_acuml,3,false));
		}
		consulta_limpa($res_item);
	}//looping de notas
	consulta_limpa($res_notas);
	*/
	$texto_final = '';
	$linhas_dados = array();
	$linhas_receita = array();
	$venda = 0;
	$receita_anterior='';
	$qtd_acuml = 0;

	$filtro_dep = '';
	if ($_SESSION['Dominio']==2){
		$filtro_dep = ' AND ((Prod_Depart = 1) or '.
							'(Prod_Depart = 2) or '.
							'(Prod_Depart = 3) or '.
							'(Prod_Depart = 15) or '.
							'(Prod_Depart = 21))  '.
					 ' AND (Id_Produto not in (606,763,955,662,7561,4029,698,3961,4949,4562,'.
											' 6392,4331,3760,3984,696,423,8080,3678,2617, '.
											' 1304,1205,1848,4183,1116,4384,428,429,430,432,431,4084,9341, '.
											' 9369,9304,9368,9530,9841,9844,9930,9931,9932,9933, '.
											' 10024,10120'.
											')) ';
	}
	if ($_SESSION['Dominio']==333){
		$filtro_dep = ' AND (Prod_Depart = 2)  ';
	}
	if ($_SESSION['Dominio']==358){
		$filtro_dep = ' AND (Prod_Depart = 20)  ';
	}

	//consulta nota
	$con_notas = 'SELECT * FROM nota_fiscal '.
				 ' WHERE Dominio="'.$_SESSION['Dominio'].'"'.
				 ' AND Empresa="'.$_REQUEST['empresa'].'"'.
				 ' AND DH_EntSai>="'.$dt_ini.'"'.
				 ' AND DH_EntSai<="'.$dt_fim.' 23:59:59"'.
				 ' AND Situacao="F" '.
				 ' AND TipoES="1" '.
				 ' AND Nat_Op_Mov_Estoque="D"'.
				 ' ORDER BY DH_EntSai';
	$res_notas = consulta_sql($con_notas);
	$nrw_notas = consulta_num_registros($res_notas);
	for($n=0;$n<$nrw_notas;$n++){
		$reg_notas = consulta_ler_objeto($res_notas);
		//caso no esteja na prpria nota
		$receita_anterior = '';
		$qtd_acuml = 0;
		$qtd_acumlE = 0;
		$seq_amb = 0;
		//consulta aliquota usada dos itens
		$con_item = 'SELECT '.
					' Seq_Item, '.
					' Quantidade_Estoque, '.
					' Id_Produto, '.
					' Nr_Receituario, '.
					' Agronomo, '.
					' NrLote '.
					' FROM nota_fiscal_item '.
					' WHERE Dominio="'.$_SESSION['Dominio'].'"'.
					' AND Empresa="'.$reg_notas->Empresa.'"'.
					' AND Nr_Nota="'.$reg_notas->Nr_Nota.'"'.
					' AND Nr_Receituario<>"N"'.
					$filtro_dep.
					' ORDER BY Nr_Receituario, Id_Produto, NrLote , Seq_Item';

		$res_item = consulta_sql($con_item);
		$nrw_item = consulta_num_registros($res_item);

		if ($nrw_item >0){
			if($reg_notas->Nat_Op_Gera_Contas=='R'){
				//nao precisa fazer nada
			}else{
				$cons_ref = 'SELECT Seq_Item FROM nota_fiscal_item_ref '.
							' WHERE Dominio="'.$_SESSION['Dominio'].'"'.
							' AND Empresa="'.$reg_notas->Empresa.'"'.
							' AND Nr_Nota="'.$reg_notas->Nr_Nota.'"'.
							' AND Campo="Qtd_Remetida"';
				$res_ref = consulta_sql($cons_ref);
				$nrw_ref = consulta_num_registros($res_ref);
				consulta_limpa($res_ref);
				if($nrw_ref>0){
					//nao precisa fazer nada
				}else{
					$nrw_item = 0;
				}
			}
		}

		for($r=0;$r<$nrw_item;$r++){
			$reg_qtd = consulta_ler_objeto($res_item);
			if ($reg_notas->Dest_Razao <> ''){
				$pessoa_nome = $reg_notas->Dest_Razao;
				$pessoa_cpf = $reg_notas->Dest_CPF_CNPJ;
			}else{
				//consulta empresa emitente
				$con_pessoa='SELECT Nome_Razao,CPF_CNPJ FROM pessoa '.
							' WHERE Dominio="'.$_SESSION['Dominio'].'"'.
							' AND Pessoa="'.$reg_notas->Destinatario.'"';
				$res_pessoa = consulta_sql($con_pessoa);
				$reg_pessoa = consulta_ler_linha($res_pessoa);
				consulta_limpa($res_pessoa);
				$pessoa_nome = $reg_pessoa[0];
				$pessoa_cpf = $reg_pessoa[1];
			}
			
			$con_desc = 'SELECT * FROM produto '.
						' WHERE Dominio="'.$_SESSION['Dominio'].'"'.
						' AND Id_Produto="'.$reg_qtd->Id_Produto.'"';
			$res_desc = consulta_sql($con_desc);
			$reg_desc = consulta_ler_objeto($res_desc);
			consulta_limpa($res_desc);

			$agronomo = ($reg_qtd->Agronomo>0) ? $reg_qtd->Agronomo : $agronomo_p;
			$sqlag ='SELECT CPF_CNPJ, Nome_Listas FROM pessoa '.
					' WHERE Dominio="'.$_SESSION['Dominio'].'" '.
					' AND Pessoa="'.$agronomo.'"';
			$resag = consulta_sql($sqlag);
			$regag = consulta_ler_objeto($resag);
			consulta_limpa($resag);

			
			$cpf_agronomo = limpa_numero($regag->CPF_CNPJ);
			

			$qtd = $reg_qtd->Quantidade_Estoque*1;
			$qtdE = $qtd;

			$qtd_emb = 1;
			if(($reg_desc->Embalagem_Qtd != 0)&&($reg_desc->Embalagem_Qtd != 1)){
				$qtd_emb = ($reg_desc->Embalagem_Qtd*1);
				$qtd = ($qtd * $qtd_emb);
			}

			$lote = str_replace(';','',$reg_qtd->NrLote);

			$nr_receita = str_replace('#','',$reg_qtd->Nr_Receituario);
			$nr_receita = str_replace('A','#A',$nr_receita);
			$nr_receita = str_replace('B','#B',$nr_receita);
			$nr_receita = str_replace('C','#C',$nr_receita);

			if (($receita_anterior==$nr_receita)&&($receita_anterior!='')){
			// 	$qtd_acuml+= $qtd;//somente acumula pro prox item
			// 	$qtd_acuml+= $qtdE;
			}else{
				$seq_amb=0;
			}
			$qtd_acuml = $qtd;  //incializa e no acumula
			$qtd_acumlE = $qtdE;
			//cria o novo registro
			$venda++;	

			

			$receita_anterior = $nr_receita;
			
			$linhas_dados[$venda]['Nr_Receita']    = $nr_receita;
			$linhas_dados[$venda]['Produto']       = $reg_desc->Codigo_Produto;
			$linhas_dados[$venda]['Produto_Descricao'] = $reg_desc->Descricao_Completa;
			$linhas_dados[$venda]['Qtd']           = $qtd;
			$linhas_dados[$venda]['Cpf_Cliente']   = $pessoa_cpf;
			$linhas_dados[$venda]['Nome_Cliente']  = $pessoa_nome;
			$linhas_dados[$venda]['Cpf_Agronomo']  = $cpf_agronomo;
			$linhas_dados[$venda]['Nome_Agronomo'] = $regag->Nome_Listas;
			$linhas_dados[$venda]['NrDoc']         = $reg_notas->NrDoc . '/' . $reg_notas->Serie;
			$linhas_dados[$venda]['UF']            = $reg_empresae->UF;
			$linhas_dados[$venda]['DH_Emissao']    = dataf($reg_notas->DH_Emissao);
			$linhas_dados[$venda]['CNPJ_Empresa']  = ($reg_empresa->CPF_CNPJ);
			$linhas_dados[$venda]['Qtd']           = formata_valor(formata_qtd($qtd_acuml,3,false));
			$linhas_dados[$venda]['Seq_Emb']       = '';
			$linhas_dados[$venda]['Lavavel']       = '';
			$linhas_dados[$venda]['Qtd_Venda']     = '';
			$linhas_dados[$venda]['Qtd_Emb']       = '';
			$linhas_dados[$venda]['Material']      = '';
			$linhas_dados[$venda]['Lote']          = '';

			if ($lote!=''){
				$seq_amb++; 

				$lavavel = 1;$nm_lavavel = 'Lavvel';
				if ($reg_desc->Embalagem_Tipo>10){
					$lavavel = 2; $nm_lavavel = 'No Lavvel';
				}
				$material = 3; $nm_material = 'Plstico';
				if (($reg_desc->Embalagem_Tipo==4)||($reg_desc->Embalagem_Tipo==14)){
					$material = 1;
				}
				if (($reg_desc->Embalagem_Tipo==3)||($reg_desc->Embalagem_Tipo==13)){
					$material = 5;
				}
				if ($reg_desc->Embalagem_Material>0){
					$material = $reg_desc->Embalagem_Material;
				}
				if ($material==1){ $nm_material = 'Ao';      }
				if ($material==2){ $nm_material = 'Alumnio'; }
				if ($material==3){ $nm_material = 'Plstico'; }
				if ($material==4){ $nm_material = 'IBC';      }
				if ($material==5){ $nm_material = 'Flexvel'; }

				$linhas_dados[$venda]['Seq_Emb']       = $seq_amb;
				$linhas_dados[$venda]['Lavavel']       = $lavavel.'-'.$nm_lavavel;
				$linhas_dados[$venda]['Qtd_Venda']     = formata_valor(formata_qtd($qtd_acumlE,3,false));
				$linhas_dados[$venda]['Qtd_Emb']       = formata_valor(formata_qtd($qtd_emb,3,false));
				$linhas_dados[$venda]['Material']      = $material.'-'.$nm_material;
				$linhas_dados[$venda]['Lote']          = $lote;
			}
		}
		consulta_limpa($res_item);
	}//looping de notas
	consulta_limpa($res_notas);	

	$linha_ini = 9;

	$worksheet1->set_column($coluna,$coluna,16);
	$worksheet1->write_string($linha_ini,$coluna,'Nr Receiturio',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'Produto',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,32);
	$worksheet1->write_string($linha_ini,$coluna,'Produto Descrio',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,20);
	$worksheet1->write_string($linha_ini,$coluna,'CPF Cliente',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,32);
	$worksheet1->write_string($linha_ini,$coluna,'Nome Cliente',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,20);
	$worksheet1->write_string($linha_ini,$coluna,'CPF Agronomo',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,32);
	$worksheet1->write_string($linha_ini,$coluna,'Nome Agronomo',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'Nr Nota',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,5);
	$worksheet1->write_string($linha_ini,$coluna,'UF',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'Emissao',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,22);
	$worksheet1->write_string($linha_ini,$coluna,'CNPJ Empresa',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'Qtd Total',$formatott);
	$coluna++;	

	$worksheet1->set_column($coluna,$coluna,8);
	$worksheet1->write_string($linha_ini,$coluna,'Seq',$formatott);
	$coluna++;
	
	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'Emb. Tipo',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,20);
	$worksheet1->write_string($linha_ini,$coluna,'Qtd Vendida (Nr Emb)',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,12);
	$worksheet1->write_string($linha_ini,$coluna,'Emb. Volume',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,15);
	$worksheet1->write_string($linha_ini,$coluna,'Emb. Material',$formatott);
	$coluna++;

	$worksheet1->set_column($coluna,$coluna,25);
	$worksheet1->write_string($linha_ini,$coluna,'Nr Lote',$formatott);
	$coluna++;

	$linha_ini++;

	foreach($linhas_dados as $linha){
		$coluna = 0;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Nr_Receita'], $formatotl);
		$coluna++;

		$worksheet1->write_number($linha_ini, $coluna, $linha['Produto'], $formatotl);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Produto_Descricao'], $formatotl);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Cpf_Cliente'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Nome_Cliente'], $formatotl);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Cpf_Agronomo'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Nome_Agronomo'], $formatotl);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['NrDoc'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['UF'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['DH_Emissao'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['CNPJ_Empresa'], $formatotc);
		$coluna++;

		$worksheet1->write_number($linha_ini, $coluna, $linha['Qtd'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Seq_Emb'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Lavavel'], $formatotl);
		$coluna++;

		$worksheet1->write_number($linha_ini, $coluna, $linha['Qtd_Venda'], $formatotc);
		$coluna++;

		$worksheet1->write_number($linha_ini, $coluna, $linha['Qtd_Emb'], $formatotc);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Material'], $formatotl);
		$coluna++;

		$worksheet1->write_string($linha_ini, $coluna, $linha['Lote'], $formatotl);
		$coluna++;

		$linha_ini++;
	}

	$workbook->close();
}
?>