<?
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	define('FPDF_FONTPATH', '../../fpdf/font/');
	require('../../fpdf/fpdf.php');
if(session::usr_conectado($_REQUEST['USER_ID'])){

	//$hora = nr2hora(hora_atual());
	//$hoje = data_atual('data');
	$filtro = '';

	class PDF extends FPDF{
		var $Empresa;
		var $FoneEmpresa;
		var $NumeroPedido;
		var $Dt_Emissao;
		var $Dt_Validade;

		var $CodCliente;
		var $NomeCliente;
		var $NmFantasiaCliente;
		var $EnderecoCliente;
		var $CidadeCliente;
		var $BairroCliente;
		var $CEPCliente;
		var $UFCliente;
		var $FoneCliente;
		var $CPFCNPJCliente;
		var $RGCliente;

		var $Transportadora;
		var $Dt_Despacho;
		var $Comprador;
		var $Frete;
		var $Observacao;
		var $CodVendedor;
		var $DescVendedor;
		var $Forma_pagto;

		var $Sub_Total;
		var $Desconto;
		var $Acrescimo;
		var $Total;
		var $Qtdade;
		var $PesoTotal;

		function Header($tipo_cab='tudo'){
			if ($this->DefOrientation=='P'){
				$tamanho_total_linha = 190;
			}else{
				$tamanho_total_linha = 275;
			}
			$this->SetFillColor(255,255,255);
			$date=getdate();
			$hoje = fill_full($date['year'],4).'-'.fill_full($date['mon'],2).'-'.fill_full($date['mday'],2);
			$hora = fill_full($date['hours'],2).':'.fill_full($date['minutes'],2).':'.fill_full($date['seconds'],2);

			$consulta_usuario = 'select Nome from usuario '.
						   ' where Dominio = "'.$_SESSION["Dominio"].'"'.
						   ' and Usuario = "'.base64_decode_si($_REQUEST['USER_ID']).'"';
			$res = consulta_sql($consulta_usuario);
			$row = consulta_ler_linha($res);
			$nome_usuario = $row[0];
			consulta_limpa($res);

			$this->SetFont('Arial','B',14);
			//Imprime Cabealho

			$this->Cell(1,  20, ' ', 0,0,'C');
			if($tipo_cab=='tudo'){
				//$this->Cell(30, 15, dataf($hoje).' '.($hora), 0,0,'L');
				$this->Cell(30, 15, '', 0,0,'L');  //para ficar certo o posicionamento do cabecalho central
				$base_y = 0;
				//$this->Cell(1,  15, ' ', 1,0,'C');
				//$this->Image(busca_imagem_empresa('blogo_menu.jpg', '../../'), (($tamanho_total_linha/2)-5), (15+$base_y), 30,15);  //50,20
				$this->Image(busca_imagem_empresa('logo_menu.jpg', '../../'), 12, (8+$base_y), 45, 16);
				//$this->Cell(1,  15, ' ', 1,1,'C');
			}else{
				$this->Cell(30, 20, " ", 0,0,'L');
			}

			$lns_cabecalho = $this->Lines_MultiCell(($tamanho_total_linha-60),5,$this->Cabecalho,1);
			$y=$this->y;
			$this->MultiCell(($tamanho_total_linha-60), (20/($lns_cabecalho*5)) * 5, $this->Cabecalho, 0,'C');
			$this->y=$y;

			$this->SetFont('Arial','B',10);
			$this->AliasNbPages();
			if($tipo_cab=='tudo'){
				//$this->Cell(30, 15, "Hora: ".($hora), 1,0,'R');
				$this->Cell(35, 20, 'Pg.: '.$this->PageNo().' / {nb}',0,0,'R');
			}
			$this->Cell(1,  20, ' ', 0,1,'C');

			$this->SetFont('Arial','B',10);
			if($tipo_cab=='tudo'){
				$this->Cell(1,  5, ' ', 0,0,'C');
				$this->Cell(($tamanho_total_linha/2), 5, $this->Empresa, 0,0,'L');
				$this->Cell(($tamanho_total_linha/2), 5, dataf($hoje).' '.($hora), 0,0,'R');
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->Cell(1,  5, ' ', 0,0,'C');
				$this->Cell(($tamanho_total_linha/2), 5, 'FONE: '.$this->FoneEmpresa, 0,0,'L');
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->Cell(1,  5, ' ', 0,0,'C');
				$this->Cell(($tamanho_total_linha/5), 5, strtoupper(busca_nome_pedido_orc()).' NR: '.$this->NumeroPedido, 0,0,'L');
				$this->Cell(($tamanho_total_linha/5), 5, $this->Dt_Emissao, 0,0,'R');
				$this->Cell(($tamanho_total_linha/5), 5, 'VLIDO AT: '.$this->Dt_Validade, 0,0,'R');
				$this->Cell(($tamanho_total_linha/5), 5, '', 0,0,'R');
				$this->Cell(($tamanho_total_linha/5), 5, strtoupper($nome_usuario), 0,0,'R');
				$this->Cell(1,  5, ' ', 0,1,'C');
			}

			if($tipo_cab=='tudo'){

				$this->SetFont('Arial','B',9); //10

				$lns = 5;
				$larg = 190;

				$this->SetFont('Arial','',9); //10

				$this->Cell(1,  $lsn, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(21, $lns, 'Cliente........: ', 'T', 'L'); //22
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$lns_lin1 = $this->Lines_MultiCell(79, $lns, $this->CodCliente.' - '.$this->NomeCliente, 'T', 'L'); //78

				$pos_y=$this->y;
				$this->MultiCell(79, $lns, $this->CodCliente.' - '.$this->NomeCliente, 'T', 'L'); //78
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(25, $lns, 'Nome Fantasia: ', 'T', 'L'); //28
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$lns_lin = $this->Lines_MultiCell(65, $lns, $this->NmFantasiaCliente, 'T', 'L'); //62
				if($lns_lin1>$lns_lin){
					$lns_lin = $lns_lin1;
				}

				$pos_y=$this->y;
				$this->MultiCell(65, $lns, $this->NmFantasiaCliente, 'T', 'L');
				$this->y=$pos_y;

				$this->Cell(1,  $lns, ' ', 0,1,'C');

				$this->y=$pos_y + ($lns_lin*5);

				$this->SetFont('Arial','',9);

				$this->Cell(1,  $lns, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(21, $lns, 'Endereo....: ', '', 'L'); //23
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(169, $lns, $this->EnderecoCliente, '', 'L'); //167
				$this->y=$pos_y;
				$this->Cell(1,  $lns, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(21, 5, 'Cidade........: ', '', 'L'); //23
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(79, 5, $this->CidadeCliente, '', 'L'); //77
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(14, 5, 'Bairro: ', '', 'L'); //14
				$this->y=$pos_y;

				$this->SetFont('Arial','B',10);

				$pos_y=$this->y;
				$this->MultiCell(76, 5, $this->BairroCliente, '', 'L'); //76
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(21, 5, 'CEP............: ', '', 'L'); //24
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(79, 5, $this->CEPCliente, '', 'L'); //76
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(8, 5, 'UF: ', '', 'L'); //9
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(42, 5, $this->UFCliente, '', 'L'); //41
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(12, 5, 'Fone: ', '', 'L'); //13
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(28, 5, $this->FoneCliente, '', 'L'); //27
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);  

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(21, 5, 'CPF/CNPJ..: ', '', 'L'); //24
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(79, 5, $this->CPFCNPJCliente, '', 'L'); //76
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(7, 5, 'IE: ', '', 'L'); //8
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(83, 5, $this->RGCliente, '', 'L'); //82
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				//linha
				$this->Cell(1,  (1/($lns_cabecalho*5)) * 5, ' ', 0,0,'C');
				$this->MultiCell(($tamanho_total_linha), (5/($lns_cabecalho*5)) * 5, ' ', 'T', 'C');
				$this->Cell(1,  (1/($lns_cabecalho*5)) * 5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(34, 5, 'Transportador(a).......: ', '', 'L'); //38
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(156, 5, $this->Transportadora, '', 'L'); //152
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(34, 5, 'Data Prev. Despacho: ', '', 'L'); //38
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(86, 5, $this->Dt_Despacho, '', 'L'); //82
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(22, 5, 'Plano Pgto..: ', '', 'L'); //24
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(48, 5, '', '', 'L'); //46
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(34, 5, 'Comprador................: ', '', 'L'); //38
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(86, 5, $this->Comprador, '', 'L'); //82
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$pos_y=$this->y;
				$this->MultiCell(22, 5, 'Forma Pgto.: ', '', 'L'); //24
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(48, 5, $this->Forma_pagto, '', 'L'); //46
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(34, 5, 'Observao..............: ', '', 'L'); //38
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$pos_y=$this->y;
				$this->MultiCell(156, 5, $this->Observacao, '', 'L');
				$this->y=$pos_y;
				$this->Cell(1,  5, ' ', 0,1,'C');

				$this->SetFont('Arial','',9);

				$label = label_vendedor_ou_rep_comercial('S');
				if($this->CodVendedor>0){
					$label_emp = empresa_representante($this->CodVendedor,'S');
				}else{
					$label_emp = '';
				}
				if($label=='Vendedor'){
					$q_pontos = '..';
				}else{
					$q_pontos = '';
				}
				$this->Cell(1,  5, ' ', 0,0,'C');
				$pos_y=$this->y;
				$this->MultiCell(34, 5, $label.'................'.$q_pontos.': ', '', 'L'); //38
				$this->y=$pos_y;

				$this->SetFont('Arial','B',9);

				$lns_lin2 = $this->Lines_MultiCell(116, $lns, $label_emp, '', 'L'); //112

				$pos_y=$this->y;
				$this->MultiCell(116, $lns, $label_emp, '', 'L');  //112
				$this->y=$pos_y;

				$this->SetFont('Arial','',9);

				$lns_lin3 = $this->Lines_MultiCell(40, $lns, '(  ) C.I.F.        (  ) F.O.B.', '', 'L');
				if($lns_lin2>$lns_lin3){
					$lns_lin3 = $lns_lin2;
				}

				$pos_y=$this->y;
				$this->MultiCell(40, 5, '(  ) C.I.F.        (  ) F.O.B.', '', 'L');
				$this->y=$pos_y;

				$this->Cell(1,  $lns, ' ', 0,1,'C');

				$this->y=$pos_y + ($lns_lin3*5);

				$lns = 1;
				$y=$this->y;
				$this->MultiCell(190, $lns, '', 'B', 'L');
				$this->y=$y;

				$this->Cell(1,      $lns, ' ', 0,1,'C');
				//Prxima Linha
				$this->x=$this->lMargin;
				$this->y=$y+$lns;
				$this->SetAutoPageBreak(true,30);
			}

			if($this->Sub_Cabecalho_Texto!=''){
				$this->SetFont('Arial',$this->Sub_Cabecalho_Style,10);
				$lns_cabecalho = $this->Lines_MultiCell($tamanho_total_linha,5,$this->Sub_Cabecalho_Texto,$this->Sub_Cabecalho_Border);
				$this->Cell(1,  ($lns_cabecalho*5), ' ', 0,0,'C');
				$y=$this->y;
				$this->MultiCell($tamanho_total_linha, 5 , $this->Sub_Cabecalho_Texto, $this->Sub_Cabecalho_Border,$this->Sub_Cabecalho_Align);
				$this->y=$y;
				$this->Cell(1,  ($lns_cabecalho*5), ' ', 0,1,'C');
				$this->x=$this->lMargin;
				$this->y=$y+($lns_cabecalho*5);
				$this->SetAutoPageBreak(true,30);
				$this->SetFont('Arial','',10);
			}

			if($this->CabecalhoGrid_Texto!=''){
				$this->Cell(1,  5, ' ', 0,0,'C');
				$this->SetFont('Arial','B',10);

				foreach($this->CabecalhoGrid_Texto as $key => $reg){
					$tamanho = $this->CabecalhoGrid_Tamanho[$key];
					$tamanho = $tamanho/100;
					$tamanho = $tamanho_total_linha*$tamanho;
					$valor = $this->CabecalhoGrid_Texto[$key];
					$this->Cell($tamanho, 5, $valor, $this->CabecalhoGrid_Border[$key],0,$this->CabecalhoGrid_Align[$key]);
				}
				$this->Cell(1,  5, ' ', 0,1,'C');
			}
			$this->SetFont('Arial','',10);
		}

		function Footer(){
			$this->SetFillColor(255,255,255);
			$tamanho_total_linha = 190;

			/*
			$con_pedido = 'select * from pedido '.
			' where Dominio="'.$_SESSION["Dominio"].'"'.
			' and Empresa="'.$_SESSION["Empresa_Codigo"].'"'.
			' and Numero_Pedido = "'.base64_decode_si($_REQUEST['idreg']).'"';
			$res_pedido = consulta_sql($con_pedido);
			$reg_pedido = consulta_ler_objeto($res_pedido);
			consulta_limpa($res_pedido);

			$total = (($reg_pedido->Valor_Sub_Total +  $reg_pedido->Valor_Acrescimo) -($reg_pedido->Valor_Desconto));
			*/

			$novo_y = 252;  //266
			$this->AliasNbPages();
			$this->SetFont("Arial","",9);
			$this->y=$novo_y+5;

			//Subtotal
			$y=$this->y;
			$this->MultiCell(140, 5, '', 'T','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 5, 'Sub-Total...:', 'T','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 5, str_replace('"','',to_money($this->Sub_Total)), 'T','R');
			$this->y=$y;

			$this->Cell(1,      5, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			//Desconto
			$y=$this->y;
			$this->MultiCell(140, 3, '', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 3, 'Desconto....:', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 3, str_replace('"','',to_money($this->Desconto)), '','R');
			$this->y=$y;

			$this->Cell(1,      3, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			//Acrescimo
			$y=$this->y;
			$this->MultiCell(140, 2, '', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 2, 'Acrscimo..:', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 2, str_replace('"','',to_money($this->Acrescimo)), '','R');
			$this->y=$y;

			$this->Cell(1,      2, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			//Total
			$this->SetFont('Arial','B',9);

			$y=$this->y;
			$this->MultiCell(140, 1, '', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 1, 'TOTAL.......:', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 1, str_replace('"','',to_money($this->Total)), '','R');
			$this->y=$y;

			$this->Cell(1,      1, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			//Qtde Total
			$this->SetFont('Arial','',9);

			$y=$this->y;
			$this->MultiCell(40, 3, '', '','L');
			$this->y=$y;

			//$y=$this->y;
			//$this->MultiCell(90, 5, '', 'B','C');
			//$this->y=$y;

			$y=$this->y;
			$this->MultiCell(100, 3, '', '','C');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 3, 'Qtde. Total.:', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 3, $this->Qtdade, '','R');
			$this->y=$y;

			$this->Cell(1,      3, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			//Peso Total
			$this->SetFont('Arial','',9);

			$y=$this->y;
			$this->MultiCell(140, 2, '', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 2, 'Peso Total..:', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 2, $this->PesoTotal, '','R');
			$this->y=$y;

			$this->Cell(1,      2, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			//Assinatura
			$this->SetFont('Arial','',9);

			$y=$this->y;
			$this->MultiCell(40, 3, '', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(90, 3, 'Assinatura', 'T','C');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(10, 3, '', '','C');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(20, 3, '', '','L');
			$this->y=$y;

			$y=$this->y;
			$this->MultiCell(30, 3, '', '','R');
			$this->y=$y;

			$this->Cell(1,      3, ' ', 0,1,'C');
			//Prxima Linha
			$this->x=$this->lMargin;
			$this->y=$y+5;
			$this->SetAutoPageBreak(true,45);

			$this->SetFont('Arial','',9);

			$y=$this->y;
			$this->MultiCell(190, 5, '', 'T','C');
			$this->y=$y;
		}
	}

	$con_pedido = 'select * from pedido '.
				  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				  ' and Empresa = "'.$_SESSION["Empresa_Codigo"].'"'.
				  ' and Numero_Pedido = "'.base64_decode_si($_REQUEST['idreg']).'"';
	$res_pedido = consulta_sql($con_pedido);
	$reg_pedido = consulta_ler_objeto($res_pedido);
	consulta_limpa($res_pedido);

	$nr_pedido = $reg_pedido->Numero_Pedido;

	//Consulta a pessoa
	$con_pessoa = 'select Pessoa, Nome_Listas, CPF_CNPJ from pessoa '.
			   ' where Dominio="'.$_SESSION["Dominio"].'"'.
			   ' and Pessoa = "'.$reg_pedido->Pessoa.'"';
	$res_pessoa = consulta_sql($con_pessoa);
	$reg_pessoa = consulta_ler_linha($res_pessoa);
	consulta_limpa($res_pessoa);

	$nome = 'Nome: '.$reg_pedido->Pessoa.' - '.$reg_pessoa[1];

	$filtro.= 'Impresso de '.busca_nome_pedido_orc();

	$pdf=new PDF();
	$pdf->Open();

	$pdf->Cabecalho = strtoupper(busca_nome_pedido_orc());
	$pdf->Cabecalho_Filtro =  $filtro;
	$pdf->Sub_Cabecalho_Texto =  '';
	$pdf->Sub_Cabecalho_Style =  'B';
	$pdf->Sub_Cabecalho_Align =  'L';
	$pdf->Sub_Cabecalho_Border =  0;

	set_time_limit(60);

	//Consulta a Empresa
	$con_empresa = 'select Pessoa, Nome_Razao from pessoa '.
				' where Dominio = "'.$_SESSION["Dominio"].'"'.
				' and Pessoa = "'.$reg_pedido->Empresa.'"';
	$res_empresa = consulta_sql($con_empresa);
	$reg_empresa = consulta_ler_linha($res_empresa);
	consulta_limpa($res_empresa);

	//Consulta o Telefone da Empresa
	$con_emp_tel = 'select Numero_Telefone from pessoa_telefone '.
				' where Dominio = "'.$_SESSION["Dominio"].'" '.
				' and Pessoa = "'.$reg_pedido->Empresa.'"'.
				' and Situacao <> "E"'.
				' order by Seq_Telefone '.
				' limit 1';
	$res_emp_tel = consulta_sql($con_emp_tel);
	$reg_emp_tel = consulta_ler_linha($res_emp_tel);
	consulta_limpa($res_emp_tel);

	//Consulta o Cliente
	$con_cli = 'select Pessoa, Nome_Razao, Nome_Fantasia, CPF_CNPJ, RG from pessoa '.
			' where Dominio = "'.$_SESSION["Dominio"].'"'.
			' and Pessoa = "'.$reg_pedido->Pessoa.'"';
	$res_cli = consulta_sql($con_cli);
	$reg_cli = consulta_ler_linha($res_cli);
	consulta_limpa($res_cli);

	if(($reg_pedido->DH_Emissao=='')||($reg_pedido->DH_Emissao=='0000-00-00')){
		$dt_emissao = '';
	}else{
		$dt_emissao = dataf($reg_pedido->DH_Emissao);
	}

	if(($reg_pedido->DT_Validade=='')||($reg_pedido->DT_Validade=='0000-00-00')){
		$dt_validade = '';
	}else{
		$dt_validade = dataf($reg_pedido->DT_Validade);
	}

	if(($reg_pedido->DH_Entrega=='')||($reg_pedido->DH_Entrega=='0000-00-00 00:00:00')){
		$dt_entrega = '';
	}else{
		$dt_entrega = dataf($reg_pedido->DH_Entrega);
	}

	$con_end_cli = 'select Logradouro, Numero, Nome_Cidade, Bairro, UF, CEP, Insc_Estadual from pessoa_endereco '.
					' where Dominio = "'.$_SESSION['Dominio'].'" '.
					' and Pessoa = "'.$reg_pedido->Pessoa.'"'.
					' and Situacao <> "E"'.
					' order by Seq_Endereco limit 1';
	$res_end_cli = consulta_sql($con_end_cli);
	$reg_end_cli = consulta_ler_linha($res_end_cli);
	consulta_limpa($res_end_cli);
	$endereco_log = $reg_end_cli[0].', ';
	if($reg_end_cli[1]!=''){
		$endereco_log.=$reg_end_cli[1];
	}else{
		$endereco_log.='S/N';
	}

	$rg_ie_cli = '';
	if($reg_end_cli[6]!=''){
		$rg_ie_cli = $reg_end_cli[6];
	}

	//Consulta o Telefone do Cliente
	$con_cli_tel = 'select Numero_Telefone from pessoa_telefone '.
				' where Dominio = "'.$_SESSION["Dominio"].'" '.
				' and Pessoa = "'.$reg_pedido->Pessoa.'"'.
				' and Situacao <> "E"'.
				' order by Seq_Telefone '.
				' limit 1';
	$res_cli_tel = consulta_sql($con_cli_tel);
	$reg_cli_tel = consulta_ler_linha($res_cli_tel);
	consulta_limpa($res_cli_tel);

	//Consulta Transportadora
	if($reg_pedido->Transportadora!=''){
		$con_transp = 'select Pessoa, Nome_Razao from pessoa '.
					  ' where Dominio = "'.$_SESSION["Dominio"].'" '.
					  ' and Pessoa = "'.$reg_pedido->Transportadora.'"';
		$res_transp = consulta_sql($con_transp);
		$reg_transp = consulta_ler_linha($res_transp);
		consulta_limpa($res_transp);

		$nome_transp = $reg_transp[1];
	}else{
		$nome_transp = '';
	}

	//Consulta Vendedor
	if($reg_pedido->Vendedor!=''){
		$con_vend = 'select Pessoa, Nome_Razao from pessoa '.
					' where Dominio = "'.$_SESSION["Dominio"].'" '.
					' and Pessoa = "'.$reg_pedido->Vendedor.'"';
		$res_vend = consulta_sql($con_vend);
		$reg_vend = consulta_ler_linha($res_vend);
		consulta_limpa($res_vend);

		$cod_vend = $reg_vend[0];
		$nome_vend = $reg_vend[1];
	}else{
		$cod_vend = '';
		$nome_vend = '';
	}

	//Consulta condicao pagamento
	$con_pagto = 'select Descricao from forma_pagto '.
				  ' where Dominio = "'.$_SESSION['Dominio'].'"'.
				  ' and Codigo_Pagto = "'.$reg_pedido->Forma_Pagto.'"';
	$res_pagto = consulta_sql($con_pagto);
	$reg_pagto = consulta_ler_linha($res_pagto);
	consulta_limpa($res_pagto);

	$frete_modal = busca_dados_combo('tipo_frete',$reg_pedido->Frete);
	if($reg_pedido->Frete==''){
		$frete_modal = '';
	}

	//variaveis
	$pdf->Empresa = $reg_empresa[1];
	$pdf->FoneEmpresa = $reg_emp_tel[0];
	$pdf->NumeroPedido = $reg_pedido->Numero_Pedido;
	$pdf->Dt_Emissao = $dt_emissao;
	$pdf->Dt_Validade = $dt_validade;

	$pdf->CodCliente = $reg_cli[0];
	$pdf->NomeCliente = $reg_cli[1];
	$pdf->NmFantasiaCliente = $reg_cli[2];
	$pdf->EnderecoCliente = $endereco_log;
	$pdf->CidadeCliente = $reg_end_cli[2];
	$pdf->BairroCliente = $reg_end_cli[3];
	$pdf->CEPCliente = $reg_end_cli[5];
	$pdf->UFCliente = $reg_end_cli[4];
	$pdf->FoneCliente = $reg_cli_tel[0];
	$pdf->CPFCNPJCliente = $reg_cli[3];
	$pdf->RGCliente = $rg_ie_cli;

	$pdf->Transportadora = $nome_transp;
	$pdf->Dt_Despacho = $dt_entrega;
	$pdf->Comprador = '';
	$pdf->Frete = $frete_modal;
	$pdf->Observacao = $reg_pedido->Observacao;
	$pdf->CodVendedor = $cod_vend;
	$pdf->DescVendedor = $nome_vend;
	$pdf->Forma_pagto = $reg_pagto[0];

	$total_ped = (($reg_pedido->Valor_Sub_Total + $reg_pedido->Valor_Acrescimo) - ($reg_pedido->Valor_Desconto));
	$pdf->Total = $total_ped;
	$pdf->Sub_Total = $reg_pedido->Valor_Sub_Total;
	$pdf->Desconto = $reg_pedido->Valor_Desconto;
	$pdf->Acrescimo = $reg_pedido->Valor_Acrescimo;

	$k=0;
	$pdf->CabecalhoGrid_Texto = '';
	$ncampos = 7;

	$pdf->AddPage();
	$pdf->SetFont('Arial','',9);

	$pdf->CabecalhoGrid_Texto[$k] = 'Qtde';
	$pdf->CabecalhoGrid_Tamanho[$k] = '5';
	$pdf->CabecalhoGrid_Align[$k] = 'C';
	$pdf->CabecalhoGrid_Border[$k] = 'TB';
	$k++;

	$pdf->CabecalhoGrid_Texto[$k] = 'U.M.';
	$pdf->CabecalhoGrid_Tamanho[$k] = '5';
	$pdf->CabecalhoGrid_Align[$k] = 'C';
	$pdf->CabecalhoGrid_Border[$k] = 'TB';
	$k++;

	$pdf->CabecalhoGrid_Texto[$k] = 'Cdigo';
	$pdf->CabecalhoGrid_Tamanho[$k] = '15';
	$pdf->CabecalhoGrid_Align[$k] = 'L';
	$pdf->CabecalhoGrid_Border[$k] = 'TB';
	$k++;

	$pdf->CabecalhoGrid_Texto[$k] = 'Descrio do Produto';
	$pdf->CabecalhoGrid_Tamanho[$k] = '41';
	$pdf->CabecalhoGrid_Align[$k] = 'L';
	$pdf->CabecalhoGrid_Border[$k] = 'TB';
	$k++;

	$pdf->CabecalhoGrid_Texto[$k] = 'Preo';
	$pdf->CabecalhoGrid_Tamanho[$k] = '13';
	$pdf->CabecalhoGrid_Align[$k] = 'R';
	$pdf->CabecalhoGrid_Border[$k] = 'TB';
	$k++;

	$pdf->CabecalhoGrid_Texto[$k] = 'Total';
	$pdf->CabecalhoGrid_Tamanho[$k] = '13';
	$pdf->CabecalhoGrid_Align[$k] = 'R';
	$pdf->CabecalhoGrid_Border[$k] = 'TB';
	$k++;

	$pdf->CabecalhoGrid_Texto[$k] = 'PE';
	$pdf->CabecalhoGrid_Tamanho[$k] = '8';
	$pdf->CabecalhoGrid_Align[$k] = 'C';
	$pdf->CabecalhoGrid_Border[$k] = 'TBL';
	$k++;

	$lns = 5;
	//imprime cabecalho
	$pdf->SetFont('Arial','B',9);
	$pdf->SetAutoPageBreak(true,45);
	$pdf->Cell(1,      $lns, '', 0,0,'C');
	$pdf->SetAutoPageBreak(false,30);

	for ($k=0;$k<$ncampos;$k++){
		$y=$pdf->y;
		$pdf->MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190, 5, $pdf->CabecalhoGrid_Texto[$k], $pdf->CabecalhoGrid_Border[$k],$pdf->CabecalhoGrid_Align[$k]);
		$pdf->y=$y;

		if($k==($ncampos-1)){
			$pdf->Cell(1,      $lns, ' ', 0,1,'C');
			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			$pdf->y=$y+$lns;
			$pdf->SetAutoPageBreak(true,30);

			$y=$pdf->y;
			$pdf->MultiCell(190, 0, '', 'T', 'L');
			$pdf->y=$y;
		}
	}

	//Prxima Linha
	$pdf->x=$pdf->lMargin;
	$pdf->y=$y;
	$pdf->SetAutoPageBreak(true,30);

	$cons_pedido_item ='Select * from pedido_item '.
					   ' where Dominio = "'.$_SESSION['Dominio'].'"'.
					   ' and Empresa="'.$_SESSION["Empresa_Codigo"].'"'.
					   ' and Numero_Pedido = "'.base64_decode_si($_REQUEST['idreg']).'"'.
					   ' and Status <> "E"';
	$res_pedido_item = consulta_sql($cons_pedido_item);
	$nro_pedido_item = consulta_num_registros($res_pedido_item);

	$quant = 0;
	$peso_prod = 0;
	$peso_total = 0;

	for($i=0;$i<$nro_pedido_item;$i++){
		$reg_pedido_item = consulta_ler_objeto($res_pedido_item);

		//consulta o peso do produto
		$cons_peso = 'select Peso_Liquido from produto '.
					 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
					 ' and Id_Produto = "'.$reg_pedido_item->ID_Produto.'"';
		$res_peso = consulta_sql($cons_peso);
		$reg_peso = consulta_ler_linha($res_peso);
		consulta_limpa($res_peso);

		$peso_prod = $reg_peso[0];
		$peso_total+= (formata_qtd($reg_pedido_item->Qtd)*formata_qtd($reg_peso[0],3,true));
		$pdf->PesoTotal = formata_qtd($peso_total,3,true);

		$lns = 0;

		//set_time_limit(60);
		$k = 0;
		$pdf->SetFont('Arial','',9);
		$pdf->Cell(1,      $lns, '', 0,0,'C');
		$pdf->SetAutoPageBreak(false,30);

		$quant+= $reg_pedido_item->Qtd;
		$pdf->Qtdade = formata_qtd($quant,3,true);

		//Consulta a descricao do produto
		$con_produto = 'select Descricao_Completa, Unidade_Venda, Codigo_Produto from produto '.
					   ' where Dominio = "'.$_SESSION['Dominio'].'"'.
					   ' and Id_Produto = "'.$reg_pedido_item->ID_Produto.'"';
		$res_produto = consulta_sql($con_produto);
		$reg_produto = consulta_ler_linha($res_produto);
		consulta_limpa($res_produto);

		//Quantidade
		$rowarr[$k]  =  formata_qtd($reg_pedido_item->Qtd);
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		//Unidade de Medida
		$rowarr[$k]  =  $reg_produto[1];
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		$codigo_produto = $reg_produto[2];
		if($reg_pedido_item->Barra_Produto!=''){
			$codigo_produto = $reg_pedido_item->Barra_Produto;
		}

		$rowarr[$k]  =  fill_full($codigo_produto,14);
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		$rowarr[$k]  =  $reg_produto[0];
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		//Valor Unitario
		$rowarr[$k]  =  str_replace('"','',to_money($reg_pedido_item->Valor_Unitario));
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		//Valor Total
		$rowarr[$k]  =  str_replace('"','',to_money($reg_pedido_item->Valor_Total)); //Custo Rep
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		//Prazo Entrega
		if(($reg_pedido_item->DT_PrazoEntrega=='')||($reg_pedido_item->DT_PrazoEntrega=='0000-00-00')){
			$prazo_entrega = '';
		}else{
			$prazo_entrega = dataf($reg_pedido_item->DT_PrazoEntrega);
		}
		$rowarr[$k]  =  $prazo_entrega;
		$vl_linha[$k] = $rowarr[$k];
		$lns_linha[$k] = $pdf->Lines_MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190,$lns,$rowarr[$k],0);
		if ($lns_linha[$k]>$lns){
			$lns = $lns_linha[$k];
		}
		$k++;

		$lns = $lns * 5;

		//$pdf->SetFont('Arial','',7);

		for ($k=0;$k<$ncampos;$k++){
			$valor = $vl_linha[$k];
			$y=$pdf->y;
			$pdf->MultiCell(($pdf->CabecalhoGrid_Tamanho[$k]/100)*190, ($lns/($lns_linha[$k]* 4)) * 4, $valor, str_replace('TB','',$pdf->CabecalhoGrid_Border[$k]),$pdf->CabecalhoGrid_Align[$k]);
			$pdf->y=$y;
		}

		$pdf->Cell(1,      $lns, ' ', 0,1,'C');
		//Prxima Linha
		$pdf->x=$pdf->lMargin;
		$pdf->y=$y+$lns;
		$pdf->SetAutoPageBreak(true,45);
	}
	consulta_limpa($res_pedido_item);
	echo $pdf->Output('Relatorio_'.config_pad('sistema_sigla').'.pdf','I');

}
?>