<?php
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	define('FPDF_FONTPATH', '../../fpdf/font/');
	require('../../fpdf/fpdf.php');
if(session::usr_conectado($_REQUEST['USER_ID'])){
	if(isset($_REQUEST['empresa'])){
		$filt_empresa = base64_decode_si($_REQUEST['empresa']);
	}else{
		$filt_empresa = $_SESSION['Empresa_Codigo'];
	}

	$fpdf = new FPDF();

	class PDF extends FPDF{
		var $NrEmpresa ;
		var $NrOS;
		var $TipoOS;

		function Header(){
			$this->AliasNbPages();

			$base_y = 0;

			$this->SetAutoPageBreak(false,30);
			$this->Image('../../imgs/os_layout29-F.jpg', 5, (5+$base_y), 200, 280);
			$this->Image(busca_imagem_empresa('logo_menu.jpg', '../../'),12, (14+$base_y), 30,15);
			$h = 60;
			$w = 10;
			$x = 40;
			$y = 12;
			$logo = busca_imagem_empresa('logo_menu.jpg', '../../');

			//Nome da empresa 
			$con_emp = 'SELECT Nome_Fantasia, Web_Site, Nome_Listas FROM pessoa '.
				  ' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= " '.$_SESSION['Empresa_Codigo'].' " ';
			$res_emp = consulta_sql($con_emp);
			$reg_emp = consulta_ler_linha($res_emp);
			consulta_limpa($res_emp);
			$lnh1 =  $reg_emp[0];

			$col = 80;
			$linha = 10;

			$this->SetFont('Arial','',8); 
				  #$this->SetTextColor(0,0,128);
			$this->y= ( $linha + ($base_y));
			$this->x=  $col;
			$this->MultiCell(110, 3, $lnh1, 0,'C');

			//Endereco empresa
			$con_end_emp = 'SELECT Logradouro, Numero, Complemento, Bairro, Nome_Cidade,  UF '.
						  ' FROM pessoa_endereco '.
						  ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						  ' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						  ' AND Situacao <> "E"'.
						  ' ORDER BY Seq_Endereco LIMIT 1';
			$res_end_emp = consulta_sql($con_end_emp);
			$reg_end_emp = consulta_ler_objeto($res_end_emp);
			consulta_limpa($res_end_emp);

			$lnh2 = $reg_end_emp->Logradouro.', ';
			if($reg_end_emp->Numero!=''){
				$lnh2.='N '.$reg_end_emp->Numero;
			}else{
				$lnh2.='S/N,';
			}
			$lnh2.=' '.$reg_end_emp->Complemento; 

			$linha +=5;
			$this->y= ( $linha + ($base_y));
			$this->x= $col;
			$this->MultiCell(110, 3, $lnh2, 0,'C');
			$con_tel_emp = 'SELECT  Numero_Telefone FROM  pessoa_telefone '.
						   ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						   ' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						   ' AND  Situacao = "A" '.
						   ' ORDER BY Seq_Telefone ';
			$res_tel_emp = consulta_sql($con_tel_emp);
			$reg_tel_emp = consulta_ler_linha($res_tel_emp);
			consulta_limpa($res_tel_emp);

			if($reg_tel_emp[0] !=''){
				$tel_emp = 'Telefone: '.$reg_tel_emp[0];                     
			}
			$linha +=5;  
			$this->y= ($linha + ($base_y));
			$this->x= $col;
			$this->MultiCell(110, 3, $tel_emp, 0,'C');

			//endereo virtual 0 e 1 , e apresentacao
			$con_contato_emp = 'SELECT EMail FROM pessoa_contato WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						  ' AND Pessoa = "'.$_SESSION['Empresa_Codigo'].'" '.
						  ' AND Situacao <> "E" '.
						  ' AND Tipo_Telefone=6 '.
						  ' OR Nome LIKE "CHAMADO%" '.
						  ' ORDER BY Seq_Contato';
			$res_contato_emp = consulta_sql($con_contato_emp);
			$reg_contato_emp = consulta_ler_linha($res_contato_emp);
			consulta_limpa($res_contato_emp);
			$end_v1=$reg_contato_emp[0];
			$end_v2= $reg_emp[1];
			$end_v3="Abertura de chamados: ".$end_v1." ou ".$end_v2;
			$linha +=4; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell(110, 3, 'Abertura de chamados:', 0,'C');
			$linha +=3.5; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell(110, 3, $end_v1, 0,'C');
			$linha +=3.5; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell(110, 3,' OU ', 0,'C');
			$linha +=3.5; 
			$this->y= ( $linha + ($base_y));
			$this->x=$col;
			$this->MultiCell(110, 3, $end_v2, 0,'C');

			$linha +=2;
			$this->y= ($linha + ($base_y));
			$this->x= $col;
			$this->MultiCell(8, 3, ' ', 0,'L');

			$con_os= 'SELECT * FROM ordem_servico '.
					 ' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
					 ' AND Empresa = "'.$_SESSION['Empresa_Codigo'].'" '.
					 ' AND Nr_OrdemServico = "'.base64_decode_si($_REQUEST['idreg']).'" ';

			$res_os = consulta_sql($con_os);
			$reg_os = consulta_ler_objeto($res_os);
			consulta_limpa($res_os);

			$ln = $linha + 3;
			$cel = 10;
			$tam = 190;
			//primeiro titulo
			$nr_os = $reg_os->Nr_OrdemServico ;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Oramento da '.UpperDados(busca_nome_os()).' N '.$nr_os, 0,'C',1);
				  //////////////////////////////////////////////////////////////////////////////////
				//inicio da Busca do Cliente 
			$con_cli = 'SELECT Nome_Razao, CPF_CNPJ, RG, EMail FROM pessoa '.
					   ' WHERE Dominio="'.$_SESSION["Dominio"].'" AND Pessoa= " '.$reg_os->Pessoa.' " ';
			$res_cli = consulta_sql($con_cli);
			$reg_cli = consulta_ler_linha($res_cli);
			consulta_limpa($res_cli);
			   
			$ln += 8;
			$cel = 10;
			$tam = 30; 
			//Nova linha - apresentacao do cliente - chamada
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'Cliente: ', 0,'L');
	   
			$cel += $tam;
			$tam = 150; 
			//Nova linha - apresentacao do cliente  - nome 
			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, $reg_cli[0], 0,'L');

			/////////////////////////// cliente - endereo
			$con_end_cli = 'SELECT Logradouro, Numero, Complemento, Bairro, Nome_Cidade, UF, CEP, Insc_Estadual'.            ' FROM pessoa_endereco '.
						   ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
						   ' AND Pessoa = "'.$reg_os->Pessoa.'"'.
						   ' AND Situacao <> "E"'.
						   ' ORDER BY Seq_Endereco LIMIT 1';
			$res_end_cli = consulta_sql($con_end_cli);
			$reg_end_cli = consulta_ler_linha($res_end_cli);
			consulta_limpa($res_end_cli);

			$end_cli = $reg_end_cli[0].', '.$reg_end_cli[1].' '.$reg_end_cli[2].' '.$reg_end_cli[3].' - '.$reg_end_cli[4].' - '.$reg_end_cli[5];

			$ln += 6;
			$cel = 10;
			$tam = 30; 
			$this->SetFont('Arial','B',8);
			// $this->SetTextColor(0,0,128);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'Endereo:', 0,'L');

			$cel += $tam;
			$tam = 130;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, $end_cli, 0,'L');

			$cel += $tam;
			$tam = 10;
			$this->SetFont('Arial','B',8);
			// $this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'CEP: ', 0,'L');

			$cel += $tam;
			$tam = 20;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, $reg_end_cli[6], 0,'L');
			/////////////////////////////// CNPJ
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			// $this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 3, 'CPF/CNPJ: ', 0,'L');

			$cel += $tam;
			$tam = 120;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, $reg_cli[1], 0,'L');

			/////////////////   TELEFONE:
			$con_cli_tel = 'SELECT  Numero_Telefone FROM pessoa_telefone '.
						  ' where Dominio = "'.$_SESSION["Dominio"].'" '.
						  ' and Pessoa = "'.$reg_os->Pessoa.'"'.
						  ' and Situacao <> "E"'.
						  ' order by Seq_Telefone '.
						  ' limit 3';
			$res_cli_tel = consulta_sql($con_cli_tel);         
			$nrows_tel = consulta_num_registros($res_cli_tel);
			$tel='';
			if($nrows_tel>0){
				for($i=0;$i<$nrows_tel;$i++){
					$reg_cli_tel = consulta_ler_linha($res_cli_tel);
					if ($tel != '') {
						$tel.=', ';
					}
					$tel.= $reg_cli_tel[0];
				}
			}
			consulta_limpa($res_cli_tel);
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			// $this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 3, 'Telefone: ', 0,'L');

			$cel += $tam;
			$tam = 120;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, $tel, 0,'L');

			///////////////////////////  EMAIL
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			// $this->SetTextColor(0,0,128);
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam , 3, 'E-mail: ', 0,'L');
			   
			$cel += $tam;
			$tam = 120;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, $reg_cli[3], 0,'L');

			///////////////////////////////////////  Equipamento
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 3, 'Equipamento: ', 0,'L');
			$cel += $tam;
			$tam = 128;
			$this->SetFont('Arial','',10);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 3,$reg_os->Equipamento, 0,'L');
			////////  entrada
			$cel += $tam;
			$tam = 14;
			$this->SetFont('Arial','B',8); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'Entrada:', 0,'L');
			$cel += $tam;
			$tam = 30;
			//$hora_os = ' '.substr($reg_os->DH_Emissao,11,5);
			$this->SetFont('Arial','',10); 
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, dataf($reg_os->DH_Emissao), 0,'L');

			///////////////////////////////////////  Marca Modelo 
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'Marca/Modelo:', 0,'L');
			$cel += $tam;
			$tam = 120;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3,$reg_os->Marca.'/'.$reg_os->Modelo, 0,'L');
			   /////////////////////////   numero de serie
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'N de Srie: ', 0,'L');
			$cel += $tam;
			$tam = 120;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3,$reg_os->NrSerie, 0,'L');
			//////////////////////    codigo INLOG
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'Cdigo INLOG: ', 0,'L');
			$cel += $tam;
			$tam = 40;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3,$reg_os->Aparelho, 0,'L');
			$cel += $tam;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam , 3, 'Obs Adicional:', 0,'L');
			$cel += $tam;
			$tam = 60;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3,$reg_os->ObsAdicional, 0,'L');
			//////////////////////   MILL DESK 
			$ln += 6;
			$cel = 10;
			$tam = 30;
			$this->SetFont('Arial','B',8);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3, 'MillDesk:', 0,'L');
			$cel += $tam;
			$tam = 120;
			$this->SetFont('Arial','',10);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel ;
			$this->MultiCell( $tam , 3,$reg_os->Setor, 0,'L');

			////////////////////// MILL DESK 
			// $ln += 6;
			// $cel = 10;
			// $tam = 30;
			// $this->SetFont('Arial','B',8);
			// $this->y= ( $ln + ($base_y));
			// $this->x= $cel;
			// $this->MultiCell($tam, 3, 'MillDesk:', 0,'L');
			// $cel += $tam;
			// $tam = 120;
			// $this->SetFont('Arial','',10);
			// $this->y= ( $ln + ($base_y));
			// $this->x= $cel ;
			// $this->MultiCell( $tam , 3,$reg_os->Setor, 0,'L');
			////////////////////////   defeito 
			$ln += 6;
			$cel = 10;
			$tam = 190;
			//primeiro titulo
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Defeito/Reclamao', 0,'C',1);
			///////////////// parecer do cliente 
			$ln += 7;
			$cel = 10;
			$tam = 190;
			$this->SetFont('Arial','',8); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 3,$reg_os->ParecerCliente, 0,'L');
			$ln += 18;
			$cel = 10;
			$tam = 190;
			//primeiro titulo
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Valores da Ordem de Servio', 0,'C',1);

			//Grade itens pedido
			$ln += 8;
			$cel = 10;
			$tam = 10;
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x=  $cel ;
			$this->MultiCell( $cel , 3, 'Item', 0,'L');

			$cel += $tam ;
			$tam = 102;
			$this->y= ($ln + ($base_y));
			$this->x=  $cel ;
			$this->MultiCell( $tam, 3, 'Produto(s)/Servio(s)', 0,'L');

			$cel += $tam ;
			$tam = 10;
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell( $tam, 3, 'Unid.', 0,'L');

			$cel += $tam ;
			$tam = 13;
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell( $tam, 3, ' Qtd', 0,'R');
			$cel += $tam ;
			$tam = 20;
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell( $tam, 3, 'Vl. Unitrio', 0,'R');

			$cel += $tam ;
			$tam = 15;
			$this->y= ($ln + ($base_y));
			$this->x=  $cel;
			$this->MultiCell($tam, 3, 'Desc.', 0,'R');

			//$cel += $tam ;
			//$tam = 15;
			//$this->y= ($ln + ($base_y));
			//$this->x=  $cel;
			//$this->MultiCell($tam, 3, 'Acresc. ', 1,'C');

			$cel += $tam ;
			$tam = 20;
			$this->y= ($ln + ($base_y));
			$this->x=  $cel ;
			$this->MultiCell($tam, 3, 'Vl. Total', 0,'R');

			/////////////////////////// A PARTIR DAQUI O FIM 
			$ln_fim = 230;
			$ln = $ln_fim;

			$cel = 90;
			$tam = 80;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x=$cel;
			$this->MultiCell($tam, 6, 'Valor Total Geral ', 0,'L',1);

			$cel += $tam;
			$tam = 30;
			//primeiro titulo
			$this->SetFont('Arial','',12);
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6,  str_replace('"','',to_money($reg_os->Valor_Total_Liquido)), 0,'C',1);

			//condicoes de pagamento 
			$ln += 6;
			////////////////////
			$con_pagto = 'SELECT Descricao FROM forma_pagto WHERE Dominio = "'.$_SESSION["Dominio"].'" '.
						' AND  Codigo_Pagto   = "'.$reg_os->Forma_Pagto.'" ';             
			$res_pagto = consulta_sql($con_pagto);         
			$reg_pagto = consulta_ler_linha($res_pagto);
			consulta_limpa($res_pagto);
			$ln += 6;
			$cel = 10;
			$tam = 190;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(250,250,250);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, 'Condies de Pagamento ', 0,'C',1);

			$ln += 7;
			$cel = 10;
			$tam = 190;
			$this->SetFont('Arial','',12); 
			$this->SetFillColor(0,0,128); 
			$this->SetTextColor(0,0,0);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell($tam, 6, $reg_pagto[0], 0,'C');

			$ln += 6;
			$cel = 10 ;
			$tam = 190;

			$frase="O grupo inlog no se responsabiliza pela perda de dados contidos no Disco Rgido.  de inteira responsabilidade do cliente ter uma cpia de segurana de seus dados.";
			$frase2 = "ORAMENTO DE REPARO DE IMPRESSORAS E PLACA ME (NOTEBOOK, DESKTOP) REPROVADOS PELO CLIENTE SERA COBRADO UMA TAXA DE R$ 25,00";
			//frases 
			$this->SetFont('Arial','B',5);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 3,UpperDados($frase), 0,'L');

			$ln += 6;
			//frases 
			$this->SetFont('Arial','B',5);
			$this->SetTextColor(0,0,0);
			$this->y= ($ln + ($base_y));
			$this->x= $cel;
			$this->MultiCell( $tam, 3,UpperDados($frase2), 0,'L');

			/////////////////////////////////////////////////            //Assinaturas 

			$ln += 18;
			for ($i=11; $i <90 ; $i++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i;
				$this->MultiCell($i+1, 4, '_', 0,'L');
			}            
			for ($i=111; $i <190 ; $i++) { 
				$this->SetFont('Arial','',8);
				$this->y= ( $ln + ($base_y));
				$this->x= $i;
				$this->MultiCell($i+1, 3, '_', 0,'L');
			} 
			$ln += 6;
			$cel = 11;
			$tam = 80;
			$this->SetFont('Arial','',12);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel  ;

			$cliente =  $reg_cli[0];
			$qtd = $this->Lines_MultiCell( $tam, 3,  $cliente, 0, 'C');
			while($qtd > 1){
				$cliente = substr( $cliente,0,strlen( $cliente)-1);
				$qtd = $this->Lines_MultiCell($tam, 3,  $cliente, 0, 'C');
			}

			$this->MultiCell( $tam, 3, $cliente, 0,'C');

			$cel+= $tam + 20;
			$tam = 80; 

			$this->SetFont('Arial','',12);
			$this->y= ( $ln + ($base_y));
			$this->x= $cel;
			$emitente =  $reg_emp[0];
			$qtd = $this->Lines_MultiCell( $tam, 3, $emitente, 0, 'C');
			while($qtd > 1){
				$emitente = substr( $emitente,0,strlen($emitente)-1);
				$qtd = $this->Lines_MultiCell($tam, 3, $emitente, 0, 'C');
			}

			$this->MultiCell( $tam, 3,  $emitente, 0,'C');

			$ln += 6;
			$cel= 100 ;

			//valores
			$this->SetFont('Arial','B',7);
			$this->SetTextColor(0,0,0);

			$this->y= 145;// 135 
		}/// FECHA O HEADER

		function Footer(){
			if($this->Cabecalho != ''){
				$base_y = 0;
				$this->y= (230 + ($base_y));
				$this->x= 25;
				$this->MultiCell(90, 4, 'Continua na prxima pgina...', 0,'L');
			}
			// ainda nao sei o por que o footrer nao aparece em todas as paginas 
		}
	}
	//$pdf->AddPage();

	$pdf=new PDF();
	$pdf->Open();
	$pdf->Cabecalho =  '';
	$pdf->Cabecalho_Filtro =  '';
	$pdf->Sub_Cabecalho_Texto =  '';
	$pdf->Sub_Cabecalho_Style =  'B';
	$pdf->Sub_Cabecalho_Align =  'L';
	$pdf->Sub_Cabecalho_Border =  0;

	$con_ordem = 'SELECT * FROM ordem_servico '.
			  ' WHERE Dominio = "'.$_SESSION["Dominio"].'" '.
			  ' AND Empresa = "'.$filt_empresa.'"'.
			  ' AND Nr_OrdemServico =  "'.base64_decode_si($_REQUEST['idreg']).'"';
	$res_ordem = consulta_sql($con_ordem);
	$reg_ordem = consulta_ler_objeto($res_ordem);
	consulta_limpa($res_ordem);

	//variaveis
	$pdf->NrEmpresa = $reg_ordem->Empresa;
	$pdf->NrOrdem = $reg_ordem->Nr_OrdemServico;

	$k = 0;
	$pdf->AddPage();
	$base_y =0;
	$total_desconto =0;

	$con_item = 'SELECT * FROM ordem_servico_item '.
				  ' WHERE  Dominio = "'.$_SESSION["Dominio"].'" '.
				  ' AND Empresa = "'.$filt_empresa.'" '.
				  ' AND Nr_OrdemServico = "'.base64_decode_si($_REQUEST['idreg']).'" '.
				  ' AND ( Status <> "C"  and Status <> "E" ) '.
				  ' ORDER BY Seq_Item asc ';
	$res_item = consulta_sql($con_item);
	$nrows_item = consulta_num_registros($res_item);

	if( $nrows_item > 0){
		$pdf->Cabecalho = 'ITENS';
		$pdf->y= (144 + ($base_y)); // original  62 , teswte 150 
		$pdf->lMargin=9;
		$pdf->x=$pdf->lMargin;

		for($i=0;$i<$nrows_item;$i++){
			$reg_item = consulta_ler_objeto($res_item);
			$lns = 4;

			$pdf->SetTextColor(0,0,0);
			$pdf->SetFont('Arial','',8);
			$pdf->Cell(1,      $lns, '', 0,0,'C');
			$pdf->SetFont('Arial','',8);
			$pdf->SetAutoPageBreak(false,30);

			$item=$i+1;
			$nm = $pdf->Lines_MultiCell(10, $lns, $item, 0, 'C');
			//serve apenas para contar ????/

			$y=$pdf->y;
			$pdf->MultiCell(10, ($lns*$nm), $item , 0,'C');
			$pdf->y=$y;  

			$cons_prod = 'SELECT Codigo_Produto, Descricao_Completa, Unidade_Venda, Codigo_Depart '.
						 ' FROM  produto '.
						 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
						 ' and Id_Produto = "'.$reg_item->Id_Produto.'" ';
			$res_prod = consulta_sql($cons_prod);
			$reg_prod = consulta_ler_linha($res_prod);
			consulta_limpa($res_prod);

			//if($reg_item->Barra_Produto!=''){
			//	$codigo_produto = $reg_item->Barra_Produto;
			//}else {
			$codigo_produto = $reg_prod[0];
			//}
			$nome_produto = $reg_prod[1];
			$obs = $reg_item->Obs;

			$prod = $codigo_produto.' - '.$nome_produto;

			//$y=$pdf->y;
			//$pdf->MultiCell(15, ($lns*$nm),$item, 0,'C');
			//$pdf->y=$y;


			// $y=$pdf->y;
			// $pdf->MultiCell(10, ($lns*$nm), $reg_item->Seq_Item , 0,'C');
			// $pdf->y=$y;         

			$y=$pdf->y;

			$novo = $pdf->Lines_MultiCell(102,  $lns, $prod, 0, 'L');
			while($novo > 1){
				$prod = substr( $prod ,0,strlen( $prod)-1);
				$novo = $pdf->Lines_MultiCell(102, $lns,  $prod, 0, 'L');
			}

			$pdf->MultiCell(102, $lns,$prod, 0,'L');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(10, $lns, $reg_prod[2], 0,'C');
			$pdf->y=$y;

			$qtd=formata_qtd($reg_item->Qtd,3,false);
			$y=$pdf->y;
			$pdf->MultiCell(13, ($lns*$nm), $qtd, 0,'R');
			$pdf->y=$y;
			$qtd_total+=$qtd;

			$y=$pdf->y;
			$pdf->MultiCell(20, ($lns*$nm), str_replace('"','',to_money($reg_item->Valor_Unitario)), 0,'R');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(15, ($lns*$nm), str_replace('"','',to_money($reg_item->Valor_Desconto)), 0,'R');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(20, ($lns*$nm), str_replace('"','',to_money($reg_item->Valor_Total)), 0,'R');
			$pdf->y=$y;

			$pdf->Cell(1,      $lns, ' ', 0,0,'C');
			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			$pdf->y=$y+($lns*$nm);
			$pdf->SetAutoPageBreak(true,80);

			//$obs = $reg_item->Obs;
			//if($obs!=''){
			//	$pdf->SetFont('Arial','B',8);
			//	//$pdf->Cell(1,      $lns, ' ', 0,1,'C');
			//	$pdf->SetFont('Arial','B',8);

			//	$y=$pdf->y;
			//	$pdf->MultiCell(11, $lns,'', 0,'L');
			//	$pdf->y=$y;
			//	$y=$pdf->y;
			//	$pdf->MultiCell(84, $lns,$obs, 0,'L');
			//	$pdf->y=$y;

			//	$pdf->Cell(1,      $lns, ' ', 0,1,'C');
			//	//Prxima Linha
			//	$pdf->x=$pdf->lMargin;
			//	$pdf->y=$y+$lns;
			//	$pdf->SetAutoPageBreak(true,30);
			//}
		}
	}
	//consulta_limpa($res_item);

	$pdf->SetAutoPageBreak(false,30);
	$pdf->Cabecalho =  '';

	//salva pdf do pedido para mandar por email
	$diretorio = '';

	$arquivo = MD5($_REQUEST['USER_ID']).'.tmp';
	$diretorio = '../../../arquivos_clientes/'.$_SESSION['Dominio'].'/upload/email';

	if(file_exists($diretorio.'/'.$arquivo)){
		unlink($diretorio.'/'.$arquivo);
	}
	rmkdir($diretorio.'/');
	$pdf->Output($diretorio.'/'.$arquivo,'F');

	echo $pdf->Output('Relatorio_'.config_pad('sistema_sigla').'.pdf','I');
}
?>