<?
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');    
	define('FPDF_FONTPATH', '../../fpdf/font/');
	require('../../fpdf/fpdf.php');
if(session::usr_conectado($_REQUEST['USER_ID']) ){

	class PDF extends FPDF{
		var $NrEmpresa;
		var $NrPedido;

		function Header(){
			$this->AliasNbPages();

			$base_y = 0;

			$this->SetAutoPageBreak(false,30);
			$this->Image('../../imgs/pedido_mod3.jpg', 5, (5+$base_y), 200, 280);
			$this->Image(busca_imagem_empresa('logo_menu.jpg', '../../'), 12, (14+$base_y), 30,15);

			//Nome
			$con_emp = 'select Nome_Razao, EMail, Web_Site from pessoa '.
					  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
					  ' and Pessoa = "'.$this->NrEmpresa.'"';
			$res_emp = consulta_sql($con_emp);
			$reg_emp = consulta_ler_linha($res_emp);
			consulta_limpa($res_emp);

			$this->SetFont('Arial','',8);
			$this->SetTextColor(0,0,128);
			$this->y= (10 + ($base_y));
			$this->x= 55;
			$this->MultiCell(80, 3, $reg_emp[0], 0,'L');

			//Endereco empresa
			$con_end_emp = 'select Logradouro, Numero, Nome_Cidade, Bairro, UF, CEP, Insc_Estadual from pessoa_endereco '.
						  ' where Dominio = "'.$_SESSION['Dominio'].'" '.
						  ' and Pessoa = "'.$this->NrEmpresa.'"'.
						  ' and Situacao <> "E"'.
						  ' order by Seq_Endereco limit 1';
			$res_end_emp = consulta_sql($con_end_emp);
			$reg_end_emp = consulta_ler_objeto($res_end_emp);
			consulta_limpa($res_end_emp);
			$endereco_emp = $reg_end_emp->Logradouro.', ';
			if($reg_end_emp->Numero!=''){
				$endereco_emp.=$reg_end_emp->Numero;
			}else{
				$endereco_emp.='S/N';
			}
			$endereco_emp.= ' - '.$reg_end_emp->Bairro;

			$this->y= (15 + ($base_y));
			$this->x= 55;
			$this->MultiCell(80, 3, $endereco_emp, 0,'L');

			$cep_emp = 'CEP '.$reg_end_emp->CEP.' - '.$reg_end_emp->Nome_Cidade.' - '.$reg_end_emp->UF;

			$this->y= (20 + ($base_y));
			$this->x= 55;
			$this->MultiCell(80, 3, $cep_emp, 0,'L');

			$email_emp = '';
			if($reg_emp[1]!=''){
				$email_emp = 'E-mail: '.$reg_emp[1];
			}
			$this->y= (25 + ($base_y));
			$this->x= 55;
			$this->MultiCell(80, 3, $email_emp, 0,'L');

			$site_emp = '';
			if($reg_emp[2]!=''){
				$site_emp = 'Site: '.$reg_emp[2];
			}

			$this->y= (30 + ($base_y));
			$this->x= 55;
			$this->MultiCell(80, 3, $site_emp, 0,'L');

			$this->y= (38 + ($base_y));
			$this->x= 116;
			$this->MultiCell(22, 3, 'Pgina: '.$this->PageNo().' / {nb}', 0,'R');

			//Pedido
			$this->SetFont('Arial','B',12);
			$this->y= (10 + ($base_y));
			$this->x= 140;
			$this->MultiCell(30, 3, UpperDados(busca_nome_pedido_orc()), 0,'L');

			//NrPedido
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,0);
			$this->y= (10 + ($base_y));
			$this->x= 160;
			$this->MultiCell(40, 3, fill_full($this->NrPedido,13), 0,'R');

			$con_pedido = 'select * from pedido '.
						 ' where Dominio = "'.$_SESSION["Dominio"].'"'.
						 ' and Empresa = "'.$_SESSION["Empresa_Codigo"].'"'.
						 ' and Numero_Pedido = "'.$this->NrPedido.'"';
			$res_pedido = consulta_sql($con_pedido);
			$reg_pedido = consulta_ler_objeto($res_pedido);
			consulta_limpa($res_pedido);

			//Data
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (20 + ($base_y));
			$this->x= 140;
			$this->MultiCell(16, 3, 'Data:', 0,'L');

			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,0);
			$this->y= (20 + ($base_y));
			$this->x= 160;
			$this->MultiCell(40, 3, dataf($reg_pedido->DH_Emissao), 0,'R');

			//Vendedor
			$label = label_vendedor_ou_rep_comercial('S');

			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (25 + ($base_y));
			$this->x= 140;
			$this->MultiCell(22, 3, $label, 0,'L');

			$nm_vend = '';
			if($reg_pedido->Vendedor>0){
				//Nome Vendedor
				/*$con_vend = 'select Nome_Listas from pessoa '.
						  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
						  ' and Pessoa = "'.$reg_pedido->Vendedor.'"';
				$res_vend = consulta_sql($con_vend);
				$reg_vend = consulta_ler_linha($res_vend);
				consulta_limpa($res_vend);*/

				$label_emp = empresa_representante($reg_pedido->Vendedor);
				$nm_vend = $label_emp;
			}
			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (30 + ($base_y));
			$this->x= 140;
			$this->MultiCell(64, 3, $nm_vend, 0,'L');

			//2 linha

			//Cliente
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (45 + ($base_y));
			$this->x= 8;
			$this->MultiCell(16, 3, 'Cliente:', 0,'L');

			$con_pess = 'select Nome_Razao, CPF_CNPJ from pessoa '.
					   ' where Dominio = "'.$_SESSION["Dominio"].'"'.
					   ' and Pessoa = "'.$reg_pedido->Pessoa.'"';
			$res_pess = consulta_sql($con_pess);
			$reg_pess = consulta_ler_linha($res_pess);
			consulta_limpa($res_pess);

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (45 + ($base_y));
			$this->x= 26;
			$this->MultiCell(175, 3, $reg_pedido->Pessoa.' - '.$reg_pess[0], 0,'L');

			//Endereco
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (52 + ($base_y));
			$this->x= 8;
			$this->MultiCell(20, 3, 'Endereo:', 0,'L');

			//Endereco pessoa
			$con_end_pess = 'select Logradouro, Numero, Nome_Cidade, Bairro, UF, CEP, Insc_Estadual from pessoa_endereco '.
						   ' where Dominio = "'.$_SESSION['Dominio'].'" '.
						   ' and Pessoa = "'.$reg_pedido->Pessoa.'"'.
						   ' and Seq_Endereco = "'.$reg_pedido->Local_Fatura.'"';
			$res_end_pess = consulta_sql($con_end_pess);
			$reg_end_pess = consulta_ler_objeto($res_end_pess);
			consulta_limpa($res_end_pess);
			$endereco_pess = $reg_end_pess->Logradouro.', ';
			if($reg_end_pess->Numero!=''){
				$endereco_pess.=$reg_end_pess->Numero;
			}else{
				$endereco_pess.='S/N';
			}
			$endereco_pess.= ' - '.$reg_end_pess->Bairro;

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (52 + ($base_y));
			$this->x= 26;
			$this->MultiCell(175, 3, $endereco_pess, 0,'L');

			//Fone
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (59 + ($base_y));
			$this->x= 8;
			$this->MultiCell(16, 3, 'Fone:', 0,'L');

			//Consulta o Telefone do Cliente
			$con_cli_tel = 'select Numero_Telefone from pessoa_telefone '.
						  ' where Dominio = "'.$_SESSION["Dominio"].'" '.
						  ' and Pessoa = "'.$reg_pedido->Pessoa.'"'.
						  ' and Situacao <> "E"'.
						  ' order by Seq_Telefone '.
						  ' limit 1';
			$res_cli_tel = consulta_sql($con_cli_tel);
			$reg_cli_tel = consulta_ler_linha($res_cli_tel);
			consulta_limpa($res_cli_tel);

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (59 + ($base_y));
			$this->x= 26;
			$this->MultiCell(40, 3, $reg_cli_tel[0], 0,'L');

			//CEP
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (59 + ($base_y));
			$this->x= 68;
			$this->MultiCell(11, 3, 'CEP:', 0,'L');

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (59 + ($base_y));
			$this->x= 80;
			$this->MultiCell(28, 3, $reg_end_pess->CEP, 0,'L');

			//Municipio
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (59 + ($base_y));
			$this->x= 103;
			$this->MultiCell(20, 3, 'Municpio:', 0,'L');

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (59 + ($base_y));
			$this->x= 122;
			$this->MultiCell(59, 3, $reg_end_pess->Nome_Cidade, 0,'L');

			//Estado
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (59 + ($base_y));
			$this->x= 181;
			$this->MultiCell(16, 3, 'Estado:', 0,'L');

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (59 + ($base_y));
			$this->x= 195;
			$this->MultiCell(8, 3, $reg_end_pess->UF, 0,'L');

			//CPF CNPJ
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (66 + ($base_y));
			$this->x= 8;
			$this->MultiCell(22, 3, 'CPF/CNPJ:', 0,'L');

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (66 + ($base_y));
			$this->x= 28;
			$this->MultiCell(80, 3, $reg_pess[1], 0,'L');

			//Insc Estadual
			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= (66 + ($base_y));
			$this->x= 110;
			$this->MultiCell(28, 3, 'Insc. Estadual:', 0,'L');

			$rg_ie_cli = '';
			if($reg_end_pess->Insc_Estadual!=''){
				$rg_ie_cli = $reg_end_pess->Insc_Estadual;
			}
			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= (66 + ($base_y));
			$this->x= 138;
			$this->MultiCell(64, 3, $rg_ie_cli, 0,'L');

			//Vencimento
			$con_vencto = 'select DT_Vencimento from pedido_parcela '.
						 ' where Dominio = "'.$_SESSION['Dominio'].'"'.
						 ' and Empresa = "'.$reg_pedido->Empresa.'"'.
						 ' and Numero_Pedido = "'.$reg_pedido->Numero_Pedido.'"'.
						 ' order by Parcela asc LIMIT 14 ';
			$res_vencto = consulta_sql($con_vencto);
			$nrows_vencto = consulta_num_registros($res_vencto);
			$dt_vencto = '';
			$posi_venc = 73;
			if($nrows_vencto>0){
				//para teste das datas
				//$nrows_vencto = $nrows_vencto*15;
				//for($a=0;$a<13;$a++){
				for($v=0;$v<$nrows_vencto;$v++){
					if($v<12){
						$reg_vencto = consulta_ler_linha($res_vencto);
						if($dt_vencto!=''){
							$dt_vencto.= ', ';
						}
						$dt_vencto.= dataf($reg_vencto[0]);
					}
				}
				//}
				//$nrows_vencto = 9;
				if($nrows_vencto>7){
					$posi_venc = 71;
				}
			}
			consulta_limpa($res_vencto);

			$this->SetFont('Arial','B',10);
			$this->SetTextColor(0,0,128);
			$this->y= ($posi_venc + ($base_y));
			$this->x= 8;
			$this->MultiCell(28, 3, 'Vencimento(s):', 0,'L');

			$this->SetFont('Arial','',10);
			$this->SetTextColor(0,0,0);
			$this->y= ($posi_venc + ($base_y));
			$this->x= 38;
			$this->MultiCell(120, 3, $dt_vencto, 0,'L');

			$ped_pago = '';
			$nr_ped_pago = '';
			if($reg_pedido->Fatura_Pago=='S'){
				$ped_pago = 'Pago';
				$nr_ped_pago = $reg_pedido->Fatura_Pago_Doc;
			}
			$this->SetFont('Arial','',8);
			$this->SetTextColor(0,0,0);
			$this->y= (71 + ($base_y));
			$this->x= 163;
			$this->MultiCell(15, 3, $ped_pago, 0,'C');

			$this->SetFont('Arial','',8);
			$this->SetTextColor(0,0,0);
			$this->y= (74 + ($base_y));
			$this->x= 163;
			$this->MultiCell(15, 3, $nr_ped_pago, 0,'C');

			$ft_tipo = busca_dados_combo('tipo_fatura',$reg_pedido->Fatura_Tipo);
			$this->SetFont('Arial','',8);
			$this->SetTextColor(0,0,0);
			$this->y= (71 + ($base_y));
			$this->x= 183;
			$nm = $this->Lines_MultiCell(20, 3, $ft_tipo, 0, 'L');
			$this->MultiCell(20, (6/$nm), $ft_tipo, 1,'C');

			//Grade itens pedido
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,128);
			$this->y= (80 + ($base_y));
			$this->x= 8;
			$this->MultiCell(18, 3, 'Cdigo', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 28;
			$this->MultiCell(14, 3, 'Quant.', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 42;
			$this->MultiCell(10, 3, 'Unid.', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 52;
			$this->MultiCell(10, 3, ' Emb.', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 62;
			$this->MultiCell(84, 3, 'Descrio dos Produtos', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 145;
			$this->MultiCell(8, 3, 'Cult', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 152;
			$this->MultiCell(9, 3, 'Aplic', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 160;
			$this->MultiCell(20, 3, 'Unitrio (R$)', 0,'C');

			$this->y= (80 + ($base_y));
			$this->x= 180;
			$this->MultiCell(22, 3, 'Total (R$)', 0,'C');

			//Rodap
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,128);
			$this->y= (250 + ($base_y));
			$this->x= 8;
			$this->MultiCell(36, 3, 'Informaes Adicionais', 0,'L');

			//Valor total
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,128);
			$this->y= (255 + ($base_y));
			$this->x= 164;
			$this->MultiCell(14, 3, 'VALOR TOTAL R$', 0,'C');

			//Ass cliente
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,128);
			$this->y= (273 + ($base_y));
			$this->x= 8;
			$this->MultiCell(28, 3, 'Ass. do Cliente', 0,'L');

			//Transportadora
			$this->SetFont('Arial','B',8);
			$this->SetTextColor(0,0,128);
			$this->y= (273 + ($base_y));
			$this->x= 110;
			$this->MultiCell(26, 3, 'Transportadora', 0,'L');

			$this->y= (84 + ($base_y));
			$this->lMargin=3;
			$this->x=$this->lMargin;

		}
		function Footer(){
			if($this->Cabecalho != ''){
				$base_y = 0;
				$this->y= (255 + ($base_y));
				$this->x= 10;
				$this->MultiCell(190, 6, 'Continua na prxima pgina...', 0,'L');
			}
		}
	}

	$pdf=new PDF();
	$pdf->Open();
	$pdf->Cabecalho =  '';
	$pdf->Cabecalho_Filtro =  '';
	$pdf->Sub_Cabecalho_Texto =  '';
	$pdf->Sub_Cabecalho_Style =  'B';
	$pdf->Sub_Cabecalho_Align =  'L';
	$pdf->Sub_Cabecalho_Border =  0;

	$con_pedido = 'select * from pedido '.
				  ' where Dominio = "'.$_SESSION["Dominio"].'"'.
				  ' and Empresa = "'.$_SESSION["Empresa_Codigo"].'"'.
				  ' and Numero_Pedido = "'.base64_decode_si($_REQUEST['idreg']).'"';
	$res_pedido = consulta_sql($con_pedido);
	$reg_pedido = consulta_ler_objeto($res_pedido);
	consulta_limpa($res_pedido);

	//variaveis
	$pdf->NrEmpresa = $reg_pedido->Empresa;
	$pdf->NrPedido = $reg_pedido->Numero_Pedido;

	$k = 0;

	$pdf->AddPage();
	$base_y =0;

	$con_item = 'select * from pedido_item '.
				' where Dominio = "'.$_SESSION["Dominio"].'"'.
				' and Empresa = "'.$_SESSION["Empresa_Codigo"].'"'.
				' and Numero_Pedido = "'.base64_decode_si($_REQUEST['idreg']).'"'.
				' order by Seq_Item asc ';
	$res_item = consulta_sql($con_item);
	$nrows_item = consulta_num_registros($res_item);
	if($nrows_item>0){

		$pdf->Cabecalho = 'ITENS';
		$pdf->y= (84 + ($base_y));
		$pdf->lMargin=3;
		$pdf->x=$pdf->lMargin;

		for($i=0;$i<$nrows_item;$i++){
			$reg_item = consulta_ler_objeto($res_item);
			$lns = 5;

			$pdf->SetAutoPageBreak(true,50);
			$pdf->SetTextColor(0,0,0);
			$pdf->SetFont('Arial','',8);
			$pdf->Cell(1,$lns, '', 0,0,'C');
			$pdf->SetAutoPageBreak(false,30);
			$pdf->SetTextColor(0,0,0);
			$pdf->SetFont('Arial','',8);

			$cons_prod = 'select Codigo_Produto, Descricao_Completa, Unidade_Venda, Embalagem_Unidade '.
						' from produto '.
						' where Dominio = "'.$_SESSION['Dominio'].'"'.
						' and Id_Produto = "'.$reg_item->ID_Produto.'"';
			$res_prod = consulta_sql($cons_prod);
			$reg_prod = consulta_ler_objeto($res_prod);
			consulta_limpa($res_prod);

			$codigo_produto = $reg_prod->Codigo_Produto;
			if($reg_item->Barra_Produto!=''){
				$codigo_produto = $reg_item->Barra_Produto;
			}
			$y=$pdf->y;
			$pdf->MultiCell(25, $lns, ' '.fill_full($codigo_produto,14), 0,'R');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(12, $lns, formata_qtd($reg_item->Qtd,3,false), 0,'R');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(11.5, $lns, $reg_prod->Unidade_Venda, 0,'C');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(9.4, $lns, $reg_prod->Embalagem_Unidade, 0,'C');
			$pdf->y=$y;

			$desc_reduzida = $reg_prod->Descricao_Completa;
			$nm = $pdf->Lines_MultiCell(84, $lns, $desc_reduzida, 0, 'L');
			while ($nm>1){
				$desc_reduzida = substr($desc_reduzida,0,strlen($desc_reduzida)-1);
				$nm = $pdf->Lines_MultiCell(84, $lns, $desc_reduzida, 0, 'L');
			}
			$y=$pdf->y;
			$pdf->MultiCell(84, $lns, $desc_reduzida, 0,'L');
			$pdf->y=$y;

			$cultura = '';
			if($reg_item->Cultura>0){
				$cultura = $reg_item->Cultura;
			}
			$y=$pdf->y;
			$pdf->MultiCell(6.5, $lns, $cultura, 0,'C');
			$pdf->y=$y;

			$aplicacao = '';
			if($reg_item->Aplicacao>0){
				$aplicacao = $reg_item->Aplicacao;
			}
			$y=$pdf->y;
			$pdf->MultiCell(8, $lns, $aplicacao, 0,'C');
			$pdf->y=$y;

			$y=$pdf->y;
			$pdf->MultiCell(18.5, $lns, formata_qtd($reg_item->Valor_Unitario,2,true), 0,'R');
			$pdf->y=$y;

			if(($reg_item->Status=='E')||($reg_item->Status=='C')){
				$vl_tot = 'Cancelado';
			}else{
				$vl_tot = formata_qtd($reg_item->Valor_Total,2,true);
			}
			$y=$pdf->y;
			$pdf->MultiCell(25, $lns, $vl_tot, 0,'R');
			$pdf->y=$y;

			$pdf->Cell(1,$lns, ' ', 0,1,'C');
			//Prxima Linha
			$pdf->x=$pdf->lMargin;
			$pdf->y=$y+$lns;
		}
	}
	consulta_limpa($res_item);

	$pdf->SetAutoPageBreak(false,30);
	$pdf->Cabecalho =  '';

	$pdf->SetFont('Arial','',8);
	$pdf->SetTextColor(0,0,0);
	$pdf->y= (255 + ($base_y));
	$pdf->x= 8;
	$pdf->MultiCell(152, 3, $reg_pedido->Observacao, 0,'L');

	$pdf->SetFont('Arial','B',10);
	$pdf->SetTextColor(0,0,0);
	$pdf->y= (258 + ($base_y));
	$pdf->x= 178;
	$pdf->MultiCell(26, 3, formata_qtd($reg_pedido->Valor_Total_Liquido,2,true), 0,'R');

	$desc_transp = '';
	if($reg_pedido->Transportadora>0){
		$con_transp = 'select Nome_Razao from pessoa '.
					 ' where Dominio = "'.$_SESSION["Dominio"].'"'.
					 ' and Pessoa = "'.$reg_pedido->Transportadora.'"';
		$res_transp = consulta_sql($con_transp);
		$reg_transp = consulta_ler_linha($res_transp);
		consulta_limpa($res_transp);

		$desc_transp = $reg_pedido->Transportadora. ' - '.$reg_transp[0];
	}

	$pdf->SetFont('Arial','',8);
	$pdf->SetTextColor(0,0,0);
	$pdf->y= (277 + ($base_y));
	$pdf->x= 110;
	$pdf->MultiCell(92, 3, $desc_transp, 0,'L');

	echo $pdf->Output('Relatorio_'.config_pad('sistema_sigla').'.pdf','I');
}
?>